import 'dart:ui';
import 'package:flutter/material.dart';
import 'package:countries_world_map/canvas/touchable_canvas.dart';
import 'package:countries_world_map/countries/asia/japan/src/japan_colors.dart';

class JapanPainter extends CustomPainter {
  final Color defaultColor;
  final JapanColors japanColors;
  final BuildContext context;
  final Function(String, TapUpDetails) callback;

  const JapanPainter(
      {required this.defaultColor,
      required this.japanColors,
      required this.context,
      required this.callback});

  @override
  void paint(Canvas canvas, Size size) {
    var japanCanvas = TouchyCanvas(context, canvas);
    Path aichiPath = Path();
    aichiPath.moveTo(size.width * 0.5950595, size.height * 0.5385084);
    aichiPath.lineTo(size.width * 0.5946708, size.height * 0.5378301);
    aichiPath.lineTo(size.width * 0.5958140, size.height * 0.5344000);
    aichiPath.lineTo(size.width * 0.5938476, size.height * 0.5316869);
    aichiPath.lineTo(size.width * 0.5940991, size.height * 0.5288576);
    aichiPath.lineTo(size.width * 0.5951509, size.height * 0.5262026);
    aichiPath.lineTo(size.width * 0.5945793, size.height * 0.5255825);
    aichiPath.lineTo(size.width * 0.5925442, size.height * 0.5262801);
    aichiPath.lineTo(size.width * 0.5899375, size.height * 0.5256018);
    aichiPath.lineTo(size.width * 0.5899375, size.height * 0.5256018);
    aichiPath.lineTo(size.width * 0.5877196, size.height * 0.5225593);
    aichiPath.lineTo(size.width * 0.5869878, size.height * 0.5202144);
    aichiPath.lineTo(size.width * 0.5869878, size.height * 0.5202144);
    aichiPath.lineTo(size.width * 0.5874909, size.height * 0.5159704);
    aichiPath.lineTo(size.width * 0.5913552, size.height * 0.5102147);
    aichiPath.lineTo(size.width * 0.5942820, size.height * 0.5105054);
    aichiPath.lineTo(size.width * 0.5980778, size.height * 0.5095364);
    aichiPath.lineTo(size.width * 0.6014619, size.height * 0.5073466);
    aichiPath.lineTo(size.width * 0.6014162, size.height * 0.5084512);
    aichiPath.lineTo(size.width * 0.6041143, size.height * 0.5101372);
    aichiPath.lineTo(size.width * 0.6040457, size.height * 0.5113968);
    aichiPath.lineTo(size.width * 0.6051890, size.height * 0.5118038);
    aichiPath.lineTo(size.width * 0.6049832, size.height * 0.5127340);
    aichiPath.lineTo(size.width * 0.6056006, size.height * 0.5133542);
    aichiPath.lineTo(size.width * 0.6063323, size.height * 0.5136448);
    aichiPath.lineTo(size.width * 0.6070183, size.height * 0.5132379);
    aichiPath.lineTo(size.width * 0.6091677, size.height * 0.5139937);
    aichiPath.lineTo(size.width * 0.6103567, size.height * 0.5153696);
    aichiPath.lineTo(size.width * 0.6123003, size.height * 0.5150401);
    aichiPath.lineTo(size.width * 0.6144039, size.height * 0.5136255);
    aichiPath.lineTo(size.width * 0.6158445, size.height * 0.5136061);
    aichiPath.lineTo(size.width * 0.6175594, size.height * 0.5145169);
    aichiPath.lineTo(size.width * 0.6173994, size.height * 0.5149820);
    aichiPath.lineTo(size.width * 0.6193201, size.height * 0.5150789);
    aichiPath.lineTo(size.width * 0.6192744, size.height * 0.5156797);
    aichiPath.lineTo(size.width * 0.6215381, size.height * 0.5166486);
    aichiPath.lineTo(size.width * 0.6254710, size.height * 0.5139355);
    aichiPath.lineTo(size.width * 0.6273003, size.height * 0.5137805);
    aichiPath.lineTo(size.width * 0.6273003, size.height * 0.5137805);
    aichiPath.lineTo(size.width * 0.6265685, size.height * 0.5153890);
    aichiPath.lineTo(size.width * 0.6280320, size.height * 0.5169587);
    aichiPath.lineTo(size.width * 0.6280091, size.height * 0.5179470);
    aichiPath.lineTo(size.width * 0.6308902, size.height * 0.5174432);
    aichiPath.lineTo(size.width * 0.6328338, size.height * 0.5163773);
    aichiPath.lineTo(size.width * 0.6364008, size.height * 0.5169587);
    aichiPath.lineTo(size.width * 0.6369039, size.height * 0.5177145);
    aichiPath.lineTo(size.width * 0.6388246, size.height * 0.5171912);
    aichiPath.lineTo(size.width * 0.6388246, size.height * 0.5171912);
    aichiPath.lineTo(size.width * 0.6381158, size.height * 0.5190904);
    aichiPath.lineTo(size.width * 0.6393048, size.height * 0.5200594);
    aichiPath.lineTo(size.width * 0.6379786, size.height * 0.5211640);
    aichiPath.lineTo(size.width * 0.6381615, size.height * 0.5220748);
    aichiPath.lineTo(size.width * 0.6371097, size.height * 0.5225399);
    aichiPath.lineTo(size.width * 0.6337713, size.height * 0.5264158);
    aichiPath.lineTo(size.width * 0.6337027, size.height * 0.5284700);
    aichiPath.lineTo(size.width * 0.6307759, size.height * 0.5322102);
    aichiPath.lineTo(size.width * 0.6244878, size.height * 0.5351752);
    aichiPath.lineTo(size.width * 0.6235045, size.height * 0.5375588);
    aichiPath.lineTo(size.width * 0.6238704, size.height * 0.5420548);
    aichiPath.lineTo(size.width * 0.6238704, size.height * 0.5420548);
    aichiPath.lineTo(size.width * 0.6160731, size.height * 0.5435858);
    aichiPath.lineTo(size.width * 0.6082302, size.height * 0.5459694);
    aichiPath.lineTo(size.width * 0.6035884, size.height * 0.5464927);
    aichiPath.lineTo(size.width * 0.6029939, size.height * 0.5460857);
    aichiPath.lineTo(size.width * 0.6048232, size.height * 0.5427719);
    aichiPath.lineTo(size.width * 0.6059436, size.height * 0.5428687);
    aichiPath.lineTo(size.width * 0.6065152, size.height * 0.5439734);
    aichiPath.lineTo(size.width * 0.6119116, size.height * 0.5419967);
    aichiPath.lineTo(size.width * 0.6138780, size.height * 0.5409696);
    aichiPath.lineTo(size.width * 0.6136494, size.height * 0.5401169);
    aichiPath.lineTo(size.width * 0.6146783, size.height * 0.5394192);
    aichiPath.lineTo(size.width * 0.6157759, size.height * 0.5397099);
    aichiPath.lineTo(size.width * 0.6162789, size.height * 0.5393417);
    aichiPath.lineTo(size.width * 0.6167591, size.height * 0.5371325);
    aichiPath.lineTo(size.width * 0.6154558, size.height * 0.5357759);
    aichiPath.lineTo(size.width * 0.6115914, size.height * 0.5351752);
    aichiPath.lineTo(size.width * 0.6104024, size.height * 0.5360666);
    aichiPath.lineTo(size.width * 0.6098536, size.height * 0.5378689);
    aichiPath.lineTo(size.width * 0.6080015, size.height * 0.5367643);
    aichiPath.lineTo(size.width * 0.6031311, size.height * 0.5372488);
    aichiPath.lineTo(size.width * 0.5998842, size.height * 0.5345938);
    aichiPath.lineTo(size.width * 0.6005930, size.height * 0.5325009);
    aichiPath.lineTo(size.width * 0.5995869, size.height * 0.5321326);
    aichiPath.lineTo(size.width * 0.5986265, size.height * 0.5332760);
    aichiPath.lineTo(size.width * 0.5980092, size.height * 0.5375782);
    aichiPath.lineTo(size.width * 0.6003415, size.height * 0.5393805);
    aichiPath.lineTo(size.width * 0.6006845, size.height * 0.5410859);
    aichiPath.lineTo(size.width * 0.5968201, size.height * 0.5399231);
    aichiPath.lineTo(size.width * 0.5950595, size.height * 0.5385084);
    aichiPath.close();

    Paint aichiPaint = Paint()..style = PaintingStyle.fill;
    aichiPaint.color = japanColors.aichi ?? defaultColor;
    japanCanvas.drawPath(aichiPath, aichiPaint, onTapUp: (tabdetail) {
      callback('aichi', tabdetail);
    });

    Path akitaPath = Path();
    akitaPath.moveTo(size.width * 0.7396857, size.height * 0.3011708);
    akitaPath.lineTo(size.width * 0.7381079, size.height * 0.2958415);
    akitaPath.lineTo(size.width * 0.7349296, size.height * 0.2927020);
    akitaPath.lineTo(size.width * 0.7360957, size.height * 0.2911323);
    akitaPath.lineTo(size.width * 0.7377878, size.height * 0.2915780);
    akitaPath.lineTo(size.width * 0.7391598, size.height * 0.2933028);
    akitaPath.lineTo(size.width * 0.7395942, size.height * 0.2910935);
    akitaPath.lineTo(size.width * 0.7389997, size.height * 0.2902990);
    akitaPath.lineTo(size.width * 0.7399143, size.height * 0.2891169);
    akitaPath.lineTo(size.width * 0.7403488, size.height * 0.2864038);
    akitaPath.lineTo(size.width * 0.7395713, size.height * 0.2836713);
    akitaPath.lineTo(size.width * 0.7371247, size.height * 0.2828186);
    akitaPath.lineTo(size.width * 0.7360957, size.height * 0.2836519);
    akitaPath.lineTo(size.width * 0.7348610, size.height * 0.2852216);
    akitaPath.lineTo(size.width * 0.7334662, size.height * 0.2892138);
    akitaPath.lineTo(size.width * 0.7347009, size.height * 0.2900277);
    akitaPath.lineTo(size.width * 0.7345180, size.height * 0.2924695);
    akitaPath.lineTo(size.width * 0.7328031, size.height * 0.2919075);
    akitaPath.lineTo(size.width * 0.7307680, size.height * 0.2921982);
    akitaPath.lineTo(size.width * 0.7303336, size.height * 0.2926826);
    akitaPath.lineTo(size.width * 0.7307223, size.height * 0.2943299);
    akitaPath.lineTo(size.width * 0.7259205, size.height * 0.2941555);
    akitaPath.lineTo(size.width * 0.7237253, size.height * 0.2905897);
    akitaPath.lineTo(size.width * 0.7232223, size.height * 0.2880704);
    akitaPath.lineTo(size.width * 0.7235424, size.height * 0.2866557);
    akitaPath.lineTo(size.width * 0.7279555, size.height * 0.2892138);
    akitaPath.lineTo(size.width * 0.7294875, size.height * 0.2888068);
    akitaPath.lineTo(size.width * 0.7328717, size.height * 0.2859774);
    akitaPath.lineTo(size.width * 0.7348610, size.height * 0.2829349);
    akitaPath.lineTo(size.width * 0.7366903, size.height * 0.2783032);
    akitaPath.lineTo(size.width * 0.7380622, size.height * 0.2724895);
    akitaPath.lineTo(size.width * 0.7381308, size.height * 0.2692531);
    akitaPath.lineTo(size.width * 0.7341979, size.height * 0.2657455);
    akitaPath.lineTo(size.width * 0.7341979, size.height * 0.2657455);
    akitaPath.lineTo(size.width * 0.7353640, size.height * 0.2655323);
    akitaPath.lineTo(size.width * 0.7379479, size.height * 0.2662106);
    akitaPath.lineTo(size.width * 0.7385424, size.height * 0.2645246);
    akitaPath.lineTo(size.width * 0.7403030, size.height * 0.2638463);
    akitaPath.lineTo(size.width * 0.7415378, size.height * 0.2644665);
    akitaPath.lineTo(size.width * 0.7420180, size.height * 0.2654160);
    akitaPath.lineTo(size.width * 0.7454021, size.height * 0.2651641);
    akitaPath.lineTo(size.width * 0.7472543, size.height * 0.2657067);
    akitaPath.lineTo(size.width * 0.7503411, size.height * 0.2649703);
    akitaPath.lineTo(size.width * 0.7523076, size.height * 0.2653191);
    akitaPath.lineTo(size.width * 0.7534509, size.height * 0.2633812);
    akitaPath.lineTo(size.width * 0.7564463, size.height * 0.2631680);
    akitaPath.lineTo(size.width * 0.7570637, size.height * 0.2647959);
    akitaPath.lineTo(size.width * 0.7588929, size.height * 0.2647959);
    akitaPath.lineTo(size.width * 0.7615225, size.height * 0.2671020);
    akitaPath.lineTo(size.width * 0.7638091, size.height * 0.2654742);
    akitaPath.lineTo(size.width * 0.7666673, size.height * 0.2671020);
    akitaPath.lineTo(size.width * 0.7684737, size.height * 0.2658811);
    akitaPath.lineTo(size.width * 0.7702115, size.height * 0.2657842);
    akitaPath.lineTo(size.width * 0.7718579, size.height * 0.2645827);
    akitaPath.lineTo(size.width * 0.7734813, size.height * 0.2647765);
    akitaPath.lineTo(size.width * 0.7740301, size.height * 0.2626836);
    akitaPath.lineTo(size.width * 0.7768426, size.height * 0.2617340);
    akitaPath.lineTo(size.width * 0.7764767, size.height * 0.2662881);
    akitaPath.lineTo(size.width * 0.7813472, size.height * 0.2658424);
    akitaPath.lineTo(size.width * 0.7819874, size.height * 0.2694082);
    akitaPath.lineTo(size.width * 0.7810499, size.height * 0.2699314);
    akitaPath.lineTo(size.width * 0.7799066, size.height * 0.2722957);
    akitaPath.lineTo(size.width * 0.7802267, size.height * 0.2748344);
    akitaPath.lineTo(size.width * 0.7802267, size.height * 0.2748344);
    akitaPath.lineTo(size.width * 0.7793121, size.height * 0.2759390);
    akitaPath.lineTo(size.width * 0.7779173, size.height * 0.2763653);
    akitaPath.lineTo(size.width * 0.7760652, size.height * 0.2785164);
    akitaPath.lineTo(size.width * 0.7769798, size.height * 0.2794660);
    akitaPath.lineTo(size.width * 0.7766368, size.height * 0.2824892);
    akitaPath.lineTo(size.width * 0.7754478, size.height * 0.2833806);
    akitaPath.lineTo(size.width * 0.7753335, size.height * 0.2885742);
    akitaPath.lineTo(size.width * 0.7767511, size.height * 0.2934191);
    akitaPath.lineTo(size.width * 0.7754707, size.height * 0.2937679);
    akitaPath.lineTo(size.width * 0.7743502, size.height * 0.2928377);
    akitaPath.lineTo(size.width * 0.7724752, size.height * 0.2937097);
    akitaPath.lineTo(size.width * 0.7726353, size.height * 0.2957639);
    akitaPath.lineTo(size.width * 0.7751963, size.height * 0.2970430);
    akitaPath.lineTo(size.width * 0.7733213, size.height * 0.2998917);
    akitaPath.lineTo(size.width * 0.7724295, size.height * 0.3001630);
    akitaPath.lineTo(size.width * 0.7739386, size.height * 0.3024304);
    akitaPath.lineTo(size.width * 0.7742359, size.height * 0.3045234);
    akitaPath.lineTo(size.width * 0.7730697, size.height * 0.3068295);
    akitaPath.lineTo(size.width * 0.7724524, size.height * 0.3067714);
    akitaPath.lineTo(size.width * 0.7710576, size.height * 0.3084380);
    akitaPath.lineTo(size.width * 0.7700972, size.height * 0.3086511);
    akitaPath.lineTo(size.width * 0.7705774, size.height * 0.3100465);
    akitaPath.lineTo(size.width * 0.7695941, size.height * 0.3126433);
    akitaPath.lineTo(size.width * 0.7678106, size.height * 0.3142905);
    akitaPath.lineTo(size.width * 0.7679249, size.height * 0.3158602);
    akitaPath.lineTo(size.width * 0.7668960, size.height * 0.3160928);
    akitaPath.lineTo(size.width * 0.7667816, size.height * 0.3173524);
    akitaPath.lineTo(size.width * 0.7676734, size.height * 0.3175268);
    akitaPath.lineTo(size.width * 0.7690454, size.height * 0.3199492);
    akitaPath.lineTo(size.width * 0.7687024, size.height * 0.3217321);
    akitaPath.lineTo(size.width * 0.7699143, size.height * 0.3231856);
    akitaPath.lineTo(size.width * 0.7724752, size.height * 0.3246778);
    akitaPath.lineTo(size.width * 0.7717207, size.height * 0.3267320);
    akitaPath.lineTo(size.width * 0.7736643, size.height * 0.3275847);
    akitaPath.lineTo(size.width * 0.7722923, size.height * 0.3281661);
    akitaPath.lineTo(size.width * 0.7712176, size.height * 0.3297745);
    akitaPath.lineTo(size.width * 0.7718350, size.height * 0.3302009);
    akitaPath.lineTo(size.width * 0.7711947, size.height * 0.3320807);
    akitaPath.lineTo(size.width * 0.7734127, size.height * 0.3328171);
    akitaPath.lineTo(size.width * 0.7737329, size.height * 0.3335922);
    akitaPath.lineTo(size.width * 0.7719265, size.height * 0.3362472);
    akitaPath.lineTo(size.width * 0.7721094, size.height * 0.3384758);
    akitaPath.lineTo(size.width * 0.7721094, size.height * 0.3384758);
    akitaPath.lineTo(size.width * 0.7704859, size.height * 0.3388053);
    akitaPath.lineTo(size.width * 0.7667359, size.height * 0.3418478);
    akitaPath.lineTo(size.width * 0.7627115, size.height * 0.3425455);
    akitaPath.lineTo(size.width * 0.7620942, size.height * 0.3421966);
    akitaPath.lineTo(size.width * 0.7620942, size.height * 0.3421966);
    akitaPath.lineTo(size.width * 0.7615454, size.height * 0.3413246);
    akitaPath.lineTo(size.width * 0.7580698, size.height * 0.3402975);
    akitaPath.lineTo(size.width * 0.7567436, size.height * 0.3368092);
    akitaPath.lineTo(size.width * 0.7543198, size.height * 0.3366542);
    akitaPath.lineTo(size.width * 0.7535195, size.height * 0.3351620);
    akitaPath.lineTo(size.width * 0.7510500, size.height * 0.3356852);
    akitaPath.lineTo(size.width * 0.7440073, size.height * 0.3338635);
    akitaPath.lineTo(size.width * 0.7422009, size.height * 0.3325070);
    akitaPath.lineTo(size.width * 0.7405774, size.height * 0.3321582);
    akitaPath.lineTo(size.width * 0.7401201, size.height * 0.3298908);
    akitaPath.lineTo(size.width * 0.7378793, size.height * 0.3303559);
    akitaPath.lineTo(size.width * 0.7370332, size.height * 0.3312474);
    akitaPath.lineTo(size.width * 0.7312939, size.height * 0.3304528);
    akitaPath.lineTo(size.width * 0.7312939, size.height * 0.3304528);
    akitaPath.lineTo(size.width * 0.7328488, size.height * 0.3276041);
    akitaPath.lineTo(size.width * 0.7323229, size.height * 0.3258018);
    akitaPath.lineTo(size.width * 0.7332146, size.height * 0.3242902);
    akitaPath.lineTo(size.width * 0.7331232, size.height * 0.3232631);
    akitaPath.lineTo(size.width * 0.7340150, size.height * 0.3220810);
    akitaPath.lineTo(size.width * 0.7356156, size.height * 0.3218678);
    akitaPath.lineTo(size.width * 0.7377649, size.height * 0.3172362);
    akitaPath.lineTo(size.width * 0.7395942, size.height * 0.3091162);
    akitaPath.lineTo(size.width * 0.7396857, size.height * 0.3011708);
    akitaPath.close();

    Paint akitaPaint = Paint()..style = PaintingStyle.fill;
    akitaPaint.color = japanColors.akita ?? defaultColor;
    japanCanvas.drawPath(akitaPath, akitaPaint, onTapUp: (tabdetail) {
      callback('akita', tabdetail);
    });

    Path aomoriPath = Path();
    aomoriPath.moveTo(size.width * 0.7880011, size.height * 0.2434981);
    aomoriPath.lineTo(size.width * 0.7901048, size.height * 0.2418896);
    aomoriPath.lineTo(size.width * 0.7914310, size.height * 0.2398548);
    aomoriPath.lineTo(size.width * 0.7927343, size.height * 0.2362697);
    aomoriPath.lineTo(size.width * 0.7932602, size.height * 0.2315217);
    aomoriPath.lineTo(size.width * 0.7946093, size.height * 0.2293125);
    aomoriPath.lineTo(size.width * 0.7929630, size.height * 0.2253204);
    aomoriPath.lineTo(size.width * 0.7909965, size.height * 0.2233049);
    aomoriPath.lineTo(size.width * 0.7891901, size.height * 0.2231499);
    aomoriPath.lineTo(size.width * 0.7872465, size.height * 0.2262700);
    aomoriPath.lineTo(size.width * 0.7846627, size.height * 0.2278397);
    aomoriPath.lineTo(size.width * 0.7811871, size.height * 0.2270258);
    aomoriPath.lineTo(size.width * 0.7796551, size.height * 0.2282854);
    aomoriPath.lineTo(size.width * 0.7755164, size.height * 0.2289443);
    aomoriPath.lineTo(size.width * 0.7735728, size.height * 0.2306303);
    aomoriPath.lineTo(size.width * 0.7714463, size.height * 0.2297195);
    aomoriPath.lineTo(size.width * 0.7730240, size.height * 0.2208244);
    aomoriPath.lineTo(size.width * 0.7739844, size.height * 0.2195454);
    aomoriPath.lineTo(size.width * 0.7746932, size.height * 0.2159796);
    aomoriPath.lineTo(size.width * 0.7779630, size.height * 0.2120456);
    aomoriPath.lineTo(size.width * 0.7774600, size.height * 0.2104565);
    aomoriPath.lineTo(size.width * 0.7781460, size.height * 0.2093906);
    aomoriPath.lineTo(size.width * 0.7820789, size.height * 0.2124332);
    aomoriPath.lineTo(size.width * 0.7850972, size.height * 0.2126463);
    aomoriPath.lineTo(size.width * 0.7871322, size.height * 0.2136153);
    aomoriPath.lineTo(size.width * 0.7907221, size.height * 0.2174330);
    aomoriPath.lineTo(size.width * 0.7940605, size.height * 0.2190803);
    aomoriPath.lineTo(size.width * 0.7960956, size.height * 0.2192934);
    aomoriPath.lineTo(size.width * 0.7983822, size.height * 0.2185764);
    aomoriPath.lineTo(size.width * 0.8030468, size.height * 0.2153401);
    aomoriPath.lineTo(size.width * 0.7996398, size.height * 0.2286148);
    aomoriPath.lineTo(size.width * 0.7994111, size.height * 0.2384789);
    aomoriPath.lineTo(size.width * 0.8006688, size.height * 0.2492344);
    aomoriPath.lineTo(size.width * 0.8038014, size.height * 0.2586527);
    aomoriPath.lineTo(size.width * 0.8064995, size.height * 0.2607650);
    aomoriPath.lineTo(size.width * 0.8080316, size.height * 0.2600092);
    aomoriPath.lineTo(size.width * 0.8085575, size.height * 0.2610751);
    aomoriPath.lineTo(size.width * 0.8129248, size.height * 0.2647378);
    aomoriPath.lineTo(size.width * 0.8129248, size.height * 0.2647378);
    aomoriPath.lineTo(size.width * 0.8118501, size.height * 0.2657842);
    aomoriPath.lineTo(size.width * 0.8086718, size.height * 0.2669858);
    aomoriPath.lineTo(size.width * 0.8084203, size.height * 0.2685942);
    aomoriPath.lineTo(size.width * 0.8063852, size.height * 0.2699314);
    aomoriPath.lineTo(size.width * 0.8035499, size.height * 0.2684392);
    aomoriPath.lineTo(size.width * 0.8019950, size.height * 0.2686136);
    aomoriPath.lineTo(size.width * 0.7980621, size.height * 0.2707453);
    aomoriPath.lineTo(size.width * 0.7965072, size.height * 0.2686524);
    aomoriPath.lineTo(size.width * 0.7920255, size.height * 0.2715399);
    aomoriPath.lineTo(size.width * 0.7885499, size.height * 0.2722763);
    aomoriPath.lineTo(size.width * 0.7868578, size.height * 0.2732453);
    aomoriPath.lineTo(size.width * 0.7867664, size.height * 0.2746406);
    aomoriPath.lineTo(size.width * 0.7857145, size.height * 0.2746793);
    aomoriPath.lineTo(size.width * 0.7834280, size.height * 0.2761909);
    aomoriPath.lineTo(size.width * 0.7812786, size.height * 0.2761715);
    aomoriPath.lineTo(size.width * 0.7802267, size.height * 0.2748537);
    aomoriPath.lineTo(size.width * 0.7802267, size.height * 0.2748537);
    aomoriPath.lineTo(size.width * 0.7799066, size.height * 0.2723151);
    aomoriPath.lineTo(size.width * 0.7810499, size.height * 0.2699508);
    aomoriPath.lineTo(size.width * 0.7819874, size.height * 0.2694275);
    aomoriPath.lineTo(size.width * 0.7813472, size.height * 0.2658618);
    aomoriPath.lineTo(size.width * 0.7764767, size.height * 0.2663075);
    aomoriPath.lineTo(size.width * 0.7768426, size.height * 0.2617534);
    aomoriPath.lineTo(size.width * 0.7740301, size.height * 0.2627029);
    aomoriPath.lineTo(size.width * 0.7734813, size.height * 0.2647959);
    aomoriPath.lineTo(size.width * 0.7718579, size.height * 0.2646021);
    aomoriPath.lineTo(size.width * 0.7702115, size.height * 0.2658036);
    aomoriPath.lineTo(size.width * 0.7684737, size.height * 0.2659005);
    aomoriPath.lineTo(size.width * 0.7666673, size.height * 0.2671214);
    aomoriPath.lineTo(size.width * 0.7638091, size.height * 0.2654936);
    aomoriPath.lineTo(size.width * 0.7615225, size.height * 0.2671214);
    aomoriPath.lineTo(size.width * 0.7588929, size.height * 0.2648153);
    aomoriPath.lineTo(size.width * 0.7570637, size.height * 0.2648153);
    aomoriPath.lineTo(size.width * 0.7564463, size.height * 0.2631874);
    aomoriPath.lineTo(size.width * 0.7534509, size.height * 0.2634006);
    aomoriPath.lineTo(size.width * 0.7523076, size.height * 0.2653385);
    aomoriPath.lineTo(size.width * 0.7503411, size.height * 0.2649897);
    aomoriPath.lineTo(size.width * 0.7472543, size.height * 0.2657261);
    aomoriPath.lineTo(size.width * 0.7454021, size.height * 0.2651835);
    aomoriPath.lineTo(size.width * 0.7420180, size.height * 0.2654354);
    aomoriPath.lineTo(size.width * 0.7415378, size.height * 0.2644858);
    aomoriPath.lineTo(size.width * 0.7403030, size.height * 0.2638657);
    aomoriPath.lineTo(size.width * 0.7385424, size.height * 0.2645440);
    aomoriPath.lineTo(size.width * 0.7379479, size.height * 0.2662300);
    aomoriPath.lineTo(size.width * 0.7353640, size.height * 0.2655517);
    aomoriPath.lineTo(size.width * 0.7341979, size.height * 0.2657649);
    aomoriPath.lineTo(size.width * 0.7341979, size.height * 0.2657649);
    aomoriPath.lineTo(size.width * 0.7347924, size.height * 0.2623154);
    aomoriPath.lineTo(size.width * 0.7343579, size.height * 0.2595248);
    aomoriPath.lineTo(size.width * 0.7333290, size.height * 0.2578581);
    aomoriPath.lineTo(size.width * 0.7311339, size.height * 0.2579550);
    aomoriPath.lineTo(size.width * 0.7307909, size.height * 0.2563659);
    aomoriPath.lineTo(size.width * 0.7348610, size.height * 0.2536141);
    aomoriPath.lineTo(size.width * 0.7371933, size.height * 0.2501258);
    aomoriPath.lineTo(size.width * 0.7386796, size.height * 0.2492731);
    aomoriPath.lineTo(size.width * 0.7400744, size.height * 0.2487886);
    aomoriPath.lineTo(size.width * 0.7428869, size.height * 0.2501258);
    aomoriPath.lineTo(size.width * 0.7461567, size.height * 0.2480522);
    aomoriPath.lineTo(size.width * 0.7480088, size.height * 0.2478584);
    aomoriPath.lineTo(size.width * 0.7489692, size.height * 0.2466763);
    aomoriPath.lineTo(size.width * 0.7513015, size.height * 0.2396804);
    aomoriPath.lineTo(size.width * 0.7514616, size.height * 0.2323163);
    aomoriPath.lineTo(size.width * 0.7498838, size.height * 0.2308628);
    aomoriPath.lineTo(size.width * 0.7482832, size.height * 0.2307078);
    aomoriPath.lineTo(size.width * 0.7486719, size.height * 0.2299520);
    aomoriPath.lineTo(size.width * 0.7506841, size.height * 0.2303977);
    aomoriPath.lineTo(size.width * 0.7515530, size.height * 0.2295644);
    aomoriPath.lineTo(size.width * 0.7524677, size.height * 0.2238476);
    aomoriPath.lineTo(size.width * 0.7549600, size.height * 0.2251847);
    aomoriPath.lineTo(size.width * 0.7564920, size.height * 0.2271033);
    aomoriPath.lineTo(size.width * 0.7579554, size.height * 0.2278009);
    aomoriPath.lineTo(size.width * 0.7594875, size.height * 0.2274327);
    aomoriPath.lineTo(size.width * 0.7617740, size.height * 0.2254754);
    aomoriPath.lineTo(size.width * 0.7642664, size.height * 0.2262118);
    aomoriPath.lineTo(size.width * 0.7657527, size.height * 0.2276071);
    aomoriPath.lineTo(size.width * 0.7655012, size.height * 0.2320062);
    aomoriPath.lineTo(size.width * 0.7663929, size.height * 0.2368898);
    aomoriPath.lineTo(size.width * 0.7680621, size.height * 0.2432462);
    aomoriPath.lineTo(size.width * 0.7701887, size.height * 0.2455523);
    aomoriPath.lineTo(size.width * 0.7732298, size.height * 0.2453391);
    aomoriPath.lineTo(size.width * 0.7759508, size.height * 0.2428586);
    aomoriPath.lineTo(size.width * 0.7764539, size.height * 0.2417734);
    aomoriPath.lineTo(size.width * 0.7759508, size.height * 0.2393703);
    aomoriPath.lineTo(size.width * 0.7767054, size.height * 0.2365603);
    aomoriPath.lineTo(size.width * 0.7801124, size.height * 0.2376068);
    aomoriPath.lineTo(size.width * 0.7816673, size.height * 0.2394672);
    aomoriPath.lineTo(size.width * 0.7812557, size.height * 0.2405331);
    aomoriPath.lineTo(size.width * 0.7829249, size.height * 0.2405137);
    aomoriPath.lineTo(size.width * 0.7850286, size.height * 0.2413858);
    aomoriPath.lineTo(size.width * 0.7862404, size.height * 0.2430911);
    aomoriPath.lineTo(size.width * 0.7880011, size.height * 0.2434981);
    aomoriPath.close();

    Paint aomoriPaint = Paint()..style = PaintingStyle.fill;
    aomoriPaint.color = japanColors.aomori ?? defaultColor;
    japanCanvas.drawPath(aomoriPath, aomoriPaint, onTapUp: (tabdetail) {
      callback('aomori', tabdetail);
    });

    Path chibaPath = Path();
    chibaPath.moveTo(size.width * 0.7297619, size.height * 0.5099046);
    chibaPath.lineTo(size.width * 0.7300820, size.height * 0.5094977);
    chibaPath.lineTo(size.width * 0.7322772, size.height * 0.5103116);
    chibaPath.lineTo(size.width * 0.7331689, size.height * 0.5094008);
    chibaPath.lineTo(size.width * 0.7324829, size.height * 0.5080055);
    chibaPath.lineTo(size.width * 0.7326887, size.height * 0.5068815);
    chibaPath.lineTo(size.width * 0.7357756, size.height * 0.5061451);
    chibaPath.lineTo(size.width * 0.7355012, size.height * 0.5051567);
    chibaPath.lineTo(size.width * 0.7361415, size.height * 0.5049048);
    chibaPath.lineTo(size.width * 0.7366903, size.height * 0.5056412);
    chibaPath.lineTo(size.width * 0.7401430, size.height * 0.5014553);
    chibaPath.lineTo(size.width * 0.7414463, size.height * 0.5023274);
    chibaPath.lineTo(size.width * 0.7419723, size.height * 0.5016491);
    chibaPath.lineTo(size.width * 0.7407375, size.height * 0.4991492);
    chibaPath.lineTo(size.width * 0.7389997, size.height * 0.4975407);
    chibaPath.lineTo(size.width * 0.7362329, size.height * 0.4952346);
    chibaPath.lineTo(size.width * 0.7346552, size.height * 0.4957966);
    chibaPath.lineTo(size.width * 0.7338549, size.height * 0.4943237);
    chibaPath.lineTo(size.width * 0.7338549, size.height * 0.4943237);
    chibaPath.lineTo(size.width * 0.7313854, size.height * 0.4899440);
    chibaPath.lineTo(size.width * 0.7313854, size.height * 0.4899440);
    chibaPath.lineTo(size.width * 0.7321628, size.height * 0.4894402);
    chibaPath.lineTo(size.width * 0.7326659, size.height * 0.4868627);
    chibaPath.lineTo(size.width * 0.7288244, size.height * 0.4806226);
    chibaPath.lineTo(size.width * 0.7287101, size.height * 0.4786072);
    chibaPath.lineTo(size.width * 0.7270866, size.height * 0.4758747);
    chibaPath.lineTo(size.width * 0.7270866, size.height * 0.4758747);
    chibaPath.lineTo(size.width * 0.7280470, size.height * 0.4759328);
    chibaPath.lineTo(size.width * 0.7288015, size.height * 0.4775607);
    chibaPath.lineTo(size.width * 0.7325287, size.height * 0.4814559);
    chibaPath.lineTo(size.width * 0.7341750, size.height * 0.4819210);
    chibaPath.lineTo(size.width * 0.7346323, size.height * 0.4832969);
    chibaPath.lineTo(size.width * 0.7370104, size.height * 0.4846535);
    chibaPath.lineTo(size.width * 0.7426354, size.height * 0.4863201);
    chibaPath.lineTo(size.width * 0.7439616, size.height * 0.4877154);
    chibaPath.lineTo(size.width * 0.7462939, size.height * 0.4869209);
    chibaPath.lineTo(size.width * 0.7482603, size.height * 0.4871340);
    chibaPath.lineTo(size.width * 0.7496094, size.height * 0.4863589);
    chibaPath.lineTo(size.width * 0.7514387, size.height * 0.4868046);
    chibaPath.lineTo(size.width * 0.7534052, size.height * 0.4852155);
    chibaPath.lineTo(size.width * 0.7580012, size.height * 0.4842078);
    chibaPath.lineTo(size.width * 0.7604707, size.height * 0.4852155);
    chibaPath.lineTo(size.width * 0.7625515, size.height * 0.4851380);
    chibaPath.lineTo(size.width * 0.7651353, size.height * 0.4870178);
    chibaPath.lineTo(size.width * 0.7679478, size.height * 0.4875216);
    chibaPath.lineTo(size.width * 0.7704859, size.height * 0.4904866);
    chibaPath.lineTo(size.width * 0.7762024, size.height * 0.4934710);
    chibaPath.lineTo(size.width * 0.7762024, size.height * 0.4934710);
    chibaPath.lineTo(size.width * 0.7759508, size.height * 0.4947307);
    chibaPath.lineTo(size.width * 0.7742130, size.height * 0.4937424);
    chibaPath.lineTo(size.width * 0.7707832, size.height * 0.4947113);
    chibaPath.lineTo(size.width * 0.7689539, size.height * 0.4942850);
    chibaPath.lineTo(size.width * 0.7672390, size.height * 0.4946532);
    chibaPath.lineTo(size.width * 0.7610195, size.height * 0.4986647);
    chibaPath.lineTo(size.width * 0.7578411, size.height * 0.5017072);
    chibaPath.lineTo(size.width * 0.7552801, size.height * 0.5058931);
    chibaPath.lineTo(size.width * 0.7546170, size.height * 0.5103891);
    chibaPath.lineTo(size.width * 0.7556917, size.height * 0.5127728);
    chibaPath.lineTo(size.width * 0.7542969, size.height * 0.5182959);
    chibaPath.lineTo(size.width * 0.7527649, size.height * 0.5185672);
    chibaPath.lineTo(size.width * 0.7516902, size.height * 0.5205439);
    chibaPath.lineTo(size.width * 0.7510500, size.height * 0.5207376);
    chibaPath.lineTo(size.width * 0.7461338, size.height * 0.5219392);
    chibaPath.lineTo(size.width * 0.7456079, size.height * 0.5210865);
    chibaPath.lineTo(size.width * 0.7426811, size.height * 0.5214547);
    chibaPath.lineTo(size.width * 0.7408290, size.height * 0.5235864);
    chibaPath.lineTo(size.width * 0.7363244, size.height * 0.5262220);
    chibaPath.lineTo(size.width * 0.7351582, size.height * 0.5285669);
    chibaPath.lineTo(size.width * 0.7353869, size.height * 0.5296909);
    chibaPath.lineTo(size.width * 0.7343579, size.height * 0.5308730);
    chibaPath.lineTo(size.width * 0.7319799, size.height * 0.5317063);
    chibaPath.lineTo(size.width * 0.7293046, size.height * 0.5312993);
    chibaPath.lineTo(size.width * 0.7288701, size.height * 0.5299040);
    chibaPath.lineTo(size.width * 0.7258747, size.height * 0.5286056);
    chibaPath.lineTo(size.width * 0.7259433, size.height * 0.5280436);
    chibaPath.lineTo(size.width * 0.7277726, size.height * 0.5282568);
    chibaPath.lineTo(size.width * 0.7306308, size.height * 0.5271716);
    chibaPath.lineTo(size.width * 0.7288473, size.height * 0.5239546);
    chibaPath.lineTo(size.width * 0.7298991, size.height * 0.5229856);
    chibaPath.lineTo(size.width * 0.7290759, size.height * 0.5222880);
    chibaPath.lineTo(size.width * 0.7297390, size.height * 0.5209314);
    chibaPath.lineTo(size.width * 0.7288015, size.height * 0.5198268);
    chibaPath.lineTo(size.width * 0.7288244, size.height * 0.5182183);
    chibaPath.lineTo(size.width * 0.7309281, size.height * 0.5168424);
    chibaPath.lineTo(size.width * 0.7311110, size.height * 0.5158347);
    chibaPath.lineTo(size.width * 0.7301049, size.height * 0.5143813);
    chibaPath.lineTo(size.width * 0.7302421, size.height * 0.5136255);
    chibaPath.lineTo(size.width * 0.7285272, size.height * 0.5127340);
    chibaPath.lineTo(size.width * 0.7297619, size.height * 0.5099046);
    chibaPath.close();

    Paint chibaPaint = Paint()..style = PaintingStyle.fill;
    chibaPaint.color = japanColors.chiba ?? defaultColor;
    japanCanvas.drawPath(chibaPath, chibaPaint, onTapUp: (tabdetail) {
      callback('chiba', tabdetail);
    });

    Path ehimePath = Path();
    ehimePath.moveTo(size.width * 0.3980249, size.height * 0.6061226);
    ehimePath.lineTo(size.width * 0.3985508, size.height * 0.6052893);
    ehimePath.lineTo(size.width * 0.3993511, size.height * 0.6047854);
    ehimePath.lineTo(size.width * 0.4001514, size.height * 0.6048630);
    ehimePath.lineTo(size.width * 0.4001971, size.height * 0.6044754);
    ehimePath.lineTo(size.width * 0.3995340, size.height * 0.6042235);
    ehimePath.lineTo(size.width * 0.3986651, size.height * 0.6039134);
    ehimePath.lineTo(size.width * 0.3975904, size.height * 0.6042235);
    ehimePath.lineTo(size.width * 0.3969502, size.height * 0.6046692);
    ehimePath.lineTo(size.width * 0.3959441, size.height * 0.6041847);
    ehimePath.lineTo(size.width * 0.3954868, size.height * 0.6049211);
    ehimePath.lineTo(size.width * 0.3945721, size.height * 0.6046692);
    ehimePath.lineTo(size.width * 0.3942520, size.height * 0.6042235);
    ehimePath.lineTo(size.width * 0.3932002, size.height * 0.6042235);
    ehimePath.lineTo(size.width * 0.3934974, size.height * 0.6033514);
    ehimePath.lineTo(size.width * 0.3938861, size.height * 0.6030995);
    ehimePath.lineTo(size.width * 0.3942063, size.height * 0.6029057);
    ehimePath.lineTo(size.width * 0.3949151, size.height * 0.6026731);
    ehimePath.lineTo(size.width * 0.3948465, size.height * 0.6023437);
    ehimePath.lineTo(size.width * 0.3947550, size.height * 0.6018592);
    ehimePath.lineTo(size.width * 0.3940691, size.height * 0.6019173);
    ehimePath.lineTo(size.width * 0.3935660, size.height * 0.6012003);
    ehimePath.lineTo(size.width * 0.3943663, size.height * 0.6006383);
    ehimePath.lineTo(size.width * 0.3942063, size.height * 0.5999406);
    ehimePath.lineTo(size.width * 0.3935889, size.height * 0.5998050);
    ehimePath.lineTo(size.width * 0.3943892, size.height * 0.5991848);
    ehimePath.lineTo(size.width * 0.3947550, size.height * 0.5991073);
    ehimePath.lineTo(size.width * 0.3952581, size.height * 0.5985841);
    ehimePath.lineTo(size.width * 0.3954639, size.height * 0.5976926);
    ehimePath.lineTo(size.width * 0.3949380, size.height * 0.5979446);
    ehimePath.lineTo(size.width * 0.3940233, size.height * 0.5978477);
    ehimePath.lineTo(size.width * 0.3944121, size.height * 0.5970531);
    ehimePath.lineTo(size.width * 0.3932459, size.height * 0.5972469);
    ehimePath.lineTo(size.width * 0.3924913, size.height * 0.5965493);
    ehimePath.lineTo(size.width * 0.3919654, size.height * 0.5966655);
    ehimePath.lineTo(size.width * 0.3911651, size.height * 0.5972275);
    ehimePath.lineTo(size.width * 0.3891987, size.height * 0.5983903);
    ehimePath.lineTo(size.width * 0.3880096, size.height * 0.5986616);
    ehimePath.lineTo(size.width * 0.3872551, size.height * 0.5993786);
    ehimePath.lineTo(size.width * 0.3847398, size.height * 0.6000182);
    ehimePath.lineTo(size.width * 0.3834365, size.height * 0.6010453);
    ehimePath.lineTo(size.width * 0.3830706, size.height * 0.6016460);
    ehimePath.lineTo(size.width * 0.3823618, size.height * 0.6021886);
    ehimePath.lineTo(size.width * 0.3811956, size.height * 0.6023049);
    ehimePath.lineTo(size.width * 0.3811270, size.height * 0.6018398);
    ehimePath.lineTo(size.width * 0.3819273, size.height * 0.6014135);
    ehimePath.lineTo(size.width * 0.3819502, size.height * 0.6010840);
    ehimePath.lineTo(size.width * 0.3807840, size.height * 0.6011228);
    ehimePath.lineTo(size.width * 0.3788404, size.height * 0.6024987);
    ehimePath.lineTo(size.width * 0.3776743, size.height * 0.6030995);
    ehimePath.lineTo(size.width * 0.3771026, size.height * 0.6031188);
    ehimePath.lineTo(size.width * 0.3820188, size.height * 0.5996112);
    ehimePath.lineTo(size.width * 0.3831850, size.height * 0.5990298);
    ehimePath.lineTo(size.width * 0.3846941, size.height * 0.5983322);
    ehimePath.lineTo(size.width * 0.3859974, size.height * 0.5984872);
    ehimePath.lineTo(size.width * 0.3867063, size.height * 0.5978477);
    ehimePath.lineTo(size.width * 0.3874151, size.height * 0.5975764);
    ehimePath.lineTo(size.width * 0.3884670, size.height * 0.5974989);
    ehimePath.lineTo(size.width * 0.3890157, size.height * 0.5972275);
    ehimePath.lineTo(size.width * 0.3892444, size.height * 0.5968787);
    ehimePath.lineTo(size.width * 0.3918968, size.height * 0.5958710);
    ehimePath.lineTo(size.width * 0.3938633, size.height * 0.5946307);
    ehimePath.lineTo(size.width * 0.3955782, size.height * 0.5938556);
    ehimePath.lineTo(size.width * 0.3960584, size.height * 0.5928866);
    ehimePath.lineTo(size.width * 0.3979563, size.height * 0.5909680);
    ehimePath.lineTo(size.width * 0.3993968, size.height * 0.5900766);
    ehimePath.lineTo(size.width * 0.4029410, size.height * 0.5889914);
    ehimePath.lineTo(size.width * 0.4057306, size.height * 0.5872279);
    ehimePath.lineTo(size.width * 0.4062108, size.height * 0.5867627);
    ehimePath.lineTo(size.width * 0.4070568, size.height * 0.5848636);
    ehimePath.lineTo(size.width * 0.4080858, size.height * 0.5840884);
    ehimePath.lineTo(size.width * 0.4075599, size.height * 0.5826931);
    ehimePath.lineTo(size.width * 0.4075370, size.height * 0.5807746);
    ehimePath.lineTo(size.width * 0.4079943, size.height * 0.5787591);
    ehimePath.lineTo(size.width * 0.4085431, size.height * 0.5774801);
    ehimePath.lineTo(size.width * 0.4095264, size.height * 0.5778095);
    ehimePath.lineTo(size.width * 0.4105096, size.height * 0.5772475);
    ehimePath.lineTo(size.width * 0.4112870, size.height * 0.5748833);
    ehimePath.lineTo(size.width * 0.4114471, size.height * 0.5736818);
    ehimePath.lineTo(size.width * 0.4154943, size.height * 0.5704454);
    ehimePath.lineTo(size.width * 0.4180324, size.height * 0.5701160);
    ehimePath.lineTo(size.width * 0.4178952, size.height * 0.5692439);
    ehimePath.lineTo(size.width * 0.4184897, size.height * 0.5689145);
    ehimePath.lineTo(size.width * 0.4181468, size.height * 0.5678292);
    ehimePath.lineTo(size.width * 0.4189699, size.height * 0.5666665);
    ehimePath.lineTo(size.width * 0.4206849, size.height * 0.5683525);
    ehimePath.lineTo(size.width * 0.4229257, size.height * 0.5710849);
    ehimePath.lineTo(size.width * 0.4245721, size.height * 0.5739531);
    ehimePath.lineTo(size.width * 0.4254410, size.height * 0.5751158);
    ehimePath.lineTo(size.width * 0.4257382, size.height * 0.5759491);
    ehimePath.lineTo(size.width * 0.4268815, size.height * 0.5766468);
    ehimePath.lineTo(size.width * 0.4290538, size.height * 0.5760266);
    ehimePath.lineTo(size.width * 0.4322092, size.height * 0.5753677);
    ehimePath.lineTo(size.width * 0.4330553, size.height * 0.5751740);
    ehimePath.lineTo(size.width * 0.4327809, size.height * 0.5742825);
    ehimePath.lineTo(size.width * 0.4355248, size.height * 0.5738949);
    ehimePath.lineTo(size.width * 0.4360736, size.height * 0.5733911);
    ehimePath.lineTo(size.width * 0.4369425, size.height * 0.5734880);
    ehimePath.lineTo(size.width * 0.4377885, size.height * 0.5741275);
    ehimePath.lineTo(size.width * 0.4393891, size.height * 0.5735461);
    ehimePath.lineTo(size.width * 0.4409440, size.height * 0.5737399);
    ehimePath.lineTo(size.width * 0.4420415, size.height * 0.5739337);
    ehimePath.lineTo(size.width * 0.4437107, size.height * 0.5745732);
    ehimePath.lineTo(size.width * 0.4448540, size.height * 0.5744375);
    ehimePath.lineTo(size.width * 0.4464318, size.height * 0.5734686);
    ehimePath.lineTo(size.width * 0.4468891, size.height * 0.5728097);
    ehimePath.lineTo(size.width * 0.4472092, size.height * 0.5719570);
    ehimePath.lineTo(size.width * 0.4475750, size.height * 0.5718020);
    ehimePath.lineTo(size.width * 0.4484897, size.height * 0.5712787);
    ehimePath.lineTo(size.width * 0.4484897, size.height * 0.5712787);
    ehimePath.lineTo(size.width * 0.4492443, size.height * 0.5718020);
    ehimePath.lineTo(size.width * 0.4514165, size.height * 0.5720539);
    ehimePath.lineTo(size.width * 0.4528113, size.height * 0.5727128);
    ehimePath.lineTo(size.width * 0.4528113, size.height * 0.5727128);
    ehimePath.lineTo(size.width * 0.4521482, size.height * 0.5740306);
    ehimePath.lineTo(size.width * 0.4527656, size.height * 0.5749802);
    ehimePath.lineTo(size.width * 0.4527656, size.height * 0.5769956);
    ehimePath.lineTo(size.width * 0.4522625, size.height * 0.5781777);
    ehimePath.lineTo(size.width * 0.4514851, size.height * 0.5787397);
    ehimePath.lineTo(size.width * 0.4514851, size.height * 0.5787397);
    ehimePath.lineTo(size.width * 0.4505476, size.height * 0.5787591);
    ehimePath.lineTo(size.width * 0.4490613, size.height * 0.5787397);
    ehimePath.lineTo(size.width * 0.4479866, size.height * 0.5793793);
    ehimePath.lineTo(size.width * 0.4468205, size.height * 0.5787204);
    ehimePath.lineTo(size.width * 0.4463403, size.height * 0.5787979);
    ehimePath.lineTo(size.width * 0.4450598, size.height * 0.5802901);
    ehimePath.lineTo(size.width * 0.4445796, size.height * 0.5808133);
    ehimePath.lineTo(size.width * 0.4441223, size.height * 0.5811234);
    ehimePath.lineTo(size.width * 0.4393891, size.height * 0.5812590);
    ehimePath.lineTo(size.width * 0.4375598, size.height * 0.5810071);
    ehimePath.lineTo(size.width * 0.4341986, size.height * 0.5810459);
    ehimePath.lineTo(size.width * 0.4337412, size.height * 0.5813753);
    ehimePath.lineTo(size.width * 0.4332382, size.height * 0.5827900);
    ehimePath.lineTo(size.width * 0.4328266, size.height * 0.5830032);
    ehimePath.lineTo(size.width * 0.4316376, size.height * 0.5833714);
    ehimePath.lineTo(size.width * 0.4308601, size.height * 0.5827125);
    ehimePath.lineTo(size.width * 0.4304028, size.height * 0.5827512);
    ehimePath.lineTo(size.width * 0.4298083, size.height * 0.5840884);
    ehimePath.lineTo(size.width * 0.4289166, size.height * 0.5856194);
    ehimePath.lineTo(size.width * 0.4280019, size.height * 0.5863945);
    ehimePath.lineTo(size.width * 0.4272016, size.height * 0.5873635);
    ehimePath.lineTo(size.width * 0.4270644, size.height * 0.5884294);
    ehimePath.lineTo(size.width * 0.4265614, size.height * 0.5889720);
    ehimePath.lineTo(size.width * 0.4251666, size.height * 0.5891658);
    ehimePath.lineTo(size.width * 0.4247550, size.height * 0.5904254);
    ehimePath.lineTo(size.width * 0.4241833, size.height * 0.5918401);
    ehimePath.lineTo(size.width * 0.4237489, size.height * 0.5927316);
    ehimePath.lineTo(size.width * 0.4244120, size.height * 0.5932936);
    ehimePath.lineTo(size.width * 0.4245035, size.height * 0.5943013);
    ehimePath.lineTo(size.width * 0.4236803, size.height * 0.5948245);
    ehimePath.lineTo(size.width * 0.4223769, size.height * 0.5965299);
    ehimePath.lineTo(size.width * 0.4223541, size.height * 0.5970531);
    ehimePath.lineTo(size.width * 0.4196102, size.height * 0.5977120);
    ehimePath.lineTo(size.width * 0.4191300, size.height * 0.5974601);
    ehimePath.lineTo(size.width * 0.4176208, size.height * 0.5976151);
    ehimePath.lineTo(size.width * 0.4146483, size.height * 0.5972082);
    ehimePath.lineTo(size.width * 0.4137108, size.height * 0.5974213);
    ehimePath.lineTo(size.width * 0.4129791, size.height * 0.5980027);
    ehimePath.lineTo(size.width * 0.4137794, size.height * 0.5986228);
    ehimePath.lineTo(size.width * 0.4141224, size.height * 0.6004445);
    ehimePath.lineTo(size.width * 0.4144654, size.height * 0.6008321);
    ehimePath.lineTo(size.width * 0.4149227, size.height * 0.6008321);
    ehimePath.lineTo(size.width * 0.4154486, size.height * 0.6022274);
    ehimePath.lineTo(size.width * 0.4164776, size.height * 0.6024987);
    ehimePath.lineTo(size.width * 0.4170949, size.height * 0.6031964);
    ehimePath.lineTo(size.width * 0.4171864, size.height * 0.6043010);
    ehimePath.lineTo(size.width * 0.4170035, size.height * 0.6047273);
    ehimePath.lineTo(size.width * 0.4151742, size.height * 0.6056188);
    ehimePath.lineTo(size.width * 0.4124074, size.height * 0.6064327);
    ehimePath.lineTo(size.width * 0.4116986, size.height * 0.6074404);
    ehimePath.lineTo(size.width * 0.4112870, size.height * 0.6096496);
    ehimePath.lineTo(size.width * 0.4103038, size.height * 0.6097078);
    ehimePath.lineTo(size.width * 0.4099151, size.height * 0.6099985);
    ehimePath.lineTo(size.width * 0.4095950, size.height * 0.6109093);
    ehimePath.lineTo(size.width * 0.4079715, size.height * 0.6126534);
    ehimePath.lineTo(size.width * 0.4075370, size.height * 0.6127891);
    ehimePath.lineTo(size.width * 0.4053648, size.height * 0.6110062);
    ehimePath.lineTo(size.width * 0.4051133, size.height * 0.6104829);
    ehimePath.lineTo(size.width * 0.4046559, size.height * 0.6106186);
    ehimePath.lineTo(size.width * 0.4043358, size.height * 0.6111806);
    ehimePath.lineTo(size.width * 0.4049989, size.height * 0.6123821);
    ehimePath.lineTo(size.width * 0.4049303, size.height * 0.6128860);
    ehimePath.lineTo(size.width * 0.4060050, size.height * 0.6138743);
    ehimePath.lineTo(size.width * 0.4064852, size.height * 0.6139712);
    ehimePath.lineTo(size.width * 0.4066910, size.height * 0.6145526);
    ehimePath.lineTo(size.width * 0.4062337, size.height * 0.6163355);
    ehimePath.lineTo(size.width * 0.4069197, size.height * 0.6169362);
    ehimePath.lineTo(size.width * 0.4073998, size.height * 0.6187579);
    ehimePath.lineTo(size.width * 0.4073770, size.height * 0.6213353);
    ehimePath.lineTo(size.width * 0.4064395, size.height * 0.6215291);
    ehimePath.lineTo(size.width * 0.4063251, size.height * 0.6222655);
    ehimePath.lineTo(size.width * 0.4063251, size.height * 0.6222655);
    ehimePath.lineTo(size.width * 0.4055934, size.height * 0.6220330);
    ehimePath.lineTo(size.width * 0.4034441, size.height * 0.6227113);
    ehimePath.lineTo(size.width * 0.4031239, size.height * 0.6221880);
    ehimePath.lineTo(size.width * 0.4025523, size.height * 0.6215291);
    ehimePath.lineTo(size.width * 0.4023465, size.height * 0.6211803);
    ehimePath.lineTo(size.width * 0.4012947, size.height * 0.6214904);
    ehimePath.lineTo(size.width * 0.4008602, size.height * 0.6216648);
    ehimePath.lineTo(size.width * 0.4002657, size.height * 0.6217811);
    ehimePath.lineTo(size.width * 0.4002200, size.height * 0.6223430);
    ehimePath.lineTo(size.width * 0.4002657, size.height * 0.6225950);
    ehimePath.lineTo(size.width * 0.3998313, size.height * 0.6230988);
    ehimePath.lineTo(size.width * 0.3990310, size.height * 0.6230407);
    ehimePath.lineTo(size.width * 0.3984136, size.height * 0.6230601);
    ehimePath.lineTo(size.width * 0.3978419, size.height * 0.6229826);
    ehimePath.lineTo(size.width * 0.3980249, size.height * 0.6222655);
    ehimePath.lineTo(size.width * 0.3972932, size.height * 0.6215291);
    ehimePath.lineTo(size.width * 0.3975218, size.height * 0.6212966);
    ehimePath.lineTo(size.width * 0.3983450, size.height * 0.6212191);
    ehimePath.lineTo(size.width * 0.3991453, size.height * 0.6207152);
    ehimePath.lineTo(size.width * 0.3977047, size.height * 0.6200563);
    ehimePath.lineTo(size.width * 0.3983450, size.height * 0.6196106);
    ehimePath.lineTo(size.width * 0.3988938, size.height * 0.6198819);
    ehimePath.lineTo(size.width * 0.3992367, size.height * 0.6199594);
    ehimePath.lineTo(size.width * 0.3995569, size.height * 0.6197656);
    ehimePath.lineTo(size.width * 0.3990767, size.height * 0.6190098);
    ehimePath.lineTo(size.width * 0.3993053, size.height * 0.6185060);
    ehimePath.lineTo(size.width * 0.3986194, size.height * 0.6182346);
    ehimePath.lineTo(size.width * 0.3983450, size.height * 0.6181571);
    ehimePath.lineTo(size.width * 0.3983221, size.height * 0.6165487);
    ehimePath.lineTo(size.width * 0.3976819, size.height * 0.6164711);
    ehimePath.lineTo(size.width * 0.3968816, size.height * 0.6171107);
    ehimePath.lineTo(size.width * 0.3959212, size.height * 0.6166456);
    ehimePath.lineTo(size.width * 0.3950523, size.height * 0.6169750);
    ehimePath.lineTo(size.width * 0.3947550, size.height * 0.6171300);
    ehimePath.lineTo(size.width * 0.3945493, size.height * 0.6175370);
    ehimePath.lineTo(size.width * 0.3944349, size.height * 0.6180990);
    ehimePath.lineTo(size.width * 0.3936118, size.height * 0.6177502);
    ehimePath.lineTo(size.width * 0.3943663, size.height * 0.6169750);
    ehimePath.lineTo(size.width * 0.3944121, size.height * 0.6162386);
    ehimePath.lineTo(size.width * 0.3947550, size.height * 0.6155603);
    ehimePath.lineTo(size.width * 0.3952581, size.height * 0.6154634);
    ehimePath.lineTo(size.width * 0.3957154, size.height * 0.6156766);
    ehimePath.lineTo(size.width * 0.3960355, size.height * 0.6163355);
    ehimePath.lineTo(size.width * 0.3967901, size.height * 0.6162192);
    ehimePath.lineTo(size.width * 0.3980935, size.height * 0.6157929);
    ehimePath.lineTo(size.width * 0.3983907, size.height * 0.6152696);
    ehimePath.lineTo(size.width * 0.3977047, size.height * 0.6150371);
    ehimePath.lineTo(size.width * 0.3981849, size.height * 0.6142813);
    ehimePath.lineTo(size.width * 0.3990538, size.height * 0.6131185);
    ehimePath.lineTo(size.width * 0.3990081, size.height * 0.6124790);
    ehimePath.lineTo(size.width * 0.3981163, size.height * 0.6123046);
    ehimePath.lineTo(size.width * 0.3977733, size.height * 0.6123240);
    ehimePath.lineTo(size.width * 0.3972703, size.height * 0.6124790);
    ehimePath.lineTo(size.width * 0.3969273, size.height * 0.6127309);
    ehimePath.lineTo(size.width * 0.3964243, size.height * 0.6124596);
    ehimePath.lineTo(size.width * 0.3965386, size.height * 0.6119752);
    ehimePath.lineTo(size.width * 0.3957154, size.height * 0.6116457);
    ehimePath.lineTo(size.width * 0.3960584, size.height * 0.6110062);
    ehimePath.lineTo(size.width * 0.3967215, size.height * 0.6103279);
    ehimePath.lineTo(size.width * 0.3955325, size.height * 0.6092427);
    ehimePath.lineTo(size.width * 0.3966986, size.height * 0.6096303);
    ehimePath.lineTo(size.width * 0.3982764, size.height * 0.6102892);
    ehimePath.lineTo(size.width * 0.3989395, size.height * 0.6109287);
    ehimePath.lineTo(size.width * 0.3997398, size.height * 0.6109674);
    ehimePath.lineTo(size.width * 0.3995569, size.height * 0.6102504);
    ehimePath.lineTo(size.width * 0.3990995, size.height * 0.6094558);
    ehimePath.lineTo(size.width * 0.3998084, size.height * 0.6089326);
    ehimePath.lineTo(size.width * 0.4010889, size.height * 0.6090101);
    ehimePath.lineTo(size.width * 0.4016148, size.height * 0.6089520);
    ehimePath.lineTo(size.width * 0.4018206, size.height * 0.6086419);
    ehimePath.lineTo(size.width * 0.4015005, size.height * 0.6079830);
    ehimePath.lineTo(size.width * 0.4008602, size.height * 0.6080605);
    ehimePath.lineTo(size.width * 0.3999913, size.height * 0.6074016);
    ehimePath.lineTo(size.width * 0.4008831, size.height * 0.6069947);
    ehimePath.lineTo(size.width * 0.4009745, size.height * 0.6063939);
    ehimePath.lineTo(size.width * 0.3991453, size.height * 0.6064908);
    ehimePath.lineTo(size.width * 0.3980249, size.height * 0.6061226);
    ehimePath.close();

    Paint ehimePaint = Paint()..style = PaintingStyle.fill;
    ehimePaint.color = japanColors.ehime ?? defaultColor;
    japanCanvas.drawPath(ehimePath, ehimePaint, onTapUp: (tabdetail) {
      callback('ehime', tabdetail);
    });

    Path fukuiPath = Path();
    fukuiPath.moveTo(size.width * 0.5448004, size.height * 0.5003507);
    fukuiPath.lineTo(size.width * 0.5474529, size.height * 0.5017460);
    fukuiPath.lineTo(size.width * 0.5476129, size.height * 0.5024824);
    fukuiPath.lineTo(size.width * 0.5483218, size.height * 0.5024049);
    fukuiPath.lineTo(size.width * 0.5492821, size.height * 0.5019010);
    fukuiPath.lineTo(size.width * 0.5477959, size.height * 0.5003313);
    fukuiPath.lineTo(size.width * 0.5482532, size.height * 0.5000794);
    fukuiPath.lineTo(size.width * 0.5494879, size.height * 0.5007770);
    fukuiPath.lineTo(size.width * 0.5503340, size.height * 0.4995174);
    fukuiPath.lineTo(size.width * 0.5490077, size.height * 0.4986453);
    fukuiPath.lineTo(size.width * 0.5484361, size.height * 0.4970174);
    fukuiPath.lineTo(size.width * 0.5497852, size.height * 0.4973081);
    fukuiPath.lineTo(size.width * 0.5507684, size.height * 0.4986453);
    fukuiPath.lineTo(size.width * 0.5525062, size.height * 0.4978701);
    fukuiPath.lineTo(size.width * 0.5528492, size.height * 0.4985484);
    fukuiPath.lineTo(size.width * 0.5556388, size.height * 0.4978508);
    fukuiPath.lineTo(size.width * 0.5561647, size.height * 0.4970174);
    fukuiPath.lineTo(size.width * 0.5555931, size.height * 0.4963973);
    fukuiPath.lineTo(size.width * 0.5557303, size.height * 0.4945563);
    fukuiPath.lineTo(size.width * 0.5547471, size.height * 0.4932385);
    fukuiPath.lineTo(size.width * 0.5575824, size.height * 0.4913199);
    fukuiPath.lineTo(size.width * 0.5584742, size.height * 0.4924827);
    fukuiPath.lineTo(size.width * 0.5579483, size.height * 0.4952539);
    fukuiPath.lineTo(size.width * 0.5587714, size.height * 0.4963004);
    fukuiPath.lineTo(size.width * 0.5601434, size.height * 0.4960872);
    fukuiPath.lineTo(size.width * 0.5612410, size.height * 0.4931416);
    fukuiPath.lineTo(size.width * 0.5612867, size.height * 0.4906611);
    fukuiPath.lineTo(size.width * 0.5599833, size.height * 0.4884712);
    fukuiPath.lineTo(size.width * 0.5565077, size.height * 0.4855256);
    fukuiPath.lineTo(size.width * 0.5566907, size.height * 0.4833938);
    fukuiPath.lineTo(size.width * 0.5548843, size.height * 0.4810877);
    fukuiPath.lineTo(size.width * 0.5573080, size.height * 0.4786265);
    fukuiPath.lineTo(size.width * 0.5581083, size.height * 0.4757390);
    fukuiPath.lineTo(size.width * 0.5629102, size.height * 0.4697508);
    fukuiPath.lineTo(size.width * 0.5623614, size.height * 0.4684718);
    fukuiPath.lineTo(size.width * 0.5643050, size.height * 0.4684718);
    fukuiPath.lineTo(size.width * 0.5678034, size.height * 0.4663595);
    fukuiPath.lineTo(size.width * 0.5678034, size.height * 0.4663595);
    fukuiPath.lineTo(size.width * 0.5716449, size.height * 0.4694408);
    fukuiPath.lineTo(size.width * 0.5722165, size.height * 0.4718632);
    fukuiPath.lineTo(size.width * 0.5731540, size.height * 0.4725996);
    fukuiPath.lineTo(size.width * 0.5752120, size.height * 0.4723477);
    fukuiPath.lineTo(size.width * 0.5766982, size.height * 0.4738205);
    fukuiPath.lineTo(size.width * 0.5777729, size.height * 0.4739174);
    fukuiPath.lineTo(size.width * 0.5817744, size.height * 0.4731035);
    fukuiPath.lineTo(size.width * 0.5860275, size.height * 0.4759328);
    fukuiPath.lineTo(size.width * 0.5865763, size.height * 0.4771343);
    fukuiPath.lineTo(size.width * 0.5908979, size.height * 0.4762041);
    fukuiPath.lineTo(size.width * 0.5908979, size.height * 0.4762041);
    fukuiPath.lineTo(size.width * 0.5913781, size.height * 0.4771537);
    fukuiPath.lineTo(size.width * 0.5902577, size.height * 0.4778707);
    fukuiPath.lineTo(size.width * 0.5896860, size.height * 0.4805645);
    fukuiPath.lineTo(size.width * 0.5908293, size.height * 0.4812815);
    fukuiPath.lineTo(size.width * 0.5907150, size.height * 0.4823086);
    fukuiPath.lineTo(size.width * 0.5925214, size.height * 0.4828512);
    fukuiPath.lineTo(size.width * 0.5922241, size.height * 0.4838008);
    fukuiPath.lineTo(size.width * 0.5936875, size.height * 0.4848279);
    fukuiPath.lineTo(size.width * 0.5943735, size.height * 0.4871922);
    fukuiPath.lineTo(size.width * 0.5929330, size.height * 0.4880836);
    fukuiPath.lineTo(size.width * 0.5925442, size.height * 0.4895952);
    fukuiPath.lineTo(size.width * 0.5894802, size.height * 0.4895564);
    fukuiPath.lineTo(size.width * 0.5868964, size.height * 0.4905060);
    fukuiPath.lineTo(size.width * 0.5859360, size.height * 0.4894983);
    fukuiPath.lineTo(size.width * 0.5848842, size.height * 0.4903704);
    fukuiPath.lineTo(size.width * 0.5836952, size.height * 0.4900409);
    fukuiPath.lineTo(size.width * 0.5825747, size.height * 0.4908936);
    fukuiPath.lineTo(size.width * 0.5806997, size.height * 0.4904866);
    fukuiPath.lineTo(size.width * 0.5794193, size.height * 0.4919788);
    fukuiPath.lineTo(size.width * 0.5787333, size.height * 0.4909905);
    fukuiPath.lineTo(size.width * 0.5763095, size.height * 0.4910293);
    fukuiPath.lineTo(size.width * 0.5736342, size.height * 0.4902153);
    fukuiPath.lineTo(size.width * 0.5715763, size.height * 0.4911455);
    fukuiPath.lineTo(size.width * 0.5715534, size.height * 0.4930253);
    fukuiPath.lineTo(size.width * 0.5692897, size.height * 0.4962035);
    fukuiPath.lineTo(size.width * 0.5692897, size.height * 0.4962035);
    fukuiPath.lineTo(size.width * 0.5651510, size.height * 0.4943819);
    fukuiPath.lineTo(size.width * 0.5636190, size.height * 0.4946338);
    fukuiPath.lineTo(size.width * 0.5629102, size.height * 0.4959322);
    fukuiPath.lineTo(size.width * 0.5648080, size.height * 0.4993430);
    fukuiPath.lineTo(size.width * 0.5645108, size.height * 0.5007964);
    fukuiPath.lineTo(size.width * 0.5619955, size.height * 0.5001763);
    fukuiPath.lineTo(size.width * 0.5611952, size.height * 0.5022498);
    fukuiPath.lineTo(size.width * 0.5582455, size.height * 0.5025018);
    fukuiPath.lineTo(size.width * 0.5572166, size.height * 0.5041878);
    fukuiPath.lineTo(size.width * 0.5561647, size.height * 0.5043816);
    fukuiPath.lineTo(size.width * 0.5544041, size.height * 0.5028894);
    fukuiPath.lineTo(size.width * 0.5520260, size.height * 0.5082574);
    fukuiPath.lineTo(size.width * 0.5507227, size.height * 0.5088000);
    fukuiPath.lineTo(size.width * 0.5499224, size.height * 0.5080249);
    fukuiPath.lineTo(size.width * 0.5484132, size.height * 0.5080055);
    fukuiPath.lineTo(size.width * 0.5482989, size.height * 0.5089744);
    fukuiPath.lineTo(size.width * 0.5474529, size.height * 0.5091682);
    fukuiPath.lineTo(size.width * 0.5464239, size.height * 0.5106023);
    fukuiPath.lineTo(size.width * 0.5464239, size.height * 0.5106023);
    fukuiPath.lineTo(size.width * 0.5432913, size.height * 0.5111062);
    fukuiPath.lineTo(size.width * 0.5398386, size.height * 0.5099628);
    fukuiPath.lineTo(size.width * 0.5358828, size.height * 0.5095946);
    fukuiPath.lineTo(size.width * 0.5355855, size.height * 0.5079086);
    fukuiPath.lineTo(size.width * 0.5325901, size.height * 0.5055637);
    fukuiPath.lineTo(size.width * 0.5332532, size.height * 0.5036258);
    fukuiPath.lineTo(size.width * 0.5320642, size.height * 0.5028118);
    fukuiPath.lineTo(size.width * 0.5330017, size.height * 0.5010677);
    fukuiPath.lineTo(size.width * 0.5330017, size.height * 0.5010677);
    fukuiPath.lineTo(size.width * 0.5350139, size.height * 0.5013972);
    fukuiPath.lineTo(size.width * 0.5345337, size.height * 0.5035095);
    fukuiPath.lineTo(size.width * 0.5349453, size.height * 0.5039940);
    fukuiPath.lineTo(size.width * 0.5408447, size.height * 0.5047498);
    fukuiPath.lineTo(size.width * 0.5449148, size.height * 0.5040134);
    fukuiPath.lineTo(size.width * 0.5455321, size.height * 0.5023080);
    fukuiPath.lineTo(size.width * 0.5440459, size.height * 0.5028312);
    fukuiPath.lineTo(size.width * 0.5439773, size.height * 0.5018623);
    fukuiPath.lineTo(size.width * 0.5426739, size.height * 0.5016491);
    fukuiPath.lineTo(size.width * 0.5438629, size.height * 0.5005057);
    fukuiPath.lineTo(size.width * 0.5448004, size.height * 0.5003507);
    fukuiPath.close();

    Paint fukuiPaint = Paint()..style = PaintingStyle.fill;
    fukuiPaint.color = japanColors.fukui ?? defaultColor;
    japanCanvas.drawPath(fukuiPath, fukuiPaint, onTapUp: (tabdetail) {
      callback('fukui', tabdetail);
    });

    Path fukuokaPath = Path();
    fukuokaPath.moveTo(size.width * 0.3044351, size.height * 0.5873441);
    fukuokaPath.lineTo(size.width * 0.3072705, size.height * 0.5847279);
    fukuokaPath.lineTo(size.width * 0.3075906, size.height * 0.5835652);
    fukuokaPath.lineTo(size.width * 0.3073162, size.height * 0.5828675);
    fukuokaPath.lineTo(size.width * 0.3065616, size.height * 0.5828869);
    fukuokaPath.lineTo(size.width * 0.3064245, size.height * 0.5815691);
    fukuokaPath.lineTo(size.width * 0.3077049, size.height * 0.5814722);
    fukuokaPath.lineTo(size.width * 0.3082766, size.height * 0.5799025);
    fukuokaPath.lineTo(size.width * 0.3102202, size.height * 0.5788948);
    fukuokaPath.lineTo(size.width * 0.3100373, size.height * 0.5781390);
    fukuokaPath.lineTo(size.width * 0.3118208, size.height * 0.5780808);
    fukuokaPath.lineTo(size.width * 0.3123924, size.height * 0.5786622);
    fukuokaPath.lineTo(size.width * 0.3147705, size.height * 0.5784491);
    fukuokaPath.lineTo(size.width * 0.3163253, size.height * 0.5776739);
    fukuokaPath.lineTo(size.width * 0.3179488, size.height * 0.5758522);
    fukuokaPath.lineTo(size.width * 0.3204641, size.height * 0.5767243);
    fukuokaPath.lineTo(size.width * 0.3214930, size.height * 0.5760654);
    fukuokaPath.lineTo(size.width * 0.3255860, size.height * 0.5768212);
    fukuokaPath.lineTo(size.width * 0.3265692, size.height * 0.5779452);
    fukuokaPath.lineTo(size.width * 0.3282613, size.height * 0.5774026);
    fukuokaPath.lineTo(size.width * 0.3289930, size.height * 0.5759104);
    fukuokaPath.lineTo(size.width * 0.3316454, size.height * 0.5744375);
    fukuokaPath.lineTo(size.width * 0.3325601, size.height * 0.5750383);
    fukuokaPath.lineTo(size.width * 0.3309137, size.height * 0.5776545);
    fukuokaPath.lineTo(size.width * 0.3313024, size.height * 0.5795149);
    fukuokaPath.lineTo(size.width * 0.3294960, size.height * 0.5808715);
    fukuokaPath.lineTo(size.width * 0.3299991, size.height * 0.5817629);
    fukuokaPath.lineTo(size.width * 0.3315082, size.height * 0.5815110);
    fukuokaPath.lineTo(size.width * 0.3327659, size.height * 0.5864139);
    fukuokaPath.lineTo(size.width * 0.3359671, size.height * 0.5904836);
    fukuokaPath.lineTo(size.width * 0.3372476, size.height * 0.5899409);
    fukuokaPath.lineTo(size.width * 0.3397171, size.height * 0.5914138);
    fukuokaPath.lineTo(size.width * 0.3397171, size.height * 0.5914138);
    fukuokaPath.lineTo(size.width * 0.3393741, size.height * 0.5921308);
    fukuokaPath.lineTo(size.width * 0.3400600, size.height * 0.5936811);
    fukuokaPath.lineTo(size.width * 0.3391683, size.height * 0.5946889);
    fukuokaPath.lineTo(size.width * 0.3394655, size.height * 0.5955803);
    fukuokaPath.lineTo(size.width * 0.3350982, size.height * 0.5957935);
    fukuokaPath.lineTo(size.width * 0.3328802, size.height * 0.5952702);
    fukuokaPath.lineTo(size.width * 0.3307537, size.height * 0.5957160);
    fukuokaPath.lineTo(size.width * 0.3270723, size.height * 0.5983903);
    fukuokaPath.lineTo(size.width * 0.3263863, size.height * 0.6015879);
    fukuokaPath.lineTo(size.width * 0.3252659, size.height * 0.6018398);
    fukuokaPath.lineTo(size.width * 0.3241912, size.height * 0.6031770);
    fukuokaPath.lineTo(size.width * 0.3248772, size.height * 0.6034870);
    fukuokaPath.lineTo(size.width * 0.3255403, size.height * 0.6053281);
    fukuokaPath.lineTo(size.width * 0.3252201, size.height * 0.6065683);
    fukuokaPath.lineTo(size.width * 0.3240311, size.height * 0.6070722);
    fukuokaPath.lineTo(size.width * 0.3237567, size.height * 0.6078086);
    fukuokaPath.lineTo(size.width * 0.3245799, size.height * 0.6081768);
    fukuokaPath.lineTo(size.width * 0.3245113, size.height * 0.6093783);
    fukuokaPath.lineTo(size.width * 0.3264320, size.height * 0.6107930);
    fukuokaPath.lineTo(size.width * 0.3253345, size.height * 0.6134674);
    fukuokaPath.lineTo(size.width * 0.3245342, size.height * 0.6139518);
    fukuokaPath.lineTo(size.width * 0.3245342, size.height * 0.6139518);
    fukuokaPath.lineTo(size.width * 0.3210357, size.height * 0.6129441);
    fukuokaPath.lineTo(size.width * 0.3195037, size.height * 0.6117620);
    fukuokaPath.lineTo(size.width * 0.3176516, size.height * 0.6118395);
    fukuokaPath.lineTo(size.width * 0.3172857, size.height * 0.6110643);
    fukuokaPath.lineTo(size.width * 0.3160738, size.height * 0.6138549);
    fukuokaPath.lineTo(size.width * 0.3126440, size.height * 0.6135255);
    fukuokaPath.lineTo(size.width * 0.3089397, size.height * 0.6164130);
    fukuokaPath.lineTo(size.width * 0.3093513, size.height * 0.6184866);
    fukuokaPath.lineTo(size.width * 0.3044580, size.height * 0.6183315);
    fukuokaPath.lineTo(size.width * 0.3044580, size.height * 0.6183315);
    fukuokaPath.lineTo(size.width * 0.3055556, size.height * 0.6161998);
    fukuokaPath.lineTo(size.width * 0.3048238, size.height * 0.6146495);
    fukuokaPath.lineTo(size.width * 0.3031318, size.height * 0.6131379);
    fukuokaPath.lineTo(size.width * 0.3032004, size.height * 0.6123434);
    fukuokaPath.lineTo(size.width * 0.3023543, size.height * 0.6119752);
    fukuokaPath.lineTo(size.width * 0.3023543, size.height * 0.6119752);
    fukuokaPath.lineTo(size.width * 0.3027431, size.height * 0.6095915);
    fukuokaPath.lineTo(size.width * 0.3040921, size.height * 0.6075761);
    fukuokaPath.lineTo(size.width * 0.3083223, size.height * 0.6048242);
    fukuokaPath.lineTo(size.width * 0.3094885, size.height * 0.6031576);
    fukuokaPath.lineTo(size.width * 0.3106546, size.height * 0.6032157);
    fukuokaPath.lineTo(size.width * 0.3107004, size.height * 0.5988554);
    fukuokaPath.lineTo(size.width * 0.3097629, size.height * 0.5984484);
    fukuokaPath.lineTo(size.width * 0.3080708, size.height * 0.5989329);
    fukuokaPath.lineTo(size.width * 0.3058071, size.height * 0.6007739);
    fukuokaPath.lineTo(size.width * 0.3043894, size.height * 0.5993980);
    fukuokaPath.lineTo(size.width * 0.3026287, size.height * 0.5990686);
    fukuokaPath.lineTo(size.width * 0.2987415, size.height * 0.5969950);
    fukuokaPath.lineTo(size.width * 0.2976440, size.height * 0.5974213);
    fukuokaPath.lineTo(size.width * 0.2956775, size.height * 0.5969562);
    fukuokaPath.lineTo(size.width * 0.2940998, size.height * 0.5975764);
    fukuokaPath.lineTo(size.width * 0.2880861, size.height * 0.5974213);
    fukuokaPath.lineTo(size.width * 0.2880861, size.height * 0.5974213);
    fukuokaPath.lineTo(size.width * 0.2884291, size.height * 0.5961035);
    fukuokaPath.lineTo(size.width * 0.2921105, size.height * 0.5954834);
    fukuokaPath.lineTo(size.width * 0.2933452, size.height * 0.5942431);
    fukuokaPath.lineTo(size.width * 0.2937797, size.height * 0.5931773);
    fukuokaPath.lineTo(size.width * 0.2928193, size.height * 0.5937587);
    fukuokaPath.lineTo(size.width * 0.2924763, size.height * 0.5928866);
    fukuokaPath.lineTo(size.width * 0.2918589, size.height * 0.5925765);
    fukuokaPath.lineTo(size.width * 0.2908300, size.height * 0.5930416);
    fukuokaPath.lineTo(size.width * 0.2903269, size.height * 0.5922665);
    fukuokaPath.lineTo(size.width * 0.2930480, size.height * 0.5915882);
    fukuokaPath.lineTo(size.width * 0.2937111, size.height * 0.5908518);
    fukuokaPath.lineTo(size.width * 0.2934367, size.height * 0.5901154);
    fukuokaPath.lineTo(size.width * 0.2953803, size.height * 0.5895340);
    fukuokaPath.lineTo(size.width * 0.2957233, size.height * 0.5883518);
    fukuokaPath.lineTo(size.width * 0.2970723, size.height * 0.5891270);
    fukuokaPath.lineTo(size.width * 0.2965007, size.height * 0.5898440);
    fukuokaPath.lineTo(size.width * 0.2969123, size.height * 0.5906580);
    fukuokaPath.lineTo(size.width * 0.2987873, size.height * 0.5909293);
    fukuokaPath.lineTo(size.width * 0.2990388, size.height * 0.5922858);
    fukuokaPath.lineTo(size.width * 0.3001364, size.height * 0.5921308);
    fukuokaPath.lineTo(size.width * 0.3005022, size.height * 0.5914719);
    fukuokaPath.lineTo(size.width * 0.3020114, size.height * 0.5916076);
    fukuokaPath.lineTo(size.width * 0.3043894, size.height * 0.5906580);
    fukuokaPath.lineTo(size.width * 0.3046638, size.height * 0.5890301);
    fukuokaPath.lineTo(size.width * 0.3059671, size.height * 0.5885844);
    fukuokaPath.lineTo(size.width * 0.3057842, size.height * 0.5874216);
    fukuokaPath.lineTo(size.width * 0.3044351, size.height * 0.5873441);
    fukuokaPath.close();

    Paint fukuokaPaint = Paint()..style = PaintingStyle.fill;
    fukuokaPaint.color = japanColors.fukuoka ?? defaultColor;
    japanCanvas.drawPath(fukuokaPath, fukuokaPaint, onTapUp: (tabdetail) {
      callback('fukuoka', tabdetail);
    });

    Path fukushimaPath = Path();
    fukushimaPath.moveTo(size.width * 0.7806612, size.height * 0.4336085);
    fukushimaPath.lineTo(size.width * 0.7792435, size.height * 0.4351783);
    fukushimaPath.lineTo(size.width * 0.7735499, size.height * 0.4374844);
    fukushimaPath.lineTo(size.width * 0.7726582, size.height * 0.4387634);
    fukushimaPath.lineTo(size.width * 0.7727496, size.height * 0.4396936);
    fukushimaPath.lineTo(size.width * 0.7727496, size.height * 0.4396936);
    fukushimaPath.lineTo(size.width * 0.7649067, size.height * 0.4376782);
    fukushimaPath.lineTo(size.width * 0.7636033, size.height * 0.4356821);
    fukushimaPath.lineTo(size.width * 0.7628259, size.height * 0.4365736);
    fukushimaPath.lineTo(size.width * 0.7638777, size.height * 0.4390929);
    fukushimaPath.lineTo(size.width * 0.7613167, size.height * 0.4400425);
    fukushimaPath.lineTo(size.width * 0.7579783, size.height * 0.4427555);
    fukushimaPath.lineTo(size.width * 0.7569951, size.height * 0.4416509);
    fukushimaPath.lineTo(size.width * 0.7543884, size.height * 0.4408370);
    fukushimaPath.lineTo(size.width * 0.7536338, size.height * 0.4385890);
    fukushimaPath.lineTo(size.width * 0.7517588, size.height * 0.4381045);
    fukushimaPath.lineTo(size.width * 0.7500210, size.height * 0.4361278);
    fukushimaPath.lineTo(size.width * 0.7487634, size.height * 0.4360697);
    fukushimaPath.lineTo(size.width * 0.7487634, size.height * 0.4360697);
    fukushimaPath.lineTo(size.width * 0.7480088, size.height * 0.4354302);
    fukushimaPath.lineTo(size.width * 0.7483747, size.height * 0.4318257);
    fukushimaPath.lineTo(size.width * 0.7464311, size.height * 0.4319225);
    fukushimaPath.lineTo(size.width * 0.7459052, size.height * 0.4301009);
    fukushimaPath.lineTo(size.width * 0.7435729, size.height * 0.4282017);
    fukushimaPath.lineTo(size.width * 0.7381079, size.height * 0.4262638);
    fukushimaPath.lineTo(size.width * 0.7325973, size.height * 0.4257212);
    fukushimaPath.lineTo(size.width * 0.7294875, size.height * 0.4268646);
    fukushimaPath.lineTo(size.width * 0.7290759, size.height * 0.4286281);
    fukushimaPath.lineTo(size.width * 0.7226964, size.height * 0.4303141);
    fukushimaPath.lineTo(size.width * 0.7221019, size.height * 0.4311280);
    fukushimaPath.lineTo(size.width * 0.7202955, size.height * 0.4314962);
    fukushimaPath.lineTo(size.width * 0.7197696, size.height * 0.4323489);
    fukushimaPath.lineTo(size.width * 0.7183290, size.height * 0.4325233);
    fukushimaPath.lineTo(size.width * 0.7162254, size.height * 0.4339574);
    fukushimaPath.lineTo(size.width * 0.7131156, size.height * 0.4344225);
    fukushimaPath.lineTo(size.width * 0.7114921, size.height * 0.4363992);
    fukushimaPath.lineTo(size.width * 0.7093428, size.height * 0.4372325);
    fukushimaPath.lineTo(size.width * 0.7093428, size.height * 0.4372325);
    fukushimaPath.lineTo(size.width * 0.7040836, size.height * 0.4358372);
    fukushimaPath.lineTo(size.width * 0.7028946, size.height * 0.4362247);
    fukushimaPath.lineTo(size.width * 0.7028717, size.height * 0.4355077);
    fukushimaPath.lineTo(size.width * 0.7028717, size.height * 0.4355077);
    fukushimaPath.lineTo(size.width * 0.7034205, size.height * 0.4346938);
    fukushimaPath.lineTo(size.width * 0.7031690, size.height * 0.4320970);
    fukushimaPath.lineTo(size.width * 0.7036720, size.height * 0.4305854);
    fukushimaPath.lineTo(size.width * 0.7027117, size.height * 0.4278917);
    fukushimaPath.lineTo(size.width * 0.7035120, size.height * 0.4254111);
    fukushimaPath.lineTo(size.width * 0.7024373, size.height * 0.4236089);
    fukushimaPath.lineTo(size.width * 0.7008824, size.height * 0.4232988);
    fukushimaPath.lineTo(size.width * 0.6995333, size.height * 0.4217484);
    fukushimaPath.lineTo(size.width * 0.7017513, size.height * 0.4190353);
    fukushimaPath.lineTo(size.width * 0.7022086, size.height * 0.4167874);
    fukushimaPath.lineTo(size.width * 0.7025287, size.height * 0.4144812);
    fukushimaPath.lineTo(size.width * 0.7009967, size.height * 0.4133960);
    fukushimaPath.lineTo(size.width * 0.7023001, size.height * 0.4116131);
    fukushimaPath.lineTo(size.width * 0.7072162, size.height * 0.4111480);
    fukushimaPath.lineTo(size.width * 0.7084739, size.height * 0.4105860);
    fukushimaPath.lineTo(size.width * 0.7100287, size.height * 0.4110511);
    fukushimaPath.lineTo(size.width * 0.7107604, size.height * 0.4087450);
    fukushimaPath.lineTo(size.width * 0.7116979, size.height * 0.4084349);
    fukushimaPath.lineTo(size.width * 0.7127726, size.height * 0.4083574);
    fukushimaPath.lineTo(size.width * 0.7136644, size.height * 0.4089775);
    fukushimaPath.lineTo(size.width * 0.7145104, size.height * 0.4085124);
    fukushimaPath.lineTo(size.width * 0.7173915, size.height * 0.4089388);
    fukushimaPath.lineTo(size.width * 0.7184891, size.height * 0.4084930);
    fukushimaPath.lineTo(size.width * 0.7176202, size.height * 0.4069039);
    fukushimaPath.lineTo(size.width * 0.7178260, size.height * 0.4053342);
    fukushimaPath.lineTo(size.width * 0.7168656, size.height * 0.4033382);
    fukushimaPath.lineTo(size.width * 0.7169342, size.height * 0.4019235);
    fukushimaPath.lineTo(size.width * 0.7204327, size.height * 0.3999080);
    fukushimaPath.lineTo(size.width * 0.7201354, size.height * 0.3994429);
    fukushimaPath.lineTo(size.width * 0.7217589, size.height * 0.3969236);
    fukushimaPath.lineTo(size.width * 0.7253717, size.height * 0.3936098);
    fukushimaPath.lineTo(size.width * 0.7253717, size.height * 0.3936098);
    fukushimaPath.lineTo(size.width * 0.7271781, size.height * 0.3932609);
    fukushimaPath.lineTo(size.width * 0.7286186, size.height * 0.3945787);
    fukushimaPath.lineTo(size.width * 0.7307680, size.height * 0.3934547);
    fukushimaPath.lineTo(size.width * 0.7321628, size.height * 0.3942105);
    fukushimaPath.lineTo(size.width * 0.7336034, size.height * 0.3940749);
    fukushimaPath.lineTo(size.width * 0.7343579, size.height * 0.3933966);
    fukushimaPath.lineTo(size.width * 0.7365759, size.height * 0.3966523);
    fukushimaPath.lineTo(size.width * 0.7393884, size.height * 0.3957609);
    fukushimaPath.lineTo(size.width * 0.7427497, size.height * 0.3979313);
    fukushimaPath.lineTo(size.width * 0.7444418, size.height * 0.3968461);
    fukushimaPath.lineTo(size.width * 0.7474143, size.height * 0.3973500);
    fukushimaPath.lineTo(size.width * 0.7504555, size.height * 0.3942299);
    fukushimaPath.lineTo(size.width * 0.7491978, size.height * 0.3934354);
    fukushimaPath.lineTo(size.width * 0.7491064, size.height * 0.3895401);
    fukushimaPath.lineTo(size.width * 0.7497924, size.height * 0.3862263);
    fukushimaPath.lineTo(size.width * 0.7497924, size.height * 0.3862263);
    fukushimaPath.lineTo(size.width * 0.7529707, size.height * 0.3875053);
    fukushimaPath.lineTo(size.width * 0.7555545, size.height * 0.3864007);
    fukushimaPath.lineTo(size.width * 0.7581612, size.height * 0.3877379);
    fukushimaPath.lineTo(size.width * 0.7590073, size.height * 0.3898502);
    fukushimaPath.lineTo(size.width * 0.7650667, size.height * 0.3893270);
    fukushimaPath.lineTo(size.width * 0.7669417, size.height * 0.3898696);
    fukushimaPath.lineTo(size.width * 0.7682222, size.height * 0.3907610);
    fukushimaPath.lineTo(size.width * 0.7678106, size.height * 0.3929703);
    fukushimaPath.lineTo(size.width * 0.7684509, size.height * 0.3944237);
    fukushimaPath.lineTo(size.width * 0.7698914, size.height * 0.3953927);
    fukushimaPath.lineTo(size.width * 0.7726582, size.height * 0.3959159);
    fukushimaPath.lineTo(size.width * 0.7730011, size.height * 0.3956058);
    fukushimaPath.lineTo(size.width * 0.7719265, size.height * 0.3948500);
    fukushimaPath.lineTo(size.width * 0.7755392, size.height * 0.3949663);
    fukushimaPath.lineTo(size.width * 0.7758365, size.height * 0.3945400);
    fukushimaPath.lineTo(size.width * 0.7757679, size.height * 0.3903347);
    fukushimaPath.lineTo(size.width * 0.7774142, size.height * 0.3898114);
    fukushimaPath.lineTo(size.width * 0.7789920, size.height * 0.3901603);
    fukushimaPath.lineTo(size.width * 0.7789920, size.height * 0.3901603);
    fukushimaPath.lineTo(size.width * 0.7798609, size.height * 0.3926408);
    fukushimaPath.lineTo(size.width * 0.7814844, size.height * 0.3934741);
    fukushimaPath.lineTo(size.width * 0.7815987, size.height * 0.3959547);
    fukushimaPath.lineTo(size.width * 0.7826048, size.height * 0.3974081);
    fukushimaPath.lineTo(size.width * 0.7838624, size.height * 0.4090938);
    fukushimaPath.lineTo(size.width * 0.7838624, size.height * 0.4155083);
    fukushimaPath.lineTo(size.width * 0.7806612, size.height * 0.4336085);
    fukushimaPath.close();
    fukushimaPath.moveTo(size.width * 0.7728182, size.height * 0.4397324);
    fukushimaPath.lineTo(size.width * 0.7728182, size.height * 0.4397324);
    fukushimaPath.lineTo(size.width * 0.7728868, size.height * 0.4397518);
    fukushimaPath.lineTo(size.width * 0.7728182, size.height * 0.4397324);
    fukushimaPath.close();

    Paint fukushimaPaint = Paint()..style = PaintingStyle.fill;
    fukushimaPaint.color = japanColors.fukushima ?? defaultColor;
    japanCanvas.drawPath(fukushimaPath, fukushimaPaint, onTapUp: (tabdetail) {
      callback('fukushima', tabdetail);
    });

    Path gifuPath = Path();
    gifuPath.moveTo(size.width * 0.5756007, size.height * 0.5169587);
    gifuPath.lineTo(size.width * 0.5739543, size.height * 0.5156215);
    gifuPath.lineTo(size.width * 0.5746860, size.height * 0.5152146);
    gifuPath.lineTo(size.width * 0.5747318, size.height * 0.5134123);
    gifuPath.lineTo(size.width * 0.5754635, size.height * 0.5124046);
    gifuPath.lineTo(size.width * 0.5755549, size.height * 0.5098078);
    gifuPath.lineTo(size.width * 0.5768126, size.height * 0.5089551);
    gifuPath.lineTo(size.width * 0.5756007, size.height * 0.5073078);
    gifuPath.lineTo(size.width * 0.5758065, size.height * 0.5053699);
    gifuPath.lineTo(size.width * 0.5743659, size.height * 0.5041296);
    gifuPath.lineTo(size.width * 0.5749147, size.height * 0.5024049);
    gifuPath.lineTo(size.width * 0.5736571, size.height * 0.5010290);
    gifuPath.lineTo(size.width * 0.5729482, size.height * 0.5019979);
    gifuPath.lineTo(size.width * 0.5711647, size.height * 0.5014359);
    gifuPath.lineTo(size.width * 0.5714391, size.height * 0.4983352);
    gifuPath.lineTo(size.width * 0.5699300, size.height * 0.4981996);
    gifuPath.lineTo(size.width * 0.5693354, size.height * 0.4961260);
    gifuPath.lineTo(size.width * 0.5693354, size.height * 0.4961260);
    gifuPath.lineTo(size.width * 0.5715763, size.height * 0.4929478);
    gifuPath.lineTo(size.width * 0.5715992, size.height * 0.4910680);
    gifuPath.lineTo(size.width * 0.5736571, size.height * 0.4901378);
    gifuPath.lineTo(size.width * 0.5763324, size.height * 0.4909517);
    gifuPath.lineTo(size.width * 0.5787562, size.height * 0.4909324);
    gifuPath.lineTo(size.width * 0.5794421, size.height * 0.4919207);
    gifuPath.lineTo(size.width * 0.5807226, size.height * 0.4904285);
    gifuPath.lineTo(size.width * 0.5825976, size.height * 0.4908548);
    gifuPath.lineTo(size.width * 0.5836952, size.height * 0.4900022);
    gifuPath.lineTo(size.width * 0.5848842, size.height * 0.4903316);
    gifuPath.lineTo(size.width * 0.5859360, size.height * 0.4894789);
    gifuPath.lineTo(size.width * 0.5868735, size.height * 0.4904866);
    gifuPath.lineTo(size.width * 0.5894574, size.height * 0.4895371);
    gifuPath.lineTo(size.width * 0.5925442, size.height * 0.4895758);
    gifuPath.lineTo(size.width * 0.5929330, size.height * 0.4880642);
    gifuPath.lineTo(size.width * 0.5943506, size.height * 0.4871728);
    gifuPath.lineTo(size.width * 0.5936647, size.height * 0.4848085);
    gifuPath.lineTo(size.width * 0.5922012, size.height * 0.4838008);
    gifuPath.lineTo(size.width * 0.5924756, size.height * 0.4828512);
    gifuPath.lineTo(size.width * 0.5906692, size.height * 0.4823086);
    gifuPath.lineTo(size.width * 0.5907836, size.height * 0.4812815);
    gifuPath.lineTo(size.width * 0.5896631, size.height * 0.4805645);
    gifuPath.lineTo(size.width * 0.5902119, size.height * 0.4778707);
    gifuPath.lineTo(size.width * 0.5913552, size.height * 0.4771537);
    gifuPath.lineTo(size.width * 0.5908750, size.height * 0.4762041);
    gifuPath.lineTo(size.width * 0.5908750, size.height * 0.4762041);
    gifuPath.lineTo(size.width * 0.5920183, size.height * 0.4740918);
    gifuPath.lineTo(size.width * 0.5914924, size.height * 0.4726577);
    gifuPath.lineTo(size.width * 0.5928872, size.height * 0.4722120);
    gifuPath.lineTo(size.width * 0.5950366, size.height * 0.4689757);
    gifuPath.lineTo(size.width * 0.5949451, size.height * 0.4682199);
    gifuPath.lineTo(size.width * 0.5932073, size.height * 0.4673866);
    gifuPath.lineTo(size.width * 0.5926357, size.height * 0.4662626);
    gifuPath.lineTo(size.width * 0.5926357, size.height * 0.4662626);
    gifuPath.lineTo(size.width * 0.5939619, size.height * 0.4661075);
    gifuPath.lineTo(size.width * 0.5946250, size.height * 0.4640533);
    gifuPath.lineTo(size.width * 0.5963857, size.height * 0.4629681);
    gifuPath.lineTo(size.width * 0.5969573, size.height * 0.4641115);
    gifuPath.lineTo(size.width * 0.5977576, size.height * 0.4634138);
    gifuPath.lineTo(size.width * 0.5998613, size.height * 0.4644022);
    gifuPath.lineTo(size.width * 0.6006387, size.height * 0.4658944);
    gifuPath.lineTo(size.width * 0.6000442, size.height * 0.4673091);
    gifuPath.lineTo(size.width * 0.6008217, size.height * 0.4674641);
    gifuPath.lineTo(size.width * 0.6040000, size.height * 0.4650998);
    gifuPath.lineTo(size.width * 0.6045716, size.height * 0.4628712);
    gifuPath.lineTo(size.width * 0.6093277, size.height * 0.4589566);
    gifuPath.lineTo(size.width * 0.6105854, size.height * 0.4589178);
    gifuPath.lineTo(size.width * 0.6111570, size.height * 0.4597705);
    gifuPath.lineTo(size.width * 0.6144954, size.height * 0.4584334);
    gifuPath.lineTo(size.width * 0.6158445, size.height * 0.4585303);
    gifuPath.lineTo(size.width * 0.6159360, size.height * 0.4602356);
    gifuPath.lineTo(size.width * 0.6164161, size.height * 0.4603131);
    gifuPath.lineTo(size.width * 0.6195030, size.height * 0.4587628);
    gifuPath.lineTo(size.width * 0.6201433, size.height * 0.4602744);
    gifuPath.lineTo(size.width * 0.6227271, size.height * 0.4609527);
    gifuPath.lineTo(size.width * 0.6243506, size.height * 0.4602938);
    gifuPath.lineTo(size.width * 0.6262713, size.height * 0.4618829);
    gifuPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    gifuPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    gifuPath.lineTo(size.width * 0.6287179, size.height * 0.4630069);
    gifuPath.lineTo(size.width * 0.6310731, size.height * 0.4642859);
    gifuPath.lineTo(size.width * 0.6312789, size.height * 0.4653130);
    gifuPath.lineTo(size.width * 0.6310731, size.height * 0.4668246);
    gifuPath.lineTo(size.width * 0.6278948, size.height * 0.4703322);
    gifuPath.lineTo(size.width * 0.6287637, size.height * 0.4713981);
    gifuPath.lineTo(size.width * 0.6286493, size.height * 0.4724058);
    gifuPath.lineTo(size.width * 0.6269344, size.height * 0.4737817);
    gifuPath.lineTo(size.width * 0.6269115, size.height * 0.4753514);
    gifuPath.lineTo(size.width * 0.6279634, size.height * 0.4763204);
    gifuPath.lineTo(size.width * 0.6296097, size.height * 0.4768049);
    gifuPath.lineTo(size.width * 0.6287179, size.height * 0.4798474);
    gifuPath.lineTo(size.width * 0.6264314, size.height * 0.4813203);
    gifuPath.lineTo(size.width * 0.6255853, size.height * 0.4831031);
    gifuPath.lineTo(size.width * 0.6245792, size.height * 0.4832969);
    gifuPath.lineTo(size.width * 0.6233902, size.height * 0.4853511);
    gifuPath.lineTo(size.width * 0.6224298, size.height * 0.4854868);
    gifuPath.lineTo(size.width * 0.6216753, size.height * 0.4848473);
    gifuPath.lineTo(size.width * 0.6190457, size.height * 0.4855256);
    gifuPath.lineTo(size.width * 0.6182454, size.height * 0.4875798);
    gifuPath.lineTo(size.width * 0.6168963, size.height * 0.4880642);
    gifuPath.lineTo(size.width * 0.6166448, size.height * 0.4891107);
    gifuPath.lineTo(size.width * 0.6173079, size.height * 0.4898665);
    gifuPath.lineTo(size.width * 0.6196859, size.height * 0.4898859);
    gifuPath.lineTo(size.width * 0.6198003, size.height * 0.4908742);
    gifuPath.lineTo(size.width * 0.6226128, size.height * 0.4915913);
    gifuPath.lineTo(size.width * 0.6244420, size.height * 0.4950601);
    gifuPath.lineTo(size.width * 0.6262256, size.height * 0.4964167);
    gifuPath.lineTo(size.width * 0.6252423, size.height * 0.4988972);
    gifuPath.lineTo(size.width * 0.6261341, size.height * 0.4997693);
    gifuPath.lineTo(size.width * 0.6259740, size.height * 0.5019010);
    gifuPath.lineTo(size.width * 0.6266829, size.height * 0.5029669);
    gifuPath.lineTo(size.width * 0.6291295, size.height * 0.5023467);
    gifuPath.lineTo(size.width * 0.6304329, size.height * 0.5033932);
    gifuPath.lineTo(size.width * 0.6304329, size.height * 0.5051567);
    gifuPath.lineTo(size.width * 0.6289466, size.height * 0.5065133);
    gifuPath.lineTo(size.width * 0.6305701, size.height * 0.5084124);
    gifuPath.lineTo(size.width * 0.6285807, size.height * 0.5089744);
    gifuPath.lineTo(size.width * 0.6291752, size.height * 0.5114356);
    gifuPath.lineTo(size.width * 0.6272545, size.height * 0.5126953);
    gifuPath.lineTo(size.width * 0.6272774, size.height * 0.5137224);
    gifuPath.lineTo(size.width * 0.6272774, size.height * 0.5137224);
    gifuPath.lineTo(size.width * 0.6254481, size.height * 0.5138774);
    gifuPath.lineTo(size.width * 0.6215152, size.height * 0.5165905);
    gifuPath.lineTo(size.width * 0.6192515, size.height * 0.5156409);
    gifuPath.lineTo(size.width * 0.6192972, size.height * 0.5150208);
    gifuPath.lineTo(size.width * 0.6173765, size.height * 0.5149433);
    gifuPath.lineTo(size.width * 0.6175366, size.height * 0.5144781);
    gifuPath.lineTo(size.width * 0.6158216, size.height * 0.5135479);
    gifuPath.lineTo(size.width * 0.6143811, size.height * 0.5135867);
    gifuPath.lineTo(size.width * 0.6122774, size.height * 0.5150014);
    gifuPath.lineTo(size.width * 0.6103338, size.height * 0.5153308);
    gifuPath.lineTo(size.width * 0.6091448, size.height * 0.5139549);
    gifuPath.lineTo(size.width * 0.6069954, size.height * 0.5131991);
    gifuPath.lineTo(size.width * 0.6063094, size.height * 0.5136061);
    gifuPath.lineTo(size.width * 0.6055777, size.height * 0.5133154);
    gifuPath.lineTo(size.width * 0.6049604, size.height * 0.5126953);
    gifuPath.lineTo(size.width * 0.6051662, size.height * 0.5117457);
    gifuPath.lineTo(size.width * 0.6040457, size.height * 0.5113581);
    gifuPath.lineTo(size.width * 0.6041143, size.height * 0.5100984);
    gifuPath.lineTo(size.width * 0.6014162, size.height * 0.5084124);
    gifuPath.lineTo(size.width * 0.6014619, size.height * 0.5073272);
    gifuPath.lineTo(size.width * 0.5980549, size.height * 0.5094977);
    gifuPath.lineTo(size.width * 0.5942592, size.height * 0.5104666);
    gifuPath.lineTo(size.width * 0.5913552, size.height * 0.5101760);
    gifuPath.lineTo(size.width * 0.5874909, size.height * 0.5159510);
    gifuPath.lineTo(size.width * 0.5869878, size.height * 0.5201950);
    gifuPath.lineTo(size.width * 0.5869878, size.height * 0.5201950);
    gifuPath.lineTo(size.width * 0.5845183, size.height * 0.5199625);
    gifuPath.lineTo(size.width * 0.5806540, size.height * 0.5151177);
    gifuPath.close();

    Paint gifuPaint = Paint()..style = PaintingStyle.fill;
    gifuPaint.color = japanColors.gifu ?? defaultColor;
    japanCanvas.drawPath(gifuPath, gifuPaint, onTapUp: (tabdetail) {
      callback('gifu', tabdetail);
    });

    Path gunmaPath = Path();
    gunmaPath.moveTo(size.width * 0.7218046, size.height * 0.4700028);
    gunmaPath.lineTo(size.width * 0.7210958, size.height * 0.4711268);
    gunmaPath.lineTo(size.width * 0.7199753, size.height * 0.4714756);
    gunmaPath.lineTo(size.width * 0.7187863, size.height * 0.4705454);
    gunmaPath.lineTo(size.width * 0.7129784, size.height * 0.4714756);
    gunmaPath.lineTo(size.width * 0.7088397, size.height * 0.4688788);
    gunmaPath.lineTo(size.width * 0.7068732, size.height * 0.4692857);
    gunmaPath.lineTo(size.width * 0.7046553, size.height * 0.4687237);
    gunmaPath.lineTo(size.width * 0.7032833, size.height * 0.4690144);
    gunmaPath.lineTo(size.width * 0.6994190, size.height * 0.4673478);
    gunmaPath.lineTo(size.width * 0.6978184, size.height * 0.4672509);
    gunmaPath.lineTo(size.width * 0.6950059, size.height * 0.4710686);
    gunmaPath.lineTo(size.width * 0.6949602, size.height * 0.4728709);
    gunmaPath.lineTo(size.width * 0.6939998, size.height * 0.4743437);
    gunmaPath.lineTo(size.width * 0.6905013, size.height * 0.4744794);
    gunmaPath.lineTo(size.width * 0.6894495, size.height * 0.4759910);
    gunmaPath.lineTo(size.width * 0.6859739, size.height * 0.4767661);
    gunmaPath.lineTo(size.width * 0.6838702, size.height * 0.4787234);
    gunmaPath.lineTo(size.width * 0.6810578, size.height * 0.4787622);
    gunmaPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    gunmaPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    gunmaPath.lineTo(size.width * 0.6785197, size.height * 0.4808939);
    gunmaPath.lineTo(size.width * 0.6776965, size.height * 0.4798862);
    gunmaPath.lineTo(size.width * 0.6763017, size.height * 0.4795180);
    gunmaPath.lineTo(size.width * 0.6754328, size.height * 0.4760879);
    gunmaPath.lineTo(size.width * 0.6761873, size.height * 0.4754096);
    gunmaPath.lineTo(size.width * 0.6755471, size.height * 0.4741112);
    gunmaPath.lineTo(size.width * 0.6740608, size.height * 0.4739561);
    gunmaPath.lineTo(size.width * 0.6730547, size.height * 0.4724833);
    gunmaPath.lineTo(size.width * 0.6734206, size.height * 0.4721539);
    gunmaPath.lineTo(size.width * 0.6744724, size.height * 0.4727934);
    gunmaPath.lineTo(size.width * 0.6755014, size.height * 0.4718632);
    gunmaPath.lineTo(size.width * 0.6755700, size.height * 0.4702935);
    gunmaPath.lineTo(size.width * 0.6746096, size.height * 0.4694408);
    gunmaPath.lineTo(size.width * 0.6740837, size.height * 0.4672897);
    gunmaPath.lineTo(size.width * 0.6764389, size.height * 0.4659719);
    gunmaPath.lineTo(size.width * 0.6765989, size.height * 0.4631038);
    gunmaPath.lineTo(size.width * 0.6759358, size.height * 0.4608751);
    gunmaPath.lineTo(size.width * 0.6740380, size.height * 0.4603907);
    gunmaPath.lineTo(size.width * 0.6724373, size.height * 0.4605845);
    gunmaPath.lineTo(size.width * 0.6714313, size.height * 0.4613596);
    gunmaPath.lineTo(size.width * 0.6694191, size.height * 0.4608751);
    gunmaPath.lineTo(size.width * 0.6689389, size.height * 0.4614759);
    gunmaPath.lineTo(size.width * 0.6679557, size.height * 0.4613402);
    gunmaPath.lineTo(size.width * 0.6650974, size.height * 0.4599062);
    gunmaPath.lineTo(size.width * 0.6649602, size.height * 0.4573869);
    gunmaPath.lineTo(size.width * 0.6663322, size.height * 0.4541699);
    gunmaPath.lineTo(size.width * 0.6662864, size.height * 0.4522514);
    gunmaPath.lineTo(size.width * 0.6684816, size.height * 0.4499646);
    gunmaPath.lineTo(size.width * 0.6706767, size.height * 0.4496546);
    gunmaPath.lineTo(size.width * 0.6706995, size.height * 0.4475422);
    gunmaPath.lineTo(size.width * 0.6747925, size.height * 0.4468446);
    gunmaPath.lineTo(size.width * 0.6783367, size.height * 0.4452361);
    gunmaPath.lineTo(size.width * 0.6783367, size.height * 0.4452361);
    gunmaPath.lineTo(size.width * 0.6789084, size.height * 0.4455655);
    gunmaPath.lineTo(size.width * 0.6797315, size.height * 0.4443446);
    gunmaPath.lineTo(size.width * 0.6824754, size.height * 0.4451973);
    gunmaPath.lineTo(size.width * 0.6842818, size.height * 0.4438989);
    gunmaPath.lineTo(size.width * 0.6840532, size.height * 0.4419610);
    gunmaPath.lineTo(size.width * 0.6855166, size.height * 0.4420191);
    gunmaPath.lineTo(size.width * 0.6889236, size.height * 0.4408176);
    gunmaPath.lineTo(size.width * 0.6883519, size.height * 0.4399649);
    gunmaPath.lineTo(size.width * 0.6890151, size.height * 0.4381239);
    gunmaPath.lineTo(size.width * 0.6909586, size.height * 0.4383371);
    gunmaPath.lineTo(size.width * 0.6911644, size.height * 0.4378332);
    gunmaPath.lineTo(size.width * 0.6905471, size.height * 0.4340930);
    gunmaPath.lineTo(size.width * 0.6942971, size.height * 0.4335504);
    gunmaPath.lineTo(size.width * 0.6961720, size.height * 0.4321357);
    gunmaPath.lineTo(size.width * 0.6964464, size.height * 0.4302947);
    gunmaPath.lineTo(size.width * 0.6999678, size.height * 0.4332985);
    gunmaPath.lineTo(size.width * 0.7002193, size.height * 0.4347713);
    gunmaPath.lineTo(size.width * 0.7023230, size.height * 0.4349070);
    gunmaPath.lineTo(size.width * 0.7028489, size.height * 0.4355658);
    gunmaPath.lineTo(size.width * 0.7028489, size.height * 0.4355658);
    gunmaPath.lineTo(size.width * 0.7028717, size.height * 0.4362829);
    gunmaPath.lineTo(size.width * 0.7040608, size.height * 0.4358953);
    gunmaPath.lineTo(size.width * 0.7093199, size.height * 0.4372712);
    gunmaPath.lineTo(size.width * 0.7093199, size.height * 0.4372712);
    gunmaPath.lineTo(size.width * 0.7079937, size.height * 0.4402556);
    gunmaPath.lineTo(size.width * 0.7103260, size.height * 0.4411083);
    gunmaPath.lineTo(size.width * 0.7079937, size.height * 0.4438408);
    gunmaPath.lineTo(size.width * 0.7086339, size.height * 0.4461082);
    gunmaPath.lineTo(size.width * 0.7072848, size.height * 0.4478329);
    gunmaPath.lineTo(size.width * 0.7068732, size.height * 0.4504879);
    gunmaPath.lineTo(size.width * 0.7102345, size.height * 0.4519219);
    gunmaPath.lineTo(size.width * 0.7130470, size.height * 0.4517863);
    gunmaPath.lineTo(size.width * 0.7138244, size.height * 0.4531041);
    gunmaPath.lineTo(size.width * 0.7119495, size.height * 0.4543637);
    gunmaPath.lineTo(size.width * 0.7110348, size.height * 0.4566892);
    gunmaPath.lineTo(size.width * 0.7117894, size.height * 0.4581621);
    gunmaPath.lineTo(size.width * 0.7090684, size.height * 0.4611658);
    gunmaPath.lineTo(size.width * 0.7086568, size.height * 0.4630262);
    gunmaPath.lineTo(size.width * 0.7110577, size.height * 0.4645378);
    gunmaPath.lineTo(size.width * 0.7109662, size.height * 0.4656618);
    gunmaPath.lineTo(size.width * 0.7135043, size.height * 0.4675416);
    gunmaPath.lineTo(size.width * 0.7158138, size.height * 0.4669796);
    gunmaPath.lineTo(size.width * 0.7174372, size.height * 0.4678129);
    gunmaPath.lineTo(size.width * 0.7199753, size.height * 0.4674641);
    gunmaPath.lineTo(size.width * 0.7208443, size.height * 0.4679292);
    gunmaPath.lineTo(size.width * 0.7206385, size.height * 0.4684718);
    gunmaPath.close();

    Paint gunmaPaint = Paint()..style = PaintingStyle.fill;
    gunmaPaint.color = japanColors.gunma ?? defaultColor;
    japanCanvas.drawPath(gunmaPath, gunmaPaint, onTapUp: (tabdetail) {
      callback('gunma', tabdetail);
    });

    Path hyogoPath = Path();
    hyogoPath.moveTo(size.width * 0.4875445, size.height * 0.5378689);
    hyogoPath.lineTo(size.width * 0.4850521, size.height * 0.5396130);
    hyogoPath.lineTo(size.width * 0.4822853, size.height * 0.5391867);
    hyogoPath.lineTo(size.width * 0.4822853, size.height * 0.5391867);
    hyogoPath.lineTo(size.width * 0.4810506, size.height * 0.5365317);
    hyogoPath.lineTo(size.width * 0.4785811, size.height * 0.5346713);
    hyogoPath.lineTo(size.width * 0.4781695, size.height * 0.5337605);
    hyogoPath.lineTo(size.width * 0.4797701, size.height * 0.5312218);
    hyogoPath.lineTo(size.width * 0.4782152, size.height * 0.5295746);
    hyogoPath.lineTo(size.width * 0.4790155, size.height * 0.5289544);
    hyogoPath.lineTo(size.width * 0.4793585, size.height * 0.5271909);
    hyogoPath.lineTo(size.width * 0.4789012, size.height * 0.5260476);
    hyogoPath.lineTo(size.width * 0.4810049, size.height * 0.5250011);
    hyogoPath.lineTo(size.width * 0.4811420, size.height * 0.5231988);
    hyogoPath.lineTo(size.width * 0.4824911, size.height * 0.5227143);
    hyogoPath.lineTo(size.width * 0.4830399, size.height * 0.5205826);
    hyogoPath.lineTo(size.width * 0.4835887, size.height * 0.5200788);
    hyogoPath.lineTo(size.width * 0.4851207, size.height * 0.5202144);
    hyogoPath.lineTo(size.width * 0.4853036, size.height * 0.5187028);
    hyogoPath.lineTo(size.width * 0.4838631, size.height * 0.5174238);
    hyogoPath.lineTo(size.width * 0.4848692, size.height * 0.5158735);
    hyogoPath.lineTo(size.width * 0.4848692, size.height * 0.5158735);
    hyogoPath.lineTo(size.width * 0.4861954, size.height * 0.5163773);
    hyogoPath.lineTo(size.width * 0.4899454, size.height * 0.5141487);
    hyogoPath.lineTo(size.width * 0.4893509, size.height * 0.5119007);
    hyogoPath.lineTo(size.width * 0.4896939, size.height * 0.5110674);
    hyogoPath.lineTo(size.width * 0.4880247, size.height * 0.5092070);
    hyogoPath.lineTo(size.width * 0.4882304, size.height * 0.5071140);
    hyogoPath.lineTo(size.width * 0.4865612, size.height * 0.5064551);
    hyogoPath.lineTo(size.width * 0.4854408, size.height * 0.5028118);
    hyogoPath.lineTo(size.width * 0.4857152, size.height * 0.5008352);
    hyogoPath.lineTo(size.width * 0.4848463, size.height * 0.4993430);
    hyogoPath.lineTo(size.width * 0.4832686, size.height * 0.4983352);
    hyogoPath.lineTo(size.width * 0.4832686, size.height * 0.4983352);
    hyogoPath.lineTo(size.width * 0.4881390, size.height * 0.4970562);
    hyogoPath.lineTo(size.width * 0.4909286, size.height * 0.4956221);
    hyogoPath.lineTo(size.width * 0.4936725, size.height * 0.4962229);
    hyogoPath.lineTo(size.width * 0.4946329, size.height * 0.4971337);
    hyogoPath.lineTo(size.width * 0.4965079, size.height * 0.4958353);
    hyogoPath.lineTo(size.width * 0.4996633, size.height * 0.4962229);
    hyogoPath.lineTo(size.width * 0.5025902, size.height * 0.4956609);
    hyogoPath.lineTo(size.width * 0.5036191, size.height * 0.4963004);
    hyogoPath.lineTo(size.width * 0.5058600, size.height * 0.4961841);
    hyogoPath.lineTo(size.width * 0.5058600, size.height * 0.4961841);
    hyogoPath.lineTo(size.width * 0.5059057, size.height * 0.5000987);
    hyogoPath.lineTo(size.width * 0.5078722, size.height * 0.5016491);
    hyogoPath.lineTo(size.width * 0.5083524, size.height * 0.5028312);
    hyogoPath.lineTo(size.width * 0.5099987, size.height * 0.5031800);
    hyogoPath.lineTo(size.width * 0.5130398, size.height * 0.5019010);
    hyogoPath.lineTo(size.width * 0.5137715, size.height * 0.5029475);
    hyogoPath.lineTo(size.width * 0.5137715, size.height * 0.5080442);
    hyogoPath.lineTo(size.width * 0.5116908, size.height * 0.5090520);
    hyogoPath.lineTo(size.width * 0.5090841, size.height * 0.5079861);
    hyogoPath.lineTo(size.width * 0.5082380, size.height * 0.5099240);
    hyogoPath.lineTo(size.width * 0.5082838, size.height * 0.5123852);
    hyogoPath.lineTo(size.width * 0.5116908, size.height * 0.5135673);
    hyogoPath.lineTo(size.width * 0.5147090, size.height * 0.5157572);
    hyogoPath.lineTo(size.width * 0.5164468, size.height * 0.5148657);
    hyogoPath.lineTo(size.width * 0.5187792, size.height * 0.5149045);
    hyogoPath.lineTo(size.width * 0.5188249, size.height * 0.5164161);
    hyogoPath.lineTo(size.width * 0.5207913, size.height * 0.5180052);
    hyogoPath.lineTo(size.width * 0.5202197, size.height * 0.5190710);
    hyogoPath.lineTo(size.width * 0.5214773, size.height * 0.5195361);
    hyogoPath.lineTo(size.width * 0.5224606, size.height * 0.5188385);
    hyogoPath.lineTo(size.width * 0.5243127, size.height * 0.5189160);
    hyogoPath.lineTo(size.width * 0.5248157, size.height * 0.5190323);
    hyogoPath.lineTo(size.width * 0.5249072, size.height * 0.5204470);
    hyogoPath.lineTo(size.width * 0.5268508, size.height * 0.5200981);
    hyogoPath.lineTo(size.width * 0.5290688, size.height * 0.5210477);
    hyogoPath.lineTo(size.width * 0.5297319, size.height * 0.5234895);
    hyogoPath.lineTo(size.width * 0.5288630, size.height * 0.5238965);
    hyogoPath.lineTo(size.width * 0.5284743, size.height * 0.5249429);
    hyogoPath.lineTo(size.width * 0.5284743, size.height * 0.5249429);
    hyogoPath.lineTo(size.width * 0.5274910, size.height * 0.5248460);
    hyogoPath.lineTo(size.width * 0.5268279, size.height * 0.5254468);
    hyogoPath.lineTo(size.width * 0.5277426, size.height * 0.5259119);
    hyogoPath.lineTo(size.width * 0.5279255, size.height * 0.5277917);
    hyogoPath.lineTo(size.width * 0.5273767, size.height * 0.5284893);
    hyogoPath.lineTo(size.width * 0.5305779, size.height * 0.5300591);
    hyogoPath.lineTo(size.width * 0.5327730, size.height * 0.5303304);
    hyogoPath.lineTo(size.width * 0.5306922, size.height * 0.5313187);
    hyogoPath.lineTo(size.width * 0.5316755, size.height * 0.5318032);
    hyogoPath.lineTo(size.width * 0.5306008, size.height * 0.5357566);
    hyogoPath.lineTo(size.width * 0.5322928, size.height * 0.5381596);
    hyogoPath.lineTo(size.width * 0.5326358, size.height * 0.5409308);
    hyogoPath.lineTo(size.width * 0.5314011, size.height * 0.5432757);
    hyogoPath.lineTo(size.width * 0.5314011, size.height * 0.5432757);
    hyogoPath.lineTo(size.width * 0.5303950, size.height * 0.5426362);
    hyogoPath.lineTo(size.width * 0.5307151, size.height * 0.5417254);
    hyogoPath.lineTo(size.width * 0.5301435, size.height * 0.5407177);
    hyogoPath.lineTo(size.width * 0.5280398, size.height * 0.5413378);
    hyogoPath.lineTo(size.width * 0.5270794, size.height * 0.5401750);
    hyogoPath.lineTo(size.width * 0.5248615, size.height * 0.5399231);
    hyogoPath.lineTo(size.width * 0.5203340, size.height * 0.5417448);
    hyogoPath.lineTo(size.width * 0.5201054, size.height * 0.5430625);
    hyogoPath.lineTo(size.width * 0.5142060, size.height * 0.5443028);
    hyogoPath.lineTo(size.width * 0.5044423, size.height * 0.5409696);
    hyogoPath.lineTo(size.width * 0.5006237, size.height * 0.5377720);
    hyogoPath.lineTo(size.width * 0.4875445, size.height * 0.5378689);
    hyogoPath.close();
    hyogoPath.moveTo(size.width * 0.5090383, size.height * 0.5593411);
    hyogoPath.lineTo(size.width * 0.5095414, size.height * 0.5608333);
    hyogoPath.lineTo(size.width * 0.5048310, size.height * 0.5624612);
    hyogoPath.lineTo(size.width * 0.5025902, size.height * 0.5640503);
    hyogoPath.lineTo(size.width * 0.4995262, size.height * 0.5644185);
    hyogoPath.lineTo(size.width * 0.4995033, size.height * 0.5635464);
    hyogoPath.lineTo(size.width * 0.4981542, size.height * 0.5629457);
    hyogoPath.lineTo(size.width * 0.4982914, size.height * 0.5619767);
    hyogoPath.lineTo(size.width * 0.4973082, size.height * 0.5616666);
    hyogoPath.lineTo(size.width * 0.4960734, size.height * 0.5597093);
    hyogoPath.lineTo(size.width * 0.4976054, size.height * 0.5578489);
    hyogoPath.lineTo(size.width * 0.4984743, size.height * 0.5583140);
    hyogoPath.lineTo(size.width * 0.4995490, size.height * 0.5578489);
    hyogoPath.lineTo(size.width * 0.5025902, size.height * 0.5523840);
    hyogoPath.lineTo(size.width * 0.5035048, size.height * 0.5514925);
    hyogoPath.lineTo(size.width * 0.5044423, size.height * 0.5515119);
    hyogoPath.lineTo(size.width * 0.5066146, size.height * 0.5486050);
    hyogoPath.lineTo(size.width * 0.5087868, size.height * 0.5477717);
    hyogoPath.lineTo(size.width * 0.5105475, size.height * 0.5456012);
    hyogoPath.lineTo(size.width * 0.5118051, size.height * 0.5450392);
    hyogoPath.lineTo(size.width * 0.5128112, size.height * 0.5466477);
    hyogoPath.lineTo(size.width * 0.5114392, size.height * 0.5480430);
    hyogoPath.lineTo(size.width * 0.5110962, size.height * 0.5495352);
    hyogoPath.lineTo(size.width * 0.5070261, size.height * 0.5540506);
    hyogoPath.lineTo(size.width * 0.5070033, size.height * 0.5570350);
    hyogoPath.lineTo(size.width * 0.5090383, size.height * 0.5593411);
    hyogoPath.close();

    Paint hyogoPaint = Paint()..style = PaintingStyle.fill;
    hyogoPaint.color = japanColors.hyogo ?? defaultColor;
    japanCanvas.drawPath(hyogoPath, hyogoPaint, onTapUp: (tabdetail) {
      callback('hyogo', tabdetail);
    });

    Path hokkaidoPath = Path();
    hokkaidoPath.moveTo(size.width * 0.7545942, size.height * 0.1386951);
    hokkaidoPath.lineTo(size.width * 0.7607908, size.height * 0.1345673);
    hokkaidoPath.lineTo(size.width * 0.7608823, size.height * 0.1334240);
    hokkaidoPath.lineTo(size.width * 0.7564006, size.height * 0.1272808);
    hokkaidoPath.lineTo(size.width * 0.7532451, size.height * 0.1253622);
    hokkaidoPath.lineTo(size.width * 0.7516445, size.height * 0.1231142);
    hokkaidoPath.lineTo(size.width * 0.7531994, size.height * 0.1181919);
    hokkaidoPath.lineTo(size.width * 0.7525820, size.height * 0.1172617);
    hokkaidoPath.lineTo(size.width * 0.7563320, size.height * 0.1174749);
    hokkaidoPath.lineTo(size.width * 0.7577039, size.height * 0.1166609);
    hokkaidoPath.lineTo(size.width * 0.7581841, size.height * 0.1156144);
    hokkaidoPath.lineTo(size.width * 0.7593960, size.height * 0.1152075);
    hokkaidoPath.lineTo(size.width * 0.7656841, size.height * 0.1203624);
    hokkaidoPath.lineTo(size.width * 0.7700972, size.height * 0.1220484);
    hokkaidoPath.lineTo(size.width * 0.7726810, size.height * 0.1245289);
    hokkaidoPath.lineTo(size.width * 0.7783517, size.height * 0.1236181);
    hokkaidoPath.lineTo(size.width * 0.7787405, size.height * 0.1228041);
    hokkaidoPath.lineTo(size.width * 0.7810728, size.height * 0.1221840);
    hokkaidoPath.lineTo(size.width * 0.7827191, size.height * 0.1222228);
    hokkaidoPath.lineTo(size.width * 0.7823990, size.height * 0.1244901);
    hokkaidoPath.lineTo(size.width * 0.7893502, size.height * 0.1271839);
    hokkaidoPath.lineTo(size.width * 0.7943807, size.height * 0.1248196);
    hokkaidoPath.lineTo(size.width * 0.7988852, size.height * 0.1206530);
    hokkaidoPath.lineTo(size.width * 0.8011489, size.height * 0.1175524);
    hokkaidoPath.lineTo(size.width * 0.8013776, size.height * 0.1129982);
    hokkaidoPath.lineTo(size.width * 0.7982221, size.height * 0.1076496);
    hokkaidoPath.lineTo(size.width * 0.7994569, size.height * 0.1038900);
    hokkaidoPath.lineTo(size.width * 0.7979477, size.height * 0.1010994);
    hokkaidoPath.lineTo(size.width * 0.7969188, size.height * 0.09670030);
    hokkaidoPath.lineTo(size.width * 0.7992511, size.height * 0.09263065);
    hokkaidoPath.lineTo(size.width * 0.8026124, size.height * 0.09090590);
    hokkaidoPath.lineTo(size.width * 0.8043502, size.height * 0.09080900);
    hokkaidoPath.lineTo(size.width * 0.8089919, size.height * 0.08825094);
    hokkaidoPath.lineTo(size.width * 0.8111184, size.height * 0.08458826);
    hokkaidoPath.lineTo(size.width * 0.8120559, size.height * 0.08080931);
    hokkaidoPath.lineTo(size.width * 0.8112556, size.height * 0.06557722);
    hokkaidoPath.lineTo(size.width * 0.8123989, size.height * 0.06495709);
    hokkaidoPath.lineTo(size.width * 0.8161489, size.height * 0.05829062);
    hokkaidoPath.lineTo(size.width * 0.8166291, size.height * 0.05274816);
    hokkaidoPath.lineTo(size.width * 0.8174980, size.height * 0.05121720);
    hokkaidoPath.lineTo(size.width * 0.8177953, size.height * 0.04811652);
    hokkaidoPath.lineTo(size.width * 0.8171093, size.height * 0.04177950);
    hokkaidoPath.lineTo(size.width * 0.8153486, size.height * 0.03433787);
    hokkaidoPath.lineTo(size.width * 0.8083974, size.height * 0.02015226);
    hokkaidoPath.lineTo(size.width * 0.8076886, size.height * 0.01790427);
    hokkaidoPath.lineTo(size.width * 0.8078486, size.height * 0.01598572);
    hokkaidoPath.lineTo(size.width * 0.8098151, size.height * 0.01352456);
    hokkaidoPath.lineTo(size.width * 0.8116215, size.height * 0.009745605);
    hokkaidoPath.lineTo(size.width * 0.8106840, size.height * 0.007032510);
    hokkaidoPath.lineTo(size.width * 0.8110270, size.height * 0.004551966);
    hokkaidoPath.lineTo(size.width * 0.8127419, size.height * 0.006044168);
    hokkaidoPath.lineTo(size.width * 0.8130392, size.height * 0.007051889);
    hokkaidoPath.lineTo(size.width * 0.8139309, size.height * 0.007361957);
    hokkaidoPath.lineTo(size.width * 0.8179553, size.height * 0.006819338);
    hokkaidoPath.lineTo(size.width * 0.8210422, size.height * 0.004997689);
    hokkaidoPath.lineTo(size.width * 0.8222998, size.height * 0.001141218);
    hokkaidoPath.lineTo(size.width * 0.8242891, size.height * 0.0005404617);
    hokkaidoPath.lineTo(size.width * 0.8253638, size.height * 0.001179977);
    hokkaidoPath.lineTo(size.width * 0.8266443, size.height * 0.003679900);
    hokkaidoPath.lineTo(size.width * 0.8279934, size.height * 0.004338794);
    hokkaidoPath.lineTo(size.width * 0.8294339, size.height * 0.007187544);
    hokkaidoPath.lineTo(size.width * 0.8347388, size.height * 0.01048202);
    hokkaidoPath.lineTo(size.width * 0.8397922, size.height * 0.01652834);
    hokkaidoPath.lineTo(size.width * 0.8511107, size.height * 0.02730320);
    hokkaidoPath.lineTo(size.width * 0.8600513, size.height * 0.04131440);
    hokkaidoPath.lineTo(size.width * 0.8659506, size.height * 0.04625611);
    hokkaidoPath.lineTo(size.width * 0.8715299, size.height * 0.05226368);
    hokkaidoPath.lineTo(size.width * 0.8842890, size.height * 0.06079055);
    hokkaidoPath.lineTo(size.width * 0.8878789, size.height * 0.06251530);
    hokkaidoPath.lineTo(size.width * 0.8886335, size.height * 0.06435633);
    hokkaidoPath.lineTo(size.width * 0.8915146, size.height * 0.06621674);
    hokkaidoPath.lineTo(size.width * 0.8999749, size.height * 0.06997631);
    hokkaidoPath.lineTo(size.width * 0.9073835, size.height * 0.07245685);
    hokkaidoPath.lineTo(size.width * 0.9208286, size.height * 0.07573195);
    hokkaidoPath.lineTo(size.width * 0.9272081, size.height * 0.07675905);
    hokkaidoPath.lineTo(size.width * 0.9282142, size.height * 0.07615829);
    hokkaidoPath.lineTo(size.width * 0.9288773, size.height * 0.07765049);
    hokkaidoPath.lineTo(size.width * 0.9287401, size.height * 0.08013104);
    hokkaidoPath.lineTo(size.width * 0.9307294, size.height * 0.08313482);
    hokkaidoPath.lineTo(size.width * 0.9320557, size.height * 0.08406502);
    hokkaidoPath.lineTo(size.width * 0.9393956, size.height * 0.08602233);
    hokkaidoPath.lineTo(size.width * 0.9471928, size.height * 0.08642929);
    hokkaidoPath.lineTo(size.width * 0.9530693, size.height * 0.08580916);
    hokkaidoPath.lineTo(size.width * 0.9582827, size.height * 0.08195269);
    hokkaidoPath.lineTo(size.width * 0.9618041, size.height * 0.07823187);
    hokkaidoPath.lineTo(size.width * 0.9667888, size.height * 0.07427850);
    hokkaidoPath.lineTo(size.width * 0.9709733, size.height * 0.07183672);
    hokkaidoPath.lineTo(size.width * 0.9724824, size.height * 0.06902673);
    hokkaidoPath.lineTo(size.width * 0.9749976, size.height * 0.06677873);
    hokkaidoPath.lineTo(size.width * 0.9767812, size.height * 0.06410440);
    hokkaidoPath.lineTo(size.width * 0.9778330, size.height * 0.06416254);
    hokkaidoPath.lineTo(size.width * 0.9788620, size.height * 0.06848411);
    hokkaidoPath.lineTo(size.width * 0.9760952, size.height * 0.07330954);
    hokkaidoPath.lineTo(size.width * 0.9740144, size.height * 0.07509243);
    hokkaidoPath.lineTo(size.width * 0.9726425, size.height * 0.07974345);
    hokkaidoPath.lineTo(size.width * 0.9686867, size.height * 0.08387123);
    hokkaidoPath.lineTo(size.width * 0.9665373, size.height * 0.08797963);
    hokkaidoPath.lineTo(size.width * 0.9667660, size.height * 0.08958811);
    hokkaidoPath.lineTo(size.width * 0.9650053, size.height * 0.09356086);
    hokkaidoPath.lineTo(size.width * 0.9655083, size.height * 0.09561506);
    hokkaidoPath.lineTo(size.width * 0.9685952, size.height * 0.1006149);
    hokkaidoPath.lineTo(size.width * 0.9720022, size.height * 0.1044326);
    hokkaidoPath.lineTo(size.width * 0.9754778, size.height * 0.1145680);
    hokkaidoPath.lineTo(size.width * 0.9788848, size.height * 0.1183663);
    hokkaidoPath.lineTo(size.width * 0.9762324, size.height * 0.1173392);
    hokkaidoPath.lineTo(size.width * 0.9757979, size.height * 0.1163121);
    hokkaidoPath.lineTo(size.width * 0.9731912, size.height * 0.1158858);
    hokkaidoPath.lineTo(size.width * 0.9726425, size.height * 0.1166028);
    hokkaidoPath.lineTo(size.width * 0.9731226, size.height * 0.1190446);
    hokkaidoPath.lineTo(size.width * 0.9750891, size.height * 0.1177462);
    hokkaidoPath.lineTo(size.width * 0.9761638, size.height * 0.1185213);
    hokkaidoPath.lineTo(size.width * 0.9755007, size.height * 0.1195872);
    hokkaidoPath.lineTo(size.width * 0.9763467, size.height * 0.1203430);
    hokkaidoPath.lineTo(size.width * 0.9772614, size.height * 0.1198004);
    hokkaidoPath.lineTo(size.width * 0.9830921, size.height * 0.1210019);
    hokkaidoPath.lineTo(size.width * 0.9878711, size.height * 0.1177074);
    hokkaidoPath.lineTo(size.width * 0.9886028, size.height * 0.1165446);
    hokkaidoPath.lineTo(size.width * 0.9911409, size.height * 0.1151687);
    hokkaidoPath.lineTo(size.width * 0.9916897, size.height * 0.1141998);
    hokkaidoPath.lineTo(size.width * 0.9991897, size.height * 0.1145873);
    hokkaidoPath.lineTo(size.width * 0.9987552, size.height * 0.1155563);
    hokkaidoPath.lineTo(size.width * 0.9960799, size.height * 0.1173198);
    hokkaidoPath.lineTo(size.width * 0.9921241, size.height * 0.1179206);
    hokkaidoPath.lineTo(size.width * 0.9878482, size.height * 0.1199166);
    hokkaidoPath.lineTo(size.width * 0.9860190, size.height * 0.1255948);
    hokkaidoPath.lineTo(size.width * 0.9842583, size.height * 0.1248971);
    hokkaidoPath.lineTo(size.width * 0.9814229, size.height * 0.1248002);
    hokkaidoPath.lineTo(size.width * 0.9752263, size.height * 0.1257885);
    hokkaidoPath.lineTo(size.width * 0.9717736, size.height * 0.1275327);
    hokkaidoPath.lineTo(size.width * 0.9688925, size.height * 0.1271257);
    hokkaidoPath.lineTo(size.width * 0.9674748, size.height * 0.1282885);
    hokkaidoPath.lineTo(size.width * 0.9671547, size.height * 0.1305171);
    hokkaidoPath.lineTo(size.width * 0.9634961, size.height * 0.1346836);
    hokkaidoPath.lineTo(size.width * 0.9611638, size.height * 0.1356332);
    hokkaidoPath.lineTo(size.width * 0.9568193, size.height * 0.1354394);
    hokkaidoPath.lineTo(size.width * 0.9547614, size.height * 0.1339085);
    hokkaidoPath.lineTo(size.width * 0.9548300, size.height * 0.1328814);
    hokkaidoPath.lineTo(size.width * 0.9555846, size.height * 0.1322806);
    hokkaidoPath.lineTo(size.width * 0.9543270, size.height * 0.1315636);
    hokkaidoPath.lineTo(size.width * 0.9526578, size.height * 0.1317574);
    hokkaidoPath.lineTo(size.width * 0.9499367, size.height * 0.1351100);
    hokkaidoPath.lineTo(size.width * 0.9498910, size.height * 0.1359045);
    hokkaidoPath.lineTo(size.width * 0.9525206, size.height * 0.1380944);
    hokkaidoPath.lineTo(size.width * 0.9479245, size.height * 0.1378618);
    hokkaidoPath.lineTo(size.width * 0.9452950, size.height * 0.1371835);
    hokkaidoPath.lineTo(size.width * 0.9371090, size.height * 0.1371448);
    hokkaidoPath.lineTo(size.width * 0.9355313, size.height * 0.1368541);
    hokkaidoPath.lineTo(size.width * 0.9319185, size.height * 0.1343929);
    hokkaidoPath.lineTo(size.width * 0.9249215, size.height * 0.1354394);
    hokkaidoPath.lineTo(size.width * 0.9193651, size.height * 0.1377262);
    hokkaidoPath.lineTo(size.width * 0.9115908, size.height * 0.1426291);
    hokkaidoPath.lineTo(size.width * 0.8995405, size.height * 0.1528420);
    hokkaidoPath.lineTo(size.width * 0.8902112, size.height * 0.1640819);
    hokkaidoPath.lineTo(size.width * 0.8867128, size.height * 0.1704965);
    hokkaidoPath.lineTo(size.width * 0.8860725, size.height * 0.1737328);
    hokkaidoPath.lineTo(size.width * 0.8873302, size.height * 0.1765234);
    hokkaidoPath.lineTo(size.width * 0.8854552, size.height * 0.1840426);
    hokkaidoPath.lineTo(size.width * 0.8833744, size.height * 0.1870076);
    hokkaidoPath.lineTo(size.width * 0.8833744, size.height * 0.1901277);
    hokkaidoPath.lineTo(size.width * 0.8749140, size.height * 0.1829186);
    hokkaidoPath.lineTo(size.width * 0.8638241, size.height * 0.1790040);
    hokkaidoPath.lineTo(size.width * 0.8453257, size.height * 0.1703802);
    hokkaidoPath.lineTo(size.width * 0.8398836, size.height * 0.1671439);
    hokkaidoPath.lineTo(size.width * 0.8356763, size.height * 0.1631711);
    hokkaidoPath.lineTo(size.width * 0.8283364, size.height * 0.1613495);
    hokkaidoPath.lineTo(size.width * 0.8232830, size.height * 0.1573767);
    hokkaidoPath.lineTo(size.width * 0.8191215, size.height * 0.1550512);
    hokkaidoPath.lineTo(size.width * 0.8149370, size.height * 0.1540241);
    hokkaidoPath.lineTo(size.width * 0.8094950, size.height * 0.1539466);
    hokkaidoPath.lineTo(size.width * 0.8022465, size.height * 0.1559620);
    hokkaidoPath.lineTo(size.width * 0.7974904, size.height * 0.1584620);
    hokkaidoPath.lineTo(size.width * 0.7913624, size.height * 0.1628804);
    hokkaidoPath.lineTo(size.width * 0.7877267, size.height * 0.1646052);
    hokkaidoPath.lineTo(size.width * 0.7828792, size.height * 0.1693531);
    hokkaidoPath.lineTo(size.width * 0.7821017, size.height * 0.1708065);
    hokkaidoPath.lineTo(size.width * 0.7796551, size.height * 0.1700314);
    hokkaidoPath.lineTo(size.width * 0.7789005, size.height * 0.1689655);
    hokkaidoPath.lineTo(size.width * 0.7797694, size.height * 0.1684035);
    hokkaidoPath.lineTo(size.width * 0.7811185, size.height * 0.1696438);
    hokkaidoPath.lineTo(size.width * 0.7813929, size.height * 0.1680741);
    hokkaidoPath.lineTo(size.width * 0.7783060, size.height * 0.1672795);
    hokkaidoPath.lineTo(size.width * 0.7763167, size.height * 0.1626866);
    hokkaidoPath.lineTo(size.width * 0.7745103, size.height * 0.1619115);
    hokkaidoPath.lineTo(size.width * 0.7720636, size.height * 0.1597410);
    hokkaidoPath.lineTo(size.width * 0.7717893, size.height * 0.1586170);
    hokkaidoPath.lineTo(size.width * 0.7688853, size.height * 0.1562333);
    hokkaidoPath.lineTo(size.width * 0.7660499, size.height * 0.1560589);
    hokkaidoPath.lineTo(size.width * 0.7631917, size.height * 0.1570860);
    hokkaidoPath.lineTo(size.width * 0.7609737, size.height * 0.1559427);
    hokkaidoPath.lineTo(size.width * 0.7582070, size.height * 0.1560008);
    hokkaidoPath.lineTo(size.width * 0.7543655, size.height * 0.1595084);
    hokkaidoPath.lineTo(size.width * 0.7510728, size.height * 0.1648377);
    hokkaidoPath.lineTo(size.width * 0.7494494, size.height * 0.1697794);
    hokkaidoPath.lineTo(size.width * 0.7500896, size.height * 0.1735390);
    hokkaidoPath.lineTo(size.width * 0.7553945, size.height * 0.1758645);
    hokkaidoPath.lineTo(size.width * 0.7616597, size.height * 0.1804187);
    hokkaidoPath.lineTo(size.width * 0.7633746, size.height * 0.1806900);
    hokkaidoPath.lineTo(size.width * 0.7665073, size.height * 0.1796629);
    hokkaidoPath.lineTo(size.width * 0.7711719, size.height * 0.1802636);
    hokkaidoPath.lineTo(size.width * 0.7739844, size.height * 0.1845464);
    hokkaidoPath.lineTo(size.width * 0.7777115, size.height * 0.1869107);
    hokkaidoPath.lineTo(size.width * 0.7801810, size.height * 0.1905540);
    hokkaidoPath.lineTo(size.width * 0.7873837, size.height * 0.1931896);
    hokkaidoPath.lineTo(size.width * 0.7886414, size.height * 0.1949143);
    hokkaidoPath.lineTo(size.width * 0.7904478, size.height * 0.1960577);
    hokkaidoPath.lineTo(size.width * 0.7890529, size.height * 0.1972398);
    hokkaidoPath.lineTo(size.width * 0.7868807, size.height * 0.1972592);
    hokkaidoPath.lineTo(size.width * 0.7843654, size.height * 0.1997785);
    hokkaidoPath.lineTo(size.width * 0.7805697, size.height * 0.2010576);
    hokkaidoPath.lineTo(size.width * 0.7786033, size.height * 0.1995266);
    hokkaidoPath.lineTo(size.width * 0.7722466, size.height * 0.1977631);
    hokkaidoPath.lineTo(size.width * 0.7701201, size.height * 0.1980732);
    hokkaidoPath.lineTo(size.width * 0.7694798, size.height * 0.1992747);
    hokkaidoPath.lineTo(size.width * 0.7685423, size.height * 0.1994685);
    hokkaidoPath.lineTo(size.width * 0.7681307, size.height * 0.1982863);
    hokkaidoPath.lineTo(size.width * 0.7696856, size.height * 0.1974143);
    hokkaidoPath.lineTo(size.width * 0.7692283, size.height * 0.1961158);
    hokkaidoPath.lineTo(size.width * 0.7678792, size.height * 0.1953988);
    hokkaidoPath.lineTo(size.width * 0.7659127, size.height * 0.1955538);
    hokkaidoPath.lineTo(size.width * 0.7649752, size.height * 0.1961934);
    hokkaidoPath.lineTo(size.width * 0.7639920, size.height * 0.1994491);
    hokkaidoPath.lineTo(size.width * 0.7606993, size.height * 0.2015033);
    hokkaidoPath.lineTo(size.width * 0.7577497, size.height * 0.2016971);
    hokkaidoPath.lineTo(size.width * 0.7569494, size.height * 0.2023366);
    hokkaidoPath.lineTo(size.width * 0.7562405, size.height * 0.2099720);
    hokkaidoPath.lineTo(size.width * 0.7553259, size.height * 0.2109022);
    hokkaidoPath.lineTo(size.width * 0.7531765, size.height * 0.2109604);
    hokkaidoPath.lineTo(size.width * 0.7486948, size.height * 0.2126463);
    hokkaidoPath.lineTo(size.width * 0.7466369, size.height * 0.2163090);
    hokkaidoPath.lineTo(size.width * 0.7457451, size.height * 0.2169292);
    hokkaidoPath.lineTo(size.width * 0.7434128, size.height * 0.2153788);
    hokkaidoPath.lineTo(size.width * 0.7408061, size.height * 0.2158052);
    hokkaidoPath.lineTo(size.width * 0.7387482, size.height * 0.2144292);
    hokkaidoPath.lineTo(size.width * 0.7362787, size.height * 0.2091581);
    hokkaidoPath.lineTo(size.width * 0.7360729, size.height * 0.2074915);
    hokkaidoPath.lineTo(size.width * 0.7370104, size.height * 0.2040613);
    hokkaidoPath.lineTo(size.width * 0.7400973, size.height * 0.1981894);
    hokkaidoPath.lineTo(size.width * 0.7400973, size.height * 0.1961546);
    hokkaidoPath.lineTo(size.width * 0.7418579, size.height * 0.1963096);
    hokkaidoPath.lineTo(size.width * 0.7425210, size.height * 0.1951663);
    hokkaidoPath.lineTo(size.width * 0.7432299, size.height * 0.1899339);
    hokkaidoPath.lineTo(size.width * 0.7423152, size.height * 0.1860968);
    hokkaidoPath.lineTo(size.width * 0.7379707, size.height * 0.1803993);
    hokkaidoPath.lineTo(size.width * 0.7364387, size.height * 0.1797016);
    hokkaidoPath.lineTo(size.width * 0.7334662, size.height * 0.1794691);
    hokkaidoPath.lineTo(size.width * 0.7323000, size.height * 0.1768916);
    hokkaidoPath.lineTo(size.width * 0.7303564, size.height * 0.1751863);
    hokkaidoPath.lineTo(size.width * 0.7277497, size.height * 0.1743917);
    hokkaidoPath.lineTo(size.width * 0.7268580, size.height * 0.1729770);
    hokkaidoPath.lineTo(size.width * 0.7264235, size.height * 0.1702833);
    hokkaidoPath.lineTo(size.width * 0.7271323, size.height * 0.1681128);
    hokkaidoPath.lineTo(size.width * 0.7292817, size.height * 0.1661168);
    hokkaidoPath.lineTo(size.width * 0.7300363, size.height * 0.1642757);
    hokkaidoPath.lineTo(size.width * 0.7301049, size.height * 0.1591402);
    hokkaidoPath.lineTo(size.width * 0.7289845, size.height * 0.1548187);
    hokkaidoPath.lineTo(size.width * 0.7310881, size.height * 0.1520087);
    hokkaidoPath.lineTo(size.width * 0.7336491, size.height * 0.1508072);
    hokkaidoPath.lineTo(size.width * 0.7388625, size.height * 0.1506909);
    hokkaidoPath.lineTo(size.width * 0.7402573, size.height * 0.1489274);
    hokkaidoPath.lineTo(size.width * 0.7434357, size.height * 0.1475127);
    hokkaidoPath.lineTo(size.width * 0.7453793, size.height * 0.1437919);
    hokkaidoPath.lineTo(size.width * 0.7472543, size.height * 0.1448965);
    hokkaidoPath.lineTo(size.width * 0.7485347, size.height * 0.1467763);
    hokkaidoPath.lineTo(size.width * 0.7505698, size.height * 0.1463306);
    hokkaidoPath.lineTo(size.width * 0.7507756, size.height * 0.1436368);
    hokkaidoPath.lineTo(size.width * 0.7526506, size.height * 0.1420090);
    hokkaidoPath.lineTo(size.width * 0.7545942, size.height * 0.1386951);
    hokkaidoPath.close();
    hokkaidoPath.moveTo(size.width * 0.7882526, size.height * 0.01964840);
    hokkaidoPath.lineTo(size.width * 0.7880468, size.height * 0.01726475);
    hokkaidoPath.lineTo(size.width * 0.7909737, size.height * 0.01484235);
    hokkaidoPath.lineTo(size.width * 0.7957069, size.height * 0.01718724);
    hokkaidoPath.lineTo(size.width * 0.7968730, size.height * 0.02069488);
    hokkaidoPath.lineTo(size.width * 0.7927343, size.height * 0.02358239);
    hokkaidoPath.lineTo(size.width * 0.7896017, size.height * 0.02150881);
    hokkaidoPath.lineTo(size.width * 0.7882526, size.height * 0.01964840);
    hokkaidoPath.close();
    hokkaidoPath.moveTo(size.width * 0.7153565, size.height * 0.1769498);
    hokkaidoPath.lineTo(size.width * 0.7146933, size.height * 0.1812520);
    hokkaidoPath.lineTo(size.width * 0.7138016, size.height * 0.1824729);
    hokkaidoPath.lineTo(size.width * 0.7123153, size.height * 0.1829186);
    hokkaidoPath.lineTo(size.width * 0.7122696, size.height * 0.1836162);
    hokkaidoPath.lineTo(size.width * 0.7108748, size.height * 0.1825697);
    hokkaidoPath.lineTo(size.width * 0.7110120, size.height * 0.1792559);
    hokkaidoPath.lineTo(size.width * 0.7100516, size.height * 0.1771048);
    hokkaidoPath.lineTo(size.width * 0.7117437, size.height * 0.1749925);
    hokkaidoPath.lineTo(size.width * 0.7161110, size.height * 0.1742560);
    hokkaidoPath.lineTo(size.width * 0.7171629, size.height * 0.1732483);
    hokkaidoPath.lineTo(size.width * 0.7172315, size.height * 0.1744886);
    hokkaidoPath.lineTo(size.width * 0.7153565, size.height * 0.1769498);
    hokkaidoPath.close();
    hokkaidoPath.moveTo(size.width * 0.7847542, size.height * 0.008776642);
    hokkaidoPath.lineTo(size.width * 0.7841597, size.height * 0.01379587);
    hokkaidoPath.lineTo(size.width * 0.7832679, size.height * 0.01404780);
    hokkaidoPath.lineTo(size.width * 0.7812557, size.height * 0.008292161);
    hokkaidoPath.lineTo(size.width * 0.7817587, size.height * 0.005753480);
    hokkaidoPath.lineTo(size.width * 0.7803639, size.height * 0.005094585);
    hokkaidoPath.lineTo(size.width * 0.7805697, size.height * 0.003679900);
    hokkaidoPath.lineTo(size.width * 0.7820560, size.height * 0.005327136);
    hokkaidoPath.lineTo(size.width * 0.7835651, size.height * 0.005036447);
    hokkaidoPath.lineTo(size.width * 0.7835194, size.height * 0.003893072);
    hokkaidoPath.lineTo(size.width * 0.7842969, size.height * 0.004416311);
    hokkaidoPath.lineTo(size.width * 0.7850972, size.height * 0.005927893);
    hokkaidoPath.lineTo(size.width * 0.7847542, size.height * 0.008776642);
    hokkaidoPath.close();

    Paint hokkaidoPaint = Paint()..style = PaintingStyle.fill;
    hokkaidoPaint.color = japanColors.hokkaido ?? defaultColor;
    japanCanvas.drawPath(hokkaidoPath, hokkaidoPaint, onTapUp: (tabdetail) {
      callback('hokkaido', tabdetail);
    });

    Path hiroshimaPath = Path();
    hiroshimaPath.moveTo(size.width * 0.4051361, size.height * 0.5638177);
    hiroshimaPath.lineTo(size.width * 0.4033526, size.height * 0.5624612);
    hiroshimaPath.lineTo(size.width * 0.4000370, size.height * 0.5658525);
    hiroshimaPath.lineTo(size.width * 0.4007459, size.height * 0.5675967);
    hiroshimaPath.lineTo(size.width * 0.4024837, size.height * 0.5672091);
    hiroshimaPath.lineTo(size.width * 0.4032154, size.height * 0.5678098);
    hiroshimaPath.lineTo(size.width * 0.4028724, size.height * 0.5682168);
    hiroshimaPath.lineTo(size.width * 0.4012718, size.height * 0.5692439);
    hiroshimaPath.lineTo(size.width * 0.4006316, size.height * 0.5687013);
    hiroshimaPath.lineTo(size.width * 0.3971102, size.height * 0.5692051);
    hiroshimaPath.lineTo(size.width * 0.3966986, size.height * 0.5680618);
    hiroshimaPath.lineTo(size.width * 0.3993053, size.height * 0.5668409);
    hiroshimaPath.lineTo(size.width * 0.3987337, size.height * 0.5659494);
    hiroshimaPath.lineTo(size.width * 0.3990538, size.height * 0.5647285);
    hiroshimaPath.lineTo(size.width * 0.4002657, size.height * 0.5638759);
    hiroshimaPath.lineTo(size.width * 0.4004486, size.height * 0.5619961);
    hiroshimaPath.lineTo(size.width * 0.3988252, size.height * 0.5586435);
    hiroshimaPath.lineTo(size.width * 0.3991681, size.height * 0.5567637);
    hiroshimaPath.lineTo(size.width * 0.3961727, size.height * 0.5555040);
    hiroshimaPath.lineTo(size.width * 0.3909593, size.height * 0.5575195);
    hiroshimaPath.lineTo(size.width * 0.3909136, size.height * 0.5582365);
    hiroshimaPath.lineTo(size.width * 0.3869578, size.height * 0.5613566);
    hiroshimaPath.lineTo(size.width * 0.3864776, size.height * 0.5623449);
    hiroshimaPath.lineTo(size.width * 0.3870950, size.height * 0.5626356);
    hiroshimaPath.lineTo(size.width * 0.3870950, size.height * 0.5626356);
    hiroshimaPath.lineTo(size.width * 0.3863404, size.height * 0.5630038);
    hiroshimaPath.lineTo(size.width * 0.3834136, size.height * 0.5624030);
    hiroshimaPath.lineTo(size.width * 0.3822703, size.height * 0.5595737);
    hiroshimaPath.lineTo(size.width * 0.3824532, size.height * 0.5583528);
    hiroshimaPath.lineTo(size.width * 0.3803496, size.height * 0.5568412);
    hiroshimaPath.lineTo(size.width * 0.3798008, size.height * 0.5542056);
    hiroshimaPath.lineTo(size.width * 0.3801895, size.height * 0.5526359);
    hiroshimaPath.lineTo(size.width * 0.3795036, size.height * 0.5513181);
    hiroshimaPath.lineTo(size.width * 0.3795036, size.height * 0.5513181);
    hiroshimaPath.lineTo(size.width * 0.3783831, size.height * 0.5500972);
    hiroshimaPath.lineTo(size.width * 0.3790691, size.height * 0.5488569);
    hiroshimaPath.lineTo(size.width * 0.3804411, size.height * 0.5485081);
    hiroshimaPath.lineTo(size.width * 0.3818816, size.height * 0.5471903);
    hiroshimaPath.lineTo(size.width * 0.3823618, size.height * 0.5437408);
    hiroshimaPath.lineTo(size.width * 0.3839624, size.height * 0.5417448);
    hiroshimaPath.lineTo(size.width * 0.3827048, size.height * 0.5410859);
    hiroshimaPath.lineTo(size.width * 0.3833907, size.height * 0.5401557);
    hiroshimaPath.lineTo(size.width * 0.3867063, size.height * 0.5384890);
    hiroshimaPath.lineTo(size.width * 0.3874151, size.height * 0.5362798);
    hiroshimaPath.lineTo(size.width * 0.3892215, size.height * 0.5364930);
    hiroshimaPath.lineTo(size.width * 0.3901362, size.height * 0.5374232);
    hiroshimaPath.lineTo(size.width * 0.3906163, size.height * 0.5365705);
    hiroshimaPath.lineTo(size.width * 0.3934517, size.height * 0.5363186);
    hiroshimaPath.lineTo(size.width * 0.3946407, size.height * 0.5371325);
    hiroshimaPath.lineTo(size.width * 0.3958069, size.height * 0.5362992);
    hiroshimaPath.lineTo(size.width * 0.3956468, size.height * 0.5358147);
    hiroshimaPath.lineTo(size.width * 0.3965843, size.height * 0.5355434);
    hiroshimaPath.lineTo(size.width * 0.3971560, size.height * 0.5363379);
    hiroshimaPath.lineTo(size.width * 0.4008831, size.height * 0.5365899);
    hiroshimaPath.lineTo(size.width * 0.4042444, size.height * 0.5345357);
    hiroshimaPath.lineTo(size.width * 0.4082687, size.height * 0.5342644);
    hiroshimaPath.lineTo(size.width * 0.4082459, size.height * 0.5325784);
    hiroshimaPath.lineTo(size.width * 0.4066681, size.height * 0.5321714);
    hiroshimaPath.lineTo(size.width * 0.4057992, size.height * 0.5312606);
    hiroshimaPath.lineTo(size.width * 0.4077428, size.height * 0.5293227);
    hiroshimaPath.lineTo(size.width * 0.4104639, size.height * 0.5288382);
    hiroshimaPath.lineTo(size.width * 0.4159516, size.height * 0.5223849);
    hiroshimaPath.lineTo(size.width * 0.4168663, size.height * 0.5222492);
    hiroshimaPath.lineTo(size.width * 0.4194958, size.height * 0.5236058);
    hiroshimaPath.lineTo(size.width * 0.4213022, size.height * 0.5224043);
    hiroshimaPath.lineTo(size.width * 0.4235431, size.height * 0.5239352);
    hiroshimaPath.lineTo(size.width * 0.4267900, size.height * 0.5231213);
    hiroshimaPath.lineTo(size.width * 0.4281163, size.height * 0.5235476);
    hiroshimaPath.lineTo(size.width * 0.4281163, size.height * 0.5235476);
    hiroshimaPath.lineTo(size.width * 0.4281163, size.height * 0.5240515);
    hiroshimaPath.lineTo(size.width * 0.4329181, size.height * 0.5234314);
    hiroshimaPath.lineTo(size.width * 0.4338784, size.height * 0.5244003);
    hiroshimaPath.lineTo(size.width * 0.4338784, size.height * 0.5244003);
    hiroshimaPath.lineTo(size.width * 0.4361879, size.height * 0.5267646);
    hiroshimaPath.lineTo(size.width * 0.4351361, size.height * 0.5291095);
    hiroshimaPath.lineTo(size.width * 0.4351132, size.height * 0.5322102);
    hiroshimaPath.lineTo(size.width * 0.4387717, size.height * 0.5360860);
    hiroshimaPath.lineTo(size.width * 0.4381086, size.height * 0.5382565);
    hiroshimaPath.lineTo(size.width * 0.4390461, size.height * 0.5419385);
    hiroshimaPath.lineTo(size.width * 0.4390232, size.height * 0.5446129);
    hiroshimaPath.lineTo(size.width * 0.4417900, size.height * 0.5478105);
    hiroshimaPath.lineTo(size.width * 0.4420644, size.height * 0.5511824);
    hiroshimaPath.lineTo(size.width * 0.4420644, size.height * 0.5511824);
    hiroshimaPath.lineTo(size.width * 0.4410354, size.height * 0.5535855);
    hiroshimaPath.lineTo(size.width * 0.4390232, size.height * 0.5537599);
    hiroshimaPath.lineTo(size.width * 0.4389318, size.height * 0.5555040);
    hiroshimaPath.lineTo(size.width * 0.4381772, size.height * 0.5561048);
    hiroshimaPath.lineTo(size.width * 0.4326894, size.height * 0.5551164);
    hiroshimaPath.lineTo(size.width * 0.4325979, size.height * 0.5547095);
    hiroshimaPath.lineTo(size.width * 0.4339013, size.height * 0.5543413);
    hiroshimaPath.lineTo(size.width * 0.4338098, size.height * 0.5531785);
    hiroshimaPath.lineTo(size.width * 0.4325294, size.height * 0.5527715);
    hiroshimaPath.lineTo(size.width * 0.4326894, size.height * 0.5536049);
    hiroshimaPath.lineTo(size.width * 0.4311803, size.height * 0.5541862);
    hiroshimaPath.lineTo(size.width * 0.4274074, size.height * 0.5554846);
    hiroshimaPath.lineTo(size.width * 0.4257153, size.height * 0.5553102);
    hiroshimaPath.lineTo(size.width * 0.4251894, size.height * 0.5572094);
    hiroshimaPath.lineTo(size.width * 0.4223083, size.height * 0.5579652);
    hiroshimaPath.lineTo(size.width * 0.4193815, size.height * 0.5575582);
    hiroshimaPath.lineTo(size.width * 0.4167519, size.height * 0.5580621);
    hiroshimaPath.lineTo(size.width * 0.4159516, size.height * 0.5591667);
    hiroshimaPath.lineTo(size.width * 0.4146940, size.height * 0.5596706);
    hiroshimaPath.lineTo(size.width * 0.4141224, size.height * 0.5585853);
    hiroshimaPath.lineTo(size.width * 0.4124989, size.height * 0.5587404);
    hiroshimaPath.lineTo(size.width * 0.4119044, size.height * 0.5604070);
    hiroshimaPath.lineTo(size.width * 0.4108754, size.height * 0.5601163);
    hiroshimaPath.lineTo(size.width * 0.4107840, size.height * 0.5620154);
    hiroshimaPath.lineTo(size.width * 0.4081315, size.height * 0.5621705);
    hiroshimaPath.lineTo(size.width * 0.4051361, size.height * 0.5638177);
    hiroshimaPath.close();

    Paint hiroshimaPaint = Paint()..style = PaintingStyle.fill;
    hiroshimaPaint.color = japanColors.hiroshima ?? defaultColor;
    japanCanvas.drawPath(hiroshimaPath, hiroshimaPaint, onTapUp: (tabdetail) {
      callback('hiroshima', tabdetail);
    });

    Path ibarakiPath = Path();
    ibarakiPath.moveTo(size.width * 0.7626201, size.height * 0.4657006);
    ibarakiPath.lineTo(size.width * 0.7623914, size.height * 0.4698090);
    ibarakiPath.lineTo(size.width * 0.7644265, size.height * 0.4761460);
    ibarakiPath.lineTo(size.width * 0.7705545, size.height * 0.4868046);
    ibarakiPath.lineTo(size.width * 0.7742816, size.height * 0.4916300);
    ibarakiPath.lineTo(size.width * 0.7761566, size.height * 0.4925408);
    ibarakiPath.lineTo(size.width * 0.7762481, size.height * 0.4934129);
    ibarakiPath.lineTo(size.width * 0.7762481, size.height * 0.4934129);
    ibarakiPath.lineTo(size.width * 0.7705316, size.height * 0.4904285);
    ibarakiPath.lineTo(size.width * 0.7679935, size.height * 0.4874635);
    ibarakiPath.lineTo(size.width * 0.7651810, size.height * 0.4869596);
    ibarakiPath.lineTo(size.width * 0.7625972, size.height * 0.4850798);
    ibarakiPath.lineTo(size.width * 0.7605164, size.height * 0.4851573);
    ibarakiPath.lineTo(size.width * 0.7580469, size.height * 0.4841496);
    ibarakiPath.lineTo(size.width * 0.7534509, size.height * 0.4851573);
    ibarakiPath.lineTo(size.width * 0.7514844, size.height * 0.4867464);
    ibarakiPath.lineTo(size.width * 0.7496552, size.height * 0.4863007);
    ibarakiPath.lineTo(size.width * 0.7483061, size.height * 0.4870759);
    ibarakiPath.lineTo(size.width * 0.7463396, size.height * 0.4868627);
    ibarakiPath.lineTo(size.width * 0.7440073, size.height * 0.4876573);
    ibarakiPath.lineTo(size.width * 0.7426811, size.height * 0.4862620);
    ibarakiPath.lineTo(size.width * 0.7370561, size.height * 0.4845953);
    ibarakiPath.lineTo(size.width * 0.7346781, size.height * 0.4832388);
    ibarakiPath.lineTo(size.width * 0.7342207, size.height * 0.4818629);
    ibarakiPath.lineTo(size.width * 0.7325744, size.height * 0.4813978);
    ibarakiPath.lineTo(size.width * 0.7288473, size.height * 0.4775025);
    ibarakiPath.lineTo(size.width * 0.7280927, size.height * 0.4758747);
    ibarakiPath.lineTo(size.width * 0.7271323, size.height * 0.4758165);
    ibarakiPath.lineTo(size.width * 0.7271323, size.height * 0.4758165);
    ibarakiPath.lineTo(size.width * 0.7262406, size.height * 0.4764948);
    ibarakiPath.lineTo(size.width * 0.7253488, size.height * 0.4763010);
    ibarakiPath.lineTo(size.width * 0.7233595, size.height * 0.4725027);
    ibarakiPath.lineTo(size.width * 0.7237482, size.height * 0.4707779);
    ibarakiPath.lineTo(size.width * 0.7237482, size.height * 0.4707779);
    ibarakiPath.lineTo(size.width * 0.7254174, size.height * 0.4706617);
    ibarakiPath.lineTo(size.width * 0.7291903, size.height * 0.4689757);
    ibarakiPath.lineTo(size.width * 0.7304479, size.height * 0.4657006);
    ibarakiPath.lineTo(size.width * 0.7330317, size.height * 0.4662432);
    ibarakiPath.lineTo(size.width * 0.7333061, size.height * 0.4645378);
    ibarakiPath.lineTo(size.width * 0.7355927, size.height * 0.4636270);
    ibarakiPath.lineTo(size.width * 0.7358899, size.height * 0.4627549);
    ibarakiPath.lineTo(size.width * 0.7394570, size.height * 0.4625999);
    ibarakiPath.lineTo(size.width * 0.7400515, size.height * 0.4623480);
    ibarakiPath.lineTo(size.width * 0.7401659, size.height * 0.4613402);
    ibarakiPath.lineTo(size.width * 0.7416979, size.height * 0.4618054);
    ibarakiPath.lineTo(size.width * 0.7426354, size.height * 0.4609139);
    ibarakiPath.lineTo(size.width * 0.7436415, size.height * 0.4608751);
    ibarakiPath.lineTo(size.width * 0.7442817, size.height * 0.4616309);
    ibarakiPath.lineTo(size.width * 0.7458137, size.height * 0.4612240);
    ibarakiPath.lineTo(size.width * 0.7462939, size.height * 0.4589566);
    ibarakiPath.lineTo(size.width * 0.7483975, size.height * 0.4553714);
    ibarakiPath.lineTo(size.width * 0.7483518, size.height * 0.4518638);
    ibarakiPath.lineTo(size.width * 0.7470485, size.height * 0.4480848);
    ibarakiPath.lineTo(size.width * 0.7476887, size.height * 0.4473484);
    ibarakiPath.lineTo(size.width * 0.7498610, size.height * 0.4469415);
    ibarakiPath.lineTo(size.width * 0.7500896, size.height * 0.4463407);
    ibarakiPath.lineTo(size.width * 0.7486491, size.height * 0.4444028);
    ibarakiPath.lineTo(size.width * 0.7491521, size.height * 0.4418835);
    ibarakiPath.lineTo(size.width * 0.7485119, size.height * 0.4399649);
    ibarakiPath.lineTo(size.width * 0.7487177, size.height * 0.4361085);
    ibarakiPath.lineTo(size.width * 0.7487177, size.height * 0.4361085);
    ibarakiPath.lineTo(size.width * 0.7499753, size.height * 0.4361666);
    ibarakiPath.lineTo(size.width * 0.7517131, size.height * 0.4381433);
    ibarakiPath.lineTo(size.width * 0.7535881, size.height * 0.4386278);
    ibarakiPath.lineTo(size.width * 0.7543427, size.height * 0.4408758);
    ibarakiPath.lineTo(size.width * 0.7569494, size.height * 0.4416897);
    ibarakiPath.lineTo(size.width * 0.7579326, size.height * 0.4427943);
    ibarakiPath.lineTo(size.width * 0.7612710, size.height * 0.4400812);
    ibarakiPath.lineTo(size.width * 0.7638320, size.height * 0.4391316);
    ibarakiPath.lineTo(size.width * 0.7627801, size.height * 0.4366123);
    ibarakiPath.lineTo(size.width * 0.7635576, size.height * 0.4357209);
    ibarakiPath.lineTo(size.width * 0.7648609, size.height * 0.4377169);
    ibarakiPath.lineTo(size.width * 0.7727039, size.height * 0.4397324);
    ibarakiPath.lineTo(size.width * 0.7727039, size.height * 0.4397324);
    ibarakiPath.lineTo(size.width * 0.7727954, size.height * 0.4397711);
    ibarakiPath.lineTo(size.width * 0.7727954, size.height * 0.4397711);
    ibarakiPath.lineTo(size.width * 0.7728639, size.height * 0.4397905);
    ibarakiPath.lineTo(size.width * 0.7728639, size.height * 0.4397905);
    ibarakiPath.lineTo(size.width * 0.7732755, size.height * 0.4410308);
    ibarakiPath.lineTo(size.width * 0.7718350, size.height * 0.4413602);
    ibarakiPath.lineTo(size.width * 0.7707146, size.height * 0.4432013);
    ibarakiPath.lineTo(size.width * 0.7680164, size.height * 0.4509530);
    ibarakiPath.lineTo(size.width * 0.7664158, size.height * 0.4532203);
    ibarakiPath.lineTo(size.width * 0.7646323, size.height * 0.4576194);
    ibarakiPath.lineTo(size.width * 0.7649981, size.height * 0.4632007);
    ibarakiPath.lineTo(size.width * 0.7626201, size.height * 0.4657006);
    ibarakiPath.close();

    Paint ibarakiPaint = Paint()..style = PaintingStyle.fill;
    ibarakiPaint.color = japanColors.ibaraki ?? defaultColor;
    japanCanvas.drawPath(ibarakiPath, ibarakiPaint, onTapUp: (tabdetail) {
      callback('ibaraki', tabdetail);
    });

    Path ishikawaPath = Path();
    ishikawaPath.moveTo(size.width * 0.5893202, size.height * 0.4285699);
    ishikawaPath.lineTo(size.width * 0.5891830, size.height * 0.4260700);
    ishikawaPath.lineTo(size.width * 0.5884513, size.height * 0.4257987);
    ishikawaPath.lineTo(size.width * 0.5876281, size.height * 0.4264576);
    ishikawaPath.lineTo(size.width * 0.5869421, size.height * 0.4259150);
    ishikawaPath.lineTo(size.width * 0.5883369, size.height * 0.4213996);
    ishikawaPath.lineTo(size.width * 0.5892516, size.height * 0.4207213);
    ishikawaPath.lineTo(size.width * 0.5892516, size.height * 0.4174850);
    ishikawaPath.lineTo(size.width * 0.5900519, size.height * 0.4167486);
    ishikawaPath.lineTo(size.width * 0.5933445, size.height * 0.4144812);
    ishikawaPath.lineTo(size.width * 0.5959284, size.height * 0.4134929);
    ishikawaPath.lineTo(size.width * 0.5985122, size.height * 0.4140355);
    ishikawaPath.lineTo(size.width * 0.6051433, size.height * 0.4111674);
    ishikawaPath.lineTo(size.width * 0.6061037, size.height * 0.4100434);
    ishikawaPath.lineTo(size.width * 0.6083445, size.height * 0.4091132);
    ishikawaPath.lineTo(size.width * 0.6112485, size.height * 0.4087837);
    ishikawaPath.lineTo(size.width * 0.6142667, size.height * 0.4074078);
    ishikawaPath.lineTo(size.width * 0.6166219, size.height * 0.4076597);
    ishikawaPath.lineTo(size.width * 0.6176966, size.height * 0.4089388);
    ishikawaPath.lineTo(size.width * 0.6171478, size.height * 0.4098496);
    ishikawaPath.lineTo(size.width * 0.6180853, size.height * 0.4114193);
    ishikawaPath.lineTo(size.width * 0.6166905, size.height * 0.4119813);
    ishikawaPath.lineTo(size.width * 0.6143811, size.height * 0.4119038);
    ishikawaPath.lineTo(size.width * 0.6131692, size.height * 0.4126014);
    ishikawaPath.lineTo(size.width * 0.6125289, size.height * 0.4148688);
    ishikawaPath.lineTo(size.width * 0.6139009, size.height * 0.4169036);
    ishikawaPath.lineTo(size.width * 0.6123918, size.height * 0.4188028);
    ishikawaPath.lineTo(size.width * 0.6082988, size.height * 0.4187059);
    ishikawaPath.lineTo(size.width * 0.6062637, size.height * 0.4196749);
    ishikawaPath.lineTo(size.width * 0.6049604, size.height * 0.4225624);
    ishikawaPath.lineTo(size.width * 0.6023079, size.height * 0.4242290);
    ishikawaPath.lineTo(size.width * 0.6010274, size.height * 0.4232019);
    ishikawaPath.lineTo(size.width * 0.5999070, size.height * 0.4230469);
    ishikawaPath.lineTo(size.width * 0.6002957, size.height * 0.4218647);
    ishikawaPath.lineTo(size.width * 0.5994954, size.height * 0.4218647);
    ishikawaPath.lineTo(size.width * 0.5961570, size.height * 0.4260700);
    ishikawaPath.lineTo(size.width * 0.5973918, size.height * 0.4265157);
    ishikawaPath.lineTo(size.width * 0.5970031, size.height * 0.4277173);
    ishikawaPath.lineTo(size.width * 0.5958369, size.height * 0.4279498);
    ishikawaPath.lineTo(size.width * 0.5961113, size.height * 0.4287831);
    ishikawaPath.lineTo(size.width * 0.5955168, size.height * 0.4295389);
    ishikawaPath.lineTo(size.width * 0.5967973, size.height * 0.4297133);
    ishikawaPath.lineTo(size.width * 0.5980778, size.height * 0.4286087);
    ishikawaPath.lineTo(size.width * 0.6006616, size.height * 0.4307598);
    ishikawaPath.lineTo(size.width * 0.6023765, size.height * 0.4295001);
    ishikawaPath.lineTo(size.width * 0.6028338, size.height * 0.4281824);
    ishikawaPath.lineTo(size.width * 0.6041143, size.height * 0.4281824);
    ishikawaPath.lineTo(size.width * 0.6042058, size.height * 0.4349457);
    ishikawaPath.lineTo(size.width * 0.6042058, size.height * 0.4349457);
    ishikawaPath.lineTo(size.width * 0.6013704, size.height * 0.4347519);
    ishikawaPath.lineTo(size.width * 0.5997241, size.height * 0.4352558);
    ishikawaPath.lineTo(size.width * 0.5965229, size.height * 0.4379107);
    ishikawaPath.lineTo(size.width * 0.5951509, size.height * 0.4446741);
    ishikawaPath.lineTo(size.width * 0.5938933, size.height * 0.4459337);
    ishikawaPath.lineTo(size.width * 0.5935275, size.height * 0.4478329);
    ishikawaPath.lineTo(size.width * 0.5940534, size.height * 0.4487244);
    ishikawaPath.lineTo(size.width * 0.5923156, size.height * 0.4511080);
    ishikawaPath.lineTo(size.width * 0.5927500, size.height * 0.4532979);
    ishikawaPath.lineTo(size.width * 0.5938019, size.height * 0.4544219);
    ishikawaPath.lineTo(size.width * 0.5920869, size.height * 0.4601581);
    ishikawaPath.lineTo(size.width * 0.5931159, size.height * 0.4638014);
    ishikawaPath.lineTo(size.width * 0.5923842, size.height * 0.4646153);
    ishikawaPath.lineTo(size.width * 0.5927043, size.height * 0.4663207);
    ishikawaPath.lineTo(size.width * 0.5927043, size.height * 0.4663207);
    ishikawaPath.lineTo(size.width * 0.5932759, size.height * 0.4674447);
    ishikawaPath.lineTo(size.width * 0.5950137, size.height * 0.4682780);
    ishikawaPath.lineTo(size.width * 0.5951052, size.height * 0.4690338);
    ishikawaPath.lineTo(size.width * 0.5929558, size.height * 0.4722895);
    ishikawaPath.lineTo(size.width * 0.5915839, size.height * 0.4727352);
    ishikawaPath.lineTo(size.width * 0.5920869, size.height * 0.4741499);
    ishikawaPath.lineTo(size.width * 0.5909436, size.height * 0.4762623);
    ishikawaPath.lineTo(size.width * 0.5909436, size.height * 0.4762623);
    ishikawaPath.lineTo(size.width * 0.5866220, size.height * 0.4771925);
    ishikawaPath.lineTo(size.width * 0.5860732, size.height * 0.4759910);
    ishikawaPath.lineTo(size.width * 0.5818202, size.height * 0.4731616);
    ishikawaPath.lineTo(size.width * 0.5778187, size.height * 0.4739755);
    ishikawaPath.lineTo(size.width * 0.5767440, size.height * 0.4738786);
    ishikawaPath.lineTo(size.width * 0.5752577, size.height * 0.4724058);
    ishikawaPath.lineTo(size.width * 0.5731998, size.height * 0.4726577);
    ishikawaPath.lineTo(size.width * 0.5722623, size.height * 0.4719213);
    ishikawaPath.lineTo(size.width * 0.5716906, size.height * 0.4694989);
    ishikawaPath.lineTo(size.width * 0.5678492, size.height * 0.4664176);
    ishikawaPath.lineTo(size.width * 0.5678492, size.height * 0.4664176);
    ishikawaPath.lineTo(size.width * 0.5703644, size.height * 0.4637045);
    ishikawaPath.lineTo(size.width * 0.5724681, size.height * 0.4630844);
    ishikawaPath.lineTo(size.width * 0.5756921, size.height * 0.4604488);
    ishikawaPath.lineTo(size.width * 0.5859132, size.height * 0.4487631);
    ishikawaPath.lineTo(size.width * 0.5884055, size.height * 0.4449454);
    ishikawaPath.lineTo(size.width * 0.5914467, size.height * 0.4375813);
    ishikawaPath.lineTo(size.width * 0.5915381, size.height * 0.4331241);
    ishikawaPath.lineTo(size.width * 0.5893659, size.height * 0.4302559);
    ishikawaPath.lineTo(size.width * 0.5893202, size.height * 0.4285699);
    ishikawaPath.close();

    Paint ishikawaPaint = Paint()..style = PaintingStyle.fill;
    ishikawaPaint.color = japanColors.ishikawa ?? defaultColor;
    japanCanvas.drawPath(ishikawaPath, ishikawaPaint, onTapUp: (tabdetail) {
      callback('ishikawa', tabdetail);
    });

    Path iwatePath = Path();
    iwatePath.moveTo(size.width * 0.8228486, size.height * 0.3220810);
    iwatePath.lineTo(size.width * 0.8238090, size.height * 0.3223910);
    iwatePath.lineTo(size.width * 0.8239233, size.height * 0.3232631);
    iwatePath.lineTo(size.width * 0.8220254, size.height * 0.3231856);
    iwatePath.lineTo(size.width * 0.8232373, size.height * 0.3242127);
    iwatePath.lineTo(size.width * 0.8243806, size.height * 0.3241933);
    iwatePath.lineTo(size.width * 0.8251352, size.height * 0.3255111);
    iwatePath.lineTo(size.width * 0.8227800, size.height * 0.3263444);
    iwatePath.lineTo(size.width * 0.8211108, size.height * 0.3262863);
    iwatePath.lineTo(size.width * 0.8211337, size.height * 0.3269839);
    iwatePath.lineTo(size.width * 0.8222541, size.height * 0.3275072);
    iwatePath.lineTo(size.width * 0.8235117, size.height * 0.3272746);
    iwatePath.lineTo(size.width * 0.8235346, size.height * 0.3277397);
    iwatePath.lineTo(size.width * 0.8220254, size.height * 0.3287668);
    iwatePath.lineTo(size.width * 0.8203334, size.height * 0.3287087);
    iwatePath.lineTo(size.width * 0.8197388, size.height * 0.3292319);
    iwatePath.lineTo(size.width * 0.8235574, size.height * 0.3312474);
    iwatePath.lineTo(size.width * 0.8215910, size.height * 0.3318287);
    iwatePath.lineTo(size.width * 0.8187099, size.height * 0.3308016);
    iwatePath.lineTo(size.width * 0.8191901, size.height * 0.3326814);
    iwatePath.lineTo(size.width * 0.8215224, size.height * 0.3331853);
    iwatePath.lineTo(size.width * 0.8187327, size.height * 0.3335341);
    iwatePath.lineTo(size.width * 0.8204248, size.height * 0.3346387);
    iwatePath.lineTo(size.width * 0.8198074, size.height * 0.3351813);
    iwatePath.lineTo(size.width * 0.8173151, size.height * 0.3350263);
    iwatePath.lineTo(size.width * 0.8162404, size.height * 0.3355108);
    iwatePath.lineTo(size.width * 0.8152800, size.height * 0.3346000);
    iwatePath.lineTo(size.width * 0.8153715, size.height * 0.3334953);
    iwatePath.lineTo(size.width * 0.8145712, size.height * 0.3331659);
    iwatePath.lineTo(size.width * 0.8147084, size.height * 0.3343480);
    iwatePath.lineTo(size.width * 0.8140224, size.height * 0.3352007);
    iwatePath.lineTo(size.width * 0.8156001, size.height * 0.3368673);
    iwatePath.lineTo(size.width * 0.8146169, size.height * 0.3369836);
    iwatePath.lineTo(size.width * 0.8148684, size.height * 0.3387471);
    iwatePath.lineTo(size.width * 0.8137937, size.height * 0.3394060);
    iwatePath.lineTo(size.width * 0.8121474, size.height * 0.3375456);
    iwatePath.lineTo(size.width * 0.8127190, size.height * 0.3365185);
    iwatePath.lineTo(size.width * 0.8122617, size.height * 0.3361503);
    iwatePath.lineTo(size.width * 0.8101581, size.height * 0.3363247);
    iwatePath.lineTo(size.width * 0.8105239, size.height * 0.3377782);
    iwatePath.lineTo(size.width * 0.8105239, size.height * 0.3377782);
    iwatePath.lineTo(size.width * 0.8078486, size.height * 0.3368286);
    iwatePath.lineTo(size.width * 0.8045560, size.height * 0.3365766);
    iwatePath.lineTo(size.width * 0.8040072, size.height * 0.3375844);
    iwatePath.lineTo(size.width * 0.8042587, size.height * 0.3410339);
    iwatePath.lineTo(size.width * 0.8027038, size.height * 0.3423904);
    iwatePath.lineTo(size.width * 0.8029325, size.height * 0.3433788);
    iwatePath.lineTo(size.width * 0.8017892, size.height * 0.3471383);
    iwatePath.lineTo(size.width * 0.7961871, size.height * 0.3452004);
    iwatePath.lineTo(size.width * 0.7941291, size.height * 0.3468864);
    iwatePath.lineTo(size.width * 0.7937404, size.height * 0.3482430);
    iwatePath.lineTo(size.width * 0.7925514, size.height * 0.3485918);
    iwatePath.lineTo(size.width * 0.7885042, size.height * 0.3466345);
    iwatePath.lineTo(size.width * 0.7874295, size.height * 0.3445221);
    iwatePath.lineTo(size.width * 0.7887785, size.height * 0.3434563);
    iwatePath.lineTo(size.width * 0.7882069, size.height * 0.3424873);
    iwatePath.lineTo(size.width * 0.7865606, size.height * 0.3420997);
    iwatePath.lineTo(size.width * 0.7815072, size.height * 0.3425842);
    iwatePath.lineTo(size.width * 0.7802496, size.height * 0.3410145);
    iwatePath.lineTo(size.width * 0.7769569, size.height * 0.3400843);
    iwatePath.lineTo(size.width * 0.7741673, size.height * 0.3383208);
    iwatePath.lineTo(size.width * 0.7719950, size.height * 0.3385921);
    iwatePath.lineTo(size.width * 0.7719950, size.height * 0.3385921);
    iwatePath.lineTo(size.width * 0.7718121, size.height * 0.3363635);
    iwatePath.lineTo(size.width * 0.7736185, size.height * 0.3337085);
    iwatePath.lineTo(size.width * 0.7732984, size.height * 0.3329333);
    iwatePath.lineTo(size.width * 0.7710804, size.height * 0.3321969);
    iwatePath.lineTo(size.width * 0.7717207, size.height * 0.3303171);
    iwatePath.lineTo(size.width * 0.7711033, size.height * 0.3298908);
    iwatePath.lineTo(size.width * 0.7721780, size.height * 0.3282823);
    iwatePath.lineTo(size.width * 0.7735499, size.height * 0.3277009);
    iwatePath.lineTo(size.width * 0.7716063, size.height * 0.3268483);
    iwatePath.lineTo(size.width * 0.7723609, size.height * 0.3247941);
    iwatePath.lineTo(size.width * 0.7697999, size.height * 0.3233019);
    iwatePath.lineTo(size.width * 0.7685880, size.height * 0.3218484);
    iwatePath.lineTo(size.width * 0.7689310, size.height * 0.3200655);
    iwatePath.lineTo(size.width * 0.7675591, size.height * 0.3176431);
    iwatePath.lineTo(size.width * 0.7666673, size.height * 0.3174687);
    iwatePath.lineTo(size.width * 0.7667816, size.height * 0.3162091);
    iwatePath.lineTo(size.width * 0.7678106, size.height * 0.3159765);
    iwatePath.lineTo(size.width * 0.7676963, size.height * 0.3144068);
    iwatePath.lineTo(size.width * 0.7694798, size.height * 0.3127595);
    iwatePath.lineTo(size.width * 0.7704630, size.height * 0.3101627);
    iwatePath.lineTo(size.width * 0.7699829, size.height * 0.3087674);
    iwatePath.lineTo(size.width * 0.7709432, size.height * 0.3085543);
    iwatePath.lineTo(size.width * 0.7723380, size.height * 0.3068876);
    iwatePath.lineTo(size.width * 0.7729554, size.height * 0.3069458);
    iwatePath.lineTo(size.width * 0.7741216, size.height * 0.3046396);
    iwatePath.lineTo(size.width * 0.7738243, size.height * 0.3025467);
    iwatePath.lineTo(size.width * 0.7723152, size.height * 0.3002793);
    iwatePath.lineTo(size.width * 0.7732069, size.height * 0.3000080);
    iwatePath.lineTo(size.width * 0.7750819, size.height * 0.2971593);
    iwatePath.lineTo(size.width * 0.7725210, size.height * 0.2958802);
    iwatePath.lineTo(size.width * 0.7723609, size.height * 0.2938260);
    iwatePath.lineTo(size.width * 0.7742359, size.height * 0.2929540);
    iwatePath.lineTo(size.width * 0.7753563, size.height * 0.2938842);
    iwatePath.lineTo(size.width * 0.7766368, size.height * 0.2935353);
    iwatePath.lineTo(size.width * 0.7752191, size.height * 0.2886905);
    iwatePath.lineTo(size.width * 0.7753335, size.height * 0.2834969);
    iwatePath.lineTo(size.width * 0.7765225, size.height * 0.2826054);
    iwatePath.lineTo(size.width * 0.7768655, size.height * 0.2795823);
    iwatePath.lineTo(size.width * 0.7759508, size.height * 0.2786327);
    iwatePath.lineTo(size.width * 0.7778030, size.height * 0.2764816);
    iwatePath.lineTo(size.width * 0.7791978, size.height * 0.2760553);
    iwatePath.lineTo(size.width * 0.7801124, size.height * 0.2749506);
    iwatePath.lineTo(size.width * 0.7801124, size.height * 0.2749506);
    iwatePath.lineTo(size.width * 0.7811642, size.height * 0.2762684);
    iwatePath.lineTo(size.width * 0.7833136, size.height * 0.2762878);
    iwatePath.lineTo(size.width * 0.7856002, size.height * 0.2747762);
    iwatePath.lineTo(size.width * 0.7866520, size.height * 0.2747375);
    iwatePath.lineTo(size.width * 0.7867435, size.height * 0.2733422);
    iwatePath.lineTo(size.width * 0.7884356, size.height * 0.2723732);
    iwatePath.lineTo(size.width * 0.7919112, size.height * 0.2716368);
    iwatePath.lineTo(size.width * 0.7963929, size.height * 0.2687493);
    iwatePath.lineTo(size.width * 0.7979477, size.height * 0.2708422);
    iwatePath.lineTo(size.width * 0.8018807, size.height * 0.2687105);
    iwatePath.lineTo(size.width * 0.8034355, size.height * 0.2685361);
    iwatePath.lineTo(size.width * 0.8062709, size.height * 0.2700283);
    iwatePath.lineTo(size.width * 0.8083059, size.height * 0.2686911);
    iwatePath.lineTo(size.width * 0.8085575, size.height * 0.2670827);
    iwatePath.lineTo(size.width * 0.8117358, size.height * 0.2658811);
    iwatePath.lineTo(size.width * 0.8128105, size.height * 0.2648347);
    iwatePath.lineTo(size.width * 0.8128105, size.height * 0.2648347);
    iwatePath.lineTo(size.width * 0.8159431, size.height * 0.2687880);
    iwatePath.lineTo(size.width * 0.8194645, size.height * 0.2754933);
    iwatePath.lineTo(size.width * 0.8172236, size.height * 0.2775862);
    iwatePath.lineTo(size.width * 0.8204020, size.height * 0.2787490);
    iwatePath.lineTo(size.width * 0.8214538, size.height * 0.2799892);
    iwatePath.lineTo(size.width * 0.8211794, size.height * 0.2804737);
    iwatePath.lineTo(size.width * 0.8200590, size.height * 0.2804931);
    iwatePath.lineTo(size.width * 0.8192358, size.height * 0.2815396);
    iwatePath.lineTo(size.width * 0.8194873, size.height * 0.2834387);
    iwatePath.lineTo(size.width * 0.8202419, size.height * 0.2843689);
    iwatePath.lineTo(size.width * 0.8214080, size.height * 0.2846984);
    iwatePath.lineTo(size.width * 0.8225285, size.height * 0.2864231);
    iwatePath.lineTo(size.width * 0.8241062, size.height * 0.2866557);
    iwatePath.lineTo(size.width * 0.8250208, size.height * 0.2880122);
    iwatePath.lineTo(size.width * 0.8242891, size.height * 0.2911129);
    iwatePath.lineTo(size.width * 0.8259355, size.height * 0.2934578);
    iwatePath.lineTo(size.width * 0.8264614, size.height * 0.2992328);
    iwatePath.lineTo(size.width * 0.8255010, size.height * 0.3025079);
    iwatePath.lineTo(size.width * 0.8265071, size.height * 0.3026436);
    iwatePath.lineTo(size.width * 0.8245635, size.height * 0.3076240);
    iwatePath.lineTo(size.width * 0.8251352, size.height * 0.3076240);
    iwatePath.lineTo(size.width * 0.8281763, size.height * 0.3041358);
    iwatePath.lineTo(size.width * 0.8282221, size.height * 0.3080504);
    iwatePath.lineTo(size.width * 0.8295940, size.height * 0.3082054);
    iwatePath.lineTo(size.width * 0.8302571, size.height * 0.3095620);
    iwatePath.lineTo(size.width * 0.8299141, size.height * 0.3102596);
    iwatePath.lineTo(size.width * 0.8284964, size.height * 0.3104147);
    iwatePath.lineTo(size.width * 0.8265300, size.height * 0.3126820);
    iwatePath.lineTo(size.width * 0.8249294, size.height * 0.3131665);
    iwatePath.lineTo(size.width * 0.8259126, size.height * 0.3148719);
    iwatePath.lineTo(size.width * 0.8285650, size.height * 0.3126820);
    iwatePath.lineTo(size.width * 0.8292739, size.height * 0.3125851);
    iwatePath.lineTo(size.width * 0.8297312, size.height * 0.3133022);
    iwatePath.lineTo(size.width * 0.8287480, size.height * 0.3158796);
    iwatePath.lineTo(size.width * 0.8261870, size.height * 0.3163835);
    iwatePath.lineTo(size.width * 0.8241519, size.height * 0.3175462);
    iwatePath.lineTo(size.width * 0.8222998, size.height * 0.3198524);
    iwatePath.lineTo(size.width * 0.8230773, size.height * 0.3205306);
    iwatePath.lineTo(size.width * 0.8248836, size.height * 0.3197167);
    iwatePath.lineTo(size.width * 0.8258897, size.height * 0.3207632);
    iwatePath.lineTo(size.width * 0.8220026, size.height * 0.3213252);
    iwatePath.lineTo(size.width * 0.8228486, size.height * 0.3220810);
    iwatePath.close();

    Paint iwatePaint = Paint()..style = PaintingStyle.fill;
    iwatePaint.color = japanColors.iwate ?? defaultColor;
    japanCanvas.drawPath(iwatePath, iwatePaint, onTapUp: (tabdetail) {
      callback('iwate', tabdetail);
    });

    Path kochiPath = Path();
    kochiPath.moveTo(size.width * 0.4264699, size.height * 0.6155991);
    kochiPath.lineTo(size.width * 0.4259211, size.height * 0.6175951);
    kochiPath.lineTo(size.width * 0.4236117, size.height * 0.6169169);
    kochiPath.lineTo(size.width * 0.4222397, size.height * 0.6177695);
    kochiPath.lineTo(size.width * 0.4212336, size.height * 0.6208508);
    kochiPath.lineTo(size.width * 0.4220111, size.height * 0.6240678);
    kochiPath.lineTo(size.width * 0.4194044, size.height * 0.6249980);
    kochiPath.lineTo(size.width * 0.4193586, size.height * 0.6271297);
    kochiPath.lineTo(size.width * 0.4217138, size.height * 0.6283506);
    kochiPath.lineTo(size.width * 0.4224684, size.height * 0.6312187);
    kochiPath.lineTo(size.width * 0.4217596, size.height * 0.6313156);
    kochiPath.lineTo(size.width * 0.4179181, size.height * 0.6284088);
    kochiPath.lineTo(size.width * 0.4161574, size.height * 0.6281956);
    kochiPath.lineTo(size.width * 0.4153571, size.height * 0.6281956);
    kochiPath.lineTo(size.width * 0.4125904, size.height * 0.6302110);
    kochiPath.lineTo(size.width * 0.4112413, size.height * 0.6295134);
    kochiPath.lineTo(size.width * 0.4106010, size.height * 0.6299010);
    kochiPath.lineTo(size.width * 0.4085203, size.height * 0.6278468);
    kochiPath.lineTo(size.width * 0.4048846, size.height * 0.6295521);
    kochiPath.lineTo(size.width * 0.4046788, size.height * 0.6279243);
    kochiPath.lineTo(size.width * 0.4062337, size.height * 0.6259670);
    kochiPath.lineTo(size.width * 0.4061194, size.height * 0.6252693);
    kochiPath.lineTo(size.width * 0.4087718, size.height * 0.6228275);
    kochiPath.lineTo(size.width * 0.4082230, size.height * 0.6220911);
    kochiPath.lineTo(size.width * 0.4063251, size.height * 0.6222268);
    kochiPath.lineTo(size.width * 0.4064395, size.height * 0.6214904);
    kochiPath.lineTo(size.width * 0.4073770, size.height * 0.6212966);
    kochiPath.lineTo(size.width * 0.4073998, size.height * 0.6187191);
    kochiPath.lineTo(size.width * 0.4062337, size.height * 0.6162967);
    kochiPath.lineTo(size.width * 0.4066910, size.height * 0.6145138);
    kochiPath.lineTo(size.width * 0.4049532, size.height * 0.6128472);
    kochiPath.lineTo(size.width * 0.4043358, size.height * 0.6111418);
    kochiPath.lineTo(size.width * 0.4051133, size.height * 0.6104248);
    kochiPath.lineTo(size.width * 0.4075142, size.height * 0.6127116);
    kochiPath.lineTo(size.width * 0.4079486, size.height * 0.6125759);
    kochiPath.lineTo(size.width * 0.4098922, size.height * 0.6099016);
    kochiPath.lineTo(size.width * 0.4112642, size.height * 0.6095721);
    kochiPath.lineTo(size.width * 0.4123846, size.height * 0.6063552);
    kochiPath.lineTo(size.width * 0.4151513, size.height * 0.6055412);
    kochiPath.lineTo(size.width * 0.4171864, size.height * 0.6042428);
    kochiPath.lineTo(size.width * 0.4170949, size.height * 0.6031382);
    kochiPath.lineTo(size.width * 0.4154715, size.height * 0.6021499);
    kochiPath.lineTo(size.width * 0.4130020, size.height * 0.5979252);
    kochiPath.lineTo(size.width * 0.4146712, size.height * 0.5971306);
    kochiPath.lineTo(size.width * 0.4196330, size.height * 0.5976345);
    kochiPath.lineTo(size.width * 0.4223769, size.height * 0.5969756);
    kochiPath.lineTo(size.width * 0.4245263, size.height * 0.5942238);
    kochiPath.lineTo(size.width * 0.4237946, size.height * 0.5926734);
    kochiPath.lineTo(size.width * 0.4252123, size.height * 0.5891076);
    kochiPath.lineTo(size.width * 0.4271102, size.height * 0.5883712);
    kochiPath.lineTo(size.width * 0.4272474, size.height * 0.5873054);
    kochiPath.lineTo(size.width * 0.4289623, size.height * 0.5855612);
    kochiPath.lineTo(size.width * 0.4304486, size.height * 0.5826931);
    kochiPath.lineTo(size.width * 0.4316833, size.height * 0.5833326);
    kochiPath.lineTo(size.width * 0.4328723, size.height * 0.5829644);
    kochiPath.lineTo(size.width * 0.4342214, size.height * 0.5810071);
    kochiPath.lineTo(size.width * 0.4441452, size.height * 0.5810846);
    kochiPath.lineTo(size.width * 0.4463632, size.height * 0.5787591);
    kochiPath.lineTo(size.width * 0.4479866, size.height * 0.5793405);
    kochiPath.lineTo(size.width * 0.4490613, size.height * 0.5787010);
    kochiPath.lineTo(size.width * 0.4514851, size.height * 0.5787010);
    kochiPath.lineTo(size.width * 0.4514851, size.height * 0.5787010);
    kochiPath.lineTo(size.width * 0.4523311, size.height * 0.5797475);
    kochiPath.lineTo(size.width * 0.4553952, size.height * 0.5807552);
    kochiPath.lineTo(size.width * 0.4595339, size.height * 0.5804257);
    kochiPath.lineTo(size.width * 0.4610201, size.height * 0.5821699);
    kochiPath.lineTo(size.width * 0.4628265, size.height * 0.5827900);
    kochiPath.lineTo(size.width * 0.4642214, size.height * 0.5824024);
    kochiPath.lineTo(size.width * 0.4651817, size.height * 0.5808327);
    kochiPath.lineTo(size.width * 0.4660735, size.height * 0.5805808);
    kochiPath.lineTo(size.width * 0.4666451, size.height * 0.5814722);
    kochiPath.lineTo(size.width * 0.4682457, size.height * 0.5811428);
    kochiPath.lineTo(size.width * 0.4694119, size.height * 0.5835846);
    kochiPath.lineTo(size.width * 0.4696405, size.height * 0.5874604);
    kochiPath.lineTo(size.width * 0.4741451, size.height * 0.5875573);
    kochiPath.lineTo(size.width * 0.4746710, size.height * 0.5891076);
    kochiPath.lineTo(size.width * 0.4735963, size.height * 0.5901541);
    kochiPath.lineTo(size.width * 0.4738250, size.height * 0.5910649);
    kochiPath.lineTo(size.width * 0.4756085, size.height * 0.5933711);
    kochiPath.lineTo(size.width * 0.4804332, size.height * 0.5937974);
    kochiPath.lineTo(size.width * 0.4804332, size.height * 0.5937974);
    kochiPath.lineTo(size.width * 0.4761344, size.height * 0.6007352);
    kochiPath.lineTo(size.width * 0.4746482, size.height * 0.6076536);
    kochiPath.lineTo(size.width * 0.4729561, size.height * 0.6053087);
    kochiPath.lineTo(size.width * 0.4715613, size.height * 0.6053087);
    kochiPath.lineTo(size.width * 0.4712869, size.height * 0.6038940);
    kochiPath.lineTo(size.width * 0.4690460, size.height * 0.6019561);
    kochiPath.lineTo(size.width * 0.4680628, size.height * 0.5999600);
    kochiPath.lineTo(size.width * 0.4648387, size.height * 0.5986422);
    kochiPath.lineTo(size.width * 0.4636726, size.height * 0.5965493);
    kochiPath.lineTo(size.width * 0.4562869, size.height * 0.5953865);
    kochiPath.lineTo(size.width * 0.4552580, size.height * 0.5943207);
    kochiPath.lineTo(size.width * 0.4480552, size.height * 0.5952896);
    kochiPath.lineTo(size.width * 0.4474836, size.height * 0.5962004);
    kochiPath.lineTo(size.width * 0.4421559, size.height * 0.5984678);
    kochiPath.lineTo(size.width * 0.4422016, size.height * 0.5997081);
    kochiPath.lineTo(size.width * 0.4371940, size.height * 0.6005026);
    kochiPath.lineTo(size.width * 0.4359364, size.height * 0.6025762);
    kochiPath.lineTo(size.width * 0.4353647, size.height * 0.6014522);
    kochiPath.lineTo(size.width * 0.4332611, size.height * 0.6020336);
    kochiPath.lineTo(size.width * 0.4334440, size.height * 0.6032351);
    kochiPath.lineTo(size.width * 0.4328266, size.height * 0.6037777);
    kochiPath.lineTo(size.width * 0.4333068, size.height * 0.6046304);
    kochiPath.lineTo(size.width * 0.4325294, size.height * 0.6061808);
    kochiPath.lineTo(size.width * 0.4333068, size.height * 0.6060063);
    kochiPath.lineTo(size.width * 0.4334668, size.height * 0.6070334);
    kochiPath.lineTo(size.width * 0.4327123, size.height * 0.6074016);
    kochiPath.lineTo(size.width * 0.4331467, size.height * 0.6084869);
    kochiPath.lineTo(size.width * 0.4310888, size.height * 0.6103085);
    kochiPath.lineTo(size.width * 0.4316605, size.height * 0.6117232);
    kochiPath.lineTo(size.width * 0.4311117, size.height * 0.6120139);
    kochiPath.lineTo(size.width * 0.4309516, size.height * 0.6112387);
    kochiPath.lineTo(size.width * 0.4299455, size.height * 0.6112969);
    kochiPath.lineTo(size.width * 0.4264699, size.height * 0.6155991);
    kochiPath.close();

    Paint kochiPaint = Paint()..style = PaintingStyle.fill;
    kochiPaint.color = japanColors.kochi ?? defaultColor;
    japanCanvas.drawPath(kochiPath, kochiPaint, onTapUp: (tabdetail) {
      callback('kochi', tabdetail);
    });

    Path kagawaPath = Path();
    kagawaPath.moveTo(size.width * 0.4565842, size.height * 0.5597093);
    kagawaPath.lineTo(size.width * 0.4614775, size.height * 0.5573450);
    kagawaPath.lineTo(size.width * 0.4618890, size.height * 0.5554846);
    kagawaPath.lineTo(size.width * 0.4666451, size.height * 0.5568412);
    kagawaPath.lineTo(size.width * 0.4703265, size.height * 0.5569768);
    kagawaPath.lineTo(size.width * 0.4727732, size.height * 0.5546513);
    kagawaPath.lineTo(size.width * 0.4739851, size.height * 0.5553877);
    kagawaPath.lineTo(size.width * 0.4735506, size.height * 0.5572482);
    kagawaPath.lineTo(size.width * 0.4739622, size.height * 0.5579652);
    kagawaPath.lineTo(size.width * 0.4747854, size.height * 0.5580815);
    kagawaPath.lineTo(size.width * 0.4750826, size.height * 0.5573063);
    kagawaPath.lineTo(size.width * 0.4761116, size.height * 0.5571319);
    kagawaPath.lineTo(size.width * 0.4786497, size.height * 0.5575776);
    kagawaPath.lineTo(size.width * 0.4786268, size.height * 0.5583721);
    kagawaPath.lineTo(size.width * 0.4777350, size.height * 0.5589729);
    kagawaPath.lineTo(size.width * 0.4781695, size.height * 0.5599031);
    kagawaPath.lineTo(size.width * 0.4807533, size.height * 0.5604070);
    kagawaPath.lineTo(size.width * 0.4826283, size.height * 0.5616279);
    kagawaPath.lineTo(size.width * 0.4835201, size.height * 0.5615116);
    kagawaPath.lineTo(size.width * 0.4866527, size.height * 0.5635464);
    kagawaPath.lineTo(size.width * 0.4866527, size.height * 0.5635464);
    kagawaPath.lineTo(size.width * 0.4862869, size.height * 0.5654068);
    kagawaPath.lineTo(size.width * 0.4853265, size.height * 0.5658332);
    kagawaPath.lineTo(size.width * 0.4828341, size.height * 0.5647092);
    kagawaPath.lineTo(size.width * 0.4821939, size.height * 0.5652905);
    kagawaPath.lineTo(size.width * 0.4784667, size.height * 0.5647867);
    kagawaPath.lineTo(size.width * 0.4745796, size.height * 0.5651355);
    kagawaPath.lineTo(size.width * 0.4728875, size.height * 0.5662595);
    kagawaPath.lineTo(size.width * 0.4730247, size.height * 0.5670734);
    kagawaPath.lineTo(size.width * 0.4722930, size.height * 0.5677323);
    kagawaPath.lineTo(size.width * 0.4694576, size.height * 0.5680036);
    kagawaPath.lineTo(size.width * 0.4667823, size.height * 0.5697671);
    kagawaPath.lineTo(size.width * 0.4657076, size.height * 0.5697671);
    kagawaPath.lineTo(size.width * 0.4637412, size.height * 0.5678874);
    kagawaPath.lineTo(size.width * 0.4605857, size.height * 0.5683718);
    kagawaPath.lineTo(size.width * 0.4588479, size.height * 0.5689338);
    kagawaPath.lineTo(size.width * 0.4582076, size.height * 0.5699028);
    kagawaPath.lineTo(size.width * 0.4568814, size.height * 0.5695346);
    kagawaPath.lineTo(size.width * 0.4545949, size.height * 0.5711625);
    kagawaPath.lineTo(size.width * 0.4542747, size.height * 0.5721508);
    kagawaPath.lineTo(size.width * 0.4528570, size.height * 0.5725771);
    kagawaPath.lineTo(size.width * 0.4528570, size.height * 0.5725771);
    kagawaPath.lineTo(size.width * 0.4485583, size.height * 0.5711431);
    kagawaPath.lineTo(size.width * 0.4501360, size.height * 0.5701741);
    kagawaPath.lineTo(size.width * 0.4508906, size.height * 0.5642053);
    kagawaPath.lineTo(size.width * 0.4474379, size.height * 0.5618604);
    kagawaPath.lineTo(size.width * 0.4475979, size.height * 0.5612209);
    kagawaPath.lineTo(size.width * 0.4483068, size.height * 0.5610465);
    kagawaPath.lineTo(size.width * 0.4519424, size.height * 0.5625968);
    kagawaPath.lineTo(size.width * 0.4532000, size.height * 0.5622674);
    kagawaPath.lineTo(size.width * 0.4565842, size.height * 0.5597093);
    kagawaPath.close();

    Paint kagawaPaint = Paint()..style = PaintingStyle.fill;
    kagawaPaint.color = japanColors.kagawa ?? defaultColor;
    japanCanvas.drawPath(kagawaPath, kagawaPaint, onTapUp: (tabdetail) {
      callback('kagawa', tabdetail);
    });

    Path kumamotoPath = Path();
    kumamotoPath.moveTo(size.width * 0.3192750, size.height * 0.6593187);
    kumamotoPath.lineTo(size.width * 0.3164168, size.height * 0.6580590);
    kumamotoPath.lineTo(size.width * 0.3158223, size.height * 0.6571094);
    kumamotoPath.lineTo(size.width * 0.3145189, size.height * 0.6568575);
    kumamotoPath.lineTo(size.width * 0.3136043, size.height * 0.6554816);
    kumamotoPath.lineTo(size.width * 0.3123696, size.height * 0.6569544);
    kumamotoPath.lineTo(size.width * 0.3102888, size.height * 0.6577489);
    kumamotoPath.lineTo(size.width * 0.3083680, size.height * 0.6577296);
    kumamotoPath.lineTo(size.width * 0.3069961, size.height * 0.6587954);
    kumamotoPath.lineTo(size.width * 0.3046181, size.height * 0.6584853);
    kumamotoPath.lineTo(size.width * 0.3038863, size.height * 0.6572838);
    kumamotoPath.lineTo(size.width * 0.3026516, size.height * 0.6567800);
    kumamotoPath.lineTo(size.width * 0.3026516, size.height * 0.6567800);
    kumamotoPath.lineTo(size.width * 0.3030632, size.height * 0.6546870);
    kumamotoPath.lineTo(size.width * 0.3054412, size.height * 0.6524972);
    kumamotoPath.lineTo(size.width * 0.3082994, size.height * 0.6474004);
    kumamotoPath.lineTo(size.width * 0.3120952, size.height * 0.6441641);
    kumamotoPath.lineTo(size.width * 0.3118208, size.height * 0.6423037);
    kumamotoPath.lineTo(size.width * 0.3109519, size.height * 0.6422455);
    kumamotoPath.lineTo(size.width * 0.3107918, size.height * 0.6413735);
    kumamotoPath.lineTo(size.width * 0.3123238, size.height * 0.6414316);
    kumamotoPath.lineTo(size.width * 0.3126211, size.height * 0.6410053);
    kumamotoPath.lineTo(size.width * 0.3105632, size.height * 0.6399394);
    kumamotoPath.lineTo(size.width * 0.3161424, size.height * 0.6352496);
    kumamotoPath.lineTo(size.width * 0.3156165, size.height * 0.6348620);
    kumamotoPath.lineTo(size.width * 0.3130784, size.height * 0.6357535);
    kumamotoPath.lineTo(size.width * 0.3070876, size.height * 0.6359473);
    kumamotoPath.lineTo(size.width * 0.3071104, size.height * 0.6352109);
    kumamotoPath.lineTo(size.width * 0.3133299, size.height * 0.6316645);
    kumamotoPath.lineTo(size.width * 0.3132842, size.height * 0.6287188);
    kumamotoPath.lineTo(size.width * 0.3138101, size.height * 0.6280405);
    kumamotoPath.lineTo(size.width * 0.3118665, size.height * 0.6257926);
    kumamotoPath.lineTo(size.width * 0.3101058, size.height * 0.6254437);
    kumamotoPath.lineTo(size.width * 0.3098086, size.height * 0.6239903);
    kumamotoPath.lineTo(size.width * 0.3064702, size.height * 0.6226725);
    kumamotoPath.lineTo(size.width * 0.3057385, size.height * 0.6192811);
    kumamotoPath.lineTo(size.width * 0.3044351, size.height * 0.6183509);
    kumamotoPath.lineTo(size.width * 0.3044351, size.height * 0.6183509);
    kumamotoPath.lineTo(size.width * 0.3093284, size.height * 0.6185060);
    kumamotoPath.lineTo(size.width * 0.3089168, size.height * 0.6164324);
    kumamotoPath.lineTo(size.width * 0.3126211, size.height * 0.6135449);
    kumamotoPath.lineTo(size.width * 0.3160510, size.height * 0.6138743);
    kumamotoPath.lineTo(size.width * 0.3172628, size.height * 0.6110837);
    kumamotoPath.lineTo(size.width * 0.3176287, size.height * 0.6118589);
    kumamotoPath.lineTo(size.width * 0.3194808, size.height * 0.6117814);
    kumamotoPath.lineTo(size.width * 0.3210128, size.height * 0.6129635);
    kumamotoPath.lineTo(size.width * 0.3245113, size.height * 0.6139712);
    kumamotoPath.lineTo(size.width * 0.3245113, size.height * 0.6139712);
    kumamotoPath.lineTo(size.width * 0.3244884, size.height * 0.6145332);
    kumamotoPath.lineTo(size.width * 0.3264778, size.height * 0.6148627);
    kumamotoPath.lineTo(size.width * 0.3278497, size.height * 0.6163936);
    kumamotoPath.lineTo(size.width * 0.3292903, size.height * 0.6164905);
    kumamotoPath.lineTo(size.width * 0.3302049, size.height * 0.6177114);
    kumamotoPath.lineTo(size.width * 0.3310738, size.height * 0.6177308);
    kumamotoPath.lineTo(size.width * 0.3321942, size.height * 0.6165099);
    kumamotoPath.lineTo(size.width * 0.3326058, size.height * 0.6148627);
    kumamotoPath.lineTo(size.width * 0.3307079, size.height * 0.6125178);
    kumamotoPath.lineTo(size.width * 0.3310052, size.height * 0.6110837);
    kumamotoPath.lineTo(size.width * 0.3333375, size.height * 0.6099985);
    kumamotoPath.lineTo(size.width * 0.3365616, size.height * 0.6105023);
    kumamotoPath.lineTo(size.width * 0.3389396, size.height * 0.6126147);
    kumamotoPath.lineTo(size.width * 0.3393741, size.height * 0.6148820);
    kumamotoPath.lineTo(size.width * 0.3413405, size.height * 0.6163936);
    kumamotoPath.lineTo(size.width * 0.3426896, size.height * 0.6195331);
    kumamotoPath.lineTo(size.width * 0.3431698, size.height * 0.6239321);
    kumamotoPath.lineTo(size.width * 0.3463710, size.height * 0.6263933);
    kumamotoPath.lineTo(size.width * 0.3463710, size.height * 0.6263933);
    kumamotoPath.lineTo(size.width * 0.3434899, size.height * 0.6267034);
    kumamotoPath.lineTo(size.width * 0.3422094, size.height * 0.6286413);
    kumamotoPath.lineTo(size.width * 0.3421408, size.height * 0.6303854);
    kumamotoPath.lineTo(size.width * 0.3399229, size.height * 0.6316257);
    kumamotoPath.lineTo(size.width * 0.3394655, size.height * 0.6334280);
    kumamotoPath.lineTo(size.width * 0.3381165, size.height * 0.6334280);
    kumamotoPath.lineTo(size.width * 0.3372933, size.height * 0.6344745);
    kumamotoPath.lineTo(size.width * 0.3367216, size.height * 0.6372069);
    kumamotoPath.lineTo(size.width * 0.3356698, size.height * 0.6378658);
    kumamotoPath.lineTo(size.width * 0.3340463, size.height * 0.6374589);
    kumamotoPath.lineTo(size.width * 0.3333832, size.height * 0.6388542);
    kumamotoPath.lineTo(size.width * 0.3324686, size.height * 0.6391836);
    kumamotoPath.lineTo(size.width * 0.3318970, size.height * 0.6418580);
    kumamotoPath.lineTo(size.width * 0.3324686, size.height * 0.6440478);
    kumamotoPath.lineTo(size.width * 0.3334290, size.height * 0.6453656);
    kumamotoPath.lineTo(size.width * 0.3344351, size.height * 0.6455400);
    kumamotoPath.lineTo(size.width * 0.3348695, size.height * 0.6477686);
    kumamotoPath.lineTo(size.width * 0.3366073, size.height * 0.6490864);
    kumamotoPath.lineTo(size.width * 0.3351668, size.height * 0.6510825);
    kumamotoPath.lineTo(size.width * 0.3338863, size.height * 0.6511406);
    kumamotoPath.lineTo(size.width * 0.3334290, size.height * 0.6522840);
    kumamotoPath.lineTo(size.width * 0.3360585, size.height * 0.6548808);
    kumamotoPath.lineTo(size.width * 0.3364473, size.height * 0.6566443);
    kumamotoPath.lineTo(size.width * 0.3344351, size.height * 0.6568575);
    kumamotoPath.lineTo(size.width * 0.3318970, size.height * 0.6561598);
    kumamotoPath.lineTo(size.width * 0.3302964, size.height * 0.6584660);
    kumamotoPath.lineTo(size.width * 0.3293817, size.height * 0.6587179);
    kumamotoPath.lineTo(size.width * 0.3274381, size.height * 0.6580396);
    kumamotoPath.lineTo(size.width * 0.3251515, size.height * 0.6594156);
    kumamotoPath.lineTo(size.width * 0.3192750, size.height * 0.6593187);
    kumamotoPath.close();
    kumamotoPath.moveTo(size.width * 0.3055098, size.height * 0.6403658);
    kumamotoPath.lineTo(size.width * 0.3065845, size.height * 0.6402301);
    kumamotoPath.lineTo(size.width * 0.3060586, size.height * 0.6427106);
    kumamotoPath.lineTo(size.width * 0.3048238, size.height * 0.6441835);
    kumamotoPath.lineTo(size.width * 0.3054641, size.height * 0.6443579);
    kumamotoPath.lineTo(size.width * 0.3041836, size.height * 0.6460051);
    kumamotoPath.lineTo(size.width * 0.3022857, size.height * 0.6467415);
    kumamotoPath.lineTo(size.width * 0.2995647, size.height * 0.6457338);
    kumamotoPath.lineTo(size.width * 0.2975068, size.height * 0.6458888);
    kumamotoPath.lineTo(size.width * 0.2973696, size.height * 0.6451524);
    kumamotoPath.lineTo(size.width * 0.2962034, size.height * 0.6448230);
    kumamotoPath.lineTo(size.width * 0.2953117, size.height * 0.6455981);
    kumamotoPath.lineTo(size.width * 0.2964550, size.height * 0.6463733);
    kumamotoPath.lineTo(size.width * 0.2965693, size.height * 0.6472260);
    kumamotoPath.lineTo(size.width * 0.2955861, size.height * 0.6491446);
    kumamotoPath.lineTo(size.width * 0.2913330, size.height * 0.6517607);
    kumamotoPath.lineTo(size.width * 0.2908071, size.height * 0.6534274);
    kumamotoPath.lineTo(size.width * 0.2883833, size.height * 0.6548033);
    kumamotoPath.lineTo(size.width * 0.2884977, size.height * 0.6566637);
    kumamotoPath.lineTo(size.width * 0.2874230, size.height * 0.6569931);
    kumamotoPath.lineTo(size.width * 0.2859138, size.height * 0.6548614);
    kumamotoPath.lineTo(size.width * 0.2864855, size.height * 0.6531754);
    kumamotoPath.lineTo(size.width * 0.2848163, size.height * 0.6527685);
    kumamotoPath.lineTo(size.width * 0.2863025, size.height * 0.6500166);
    kumamotoPath.lineTo(size.width * 0.2852965, size.height * 0.6488926);
    kumamotoPath.lineTo(size.width * 0.2852507, size.height * 0.6474973);
    kumamotoPath.lineTo(size.width * 0.2879718, size.height * 0.6428269);
    kumamotoPath.lineTo(size.width * 0.2883833, size.height * 0.6406371);
    kumamotoPath.lineTo(size.width * 0.2915617, size.height * 0.6393774);
    kumamotoPath.lineTo(size.width * 0.2947858, size.height * 0.6390867);
    kumamotoPath.lineTo(size.width * 0.2953345, size.height * 0.6396293);
    kumamotoPath.lineTo(size.width * 0.2949916, size.height * 0.6414122);
    kumamotoPath.lineTo(size.width * 0.2955861, size.height * 0.6434083);
    kumamotoPath.lineTo(size.width * 0.2992903, size.height * 0.6418386);
    kumamotoPath.lineTo(size.width * 0.3006623, size.height * 0.6404433);
    kumamotoPath.lineTo(size.width * 0.3026516, size.height * 0.6399200);
    kumamotoPath.lineTo(size.width * 0.3039549, size.height * 0.6406371);
    kumamotoPath.lineTo(size.width * 0.3055098, size.height * 0.6403658);
    kumamotoPath.close();
    kumamotoPath.moveTo(size.width * 0.2936882, size.height * 0.6541638);
    kumamotoPath.lineTo(size.width * 0.2935053, size.height * 0.6527878);
    kumamotoPath.lineTo(size.width * 0.2948315, size.height * 0.6516445);
    kumamotoPath.lineTo(size.width * 0.2943284, size.height * 0.6535049);
    kumamotoPath.lineTo(size.width * 0.2958376, size.height * 0.6567994);
    kumamotoPath.lineTo(size.width * 0.2947858, size.height * 0.6573420);
    kumamotoPath.lineTo(size.width * 0.2937111, size.height * 0.6597450);
    kumamotoPath.lineTo(size.width * 0.2913788, size.height * 0.6581559);
    kumamotoPath.lineTo(size.width * 0.2915617, size.height * 0.6567025);
    kumamotoPath.lineTo(size.width * 0.2907842, size.height * 0.6560048);
    kumamotoPath.lineTo(size.width * 0.2911044, size.height * 0.6543188);
    kumamotoPath.lineTo(size.width * 0.2936882, size.height * 0.6541638);
    kumamotoPath.close();
    kumamotoPath.moveTo(size.width * 0.3066531, size.height * 0.6387573);
    kumamotoPath.lineTo(size.width * 0.3054412, size.height * 0.6392805);
    kumamotoPath.lineTo(size.width * 0.3046181, size.height * 0.6389704);
    kumamotoPath.lineTo(size.width * 0.3041150, size.height * 0.6372845);
    kumamotoPath.lineTo(size.width * 0.3063101, size.height * 0.6355597);
    kumamotoPath.lineTo(size.width * 0.3070647, size.height * 0.6372651);
    kumamotoPath.lineTo(size.width * 0.3063330, size.height * 0.6380790);
    kumamotoPath.lineTo(size.width * 0.3066531, size.height * 0.6387573);
    kumamotoPath.close();

    Paint kumamotoPaint = Paint()..style = PaintingStyle.fill;
    kumamotoPaint.color = japanColors.kumamoto ?? defaultColor;
    japanCanvas.drawPath(kumamotoPath, kumamotoPaint, onTapUp: (tabdetail) {
      callback('kumamoto', tabdetail);
    });

    Path kanagawaPath = Path();
    kanagawaPath.moveTo(size.width * 0.6883291, size.height * 0.5083931);
    kanagawaPath.lineTo(size.width * 0.6892666, size.height * 0.5062032);
    kanagawaPath.lineTo(size.width * 0.6933596, size.height * 0.5045947);
    kanagawaPath.lineTo(size.width * 0.6944114, size.height * 0.5033351);
    kanagawaPath.lineTo(size.width * 0.6960349, size.height * 0.5031413);
    kanagawaPath.lineTo(size.width * 0.6971553, size.height * 0.5021336);
    kanagawaPath.lineTo(size.width * 0.6979327, size.height * 0.5007770);
    kanagawaPath.lineTo(size.width * 0.6979784, size.height * 0.4957190);
    kanagawaPath.lineTo(size.width * 0.6979784, size.height * 0.4957190);
    kanagawaPath.lineTo(size.width * 0.6993504, size.height * 0.4959710);
    kanagawaPath.lineTo(size.width * 0.7004022, size.height * 0.4970368);
    kanagawaPath.lineTo(size.width * 0.7017970, size.height * 0.4969787);
    kanagawaPath.lineTo(size.width * 0.7031461, size.height * 0.4988972);
    kanagawaPath.lineTo(size.width * 0.7051126, size.height * 0.4985872);
    kanagawaPath.lineTo(size.width * 0.7100745, size.height * 0.4999631);
    kanagawaPath.lineTo(size.width * 0.7131613, size.height * 0.5036258);
    kanagawaPath.lineTo(size.width * 0.7138473, size.height * 0.5035676);
    kanagawaPath.lineTo(size.width * 0.7142818, size.height * 0.4996530);
    kanagawaPath.lineTo(size.width * 0.7124754, size.height * 0.4984515);
    kanagawaPath.lineTo(size.width * 0.7129784, size.height * 0.4980058);
    kanagawaPath.lineTo(size.width * 0.7140988, size.height * 0.4989166);
    kanagawaPath.lineTo(size.width * 0.7158366, size.height * 0.4971531);
    kanagawaPath.lineTo(size.width * 0.7219647, size.height * 0.4996143);
    kanagawaPath.lineTo(size.width * 0.7227192, size.height * 0.5009127);
    kanagawaPath.lineTo(size.width * 0.7238168, size.height * 0.5013584);
    kanagawaPath.lineTo(size.width * 0.7238397, size.height * 0.5020948);
    kanagawaPath.lineTo(size.width * 0.7238397, size.height * 0.5020948);
    kanagawaPath.lineTo(size.width * 0.7253031, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7253031, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7253259, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7253259, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7253945, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7253945, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7254403, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7254403, size.height * 0.5017266);
    kanagawaPath.lineTo(size.width * 0.7264006, size.height * 0.5031413);
    kanagawaPath.lineTo(size.width * 0.7229936, size.height * 0.5046529);
    kanagawaPath.lineTo(size.width * 0.7213016, size.height * 0.5045366);
    kanagawaPath.lineTo(size.width * 0.7203641, size.height * 0.5053311);
    kanagawaPath.lineTo(size.width * 0.7212330, size.height * 0.5062032);
    kanagawaPath.lineTo(size.width * 0.7221476, size.height * 0.5059707);
    kanagawaPath.lineTo(size.width * 0.7230622, size.height * 0.5065327);
    kanagawaPath.lineTo(size.width * 0.7221247, size.height * 0.5082380);
    kanagawaPath.lineTo(size.width * 0.7213244, size.height * 0.5077536);
    kanagawaPath.lineTo(size.width * 0.7202497, size.height * 0.5079086);
    kanagawaPath.lineTo(size.width * 0.7200211, size.height * 0.5086644);
    kanagawaPath.lineTo(size.width * 0.7211415, size.height * 0.5091682);
    kanagawaPath.lineTo(size.width * 0.7217589, size.height * 0.5117263);
    kanagawaPath.lineTo(size.width * 0.7209814, size.height * 0.5130828);
    kanagawaPath.lineTo(size.width * 0.7231766, size.height * 0.5145944);
    kanagawaPath.lineTo(size.width * 0.7256232, size.height * 0.5150401);
    kanagawaPath.lineTo(size.width * 0.7246400, size.height * 0.5170943);
    kanagawaPath.lineTo(size.width * 0.7230165, size.height * 0.5172688);
    kanagawaPath.lineTo(size.width * 0.7215302, size.height * 0.5183346);
    kanagawaPath.lineTo(size.width * 0.7218046, size.height * 0.5194780);
    kanagawaPath.lineTo(size.width * 0.7225821, size.height * 0.5196524);
    kanagawaPath.lineTo(size.width * 0.7224906, size.height * 0.5204857);
    kanagawaPath.lineTo(size.width * 0.7194266, size.height * 0.5204276);
    kanagawaPath.lineTo(size.width * 0.7197696, size.height * 0.5181408);
    kanagawaPath.lineTo(size.width * 0.7190150, size.height * 0.5158541);
    kanagawaPath.lineTo(size.width * 0.7175744, size.height * 0.5145363);
    kanagawaPath.lineTo(size.width * 0.7177116, size.height * 0.5133154);
    kanagawaPath.lineTo(size.width * 0.7119037, size.height * 0.5121139);
    kanagawaPath.lineTo(size.width * 0.7063016, size.height * 0.5127728);
    kanagawaPath.lineTo(size.width * 0.7014541, size.height * 0.5140518);
    kanagawaPath.lineTo(size.width * 0.6988016, size.height * 0.5158541);
    kanagawaPath.lineTo(size.width * 0.6984129, size.height * 0.5199043);
    kanagawaPath.lineTo(size.width * 0.6969495, size.height * 0.5205826);
    kanagawaPath.lineTo(size.width * 0.6969495, size.height * 0.5205826);
    kanagawaPath.lineTo(size.width * 0.6934739, size.height * 0.5201756);
    kanagawaPath.lineTo(size.width * 0.6931766, size.height * 0.5188579);
    kanagawaPath.lineTo(size.width * 0.6915760, size.height * 0.5178114);
    kanagawaPath.lineTo(size.width * 0.6910272, size.height * 0.5148851);
    kanagawaPath.lineTo(size.width * 0.6923306, size.height * 0.5136642);
    kanagawaPath.lineTo(size.width * 0.6929480, size.height * 0.5118038);
    kanagawaPath.lineTo(size.width * 0.6921705, size.height * 0.5088388);
    kanagawaPath.lineTo(size.width * 0.6918275, size.height * 0.5083737);
    kanagawaPath.lineTo(size.width * 0.6883291, size.height * 0.5083931);
    kanagawaPath.close();

    Paint kanagawaPaint = Paint()..style = PaintingStyle.fill;
    kanagawaPaint.color = japanColors.kanagawa ?? defaultColor;
    japanCanvas.drawPath(kanagawaPath, kanagawaPaint, onTapUp: (tabdetail) {
      callback('kanagawa', tabdetail);
    });

    Path kagoshimaPath = Path();
    kagoshimaPath.moveTo(size.width * 0.2982385, size.height * 0.6895503);
    kagoshimaPath.lineTo(size.width * 0.3008223, size.height * 0.6858876);
    kagoshimaPath.lineTo(size.width * 0.3014397, size.height * 0.6813529);
    kagoshimaPath.lineTo(size.width * 0.3009824, size.height * 0.6792793);
    kagoshimaPath.lineTo(size.width * 0.2939169, size.height * 0.6730973);
    kagoshimaPath.lineTo(size.width * 0.2965007, size.height * 0.6678649);
    kagoshimaPath.lineTo(size.width * 0.2960891, size.height * 0.6657526);
    kagoshimaPath.lineTo(size.width * 0.2944199, size.height * 0.6630395);
    kagoshimaPath.lineTo(size.width * 0.2957233, size.height * 0.6609465);
    kagoshimaPath.lineTo(size.width * 0.2940769, size.height * 0.6598225);
    kagoshimaPath.lineTo(size.width * 0.2945571, size.height * 0.6587760);
    kagoshimaPath.lineTo(size.width * 0.2964778, size.height * 0.6579427);
    kagoshimaPath.lineTo(size.width * 0.2976669, size.height * 0.6579621);
    kagoshimaPath.lineTo(size.width * 0.2992217, size.height * 0.6588536);
    kagoshimaPath.lineTo(size.width * 0.3016912, size.height * 0.6586598);
    kagoshimaPath.lineTo(size.width * 0.3026973, size.height * 0.6567994);
    kagoshimaPath.lineTo(size.width * 0.3026973, size.height * 0.6567994);
    kagoshimaPath.lineTo(size.width * 0.3039321, size.height * 0.6573032);
    kagoshimaPath.lineTo(size.width * 0.3046638, size.height * 0.6585047);
    kagoshimaPath.lineTo(size.width * 0.3070418, size.height * 0.6588148);
    kagoshimaPath.lineTo(size.width * 0.3084138, size.height * 0.6577489);
    kagoshimaPath.lineTo(size.width * 0.3103345, size.height * 0.6577683);
    kagoshimaPath.lineTo(size.width * 0.3124153, size.height * 0.6569738);
    kagoshimaPath.lineTo(size.width * 0.3136500, size.height * 0.6555009);
    kagoshimaPath.lineTo(size.width * 0.3145647, size.height * 0.6568769);
    kagoshimaPath.lineTo(size.width * 0.3158680, size.height * 0.6571288);
    kagoshimaPath.lineTo(size.width * 0.3164625, size.height * 0.6580784);
    kagoshimaPath.lineTo(size.width * 0.3193208, size.height * 0.6593380);
    kagoshimaPath.lineTo(size.width * 0.3193208, size.height * 0.6593380);
    kagoshimaPath.lineTo(size.width * 0.3182232, size.height * 0.6612760);
    kagoshimaPath.lineTo(size.width * 0.3197095, size.height * 0.6617217);
    kagoshimaPath.lineTo(size.width * 0.3215845, size.height * 0.6632526);
    kagoshimaPath.lineTo(size.width * 0.3225448, size.height * 0.6660045);
    kagoshimaPath.lineTo(size.width * 0.3250144, size.height * 0.6666828);
    kagoshimaPath.lineTo(size.width * 0.3267064, size.height * 0.6683300);
    kagoshimaPath.lineTo(size.width * 0.3264320, size.height * 0.6707718);
    kagoshimaPath.lineTo(size.width * 0.3259747, size.height * 0.6709074);
    kagoshimaPath.lineTo(size.width * 0.3263634, size.height * 0.6726128);
    kagoshimaPath.lineTo(size.width * 0.3278497, size.height * 0.6728066);
    kagoshimaPath.lineTo(size.width * 0.3285357, size.height * 0.6735043);
    kagoshimaPath.lineTo(size.width * 0.3310052, size.height * 0.6737562);
    kagoshimaPath.lineTo(size.width * 0.3305936, size.height * 0.6749383);
    kagoshimaPath.lineTo(size.width * 0.3324000, size.height * 0.6753065);
    kagoshimaPath.lineTo(size.width * 0.3327659, size.height * 0.6783491);
    kagoshimaPath.lineTo(size.width * 0.3340235, size.height * 0.6802289);
    kagoshimaPath.lineTo(size.width * 0.3351668, size.height * 0.6791049);
    kagoshimaPath.lineTo(size.width * 0.3367902, size.height * 0.6803451);
    kagoshimaPath.lineTo(size.width * 0.3389854, size.height * 0.6801320);
    kagoshimaPath.lineTo(size.width * 0.3400600, size.height * 0.6806940);
    kagoshimaPath.lineTo(size.width * 0.3407460, size.height * 0.6824769);
    kagoshimaPath.lineTo(size.width * 0.3401744, size.height * 0.6836784);
    kagoshimaPath.lineTo(size.width * 0.3406088, size.height * 0.6853062);
    kagoshimaPath.lineTo(size.width * 0.3391911, size.height * 0.6865853);
    kagoshimaPath.lineTo(size.width * 0.3389168, size.height * 0.6879806);
    kagoshimaPath.lineTo(size.width * 0.3389168, size.height * 0.6879806);
    kagoshimaPath.lineTo(size.width * 0.3362415, size.height * 0.6871666);
    kagoshimaPath.lineTo(size.width * 0.3339777, size.height * 0.6886782);
    kagoshimaPath.lineTo(size.width * 0.3323771, size.height * 0.6907906);
    kagoshimaPath.lineTo(size.width * 0.3321942, size.height * 0.6923409);
    kagoshimaPath.lineTo(size.width * 0.3362415, size.height * 0.6935230);
    kagoshimaPath.lineTo(size.width * 0.3362872, size.height * 0.6943563);
    kagoshimaPath.lineTo(size.width * 0.3348009, size.height * 0.6957323);
    kagoshimaPath.lineTo(size.width * 0.3352125, size.height * 0.6960811);
    kagoshimaPath.lineTo(size.width * 0.3370189, size.height * 0.6955385);
    kagoshimaPath.lineTo(size.width * 0.3372933, size.height * 0.6960230);
    kagoshimaPath.lineTo(size.width * 0.3343893, size.height * 0.6982128);
    kagoshimaPath.lineTo(size.width * 0.3320799, size.height * 0.6982709);
    kagoshimaPath.lineTo(size.width * 0.3315997, size.height * 0.6998988);
    kagoshimaPath.lineTo(size.width * 0.3297933, size.height * 0.7021662);
    kagoshimaPath.lineTo(size.width * 0.3257689, size.height * 0.7040653);
    kagoshimaPath.lineTo(size.width * 0.3224762, size.height * 0.7045498);
    kagoshimaPath.lineTo(size.width * 0.3162110, size.height * 0.7085226);
    kagoshimaPath.lineTo(size.width * 0.3170342, size.height * 0.7058870);
    kagoshimaPath.lineTo(size.width * 0.3158680, size.height * 0.7051118);
    kagoshimaPath.lineTo(size.width * 0.3199839, size.height * 0.7024181);
    kagoshimaPath.lineTo(size.width * 0.3209900, size.height * 0.7002476);
    kagoshimaPath.lineTo(size.width * 0.3204183, size.height * 0.6988523);
    kagoshimaPath.lineTo(size.width * 0.3220189, size.height * 0.6971276);
    kagoshimaPath.lineTo(size.width * 0.3226363, size.height * 0.6933874);
    kagoshimaPath.lineTo(size.width * 0.3204869, size.height * 0.6893953);
    kagoshimaPath.lineTo(size.width * 0.3194351, size.height * 0.6882325);
    kagoshimaPath.lineTo(size.width * 0.3179031, size.height * 0.6876899);
    kagoshimaPath.lineTo(size.width * 0.3181546, size.height * 0.6839303);
    kagoshimaPath.lineTo(size.width * 0.3150677, size.height * 0.6839884);
    kagoshimaPath.lineTo(size.width * 0.3130784, size.height * 0.6823993);
    kagoshimaPath.lineTo(size.width * 0.3146333, size.height * 0.6806358);
    kagoshimaPath.lineTo(size.width * 0.3170342, size.height * 0.6802482);
    kagoshimaPath.lineTo(size.width * 0.3187263, size.height * 0.6814498);
    kagoshimaPath.lineTo(size.width * 0.3184747, size.height * 0.6830582);
    kagoshimaPath.lineTo(size.width * 0.3208985, size.height * 0.6832326);
    kagoshimaPath.lineTo(size.width * 0.3234823, size.height * 0.6792405);
    kagoshimaPath.lineTo(size.width * 0.3223619, size.height * 0.6771088);
    kagoshimaPath.lineTo(size.width * 0.3162567, size.height * 0.6755972);
    kagoshimaPath.lineTo(size.width * 0.3143360, size.height * 0.6768956);
    kagoshimaPath.lineTo(size.width * 0.3138330, size.height * 0.6792018);
    kagoshimaPath.lineTo(size.width * 0.3117065, size.height * 0.6817986);
    kagoshimaPath.lineTo(size.width * 0.3120494, size.height * 0.6828451);
    kagoshimaPath.lineTo(size.width * 0.3104488, size.height * 0.6856938);
    kagoshimaPath.lineTo(size.width * 0.3099001, size.height * 0.6856357);
    kagoshimaPath.lineTo(size.width * 0.3095342, size.height * 0.6875348);
    kagoshimaPath.lineTo(size.width * 0.3101287, size.height * 0.6900929);
    kagoshimaPath.lineTo(size.width * 0.3119580, size.height * 0.6940850);
    kagoshimaPath.lineTo(size.width * 0.3144046, size.height * 0.6959842);
    kagoshimaPath.lineTo(size.width * 0.3164397, size.height * 0.6964299);
    kagoshimaPath.lineTo(size.width * 0.3152507, size.height * 0.6998407);
    kagoshimaPath.lineTo(size.width * 0.3128955, size.height * 0.7012747);
    kagoshimaPath.lineTo(size.width * 0.3114778, size.height * 0.7003251);
    kagoshimaPath.lineTo(size.width * 0.3097400, size.height * 0.7008871);
    kagoshimaPath.lineTo(size.width * 0.3091912, size.height * 0.7003251);
    kagoshimaPath.lineTo(size.width * 0.3093284, size.height * 0.6987360);
    kagoshimaPath.lineTo(size.width * 0.3071333, size.height * 0.6970888);
    kagoshimaPath.lineTo(size.width * 0.3022857, size.height * 0.6971276);
    kagoshimaPath.lineTo(size.width * 0.3003193, size.height * 0.6964105);
    kagoshimaPath.lineTo(size.width * 0.2960662, size.height * 0.6972051);
    kagoshimaPath.lineTo(size.width * 0.2956547, size.height * 0.6943370);
    kagoshimaPath.lineTo(size.width * 0.2941912, size.height * 0.6938912);
    kagoshimaPath.lineTo(size.width * 0.2958376, size.height * 0.6928254);
    kagoshimaPath.lineTo(size.width * 0.2923163, size.height * 0.6899572);
    kagoshimaPath.lineTo(size.width * 0.2935510, size.height * 0.6886782);
    kagoshimaPath.lineTo(size.width * 0.2941455, size.height * 0.6896084);
    kagoshimaPath.lineTo(size.width * 0.2965007, size.height * 0.6905968);
    kagoshimaPath.lineTo(size.width * 0.2982385, size.height * 0.6895503);
    kagoshimaPath.close();
    kagoshimaPath.moveTo(size.width * 0.3088482, size.height * 0.7321071);
    kagoshimaPath.lineTo(size.width * 0.3120952, size.height * 0.7333280);
    kagoshimaPath.lineTo(size.width * 0.3119580, size.height * 0.7339675);
    kagoshimaPath.lineTo(size.width * 0.3150906, size.height * 0.7346846);
    kagoshimaPath.lineTo(size.width * 0.3166226, size.height * 0.7359054);
    kagoshimaPath.lineTo(size.width * 0.3157537, size.height * 0.7393162);
    kagoshimaPath.lineTo(size.width * 0.3127583, size.height * 0.7418743);
    kagoshimaPath.lineTo(size.width * 0.3099229, size.height * 0.7424556);
    kagoshimaPath.lineTo(size.width * 0.3060586, size.height * 0.7419130);
    kagoshimaPath.lineTo(size.width * 0.3054641, size.height * 0.7403821);
    kagoshimaPath.lineTo(size.width * 0.3049610, size.height * 0.7407309);
    kagoshimaPath.lineTo(size.width * 0.3049839, size.height * 0.7393937);
    kagoshimaPath.lineTo(size.width * 0.3039549, size.height * 0.7382697);
    kagoshimaPath.lineTo(size.width * 0.3033376, size.height * 0.7360605);
    kagoshimaPath.lineTo(size.width * 0.3034290, size.height * 0.7351497);
    kagoshimaPath.lineTo(size.width * 0.3055784, size.height * 0.7349946);
    kagoshimaPath.lineTo(size.width * 0.3072705, size.height * 0.7332311);
    kagoshimaPath.lineTo(size.width * 0.3072934, size.height * 0.7323203);
    kagoshimaPath.lineTo(size.width * 0.3085510, size.height * 0.7324947);
    kagoshimaPath.lineTo(size.width * 0.3088025, size.height * 0.7317777);
    kagoshimaPath.lineTo(size.width * 0.3088482, size.height * 0.7321071);
    kagoshimaPath.close();
    kagoshimaPath.moveTo(size.width * 0.3291073, size.height * 0.7269329);
    kagoshimaPath.lineTo(size.width * 0.3286957, size.height * 0.7229407);
    kagoshimaPath.lineTo(size.width * 0.3305707, size.height * 0.7204214);
    kagoshimaPath.lineTo(size.width * 0.3312567, size.height * 0.7204408);
    kagoshimaPath.lineTo(size.width * 0.3315997, size.height * 0.7178440);
    kagoshimaPath.lineTo(size.width * 0.3340235, size.height * 0.7153828);
    kagoshimaPath.lineTo(size.width * 0.3351896, size.height * 0.7175921);
    kagoshimaPath.lineTo(size.width * 0.3346409, size.height * 0.7186773);
    kagoshimaPath.lineTo(size.width * 0.3350067, size.height * 0.7217392);
    kagoshimaPath.lineTo(size.width * 0.3338406, size.height * 0.7231345);
    kagoshimaPath.lineTo(size.width * 0.3340235, size.height * 0.7253631);
    kagoshimaPath.lineTo(size.width * 0.3329259, size.height * 0.7265840);
    kagoshimaPath.lineTo(size.width * 0.3330174, size.height * 0.7274949);
    kagoshimaPath.lineTo(size.width * 0.3314396, size.height * 0.7283088);
    kagoshimaPath.lineTo(size.width * 0.3297476, size.height * 0.7312544);
    kagoshimaPath.lineTo(size.width * 0.3300677, size.height * 0.7317970);
    kagoshimaPath.lineTo(size.width * 0.3295646, size.height * 0.7322815);
    kagoshimaPath.lineTo(size.width * 0.3305479, size.height * 0.7332892);
    kagoshimaPath.lineTo(size.width * 0.3300220, size.height * 0.7342001);
    kagoshimaPath.lineTo(size.width * 0.3306393, size.height * 0.7348783);
    kagoshimaPath.lineTo(size.width * 0.3298848, size.height * 0.7351109);
    kagoshimaPath.lineTo(size.width * 0.3298619, size.height * 0.7360023);
    kagoshimaPath.lineTo(size.width * 0.3280098, size.height * 0.7359830);
    kagoshimaPath.lineTo(size.width * 0.3257232, size.height * 0.7373008);
    kagoshimaPath.lineTo(size.width * 0.3250372, size.height * 0.7361768);
    kagoshimaPath.lineTo(size.width * 0.3254259, size.height * 0.7344714);
    kagoshimaPath.lineTo(size.width * 0.3246485, size.height * 0.7318552);
    kagoshimaPath.lineTo(size.width * 0.3257461, size.height * 0.7318746);
    kagoshimaPath.lineTo(size.width * 0.3291073, size.height * 0.7269329);
    kagoshimaPath.close();
    kagoshimaPath.moveTo(size.width * 0.2739321, size.height * 0.6797444);
    kagoshimaPath.lineTo(size.width * 0.2721715, size.height * 0.6806552);
    kagoshimaPath.lineTo(size.width * 0.2712340, size.height * 0.6800932);
    kagoshimaPath.lineTo(size.width * 0.2709367, size.height * 0.6790080);
    kagoshimaPath.lineTo(size.width * 0.2717828, size.height * 0.6786010);
    kagoshimaPath.lineTo(size.width * 0.2726745, size.height * 0.6764305);
    kagoshimaPath.lineTo(size.width * 0.2756928, size.height * 0.6754809);
    kagoshimaPath.lineTo(size.width * 0.2766760, size.height * 0.6730779);
    kagoshimaPath.lineTo(size.width * 0.2774992, size.height * 0.6734074);
    kagoshimaPath.lineTo(size.width * 0.2773849, size.height * 0.6743570);
    kagoshimaPath.lineTo(size.width * 0.2759443, size.height * 0.6765856);
    kagoshimaPath.lineTo(size.width * 0.2745724, size.height * 0.6769344);
    kagoshimaPath.lineTo(size.width * 0.2748239, size.height * 0.6777289);
    kagoshimaPath.lineTo(size.width * 0.2739550, size.height * 0.6785235);
    kagoshimaPath.lineTo(size.width * 0.2745495, size.height * 0.6791436);
    kagoshimaPath.lineTo(size.width * 0.2739321, size.height * 0.6797444);
    kagoshimaPath.close();
    kagoshimaPath.moveTo(size.width * 0.2788712, size.height * 0.6710237);
    kagoshimaPath.lineTo(size.width * 0.2781395, size.height * 0.6699385);
    kagoshimaPath.lineTo(size.width * 0.2789398, size.height * 0.6690277);
    kagoshimaPath.lineTo(size.width * 0.2801745, size.height * 0.6691827);
    kagoshimaPath.lineTo(size.width * 0.2810434, size.height * 0.6701323);
    kagoshimaPath.lineTo(size.width * 0.2829870, size.height * 0.6697641);
    kagoshimaPath.lineTo(size.width * 0.2832614, size.height * 0.6705005);
    kagoshimaPath.lineTo(size.width * 0.2831928, size.height * 0.6716632);
    kagoshimaPath.lineTo(size.width * 0.2811120, size.height * 0.6722446);
    kagoshimaPath.lineTo(size.width * 0.2799459, size.height * 0.6717214);
    kagoshimaPath.lineTo(size.width * 0.2801288, size.height * 0.6710819);
    kagoshimaPath.lineTo(size.width * 0.2792141, size.height * 0.6704423);
    kagoshimaPath.lineTo(size.width * 0.2788712, size.height * 0.6710237);
    kagoshimaPath.close();
    kagoshimaPath.moveTo(size.width * 0.2967522, size.height * 0.7317970);
    kagoshimaPath.lineTo(size.width * 0.2983300, size.height * 0.7327466);
    kagoshimaPath.lineTo(size.width * 0.2983071, size.height * 0.7332505);
    kagoshimaPath.lineTo(size.width * 0.2973925, size.height * 0.7331148);
    kagoshimaPath.lineTo(size.width * 0.2958605, size.height * 0.7338706);
    kagoshimaPath.lineTo(size.width * 0.2949916, size.height * 0.7329986);
    kagoshimaPath.lineTo(size.width * 0.2951745, size.height * 0.7320684);
    kagoshimaPath.lineTo(size.width * 0.2940312, size.height * 0.7323203);
    kagoshimaPath.lineTo(size.width * 0.2928193, size.height * 0.7308668);
    kagoshimaPath.lineTo(size.width * 0.2967522, size.height * 0.7317970);
    kagoshimaPath.close();

    Paint kagoshimaPaint = Paint()..style = PaintingStyle.fill;
    kagoshimaPaint.color = japanColors.kagoshima ?? defaultColor;
    japanCanvas.drawPath(kagoshimaPath, kagoshimaPaint, onTapUp: (tabdetail) {
      callback('kagoshima', tabdetail);
    });

    Path kyotoPath = Path();
    kyotoPath.moveTo(size.width * 0.5285429, size.height * 0.5249817);
    kyotoPath.lineTo(size.width * 0.5289316, size.height * 0.5239546);
    kyotoPath.lineTo(size.width * 0.5297776, size.height * 0.5235476);
    kyotoPath.lineTo(size.width * 0.5291145, size.height * 0.5211059);
    kyotoPath.lineTo(size.width * 0.5268965, size.height * 0.5201563);
    kyotoPath.lineTo(size.width * 0.5249301, size.height * 0.5205051);
    kyotoPath.lineTo(size.width * 0.5248386, size.height * 0.5190710);
    kyotoPath.lineTo(size.width * 0.5243355, size.height * 0.5189548);
    kyotoPath.lineTo(size.width * 0.5224834, size.height * 0.5188772);
    kyotoPath.lineTo(size.width * 0.5215231, size.height * 0.5195749);
    kyotoPath.lineTo(size.width * 0.5202426, size.height * 0.5191098);
    kyotoPath.lineTo(size.width * 0.5208142, size.height * 0.5180439);
    kyotoPath.lineTo(size.width * 0.5188478, size.height * 0.5164355);
    kyotoPath.lineTo(size.width * 0.5188020, size.height * 0.5149433);
    kyotoPath.lineTo(size.width * 0.5164697, size.height * 0.5148851);
    kyotoPath.lineTo(size.width * 0.5147090, size.height * 0.5157959);
    kyotoPath.lineTo(size.width * 0.5116908, size.height * 0.5135867);
    kyotoPath.lineTo(size.width * 0.5082838, size.height * 0.5124046);
    kyotoPath.lineTo(size.width * 0.5082380, size.height * 0.5099628);
    kyotoPath.lineTo(size.width * 0.5090841, size.height * 0.5080249);
    kyotoPath.lineTo(size.width * 0.5116908, size.height * 0.5090907);
    kyotoPath.lineTo(size.width * 0.5137715, size.height * 0.5080830);
    kyotoPath.lineTo(size.width * 0.5137944, size.height * 0.5029863);
    kyotoPath.lineTo(size.width * 0.5130398, size.height * 0.5019398);
    kyotoPath.lineTo(size.width * 0.5099987, size.height * 0.5032188);
    kyotoPath.lineTo(size.width * 0.5083524, size.height * 0.5028700);
    kyotoPath.lineTo(size.width * 0.5078722, size.height * 0.5016878);
    kyotoPath.lineTo(size.width * 0.5059057, size.height * 0.5001375);
    kyotoPath.lineTo(size.width * 0.5058600, size.height * 0.4962229);
    kyotoPath.lineTo(size.width * 0.5058600, size.height * 0.4962229);
    kyotoPath.lineTo(size.width * 0.5064545, size.height * 0.4968043);
    kyotoPath.lineTo(size.width * 0.5086725, size.height * 0.4967655);
    kyotoPath.lineTo(size.width * 0.5100216, size.height * 0.4961841);
    kyotoPath.lineTo(size.width * 0.5110505, size.height * 0.4946726);
    kyotoPath.lineTo(size.width * 0.5129026, size.height * 0.4947888);
    kyotoPath.lineTo(size.width * 0.5172929, size.height * 0.4921726);
    kyotoPath.lineTo(size.width * 0.5216145, size.height * 0.4910099);
    kyotoPath.lineTo(size.width * 0.5240840, size.height * 0.4923277);
    kyotoPath.lineTo(size.width * 0.5255932, size.height * 0.4946532);
    kyotoPath.lineTo(size.width * 0.5231465, size.height * 0.4966105);
    kyotoPath.lineTo(size.width * 0.5227121, size.height * 0.4980445);
    kyotoPath.lineTo(size.width * 0.5202197, size.height * 0.5006026);
    kyotoPath.lineTo(size.width * 0.5203569, size.height * 0.5017654);
    kyotoPath.lineTo(size.width * 0.5210429, size.height * 0.5017460);
    kyotoPath.lineTo(size.width * 0.5223920, size.height * 0.4998662);
    kyotoPath.lineTo(size.width * 0.5237868, size.height * 0.5005251);
    kyotoPath.lineTo(size.width * 0.5240840, size.height * 0.5008545);
    kyotoPath.lineTo(size.width * 0.5226206, size.height * 0.5019204);
    kyotoPath.lineTo(size.width * 0.5257075, size.height * 0.5031025);
    kyotoPath.lineTo(size.width * 0.5262791, size.height * 0.5024630);
    kyotoPath.lineTo(size.width * 0.5265993, size.height * 0.5051374);
    kyotoPath.lineTo(size.width * 0.5276968, size.height * 0.5042071);
    kyotoPath.lineTo(size.width * 0.5296175, size.height * 0.5046141);
    kyotoPath.lineTo(size.width * 0.5297319, size.height * 0.5036258);
    kyotoPath.lineTo(size.width * 0.5268508, size.height * 0.5020948);
    kyotoPath.lineTo(size.width * 0.5287944, size.height * 0.5007770);
    kyotoPath.lineTo(size.width * 0.5309209, size.height * 0.5005638);
    kyotoPath.lineTo(size.width * 0.5312639, size.height * 0.4994399);
    kyotoPath.lineTo(size.width * 0.5320642, size.height * 0.4994205);
    kyotoPath.lineTo(size.width * 0.5320871, size.height * 0.5005251);
    kyotoPath.lineTo(size.width * 0.5330246, size.height * 0.5010096);
    kyotoPath.lineTo(size.width * 0.5330246, size.height * 0.5010096);
    kyotoPath.lineTo(size.width * 0.5320871, size.height * 0.5027343);
    kyotoPath.lineTo(size.width * 0.5332761, size.height * 0.5035483);
    kyotoPath.lineTo(size.width * 0.5326130, size.height * 0.5055056);
    kyotoPath.lineTo(size.width * 0.5356084, size.height * 0.5078504);
    kyotoPath.lineTo(size.width * 0.5359056, size.height * 0.5095364);
    kyotoPath.lineTo(size.width * 0.5398614, size.height * 0.5099046);
    kyotoPath.lineTo(size.width * 0.5432913, size.height * 0.5110480);
    kyotoPath.lineTo(size.width * 0.5464239, size.height * 0.5105442);
    kyotoPath.lineTo(size.width * 0.5464239, size.height * 0.5105442);
    kyotoPath.lineTo(size.width * 0.5491221, size.height * 0.5141099);
    kyotoPath.lineTo(size.width * 0.5500824, size.height * 0.5140906);
    kyotoPath.lineTo(size.width * 0.5492135, size.height * 0.5168812);
    kyotoPath.lineTo(size.width * 0.5501968, size.height * 0.5209702);
    kyotoPath.lineTo(size.width * 0.5494879, size.height * 0.5243422);
    kyotoPath.lineTo(size.width * 0.5487105, size.height * 0.5248267);
    kyotoPath.lineTo(size.width * 0.5493736, size.height * 0.5270940);
    kyotoPath.lineTo(size.width * 0.5514087, size.height * 0.5300203);
    kyotoPath.lineTo(size.width * 0.5508599, size.height * 0.5320939);
    kyotoPath.lineTo(size.width * 0.5524833, size.height * 0.5330047);
    kyotoPath.lineTo(size.width * 0.5541526, size.height * 0.5322683);
    kyotoPath.lineTo(size.width * 0.5544498, size.height * 0.5339737);
    kyotoPath.lineTo(size.width * 0.5551586, size.height * 0.5338768);
    kyotoPath.lineTo(size.width * 0.5558446, size.height * 0.5345938);
    kyotoPath.lineTo(size.width * 0.5567593, size.height * 0.5343031);
    kyotoPath.lineTo(size.width * 0.5581541, size.height * 0.5354659);
    kyotoPath.lineTo(size.width * 0.5575596, size.height * 0.5359697);
    kyotoPath.lineTo(size.width * 0.5579025, size.height * 0.5367643);
    kyotoPath.lineTo(size.width * 0.5579025, size.height * 0.5367643);
    kyotoPath.lineTo(size.width * 0.5589315, size.height * 0.5390898);
    kyotoPath.lineTo(size.width * 0.5589315, size.height * 0.5390898);
    kyotoPath.lineTo(size.width * 0.5581541, size.height * 0.5405432);
    kyotoPath.lineTo(size.width * 0.5568279, size.height * 0.5403882);
    kyotoPath.lineTo(size.width * 0.5557074, size.height * 0.5390898);
    kyotoPath.lineTo(size.width * 0.5534437, size.height * 0.5390704);
    kyotoPath.lineTo(size.width * 0.5536266, size.height * 0.5383728);
    kyotoPath.lineTo(size.width * 0.5519346, size.height * 0.5405626);
    kyotoPath.lineTo(size.width * 0.5502654, size.height * 0.5407177);
    kyotoPath.lineTo(size.width * 0.5458751, size.height * 0.5397099);
    kyotoPath.lineTo(size.width * 0.5446861, size.height * 0.5373457);
    kyotoPath.lineTo(size.width * 0.5446861, size.height * 0.5373457);
    kyotoPath.lineTo(size.width * 0.5453264, size.height * 0.5361441);
    kyotoPath.lineTo(size.width * 0.5429940, size.height * 0.5339155);
    kyotoPath.lineTo(size.width * 0.5422852, size.height * 0.5318613);
    kyotoPath.lineTo(size.width * 0.5394498, size.height * 0.5296327);
    kyotoPath.lineTo(size.width * 0.5394498, size.height * 0.5284312);
    kyotoPath.lineTo(size.width * 0.5377349, size.height * 0.5283925);
    kyotoPath.lineTo(size.width * 0.5371404, size.height * 0.5297102);
    kyotoPath.lineTo(size.width * 0.5380093, size.height * 0.5305242);
    kyotoPath.lineTo(size.width * 0.5362029, size.height * 0.5310280);
    kyotoPath.lineTo(size.width * 0.5346252, size.height * 0.5296133);
    kyotoPath.lineTo(size.width * 0.5340535, size.height * 0.5298265);
    kyotoPath.lineTo(size.width * 0.5338935, size.height * 0.5275785);
    kyotoPath.lineTo(size.width * 0.5289544, size.height * 0.5264158);
    kyotoPath.close();

    Paint kyotoPaint = Paint()..style = PaintingStyle.fill;
    kyotoPaint.color = japanColors.kyoto ?? defaultColor;
    japanCanvas.drawPath(kyotoPath, kyotoPaint, onTapUp: (tabdetail) {
      callback('kyoto', tabdetail);
    });

    Path miePath = Path();
    miePath.moveTo(size.width * 0.5881997, size.height * 0.5598062);
    miePath.lineTo(size.width * 0.5877653, size.height * 0.5600581);
    miePath.lineTo(size.width * 0.5892744, size.height * 0.5577326);
    miePath.lineTo(size.width * 0.5879711, size.height * 0.5570931);
    miePath.lineTo(size.width * 0.5864619, size.height * 0.5598256);
    miePath.lineTo(size.width * 0.5839467, size.height * 0.5612597);
    miePath.lineTo(size.width * 0.5831007, size.height * 0.5613566);
    miePath.lineTo(size.width * 0.5824833, size.height * 0.5598256);
    miePath.lineTo(size.width * 0.5818430, size.height * 0.5600000);
    miePath.lineTo(size.width * 0.5813171, size.height * 0.5616279);
    miePath.lineTo(size.width * 0.5811113, size.height * 0.5602907);
    miePath.lineTo(size.width * 0.5795107, size.height * 0.5602713);
    miePath.lineTo(size.width * 0.5801510, size.height * 0.5620930);
    miePath.lineTo(size.width * 0.5796479, size.height * 0.5625581);
    miePath.lineTo(size.width * 0.5729025, size.height * 0.5639534);
    miePath.lineTo(size.width * 0.5719650, size.height * 0.5637402);
    miePath.lineTo(size.width * 0.5705016, size.height * 0.5648061);
    miePath.lineTo(size.width * 0.5692440, size.height * 0.5667634);
    miePath.lineTo(size.width * 0.5700443, size.height * 0.5679455);
    miePath.lineTo(size.width * 0.5710046, size.height * 0.5678292);
    miePath.lineTo(size.width * 0.5702043, size.height * 0.5691664);
    miePath.lineTo(size.width * 0.5688095, size.height * 0.5693602);
    miePath.lineTo(size.width * 0.5679635, size.height * 0.5683137);
    miePath.lineTo(size.width * 0.5670260, size.height * 0.5685269);
    miePath.lineTo(size.width * 0.5674376, size.height * 0.5691470);
    miePath.lineTo(size.width * 0.5658370, size.height * 0.5696121);
    miePath.lineTo(size.width * 0.5662486, size.height * 0.5702322);
    miePath.lineTo(size.width * 0.5678034, size.height * 0.5700385);
    miePath.lineTo(size.width * 0.5678263, size.height * 0.5713562);
    miePath.lineTo(size.width * 0.5694726, size.height * 0.5720733);
    miePath.lineTo(size.width * 0.5690839, size.height * 0.5743988);
    miePath.lineTo(size.width * 0.5675748, size.height * 0.5745732);
    miePath.lineTo(size.width * 0.5657912, size.height * 0.5767631);
    miePath.lineTo(size.width * 0.5636419, size.height * 0.5771119);
    miePath.lineTo(size.width * 0.5627044, size.height * 0.5783909);
    miePath.lineTo(size.width * 0.5613095, size.height * 0.5783328);
    miePath.lineTo(size.width * 0.5588858, size.height * 0.5819761);
    miePath.lineTo(size.width * 0.5572394, size.height * 0.5858519);
    miePath.lineTo(size.width * 0.5572394, size.height * 0.5858519);
    miePath.lineTo(size.width * 0.5542897, size.height * 0.5853287);
    miePath.lineTo(size.width * 0.5504026, size.height * 0.5815691);
    miePath.lineTo(size.width * 0.5505626, size.height * 0.5778483);
    miePath.lineTo(size.width * 0.5505626, size.height * 0.5778483);
    miePath.lineTo(size.width * 0.5530779, size.height * 0.5745151);
    miePath.lineTo(size.width * 0.5558446, size.height * 0.5737593);
    miePath.lineTo(size.width * 0.5577425, size.height * 0.5715888);
    miePath.lineTo(size.width * 0.5614467, size.height * 0.5720733);
    miePath.lineTo(size.width * 0.5611266, size.height * 0.5694958);
    miePath.lineTo(size.width * 0.5616754, size.height * 0.5689726);
    miePath.lineTo(size.width * 0.5619498, size.height * 0.5655812);
    miePath.lineTo(size.width * 0.5611038, size.height * 0.5642634);
    miePath.lineTo(size.width * 0.5627730, size.height * 0.5616279);
    miePath.lineTo(size.width * 0.5611952, size.height * 0.5593992);
    miePath.lineTo(size.width * 0.5627272, size.height * 0.5587016);
    miePath.lineTo(size.width * 0.5600748, size.height * 0.5551164);
    miePath.lineTo(size.width * 0.5612181, size.height * 0.5532754);
    miePath.lineTo(size.width * 0.5662028, size.height * 0.5526553);
    miePath.lineTo(size.width * 0.5670946, size.height * 0.5508336);
    miePath.lineTo(size.width * 0.5664315, size.height * 0.5489732);
    miePath.lineTo(size.width * 0.5649452, size.height * 0.5494771);
    miePath.lineTo(size.width * 0.5638934, size.height * 0.5475198);
    miePath.lineTo(size.width * 0.5620184, size.height * 0.5480430);
    miePath.lineTo(size.width * 0.5596403, size.height * 0.5470547);
    miePath.lineTo(size.width * 0.5590458, size.height * 0.5462601);
    miePath.lineTo(size.width * 0.5600519, size.height * 0.5443222);
    miePath.lineTo(size.width * 0.5599376, size.height * 0.5431594);
    miePath.lineTo(size.width * 0.5608065, size.height * 0.5421517);
    miePath.lineTo(size.width * 0.5589772, size.height * 0.5391092);
    miePath.lineTo(size.width * 0.5589772, size.height * 0.5391092);
    miePath.lineTo(size.width * 0.5579483, size.height * 0.5367643);
    miePath.lineTo(size.width * 0.5579483, size.height * 0.5367643);
    miePath.lineTo(size.width * 0.5610123, size.height * 0.5356984);
    miePath.lineTo(size.width * 0.5608522, size.height * 0.5347101);
    miePath.lineTo(size.width * 0.5626129, size.height * 0.5334892);
    miePath.lineTo(size.width * 0.5624300, size.height * 0.5330047);
    miePath.lineTo(size.width * 0.5610123, size.height * 0.5329078);
    miePath.lineTo(size.width * 0.5608522, size.height * 0.5324233);
    miePath.lineTo(size.width * 0.5619269, size.height * 0.5316675);
    miePath.lineTo(size.width * 0.5626586, size.height * 0.5324040);
    miePath.lineTo(size.width * 0.5649909, size.height * 0.5323652);
    miePath.lineTo(size.width * 0.5680550, size.height * 0.5336442);
    miePath.lineTo(size.width * 0.5733827, size.height * 0.5314544);
    miePath.lineTo(size.width * 0.5738629, size.height * 0.5296715);
    miePath.lineTo(size.width * 0.5756693, size.height * 0.5275398);
    miePath.lineTo(size.width * 0.5757607, size.height * 0.5248654);
    miePath.lineTo(size.width * 0.5774299, size.height * 0.5200206);
    miePath.lineTo(size.width * 0.5758065, size.height * 0.5186059);
    miePath.lineTo(size.width * 0.5756235, size.height * 0.5169587);
    miePath.lineTo(size.width * 0.5756235, size.height * 0.5169587);
    miePath.lineTo(size.width * 0.5756235, size.height * 0.5169587);
    miePath.lineTo(size.width * 0.5756235, size.height * 0.5169587);
    miePath.lineTo(size.width * 0.5806769, size.height * 0.5151177);
    miePath.lineTo(size.width * 0.5845641, size.height * 0.5199431);
    miePath.lineTo(size.width * 0.5870336, size.height * 0.5201756);
    miePath.lineTo(size.width * 0.5870336, size.height * 0.5201756);
    miePath.lineTo(size.width * 0.5877653, size.height * 0.5225205);
    miePath.lineTo(size.width * 0.5899833, size.height * 0.5255631);
    miePath.lineTo(size.width * 0.5899833, size.height * 0.5255631);
    miePath.lineTo(size.width * 0.5882455, size.height * 0.5259507);
    miePath.lineTo(size.width * 0.5861418, size.height * 0.5272878);
    miePath.lineTo(size.width * 0.5853186, size.height * 0.5292645);
    miePath.lineTo(size.width * 0.5859132, size.height * 0.5314350);
    miePath.lineTo(size.width * 0.5815001, size.height * 0.5371519);
    miePath.lineTo(size.width * 0.5802196, size.height * 0.5403107);
    miePath.lineTo(size.width * 0.5803568, size.height * 0.5415897);
    miePath.lineTo(size.width * 0.5818888, size.height * 0.5421517);
    miePath.lineTo(size.width * 0.5810199, size.height * 0.5447292);
    miePath.lineTo(size.width * 0.5858217, size.height * 0.5459113);
    miePath.lineTo(size.width * 0.5864619, size.height * 0.5472291);
    miePath.lineTo(size.width * 0.5893888, size.height * 0.5481399);
    miePath.lineTo(size.width * 0.5918583, size.height * 0.5497096);
    miePath.lineTo(size.width * 0.5945564, size.height * 0.5497678);
    miePath.lineTo(size.width * 0.5950595, size.height * 0.5510274);
    miePath.lineTo(size.width * 0.5963400, size.height * 0.5512793);
    miePath.lineTo(size.width * 0.5958598, size.height * 0.5518220);
    miePath.lineTo(size.width * 0.5962256, size.height * 0.5523646);
    miePath.lineTo(size.width * 0.5978491, size.height * 0.5521127);
    miePath.lineTo(size.width * 0.5984893, size.height * 0.5526746);
    miePath.lineTo(size.width * 0.5986723, size.height * 0.5540893);
    miePath.lineTo(size.width * 0.5960884, size.height * 0.5553877);
    miePath.lineTo(size.width * 0.5963400, size.height * 0.5560273);
    miePath.lineTo(size.width * 0.5977805, size.height * 0.5562986);
    miePath.lineTo(size.width * 0.5963400, size.height * 0.5576745);
    miePath.lineTo(size.width * 0.5970031, size.height * 0.5585853);
    miePath.lineTo(size.width * 0.5959512, size.height * 0.5610465);
    miePath.lineTo(size.width * 0.5937333, size.height * 0.5615697);
    miePath.lineTo(size.width * 0.5906006, size.height * 0.5606589);
    miePath.lineTo(size.width * 0.5930701, size.height * 0.5603488);
    miePath.lineTo(size.width * 0.5943049, size.height * 0.5608721);
    miePath.lineTo(size.width * 0.5944650, size.height * 0.5596124);
    miePath.lineTo(size.width * 0.5933674, size.height * 0.5593799);
    miePath.lineTo(size.width * 0.5927500, size.height * 0.5597675);
    miePath.lineTo(size.width * 0.5894116, size.height * 0.5591086);
    miePath.lineTo(size.width * 0.5881997, size.height * 0.5598062);
    miePath.close();

    Paint miePaint = Paint()..style = PaintingStyle.fill;
    miePaint.color = japanColors.mie ?? defaultColor;
    japanCanvas.drawPath(miePath, miePaint, onTapUp: (tabdetail) {
      callback('mie', tabdetail);
    });

    Path miyagiPath = Path();
    miyagiPath.moveTo(size.width * 0.7849600, size.height * 0.3679904);
    miyagiPath.lineTo(size.width * 0.7840225, size.height * 0.3693663);
    miyagiPath.lineTo(size.width * 0.7847542, size.height * 0.3698508);
    miyagiPath.lineTo(size.width * 0.7855316, size.height * 0.3695601);
    miyagiPath.lineTo(size.width * 0.7859432, size.height * 0.3708198);
    miyagiPath.lineTo(size.width * 0.7830621, size.height * 0.3722732);
    miyagiPath.lineTo(size.width * 0.7791520, size.height * 0.3792885);
    miyagiPath.lineTo(size.width * 0.7782374, size.height * 0.3864588);
    miyagiPath.lineTo(size.width * 0.7789691, size.height * 0.3902378);
    miyagiPath.lineTo(size.width * 0.7789691, size.height * 0.3902378);
    miyagiPath.lineTo(size.width * 0.7773914, size.height * 0.3898890);
    miyagiPath.lineTo(size.width * 0.7757450, size.height * 0.3904122);
    miyagiPath.lineTo(size.width * 0.7758136, size.height * 0.3946175);
    miyagiPath.lineTo(size.width * 0.7755164, size.height * 0.3950438);
    miyagiPath.lineTo(size.width * 0.7719036, size.height * 0.3949276);
    miyagiPath.lineTo(size.width * 0.7729783, size.height * 0.3956834);
    miyagiPath.lineTo(size.width * 0.7726353, size.height * 0.3959934);
    miyagiPath.lineTo(size.width * 0.7698685, size.height * 0.3954702);
    miyagiPath.lineTo(size.width * 0.7684280, size.height * 0.3945012);
    miyagiPath.lineTo(size.width * 0.7677877, size.height * 0.3930478);
    miyagiPath.lineTo(size.width * 0.7681993, size.height * 0.3908385);
    miyagiPath.lineTo(size.width * 0.7669188, size.height * 0.3899471);
    miyagiPath.lineTo(size.width * 0.7650438, size.height * 0.3894045);
    miyagiPath.lineTo(size.width * 0.7589844, size.height * 0.3899277);
    miyagiPath.lineTo(size.width * 0.7581384, size.height * 0.3878154);
    miyagiPath.lineTo(size.width * 0.7555317, size.height * 0.3864782);
    miyagiPath.lineTo(size.width * 0.7529478, size.height * 0.3875828);
    miyagiPath.lineTo(size.width * 0.7497695, size.height * 0.3863038);
    miyagiPath.lineTo(size.width * 0.7497695, size.height * 0.3863038);
    miyagiPath.lineTo(size.width * 0.7496323, size.height * 0.3824667);
    miyagiPath.lineTo(size.width * 0.7535652, size.height * 0.3824473);
    miyagiPath.lineTo(size.width * 0.7558289, size.height * 0.3813815);
    miyagiPath.lineTo(size.width * 0.7562634, size.height * 0.3794048);
    miyagiPath.lineTo(size.width * 0.7588015, size.height * 0.3763429);
    miyagiPath.lineTo(size.width * 0.7582756, size.height * 0.3739592);
    miyagiPath.lineTo(size.width * 0.7586414, size.height * 0.3719825);
    miyagiPath.lineTo(size.width * 0.7610423, size.height * 0.3694245);
    miyagiPath.lineTo(size.width * 0.7606765, size.height * 0.3682617);
    miyagiPath.lineTo(size.width * 0.7631688, size.height * 0.3660525);
    miyagiPath.lineTo(size.width * 0.7645637, size.height * 0.3629518);
    miyagiPath.lineTo(size.width * 0.7641063, size.height * 0.3615953);
    miyagiPath.lineTo(size.width * 0.7627344, size.height * 0.3608395);
    miyagiPath.lineTo(size.width * 0.7621170, size.height * 0.3590760);
    miyagiPath.lineTo(size.width * 0.7629859, size.height * 0.3578163);
    miyagiPath.lineTo(size.width * 0.7629173, size.height * 0.3567698);
    miyagiPath.lineTo(size.width * 0.7615225, size.height * 0.3541149);
    miyagiPath.lineTo(size.width * 0.7617512, size.height * 0.3536691);
    miyagiPath.lineTo(size.width * 0.7632603, size.height * 0.3543474);
    miyagiPath.lineTo(size.width * 0.7641749, size.height * 0.3541536);
    miyagiPath.lineTo(size.width * 0.7651582, size.height * 0.3519250);
    miyagiPath.lineTo(size.width * 0.7646551, size.height * 0.3500452);
    miyagiPath.lineTo(size.width * 0.7662100, size.height * 0.3479135);
    miyagiPath.lineTo(size.width * 0.7643121, size.height * 0.3470414);
    miyagiPath.lineTo(size.width * 0.7638777, size.height * 0.3449872);
    miyagiPath.lineTo(size.width * 0.7614539, size.height * 0.3430106);
    miyagiPath.lineTo(size.width * 0.7619798, size.height * 0.3423323);
    miyagiPath.lineTo(size.width * 0.7619798, size.height * 0.3423323);
    miyagiPath.lineTo(size.width * 0.7625972, size.height * 0.3426811);
    miyagiPath.lineTo(size.width * 0.7666216, size.height * 0.3419835);
    miyagiPath.lineTo(size.width * 0.7703716, size.height * 0.3389409);
    miyagiPath.lineTo(size.width * 0.7719950, size.height * 0.3386115);
    miyagiPath.lineTo(size.width * 0.7719950, size.height * 0.3386115);
    miyagiPath.lineTo(size.width * 0.7741673, size.height * 0.3383402);
    miyagiPath.lineTo(size.width * 0.7769569, size.height * 0.3401037);
    miyagiPath.lineTo(size.width * 0.7802496, size.height * 0.3410339);
    miyagiPath.lineTo(size.width * 0.7815072, size.height * 0.3426036);
    miyagiPath.lineTo(size.width * 0.7865606, size.height * 0.3421191);
    miyagiPath.lineTo(size.width * 0.7882069, size.height * 0.3425067);
    miyagiPath.lineTo(size.width * 0.7887785, size.height * 0.3434757);
    miyagiPath.lineTo(size.width * 0.7874295, size.height * 0.3445415);
    miyagiPath.lineTo(size.width * 0.7885042, size.height * 0.3466539);
    miyagiPath.lineTo(size.width * 0.7925514, size.height * 0.3486112);
    miyagiPath.lineTo(size.width * 0.7937404, size.height * 0.3482623);
    miyagiPath.lineTo(size.width * 0.7941291, size.height * 0.3469058);
    miyagiPath.lineTo(size.width * 0.7961871, size.height * 0.3452198);
    miyagiPath.lineTo(size.width * 0.8017892, size.height * 0.3471577);
    miyagiPath.lineTo(size.width * 0.8029325, size.height * 0.3433981);
    miyagiPath.lineTo(size.width * 0.8027038, size.height * 0.3424098);
    miyagiPath.lineTo(size.width * 0.8042587, size.height * 0.3410533);
    miyagiPath.lineTo(size.width * 0.8040072, size.height * 0.3376037);
    miyagiPath.lineTo(size.width * 0.8045560, size.height * 0.3365960);
    miyagiPath.lineTo(size.width * 0.8078486, size.height * 0.3368480);
    miyagiPath.lineTo(size.width * 0.8105239, size.height * 0.3377975);
    miyagiPath.lineTo(size.width * 0.8105239, size.height * 0.3377975);
    miyagiPath.lineTo(size.width * 0.8124675, size.height * 0.3433206);
    miyagiPath.lineTo(size.width * 0.8115986, size.height * 0.3430881);
    miyagiPath.lineTo(size.width * 0.8104325, size.height * 0.3414990);
    miyagiPath.lineTo(size.width * 0.8088547, size.height * 0.3418866);
    miyagiPath.lineTo(size.width * 0.8086489, size.height * 0.3451229);
    miyagiPath.lineTo(size.width * 0.8055392, size.height * 0.3467508);
    miyagiPath.lineTo(size.width * 0.8051962, size.height * 0.3478360);
    miyagiPath.lineTo(size.width * 0.8075285, size.height * 0.3491538);
    miyagiPath.lineTo(size.width * 0.8074142, size.height * 0.3514987);
    miyagiPath.lineTo(size.width * 0.8057907, size.height * 0.3502584);
    miyagiPath.lineTo(size.width * 0.8034813, size.height * 0.3520800);
    miyagiPath.lineTo(size.width * 0.8021093, size.height * 0.3524289);
    miyagiPath.lineTo(size.width * 0.8020407, size.height * 0.3538242);
    miyagiPath.lineTo(size.width * 0.8059736, size.height * 0.3542311);
    miyagiPath.lineTo(size.width * 0.8056992, size.height * 0.3555489);
    miyagiPath.lineTo(size.width * 0.8040529, size.height * 0.3567892);
    miyagiPath.lineTo(size.width * 0.8029782, size.height * 0.3568861);
    miyagiPath.lineTo(size.width * 0.8030468, size.height * 0.3578357);
    miyagiPath.lineTo(size.width * 0.8040758, size.height * 0.3582233);
    miyagiPath.lineTo(size.width * 0.8044416, size.height * 0.3592697);
    miyagiPath.lineTo(size.width * 0.8055392, size.height * 0.3589403);
    miyagiPath.lineTo(size.width * 0.8069340, size.height * 0.3596380);
    miyagiPath.lineTo(size.width * 0.8062709, size.height * 0.3614790);
    miyagiPath.lineTo(size.width * 0.8051962, size.height * 0.3602193);
    miyagiPath.lineTo(size.width * 0.8043730, size.height * 0.3604325);
    miyagiPath.lineTo(size.width * 0.8043730, size.height * 0.3636301);
    miyagiPath.lineTo(size.width * 0.8022465, size.height * 0.3635913);
    miyagiPath.lineTo(size.width * 0.8030697, size.height * 0.3642115);
    miyagiPath.lineTo(size.width * 0.8033441, size.height * 0.3660331);
    miyagiPath.lineTo(size.width * 0.8063852, size.height * 0.3657230);
    miyagiPath.lineTo(size.width * 0.8064538, size.height * 0.3662850);
    miyagiPath.lineTo(size.width * 0.8049447, size.height * 0.3665176);
    miyagiPath.lineTo(size.width * 0.8065224, size.height * 0.3700058);
    miyagiPath.lineTo(size.width * 0.8057450, size.height * 0.3719050);
    miyagiPath.lineTo(size.width * 0.8024066, size.height * 0.3698508);
    miyagiPath.lineTo(size.width * 0.8030011, size.height * 0.3688431);
    miyagiPath.lineTo(size.width * 0.8008746, size.height * 0.3683199);
    miyagiPath.lineTo(size.width * 0.8014691, size.height * 0.3674478);
    miyagiPath.lineTo(size.width * 0.8027724, size.height * 0.3670214);
    miyagiPath.lineTo(size.width * 0.8015377, size.height * 0.3657812);
    miyagiPath.lineTo(size.width * 0.7989538, size.height * 0.3665176);
    miyagiPath.lineTo(size.width * 0.7985651, size.height * 0.3652386);
    miyagiPath.lineTo(size.width * 0.7979477, size.height * 0.3650254);
    miyagiPath.lineTo(size.width * 0.7957298, size.height * 0.3649091);
    miyagiPath.lineTo(size.width * 0.7921627, size.height * 0.3657812);
    miyagiPath.lineTo(size.width * 0.7893045, size.height * 0.3674090);
    miyagiPath.lineTo(size.width * 0.7895789, size.height * 0.3691919);
    miyagiPath.lineTo(size.width * 0.7883441, size.height * 0.3695214);
    miyagiPath.lineTo(size.width * 0.7881840, size.height * 0.3668470);
    miyagiPath.lineTo(size.width * 0.7860804, size.height * 0.3666145);
    miyagiPath.lineTo(size.width * 0.7849142, size.height * 0.3672152);
    miyagiPath.lineTo(size.width * 0.7849600, size.height * 0.3679904);
    miyagiPath.close();

    Paint miyagiPaint = Paint()..style = PaintingStyle.fill;
    miyagiPaint.color = japanColors.miyagi ?? defaultColor;
    japanCanvas.drawPath(miyagiPath, miyagiPaint, onTapUp: (tabdetail) {
      callback('miyagi', tabdetail);
    });

    Path miyazakiPath = Path();
    miyazakiPath.moveTo(size.width * 0.3542140, size.height * 0.6617217);
    miyazakiPath.lineTo(size.width * 0.3519274, size.height * 0.6682719);
    miyazakiPath.lineTo(size.width * 0.3515844, size.height * 0.6710819);
    miyazakiPath.lineTo(size.width * 0.3534823, size.height * 0.6733492);
    miyazakiPath.lineTo(size.width * 0.3522018, size.height * 0.6763724);
    miyazakiPath.lineTo(size.width * 0.3523390, size.height * 0.6802870);
    miyazakiPath.lineTo(size.width * 0.3505326, size.height * 0.6811784);
    miyazakiPath.lineTo(size.width * 0.3484747, size.height * 0.6852287);
    miyazakiPath.lineTo(size.width * 0.3490234, size.height * 0.6867791);
    miyazakiPath.lineTo(size.width * 0.3477658, size.height * 0.6874379);
    miyazakiPath.lineTo(size.width * 0.3482003, size.height * 0.6892984);
    miyazakiPath.lineTo(size.width * 0.3464167, size.height * 0.6907130);
    miyazakiPath.lineTo(size.width * 0.3471942, size.height * 0.6920890);
    miyazakiPath.lineTo(size.width * 0.3460280, size.height * 0.6921471);
    miyazakiPath.lineTo(size.width * 0.3448390, size.height * 0.6912557);
    miyazakiPath.lineTo(size.width * 0.3428268, size.height * 0.6914107);
    miyazakiPath.lineTo(size.width * 0.3412719, size.height * 0.6884844);
    miyazakiPath.lineTo(size.width * 0.3388710, size.height * 0.6879806);
    miyazakiPath.lineTo(size.width * 0.3388710, size.height * 0.6879806);
    miyazakiPath.lineTo(size.width * 0.3391454, size.height * 0.6865853);
    miyazakiPath.lineTo(size.width * 0.3405631, size.height * 0.6853062);
    miyazakiPath.lineTo(size.width * 0.3401286, size.height * 0.6836784);
    miyazakiPath.lineTo(size.width * 0.3407003, size.height * 0.6824769);
    miyazakiPath.lineTo(size.width * 0.3400143, size.height * 0.6806940);
    miyazakiPath.lineTo(size.width * 0.3389396, size.height * 0.6801320);
    miyazakiPath.lineTo(size.width * 0.3367445, size.height * 0.6803451);
    miyazakiPath.lineTo(size.width * 0.3351210, size.height * 0.6791049);
    miyazakiPath.lineTo(size.width * 0.3339777, size.height * 0.6802289);
    miyazakiPath.lineTo(size.width * 0.3327201, size.height * 0.6783491);
    miyazakiPath.lineTo(size.width * 0.3323543, size.height * 0.6753065);
    miyazakiPath.lineTo(size.width * 0.3305479, size.height * 0.6749383);
    miyazakiPath.lineTo(size.width * 0.3309595, size.height * 0.6737562);
    miyazakiPath.lineTo(size.width * 0.3284900, size.height * 0.6735043);
    miyazakiPath.lineTo(size.width * 0.3278040, size.height * 0.6728066);
    miyazakiPath.lineTo(size.width * 0.3263177, size.height * 0.6726128);
    miyazakiPath.lineTo(size.width * 0.3259290, size.height * 0.6709074);
    miyazakiPath.lineTo(size.width * 0.3263863, size.height * 0.6707718);
    miyazakiPath.lineTo(size.width * 0.3266607, size.height * 0.6683300);
    miyazakiPath.lineTo(size.width * 0.3249686, size.height * 0.6666828);
    miyazakiPath.lineTo(size.width * 0.3224991, size.height * 0.6660045);
    miyazakiPath.lineTo(size.width * 0.3215387, size.height * 0.6632526);
    miyazakiPath.lineTo(size.width * 0.3196638, size.height * 0.6617217);
    miyazakiPath.lineTo(size.width * 0.3181775, size.height * 0.6612760);
    miyazakiPath.lineTo(size.width * 0.3192750, size.height * 0.6593380);
    miyazakiPath.lineTo(size.width * 0.3192750, size.height * 0.6593380);
    miyazakiPath.lineTo(size.width * 0.3251515, size.height * 0.6594349);
    miyazakiPath.lineTo(size.width * 0.3274381, size.height * 0.6580590);
    miyazakiPath.lineTo(size.width * 0.3293817, size.height * 0.6587373);
    miyazakiPath.lineTo(size.width * 0.3302964, size.height * 0.6584853);
    miyazakiPath.lineTo(size.width * 0.3318970, size.height * 0.6561792);
    miyazakiPath.lineTo(size.width * 0.3344351, size.height * 0.6568769);
    miyazakiPath.lineTo(size.width * 0.3364473, size.height * 0.6566637);
    miyazakiPath.lineTo(size.width * 0.3360585, size.height * 0.6549002);
    miyazakiPath.lineTo(size.width * 0.3334290, size.height * 0.6523034);
    miyazakiPath.lineTo(size.width * 0.3338863, size.height * 0.6511600);
    miyazakiPath.lineTo(size.width * 0.3351668, size.height * 0.6511019);
    miyazakiPath.lineTo(size.width * 0.3366073, size.height * 0.6491058);
    miyazakiPath.lineTo(size.width * 0.3348695, size.height * 0.6477880);
    miyazakiPath.lineTo(size.width * 0.3344351, size.height * 0.6455594);
    miyazakiPath.lineTo(size.width * 0.3334290, size.height * 0.6453850);
    miyazakiPath.lineTo(size.width * 0.3324686, size.height * 0.6440672);
    miyazakiPath.lineTo(size.width * 0.3318970, size.height * 0.6418773);
    miyazakiPath.lineTo(size.width * 0.3324686, size.height * 0.6392030);
    miyazakiPath.lineTo(size.width * 0.3333832, size.height * 0.6388735);
    miyazakiPath.lineTo(size.width * 0.3340463, size.height * 0.6374782);
    miyazakiPath.lineTo(size.width * 0.3356698, size.height * 0.6378852);
    miyazakiPath.lineTo(size.width * 0.3367216, size.height * 0.6372263);
    miyazakiPath.lineTo(size.width * 0.3372933, size.height * 0.6344938);
    miyazakiPath.lineTo(size.width * 0.3381165, size.height * 0.6334474);
    miyazakiPath.lineTo(size.width * 0.3394655, size.height * 0.6334474);
    miyazakiPath.lineTo(size.width * 0.3399229, size.height * 0.6316451);
    miyazakiPath.lineTo(size.width * 0.3421408, size.height * 0.6304048);
    miyazakiPath.lineTo(size.width * 0.3422094, size.height * 0.6286607);
    miyazakiPath.lineTo(size.width * 0.3434899, size.height * 0.6267228);
    miyazakiPath.lineTo(size.width * 0.3463710, size.height * 0.6264127);
    miyazakiPath.lineTo(size.width * 0.3463710, size.height * 0.6264127);
    miyazakiPath.lineTo(size.width * 0.3474686, size.height * 0.6275367);
    miyazakiPath.lineTo(size.width * 0.3483375, size.height * 0.6275561);
    miyazakiPath.lineTo(size.width * 0.3529564, size.height * 0.6261995);
    miyazakiPath.lineTo(size.width * 0.3548542, size.height * 0.6278661);
    miyazakiPath.lineTo(size.width * 0.3544426, size.height * 0.6287770);
    miyazakiPath.lineTo(size.width * 0.3548771, size.height * 0.6293390);
    miyazakiPath.lineTo(size.width * 0.3569350, size.height * 0.6299203);
    miyazakiPath.lineTo(size.width * 0.3581240, size.height * 0.6290676);
    miyazakiPath.lineTo(size.width * 0.3632231, size.height * 0.6291064);
    miyazakiPath.lineTo(size.width * 0.3643435, size.height * 0.6279824);
    miyazakiPath.lineTo(size.width * 0.3646865, size.height * 0.6265483);
    miyazakiPath.lineTo(size.width * 0.3665158, size.height * 0.6262577);
    miyazakiPath.lineTo(size.width * 0.3702658, size.height * 0.6274592);
    miyazakiPath.lineTo(size.width * 0.3696713, size.height * 0.6304823);
    miyazakiPath.lineTo(size.width * 0.3709517, size.height * 0.6305017);
    miyazakiPath.lineTo(size.width * 0.3709517, size.height * 0.6305017);
    miyazakiPath.lineTo(size.width * 0.3704258, size.height * 0.6315094);
    miyazakiPath.lineTo(size.width * 0.3668588, size.height * 0.6333892);
    miyazakiPath.lineTo(size.width * 0.3655097, size.height * 0.6366256);
    miyazakiPath.lineTo(size.width * 0.3630402, size.height * 0.6376527);
    miyazakiPath.lineTo(size.width * 0.3621255, size.height * 0.6393387);
    miyazakiPath.lineTo(size.width * 0.3626515, size.height * 0.6405595);
    miyazakiPath.lineTo(size.width * 0.3643207, size.height * 0.6415866);
    miyazakiPath.lineTo(size.width * 0.3628115, size.height * 0.6426331);
    miyazakiPath.lineTo(size.width * 0.3607536, size.height * 0.6429626);
    miyazakiPath.lineTo(size.width * 0.3611880, size.height * 0.6440284);
    miyazakiPath.lineTo(size.width * 0.3625371, size.height * 0.6447067);
    miyazakiPath.lineTo(size.width * 0.3604335, size.height * 0.6454044);
    miyazakiPath.lineTo(size.width * 0.3577582, size.height * 0.6507918);
    miyazakiPath.lineTo(size.width * 0.3542140, size.height * 0.6617217);
    miyazakiPath.close();

    Paint miyazakiPaint = Paint()..style = PaintingStyle.fill;
    miyazakiPaint.color = japanColors.miyazaki ?? defaultColor;
    japanCanvas.drawPath(miyazakiPath, miyazakiPaint, onTapUp: (tabdetail) {
      callback('miyazaki', tabdetail);
    });

    Path niigataPath = Path();
    niigataPath.moveTo(size.width * 0.6564542, size.height * 0.4249073);
    niigataPath.lineTo(size.width * 0.6606843, size.height * 0.4225430);
    niigataPath.lineTo(size.width * 0.6665380, size.height * 0.4174269);
    niigataPath.lineTo(size.width * 0.6718200, size.height * 0.4149076);
    niigataPath.lineTo(size.width * 0.6770562, size.height * 0.4074466);
    niigataPath.lineTo(size.width * 0.6789770, size.height * 0.4063226);
    niigataPath.lineTo(size.width * 0.6805318, size.height * 0.4040358);
    niigataPath.lineTo(size.width * 0.6836873, size.height * 0.3951020);
    niigataPath.lineTo(size.width * 0.6857681, size.height * 0.3929703);
    niigataPath.lineTo(size.width * 0.6950745, size.height * 0.3872921);
    niigataPath.lineTo(size.width * 0.7005166, size.height * 0.3860712);
    niigataPath.lineTo(size.width * 0.7044266, size.height * 0.3839201);
    niigataPath.lineTo(size.width * 0.7084281, size.height * 0.3802769);
    niigataPath.lineTo(size.width * 0.7112635, size.height * 0.3764010);
    niigataPath.lineTo(size.width * 0.7122010, size.height * 0.3733197);
    niigataPath.lineTo(size.width * 0.7124982, size.height * 0.3658006);
    niigataPath.lineTo(size.width * 0.7167284, size.height * 0.3585333);
    niigataPath.lineTo(size.width * 0.7167284, size.height * 0.3585333);
    niigataPath.lineTo(size.width * 0.7208671, size.height * 0.3603937);
    niigataPath.lineTo(size.width * 0.7242513, size.height * 0.3610139);
    niigataPath.lineTo(size.width * 0.7248000, size.height * 0.3615759);
    niigataPath.lineTo(size.width * 0.7238854, size.height * 0.3654323);
    niigataPath.lineTo(size.width * 0.7257147, size.height * 0.3676222);
    niigataPath.lineTo(size.width * 0.7299220, size.height * 0.3685524);
    niigataPath.lineTo(size.width * 0.7325515, size.height * 0.3709361);
    niigataPath.lineTo(size.width * 0.7307451, size.height * 0.3740174);
    niigataPath.lineTo(size.width * 0.7276125, size.height * 0.3756840);
    niigataPath.lineTo(size.width * 0.7239997, size.height * 0.3752576);
    niigataPath.lineTo(size.width * 0.7228107, size.height * 0.3768467);
    niigataPath.lineTo(size.width * 0.7231766, size.height * 0.3793854);
    niigataPath.lineTo(size.width * 0.7223991, size.height * 0.3809745);
    niigataPath.lineTo(size.width * 0.7231994, size.height * 0.3824473);
    niigataPath.lineTo(size.width * 0.7216217, size.height * 0.3834357);
    niigataPath.lineTo(size.width * 0.7202726, size.height * 0.3895789);
    niigataPath.lineTo(size.width * 0.7217817, size.height * 0.3918269);
    niigataPath.lineTo(size.width * 0.7232909, size.height * 0.3924470);
    niigataPath.lineTo(size.width * 0.7243199, size.height * 0.3921951);
    niigataPath.lineTo(size.width * 0.7253488, size.height * 0.3936873);
    niigataPath.lineTo(size.width * 0.7253488, size.height * 0.3936873);
    niigataPath.lineTo(size.width * 0.7217360, size.height * 0.3970011);
    niigataPath.lineTo(size.width * 0.7201125, size.height * 0.3995204);
    niigataPath.lineTo(size.width * 0.7204098, size.height * 0.3999855);
    niigataPath.lineTo(size.width * 0.7169113, size.height * 0.4020010);
    niigataPath.lineTo(size.width * 0.7168427, size.height * 0.4034157);
    niigataPath.lineTo(size.width * 0.7178031, size.height * 0.4054117);
    niigataPath.lineTo(size.width * 0.7175973, size.height * 0.4069815);
    niigataPath.lineTo(size.width * 0.7184662, size.height * 0.4085706);
    niigataPath.lineTo(size.width * 0.7173686, size.height * 0.4090163);
    niigataPath.lineTo(size.width * 0.7144876, size.height * 0.4085899);
    niigataPath.lineTo(size.width * 0.7136415, size.height * 0.4090550);
    niigataPath.lineTo(size.width * 0.7127498, size.height * 0.4084349);
    niigataPath.lineTo(size.width * 0.7116751, size.height * 0.4085124);
    niigataPath.lineTo(size.width * 0.7107376, size.height * 0.4088225);
    niigataPath.lineTo(size.width * 0.7100059, size.height * 0.4111286);
    niigataPath.lineTo(size.width * 0.7084510, size.height * 0.4106635);
    niigataPath.lineTo(size.width * 0.7071934, size.height * 0.4112255);
    niigataPath.lineTo(size.width * 0.7022772, size.height * 0.4116906);
    niigataPath.lineTo(size.width * 0.7009739, size.height * 0.4134735);
    niigataPath.lineTo(size.width * 0.7025059, size.height * 0.4145587);
    niigataPath.lineTo(size.width * 0.7021858, size.height * 0.4168649);
    niigataPath.lineTo(size.width * 0.7017284, size.height * 0.4191129);
    niigataPath.lineTo(size.width * 0.6995105, size.height * 0.4218260);
    niigataPath.lineTo(size.width * 0.7008595, size.height * 0.4233763);
    niigataPath.lineTo(size.width * 0.7024144, size.height * 0.4236864);
    niigataPath.lineTo(size.width * 0.7034891, size.height * 0.4254886);
    niigataPath.lineTo(size.width * 0.7026888, size.height * 0.4279692);
    niigataPath.lineTo(size.width * 0.7036492, size.height * 0.4306629);
    niigataPath.lineTo(size.width * 0.7031461, size.height * 0.4321745);
    niigataPath.lineTo(size.width * 0.7033976, size.height * 0.4347713);
    niigataPath.lineTo(size.width * 0.7028489, size.height * 0.4355852);
    niigataPath.lineTo(size.width * 0.7028489, size.height * 0.4355852);
    niigataPath.lineTo(size.width * 0.7023230, size.height * 0.4349263);
    niigataPath.lineTo(size.width * 0.7002193, size.height * 0.4347907);
    niigataPath.lineTo(size.width * 0.6999678, size.height * 0.4333179);
    niigataPath.lineTo(size.width * 0.6964464, size.height * 0.4303141);
    niigataPath.lineTo(size.width * 0.6961720, size.height * 0.4321745);
    niigataPath.lineTo(size.width * 0.6942971, size.height * 0.4335892);
    niigataPath.lineTo(size.width * 0.6905699, size.height * 0.4341318);
    niigataPath.lineTo(size.width * 0.6911873, size.height * 0.4378720);
    niigataPath.lineTo(size.width * 0.6909586, size.height * 0.4383565);
    niigataPath.lineTo(size.width * 0.6890379, size.height * 0.4381627);
    niigataPath.lineTo(size.width * 0.6883748, size.height * 0.4400037);
    niigataPath.lineTo(size.width * 0.6889465, size.height * 0.4408564);
    niigataPath.lineTo(size.width * 0.6855395, size.height * 0.4420579);
    niigataPath.lineTo(size.width * 0.6840532, size.height * 0.4419998);
    niigataPath.lineTo(size.width * 0.6843047, size.height * 0.4439377);
    niigataPath.lineTo(size.width * 0.6824983, size.height * 0.4452361);
    niigataPath.lineTo(size.width * 0.6797544, size.height * 0.4443834);
    niigataPath.lineTo(size.width * 0.6789312, size.height * 0.4456043);
    niigataPath.lineTo(size.width * 0.6783596, size.height * 0.4452942);
    niigataPath.lineTo(size.width * 0.6783596, size.height * 0.4452942);
    niigataPath.lineTo(size.width * 0.6780852, size.height * 0.4443640);
    niigataPath.lineTo(size.width * 0.6772163, size.height * 0.4438795);
    niigataPath.lineTo(size.width * 0.6784053, size.height * 0.4422323);
    niigataPath.lineTo(size.width * 0.6778794, size.height * 0.4413409);
    niigataPath.lineTo(size.width * 0.6781995, size.height * 0.4399262);
    niigataPath.lineTo(size.width * 0.6759587, size.height * 0.4390541);
    niigataPath.lineTo(size.width * 0.6736035, size.height * 0.4369418);
    niigataPath.lineTo(size.width * 0.6735120, size.height * 0.4339380);
    niigataPath.lineTo(size.width * 0.6725517, size.height * 0.4321163);
    niigataPath.lineTo(size.width * 0.6706995, size.height * 0.4316706);
    niigataPath.lineTo(size.width * 0.6648459, size.height * 0.4332403);
    niigataPath.lineTo(size.width * 0.6631767, size.height * 0.4362635);
    niigataPath.lineTo(size.width * 0.6604557, size.height * 0.4372906);
    niigataPath.lineTo(size.width * 0.6598612, size.height * 0.4404882);
    niigataPath.lineTo(size.width * 0.6592895, size.height * 0.4405657);
    niigataPath.lineTo(size.width * 0.6586264, size.height * 0.4393448);
    niigataPath.lineTo(size.width * 0.6566828, size.height * 0.4392285);
    niigataPath.lineTo(size.width * 0.6543734, size.height * 0.4405076);
    niigataPath.lineTo(size.width * 0.6515380, size.height * 0.4405463);
    niigataPath.lineTo(size.width * 0.6494115, size.height * 0.4426005);
    niigataPath.lineTo(size.width * 0.6472392, size.height * 0.4412633);
    niigataPath.lineTo(size.width * 0.6484969, size.height * 0.4387634);
    niigataPath.lineTo(size.width * 0.6476508, size.height * 0.4376782);
    niigataPath.lineTo(size.width * 0.6433978, size.height * 0.4369224);
    niigataPath.lineTo(size.width * 0.6410883, size.height * 0.4370968);
    niigataPath.lineTo(size.width * 0.6412713, size.height * 0.4395967);
    niigataPath.lineTo(size.width * 0.6394877, size.height * 0.4421354);
    niigataPath.lineTo(size.width * 0.6363551, size.height * 0.4441702);
    niigataPath.lineTo(size.width * 0.6363551, size.height * 0.4441702);
    niigataPath.lineTo(size.width * 0.6350060, size.height * 0.4409145);
    niigataPath.lineTo(size.width * 0.6350060, size.height * 0.4394223);
    niigataPath.lineTo(size.width * 0.6341143, size.height * 0.4382596);
    niigataPath.lineTo(size.width * 0.6340457, size.height * 0.4359534);
    niigataPath.lineTo(size.width * 0.6321707, size.height * 0.4354690);
    niigataPath.lineTo(size.width * 0.6305701, size.height * 0.4338992);
    niigataPath.lineTo(size.width * 0.6305701, size.height * 0.4338992);
    niigataPath.lineTo(size.width * 0.6429633, size.height * 0.4300621);
    niigataPath.lineTo(size.width * 0.6471020, size.height * 0.4274847);
    niigataPath.lineTo(size.width * 0.6490685, size.height * 0.4269033);
    niigataPath.lineTo(size.width * 0.6511722, size.height * 0.4247716);
    niigataPath.lineTo(size.width * 0.6537103, size.height * 0.4253142);
    niigataPath.lineTo(size.width * 0.6564542, size.height * 0.4249073);
    niigataPath.close();
    niigataPath.moveTo(size.width * 0.6678871, size.height * 0.3769049);
    niigataPath.lineTo(size.width * 0.6665380, size.height * 0.3793466);
    niigataPath.lineTo(size.width * 0.6669724, size.height * 0.3814202);
    niigataPath.lineTo(size.width * 0.6685730, size.height * 0.3820016);
    niigataPath.lineTo(size.width * 0.6722544, size.height * 0.3807420);
    niigataPath.lineTo(size.width * 0.6727117, size.height * 0.3812264);
    niigataPath.lineTo(size.width * 0.6694648, size.height * 0.3888425);
    niigataPath.lineTo(size.width * 0.6631767, size.height * 0.3931641);
    niigataPath.lineTo(size.width * 0.6606615, size.height * 0.3932803);
    niigataPath.lineTo(size.width * 0.6583520, size.height * 0.3944625);
    niigataPath.lineTo(size.width * 0.6566599, size.height * 0.3941718);
    niigataPath.lineTo(size.width * 0.6561798, size.height * 0.3932609);
    niigataPath.lineTo(size.width * 0.6591752, size.height * 0.3921563);
    niigataPath.lineTo(size.width * 0.6599526, size.height * 0.3905285);
    niigataPath.lineTo(size.width * 0.6597240, size.height * 0.3888812);
    niigataPath.lineTo(size.width * 0.6622621, size.height * 0.3869433);
    niigataPath.lineTo(size.width * 0.6627880, size.height * 0.3852186);
    niigataPath.lineTo(size.width * 0.6622163, size.height * 0.3860131);
    niigataPath.lineTo(size.width * 0.6610273, size.height * 0.3848891);
    niigataPath.lineTo(size.width * 0.6596325, size.height * 0.3846953);
    niigataPath.lineTo(size.width * 0.6583520, size.height * 0.3867301);
    niigataPath.lineTo(size.width * 0.6574145, size.height * 0.3862650);
    niigataPath.lineTo(size.width * 0.6574374, size.height * 0.3845597);
    niigataPath.lineTo(size.width * 0.6569115, size.height * 0.3842690);
    niigataPath.lineTo(size.width * 0.6577118, size.height * 0.3835907);
    niigataPath.lineTo(size.width * 0.6577804, size.height * 0.3809357);
    niigataPath.lineTo(size.width * 0.6600212, size.height * 0.3785133);
    niigataPath.lineTo(size.width * 0.6616218, size.height * 0.3754320);
    niigataPath.lineTo(size.width * 0.6634054, size.height * 0.3746956);
    niigataPath.lineTo(size.width * 0.6649602, size.height * 0.3727771);
    niigataPath.lineTo(size.width * 0.6665837, size.height * 0.3724283);
    niigataPath.lineTo(size.width * 0.6676355, size.height * 0.3694439);
    niigataPath.lineTo(size.width * 0.6701279, size.height * 0.3689400);
    niigataPath.lineTo(size.width * 0.6691218, size.height * 0.3751607);
    niigataPath.lineTo(size.width * 0.6678871, size.height * 0.3769049);
    niigataPath.close();

    Paint niigataPaint = Paint()..style = PaintingStyle.fill;
    niigataPaint.color = japanColors.niigata ?? defaultColor;
    japanCanvas.drawPath(niigataPath, niigataPaint, onTapUp: (tabdetail) {
      callback('niigata', tabdetail);
    });

    Path naganoPath = Path();
    naganoPath.moveTo(size.width * 0.6272774, size.height * 0.5137224);
    naganoPath.lineTo(size.width * 0.6272545, size.height * 0.5126953);
    naganoPath.lineTo(size.width * 0.6291752, size.height * 0.5114356);
    naganoPath.lineTo(size.width * 0.6285807, size.height * 0.5089744);
    naganoPath.lineTo(size.width * 0.6305701, size.height * 0.5084124);
    naganoPath.lineTo(size.width * 0.6289466, size.height * 0.5065133);
    naganoPath.lineTo(size.width * 0.6304329, size.height * 0.5051567);
    naganoPath.lineTo(size.width * 0.6304329, size.height * 0.5033932);
    naganoPath.lineTo(size.width * 0.6291295, size.height * 0.5023467);
    naganoPath.lineTo(size.width * 0.6266829, size.height * 0.5029669);
    naganoPath.lineTo(size.width * 0.6259740, size.height * 0.5019010);
    naganoPath.lineTo(size.width * 0.6261341, size.height * 0.4997693);
    naganoPath.lineTo(size.width * 0.6252423, size.height * 0.4988972);
    naganoPath.lineTo(size.width * 0.6262256, size.height * 0.4964167);
    naganoPath.lineTo(size.width * 0.6244420, size.height * 0.4950601);
    naganoPath.lineTo(size.width * 0.6226128, size.height * 0.4915913);
    naganoPath.lineTo(size.width * 0.6198003, size.height * 0.4908742);
    naganoPath.lineTo(size.width * 0.6196859, size.height * 0.4898859);
    naganoPath.lineTo(size.width * 0.6173079, size.height * 0.4898665);
    naganoPath.lineTo(size.width * 0.6166448, size.height * 0.4891107);
    naganoPath.lineTo(size.width * 0.6168963, size.height * 0.4880642);
    naganoPath.lineTo(size.width * 0.6182454, size.height * 0.4875798);
    naganoPath.lineTo(size.width * 0.6190457, size.height * 0.4855256);
    naganoPath.lineTo(size.width * 0.6216753, size.height * 0.4848473);
    naganoPath.lineTo(size.width * 0.6224298, size.height * 0.4854868);
    naganoPath.lineTo(size.width * 0.6233902, size.height * 0.4853511);
    naganoPath.lineTo(size.width * 0.6245792, size.height * 0.4832969);
    naganoPath.lineTo(size.width * 0.6255853, size.height * 0.4831031);
    naganoPath.lineTo(size.width * 0.6264314, size.height * 0.4813203);
    naganoPath.lineTo(size.width * 0.6287179, size.height * 0.4798474);
    naganoPath.lineTo(size.width * 0.6296097, size.height * 0.4768049);
    naganoPath.lineTo(size.width * 0.6279634, size.height * 0.4763204);
    naganoPath.lineTo(size.width * 0.6269115, size.height * 0.4753514);
    naganoPath.lineTo(size.width * 0.6269344, size.height * 0.4737817);
    naganoPath.lineTo(size.width * 0.6286493, size.height * 0.4724058);
    naganoPath.lineTo(size.width * 0.6287637, size.height * 0.4713981);
    naganoPath.lineTo(size.width * 0.6278948, size.height * 0.4703322);
    naganoPath.lineTo(size.width * 0.6310731, size.height * 0.4668246);
    naganoPath.lineTo(size.width * 0.6312789, size.height * 0.4653130);
    naganoPath.lineTo(size.width * 0.6310731, size.height * 0.4642859);
    naganoPath.lineTo(size.width * 0.6287179, size.height * 0.4630069);
    naganoPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    naganoPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    naganoPath.lineTo(size.width * 0.6304786, size.height * 0.4603519);
    naganoPath.lineTo(size.width * 0.6314390, size.height * 0.4587822);
    naganoPath.lineTo(size.width * 0.6313932, size.height * 0.4573287);
    naganoPath.lineTo(size.width * 0.6322850, size.height * 0.4563016);
    naganoPath.lineTo(size.width * 0.6336798, size.height * 0.4559722);
    naganoPath.lineTo(size.width * 0.6334054, size.height * 0.4550226);
    naganoPath.lineTo(size.width * 0.6329252, size.height * 0.4551001);
    naganoPath.lineTo(size.width * 0.6331768, size.height * 0.4536079);
    naganoPath.lineTo(size.width * 0.6358749, size.height * 0.4522514);
    naganoPath.lineTo(size.width * 0.6363322, size.height * 0.4441509);
    naganoPath.lineTo(size.width * 0.6363322, size.height * 0.4441509);
    naganoPath.lineTo(size.width * 0.6394649, size.height * 0.4421160);
    naganoPath.lineTo(size.width * 0.6412484, size.height * 0.4395774);
    naganoPath.lineTo(size.width * 0.6410655, size.height * 0.4370774);
    naganoPath.lineTo(size.width * 0.6433749, size.height * 0.4369030);
    naganoPath.lineTo(size.width * 0.6476280, size.height * 0.4376588);
    naganoPath.lineTo(size.width * 0.6484740, size.height * 0.4387440);
    naganoPath.lineTo(size.width * 0.6472164, size.height * 0.4412633);
    naganoPath.lineTo(size.width * 0.6493886, size.height * 0.4426005);
    naganoPath.lineTo(size.width * 0.6515151, size.height * 0.4405463);
    naganoPath.lineTo(size.width * 0.6543505, size.height * 0.4404882);
    naganoPath.lineTo(size.width * 0.6566599, size.height * 0.4392285);
    naganoPath.lineTo(size.width * 0.6586035, size.height * 0.4393448);
    naganoPath.lineTo(size.width * 0.6592666, size.height * 0.4405463);
    naganoPath.lineTo(size.width * 0.6598154, size.height * 0.4404688);
    naganoPath.lineTo(size.width * 0.6604099, size.height * 0.4372712);
    naganoPath.lineTo(size.width * 0.6631310, size.height * 0.4362441);
    naganoPath.lineTo(size.width * 0.6648002, size.height * 0.4332016);
    naganoPath.lineTo(size.width * 0.6706767, size.height * 0.4316319);
    naganoPath.lineTo(size.width * 0.6725288, size.height * 0.4320776);
    naganoPath.lineTo(size.width * 0.6734892, size.height * 0.4338992);
    naganoPath.lineTo(size.width * 0.6735806, size.height * 0.4369030);
    naganoPath.lineTo(size.width * 0.6759358, size.height * 0.4390154);
    naganoPath.lineTo(size.width * 0.6781767, size.height * 0.4398874);
    naganoPath.lineTo(size.width * 0.6778565, size.height * 0.4413021);
    naganoPath.lineTo(size.width * 0.6783825, size.height * 0.4421742);
    naganoPath.lineTo(size.width * 0.6771934, size.height * 0.4438408);
    naganoPath.lineTo(size.width * 0.6780623, size.height * 0.4443059);
    naganoPath.lineTo(size.width * 0.6783367, size.height * 0.4452361);
    naganoPath.lineTo(size.width * 0.6783367, size.height * 0.4452361);
    naganoPath.lineTo(size.width * 0.6747925, size.height * 0.4468446);
    naganoPath.lineTo(size.width * 0.6706995, size.height * 0.4475422);
    naganoPath.lineTo(size.width * 0.6706767, size.height * 0.4496546);
    naganoPath.lineTo(size.width * 0.6684816, size.height * 0.4499646);
    naganoPath.lineTo(size.width * 0.6662864, size.height * 0.4522514);
    naganoPath.lineTo(size.width * 0.6663322, size.height * 0.4541699);
    naganoPath.lineTo(size.width * 0.6649602, size.height * 0.4573869);
    naganoPath.lineTo(size.width * 0.6650974, size.height * 0.4599062);
    naganoPath.lineTo(size.width * 0.6679557, size.height * 0.4613402);
    naganoPath.lineTo(size.width * 0.6689389, size.height * 0.4614759);
    naganoPath.lineTo(size.width * 0.6694191, size.height * 0.4608751);
    naganoPath.lineTo(size.width * 0.6714313, size.height * 0.4613596);
    naganoPath.lineTo(size.width * 0.6724373, size.height * 0.4605845);
    naganoPath.lineTo(size.width * 0.6740380, size.height * 0.4603907);
    naganoPath.lineTo(size.width * 0.6759358, size.height * 0.4608751);
    naganoPath.lineTo(size.width * 0.6765989, size.height * 0.4631038);
    naganoPath.lineTo(size.width * 0.6764389, size.height * 0.4659719);
    naganoPath.lineTo(size.width * 0.6740837, size.height * 0.4672897);
    naganoPath.lineTo(size.width * 0.6746096, size.height * 0.4694408);
    naganoPath.lineTo(size.width * 0.6755700, size.height * 0.4702935);
    naganoPath.lineTo(size.width * 0.6755014, size.height * 0.4718632);
    naganoPath.lineTo(size.width * 0.6744724, size.height * 0.4727934);
    naganoPath.lineTo(size.width * 0.6734206, size.height * 0.4721539);
    naganoPath.lineTo(size.width * 0.6730547, size.height * 0.4724833);
    naganoPath.lineTo(size.width * 0.6740608, size.height * 0.4739561);
    naganoPath.lineTo(size.width * 0.6755471, size.height * 0.4741112);
    naganoPath.lineTo(size.width * 0.6761873, size.height * 0.4754096);
    naganoPath.lineTo(size.width * 0.6754328, size.height * 0.4760879);
    naganoPath.lineTo(size.width * 0.6763017, size.height * 0.4795180);
    naganoPath.lineTo(size.width * 0.6776965, size.height * 0.4798862);
    naganoPath.lineTo(size.width * 0.6785197, size.height * 0.4808939);
    naganoPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    naganoPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    naganoPath.lineTo(size.width * 0.6791142, size.height * 0.4816109);
    naganoPath.lineTo(size.width * 0.6803032, size.height * 0.4836458);
    naganoPath.lineTo(size.width * 0.6798459, size.height * 0.4846535);
    naganoPath.lineTo(size.width * 0.6798459, size.height * 0.4846535);
    naganoPath.lineTo(size.width * 0.6789312, size.height * 0.4846341);
    naganoPath.lineTo(size.width * 0.6772620, size.height * 0.4864558);
    naganoPath.lineTo(size.width * 0.6750440, size.height * 0.4864751);
    naganoPath.lineTo(size.width * 0.6738093, size.height * 0.4842659);
    naganoPath.lineTo(size.width * 0.6697849, size.height * 0.4842078);
    naganoPath.lineTo(size.width * 0.6692819, size.height * 0.4850023);
    naganoPath.lineTo(size.width * 0.6681843, size.height * 0.4851767);
    naganoPath.lineTo(size.width * 0.6670867, size.height * 0.4841496);
    naganoPath.lineTo(size.width * 0.6671096, size.height * 0.4828512);
    naganoPath.lineTo(size.width * 0.6638398, size.height * 0.4817272);
    naganoPath.lineTo(size.width * 0.6597926, size.height * 0.4869790);
    naganoPath.lineTo(size.width * 0.6581462, size.height * 0.4857775);
    naganoPath.lineTo(size.width * 0.6576889, size.height * 0.4860100);
    naganoPath.lineTo(size.width * 0.6554709, size.height * 0.4898277);
    naganoPath.lineTo(size.width * 0.6574831, size.height * 0.4914944);
    naganoPath.lineTo(size.width * 0.6551965, size.height * 0.4936261);
    naganoPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    naganoPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    naganoPath.lineTo(size.width * 0.6555395, size.height * 0.5002344);
    naganoPath.lineTo(size.width * 0.6547164, size.height * 0.4999631);
    naganoPath.lineTo(size.width * 0.6534359, size.height * 0.5012227);
    naganoPath.lineTo(size.width * 0.6541904, size.height * 0.5017266);
    naganoPath.lineTo(size.width * 0.6532529, size.height * 0.5028118);
    naganoPath.lineTo(size.width * 0.6542133, size.height * 0.5053505);
    naganoPath.lineTo(size.width * 0.6525212, size.height * 0.5058544);
    naganoPath.lineTo(size.width * 0.6525212, size.height * 0.5071528);
    naganoPath.lineTo(size.width * 0.6537331, size.height * 0.5084512);
    naganoPath.lineTo(size.width * 0.6534130, size.height * 0.5098465);
    naganoPath.lineTo(size.width * 0.6496401, size.height * 0.5110674);
    naganoPath.lineTo(size.width * 0.6468734, size.height * 0.5130247);
    naganoPath.lineTo(size.width * 0.6439466, size.height * 0.5142650);
    naganoPath.lineTo(size.width * 0.6434664, size.height * 0.5150983);
    naganoPath.lineTo(size.width * 0.6423002, size.height * 0.5151177);
    naganoPath.lineTo(size.width * 0.6412484, size.height * 0.5169199);
    naganoPath.lineTo(size.width * 0.6388018, size.height * 0.5171331);
    naganoPath.lineTo(size.width * 0.6388018, size.height * 0.5171331);
    naganoPath.lineTo(size.width * 0.6368810, size.height * 0.5176370);
    naganoPath.lineTo(size.width * 0.6363780, size.height * 0.5168812);
    naganoPath.lineTo(size.width * 0.6328338, size.height * 0.5162998);
    naganoPath.lineTo(size.width * 0.6308673, size.height * 0.5173850);
    naganoPath.lineTo(size.width * 0.6280091, size.height * 0.5178889);
    naganoPath.lineTo(size.width * 0.6280091, size.height * 0.5169006);
    naganoPath.lineTo(size.width * 0.6265685, size.height * 0.5153308);
    naganoPath.close();

    Paint naganoPaint = Paint()..style = PaintingStyle.fill;
    naganoPaint.color = japanColors.nagano ?? defaultColor;
    japanCanvas.drawPath(naganoPath, naganoPaint, onTapUp: (tabdetail) {
      callback('nagano', tabdetail);
    });

    Path naraPath = Path();
    naraPath.moveTo(size.width * 0.5589315, size.height * 0.5390898);
    naraPath.lineTo(size.width * 0.5607608, size.height * 0.5421323);
    naraPath.lineTo(size.width * 0.5598919, size.height * 0.5431401);
    naraPath.lineTo(size.width * 0.5600062, size.height * 0.5442834);
    naraPath.lineTo(size.width * 0.5590230, size.height * 0.5462407);
    naraPath.lineTo(size.width * 0.5596175, size.height * 0.5470353);
    naraPath.lineTo(size.width * 0.5619727, size.height * 0.5480043);
    naraPath.lineTo(size.width * 0.5638477, size.height * 0.5474810);
    naraPath.lineTo(size.width * 0.5649223, size.height * 0.5494383);
    naraPath.lineTo(size.width * 0.5664086, size.height * 0.5489151);
    naraPath.lineTo(size.width * 0.5670717, size.height * 0.5507755);
    naraPath.lineTo(size.width * 0.5661800, size.height * 0.5526165);
    naraPath.lineTo(size.width * 0.5611952, size.height * 0.5532366);
    naraPath.lineTo(size.width * 0.5600519, size.height * 0.5550777);
    naraPath.lineTo(size.width * 0.5626815, size.height * 0.5586628);
    naraPath.lineTo(size.width * 0.5611724, size.height * 0.5593605);
    naraPath.lineTo(size.width * 0.5627501, size.height * 0.5616085);
    naraPath.lineTo(size.width * 0.5611038, size.height * 0.5642441);
    naraPath.lineTo(size.width * 0.5619498, size.height * 0.5655618);
    naraPath.lineTo(size.width * 0.5616525, size.height * 0.5689532);
    naraPath.lineTo(size.width * 0.5611038, size.height * 0.5694765);
    naraPath.lineTo(size.width * 0.5614239, size.height * 0.5720539);
    naraPath.lineTo(size.width * 0.5577196, size.height * 0.5715694);
    naraPath.lineTo(size.width * 0.5558446, size.height * 0.5737205);
    naraPath.lineTo(size.width * 0.5530779, size.height * 0.5744763);
    naraPath.lineTo(size.width * 0.5505626, size.height * 0.5778095);
    naraPath.lineTo(size.width * 0.5505626, size.height * 0.5778095);
    naraPath.lineTo(size.width * 0.5459666, size.height * 0.5784684);
    naraPath.lineTo(size.width * 0.5444575, size.height * 0.5776739);
    naraPath.lineTo(size.width * 0.5429483, size.height * 0.5776545);
    naraPath.lineTo(size.width * 0.5403187, size.height * 0.5789723);
    naraPath.lineTo(size.width * 0.5398157, size.height * 0.5778677);
    naraPath.lineTo(size.width * 0.5389697, size.height * 0.5776157);
    naraPath.lineTo(size.width * 0.5405931, size.height * 0.5740693);
    naraPath.lineTo(size.width * 0.5399529, size.height * 0.5730810);
    naraPath.lineTo(size.width * 0.5386267, size.height * 0.5726740);
    naraPath.lineTo(size.width * 0.5387639, size.height * 0.5716663);
    naraPath.lineTo(size.width * 0.5361572, size.height * 0.5698059);
    naraPath.lineTo(size.width * 0.5364316, size.height * 0.5687594);
    naraPath.lineTo(size.width * 0.5398614, size.height * 0.5659494);
    naraPath.lineTo(size.width * 0.5407303, size.height * 0.5648254);
    naraPath.lineTo(size.width * 0.5407075, size.height * 0.5634495);
    naraPath.lineTo(size.width * 0.5419422, size.height * 0.5629263);
    naraPath.lineTo(size.width * 0.5437943, size.height * 0.5636433);
    naraPath.lineTo(size.width * 0.5446861, size.height * 0.5624805);
    naraPath.lineTo(size.width * 0.5442059, size.height * 0.5612209);
    naraPath.lineTo(size.width * 0.5421709, size.height * 0.5602519);
    naraPath.lineTo(size.width * 0.5417136, size.height * 0.5569187);
    naraPath.lineTo(size.width * 0.5407989, size.height * 0.5556009);
    naraPath.lineTo(size.width * 0.5407989, size.height * 0.5556009);
    naraPath.lineTo(size.width * 0.5421937, size.height * 0.5548839);
    naraPath.lineTo(size.width * 0.5426282, size.height * 0.5527522);
    naraPath.lineTo(size.width * 0.5424453, size.height * 0.5504848);
    naraPath.lineTo(size.width * 0.5412334, size.height * 0.5480624);
    naraPath.lineTo(size.width * 0.5425367, size.height * 0.5463183);
    naraPath.lineTo(size.width * 0.5420565, size.height * 0.5454462);
    naraPath.lineTo(size.width * 0.5411876, size.height * 0.5453105);
    naraPath.lineTo(size.width * 0.5423538, size.height * 0.5407177);
    naraPath.lineTo(size.width * 0.5435200, size.height * 0.5398650);
    naraPath.lineTo(size.width * 0.5438858, size.height * 0.5372294);
    naraPath.lineTo(size.width * 0.5446861, size.height * 0.5373457);
    naraPath.lineTo(size.width * 0.5446861, size.height * 0.5373457);
    naraPath.lineTo(size.width * 0.5458751, size.height * 0.5397099);
    naraPath.lineTo(size.width * 0.5502654, size.height * 0.5407177);
    naraPath.lineTo(size.width * 0.5519346, size.height * 0.5405626);
    naraPath.lineTo(size.width * 0.5536266, size.height * 0.5383728);
    naraPath.lineTo(size.width * 0.5534437, size.height * 0.5390704);
    naraPath.lineTo(size.width * 0.5557074, size.height * 0.5390898);
    naraPath.lineTo(size.width * 0.5568279, size.height * 0.5403882);
    naraPath.lineTo(size.width * 0.5581541, size.height * 0.5405432);
    naraPath.close();

    Paint naraPaint = Paint()..style = PaintingStyle.fill;
    naraPaint.color = japanColors.nara ?? defaultColor;
    japanCanvas.drawPath(naraPath, naraPaint, onTapUp: (tabdetail) {
      callback('nara', tabdetail);
    });

    Path nagasakiPath = Path();
    nagasakiPath.moveTo(size.width * 0.2980784, size.height * 0.6244748);
    nagasakiPath.lineTo(size.width * 0.3002507, size.height * 0.6242035);
    nagasakiPath.lineTo(size.width * 0.3013711, size.height * 0.6249011);
    nagasakiPath.lineTo(size.width * 0.3033833, size.height * 0.6282150);
    nagasakiPath.lineTo(size.width * 0.3033833, size.height * 0.6303467);
    nagasakiPath.lineTo(size.width * 0.3019885, size.height * 0.6318970);
    nagasakiPath.lineTo(size.width * 0.3025144, size.height * 0.6324978);
    nagasakiPath.lineTo(size.width * 0.3020342, size.height * 0.6334474);
    nagasakiPath.lineTo(size.width * 0.2983528, size.height * 0.6346101);
    nagasakiPath.lineTo(size.width * 0.2968437, size.height * 0.6362573);
    nagasakiPath.lineTo(size.width * 0.2939397, size.height * 0.6371682);
    nagasakiPath.lineTo(size.width * 0.2940083, size.height * 0.6358504);
    nagasakiPath.lineTo(size.width * 0.2921791, size.height * 0.6349008);
    nagasakiPath.lineTo(size.width * 0.2923620, size.height * 0.6332148);
    nagasakiPath.lineTo(size.width * 0.2955861, size.height * 0.6310443);
    nagasakiPath.lineTo(size.width * 0.2957233, size.height * 0.6298622);
    nagasakiPath.lineTo(size.width * 0.2946486, size.height * 0.6293777);
    nagasakiPath.lineTo(size.width * 0.2950830, size.height * 0.6285638);
    nagasakiPath.lineTo(size.width * 0.2944885, size.height * 0.6280018);
    nagasakiPath.lineTo(size.width * 0.2902355, size.height * 0.6279437);
    nagasakiPath.lineTo(size.width * 0.2877660, size.height * 0.6293196);
    nagasakiPath.lineTo(size.width * 0.2842675, size.height * 0.6291452);
    nagasakiPath.lineTo(size.width * 0.2838330, size.height * 0.6310637);
    nagasakiPath.lineTo(size.width * 0.2816837, size.height * 0.6339512);
    nagasakiPath.lineTo(size.width * 0.2794885, size.height * 0.6350558);
    nagasakiPath.lineTo(size.width * 0.2775678, size.height * 0.6371876);
    nagasakiPath.lineTo(size.width * 0.2745724, size.height * 0.6381178);
    nagasakiPath.lineTo(size.width * 0.2751212, size.height * 0.6370713);
    nagasakiPath.lineTo(size.width * 0.2764703, size.height * 0.6366062);
    nagasakiPath.lineTo(size.width * 0.2787797, size.height * 0.6306955);
    nagasakiPath.lineTo(size.width * 0.2758300, size.height * 0.6277305);
    nagasakiPath.lineTo(size.width * 0.2762645, size.height * 0.6268584);
    nagasakiPath.lineTo(size.width * 0.2749840, size.height * 0.6266840);
    nagasakiPath.lineTo(size.width * 0.2745724, size.height * 0.6274786);
    nagasakiPath.lineTo(size.width * 0.2725145, size.height * 0.6257926);
    nagasakiPath.lineTo(size.width * 0.2711425, size.height * 0.6223818);
    nagasakiPath.lineTo(size.width * 0.2697020, size.height * 0.6207927);
    nagasakiPath.lineTo(size.width * 0.2695419, size.height * 0.6196881);
    nagasakiPath.lineTo(size.width * 0.2705937, size.height * 0.6182734);
    nagasakiPath.lineTo(size.width * 0.2711197, size.height * 0.6152115);
    nagasakiPath.lineTo(size.width * 0.2733376, size.height * 0.6146882);
    nagasakiPath.lineTo(size.width * 0.2746181, size.height * 0.6160836);
    nagasakiPath.lineTo(size.width * 0.2742751, size.height * 0.6183509);
    nagasakiPath.lineTo(size.width * 0.2751669, size.height * 0.6185253);
    nagasakiPath.lineTo(size.width * 0.2757385, size.height * 0.6177114);
    nagasakiPath.lineTo(size.width * 0.2780480, size.height * 0.6189129);
    nagasakiPath.lineTo(size.width * 0.2780937, size.height * 0.6220717);
    nagasakiPath.lineTo(size.width * 0.2772248, size.height * 0.6220524);
    nagasakiPath.lineTo(size.width * 0.2775678, size.height * 0.6234477);
    nagasakiPath.lineTo(size.width * 0.2768361, size.height * 0.6247267);
    nagasakiPath.lineTo(size.width * 0.2781852, size.height * 0.6248430);
    nagasakiPath.lineTo(size.width * 0.2795343, size.height * 0.6263158);
    nagasakiPath.lineTo(size.width * 0.2817523, size.height * 0.6241259);
    nagasakiPath.lineTo(size.width * 0.2854794, size.height * 0.6261220);
    nagasakiPath.lineTo(size.width * 0.2867827, size.height * 0.6256375);
    nagasakiPath.lineTo(size.width * 0.2832843, size.height * 0.6221493);
    nagasakiPath.lineTo(size.width * 0.2841760, size.height * 0.6193005);
    nagasakiPath.lineTo(size.width * 0.2833071, size.height * 0.6174789);
    nagasakiPath.lineTo(size.width * 0.2801059, size.height * 0.6156572);
    nagasakiPath.lineTo(size.width * 0.2765389, size.height * 0.6158898);
    nagasakiPath.lineTo(size.width * 0.2746410, size.height * 0.6151340);
    nagasakiPath.lineTo(size.width * 0.2739093, size.height * 0.6112387);
    nagasakiPath.lineTo(size.width * 0.2728803, size.height * 0.6114132);
    nagasakiPath.lineTo(size.width * 0.2733834, size.height * 0.6129829);
    nagasakiPath.lineTo(size.width * 0.2713712, size.height * 0.6141262);
    nagasakiPath.lineTo(size.width * 0.2709367, size.height * 0.6127309);
    nagasakiPath.lineTo(size.width * 0.2724001, size.height * 0.6125759);
    nagasakiPath.lineTo(size.width * 0.2718742, size.height * 0.6112387);
    nagasakiPath.lineTo(size.width * 0.2699992, size.height * 0.6111225);
    nagasakiPath.lineTo(size.width * 0.2692218, size.height * 0.6098047);
    nagasakiPath.lineTo(size.width * 0.2675526, size.height * 0.6088551);
    nagasakiPath.lineTo(size.width * 0.2662950, size.height * 0.6088745);
    nagasakiPath.lineTo(size.width * 0.2665922, size.height * 0.6071497);
    nagasakiPath.lineTo(size.width * 0.2679184, size.height * 0.6063358);
    nagasakiPath.lineTo(size.width * 0.2673239, size.height * 0.6035839);
    nagasakiPath.lineTo(size.width * 0.2682386, size.height * 0.6013747);
    nagasakiPath.lineTo(size.width * 0.2695876, size.height * 0.6022661);
    nagasakiPath.lineTo(size.width * 0.2716456, size.height * 0.6005608);
    nagasakiPath.lineTo(size.width * 0.2723087, size.height * 0.6010840);
    nagasakiPath.lineTo(size.width * 0.2715084, size.height * 0.6021111);
    nagasakiPath.lineTo(size.width * 0.2719428, size.height * 0.6026344);
    nagasakiPath.lineTo(size.width * 0.2736578, size.height * 0.6029250);
    nagasakiPath.lineTo(size.width * 0.2751669, size.height * 0.6020336);
    nagasakiPath.lineTo(size.width * 0.2759443, size.height * 0.6026537);
    nagasakiPath.lineTo(size.width * 0.2766989, size.height * 0.6017817);
    nagasakiPath.lineTo(size.width * 0.2771791, size.height * 0.6034095);
    nagasakiPath.lineTo(size.width * 0.2771791, size.height * 0.6034095);
    nagasakiPath.lineTo(size.width * 0.2758300, size.height * 0.6053281);
    nagasakiPath.lineTo(size.width * 0.2782309, size.height * 0.6080024);
    nagasakiPath.lineTo(size.width * 0.2782995, size.height * 0.6104442);
    nagasakiPath.lineTo(size.width * 0.2814550, size.height * 0.6115682);
    nagasakiPath.lineTo(size.width * 0.2837873, size.height * 0.6113744);
    nagasakiPath.lineTo(size.width * 0.2846105, size.height * 0.6130604);
    nagasakiPath.lineTo(size.width * 0.2843818, size.height * 0.6138743);
    nagasakiPath.lineTo(size.width * 0.2831928, size.height * 0.6140681);
    nagasakiPath.lineTo(size.width * 0.2830785, size.height * 0.6147658);
    nagasakiPath.lineTo(size.width * 0.2857080, size.height * 0.6162580);
    nagasakiPath.lineTo(size.width * 0.2892522, size.height * 0.6194555);
    nagasakiPath.lineTo(size.width * 0.2956547, size.height * 0.6207733);
    nagasakiPath.lineTo(size.width * 0.2956547, size.height * 0.6207733);
    nagasakiPath.lineTo(size.width * 0.2955403, size.height * 0.6219361);
    nagasakiPath.lineTo(size.width * 0.2939855, size.height * 0.6225950);
    nagasakiPath.lineTo(size.width * 0.2921562, size.height * 0.6243972);
    nagasakiPath.lineTo(size.width * 0.2940998, size.height * 0.6258313);
    nagasakiPath.lineTo(size.width * 0.2980784, size.height * 0.6244748);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2561883, size.height * 0.5580039);
    nagasakiPath.lineTo(size.width * 0.2569886, size.height * 0.5557947);
    nagasakiPath.lineTo(size.width * 0.2557081, size.height * 0.5571706);
    nagasakiPath.lineTo(size.width * 0.2526898, size.height * 0.5570737);
    nagasakiPath.lineTo(size.width * 0.2515465, size.height * 0.5564924);
    nagasakiPath.lineTo(size.width * 0.2527356, size.height * 0.5562211);
    nagasakiPath.lineTo(size.width * 0.2533758, size.height * 0.5553684);
    nagasakiPath.lineTo(size.width * 0.2536730, size.height * 0.5515119);
    nagasakiPath.lineTo(size.width * 0.2552051, size.height * 0.5488957);
    nagasakiPath.lineTo(size.width * 0.2561426, size.height * 0.5485469);
    nagasakiPath.lineTo(size.width * 0.2560968, size.height * 0.5477329);
    nagasakiPath.lineTo(size.width * 0.2543133, size.height * 0.5475198);
    nagasakiPath.lineTo(size.width * 0.2542447, size.height * 0.5468027);
    nagasakiPath.lineTo(size.width * 0.2550907, size.height * 0.5459500);
    nagasakiPath.lineTo(size.width * 0.2557767, size.height * 0.5431788);
    nagasakiPath.lineTo(size.width * 0.2590694, size.height * 0.5430432);
    nagasakiPath.lineTo(size.width * 0.2599611, size.height * 0.5411828);
    nagasakiPath.lineTo(size.width * 0.2615846, size.height * 0.5405045);
    nagasakiPath.lineTo(size.width * 0.2630709, size.height * 0.5410665);
    nagasakiPath.lineTo(size.width * 0.2637797, size.height * 0.5422486);
    nagasakiPath.lineTo(size.width * 0.2625221, size.height * 0.5450780);
    nagasakiPath.lineTo(size.width * 0.2626822, size.height * 0.5474810);
    nagasakiPath.lineTo(size.width * 0.2609444, size.height * 0.5498259);
    nagasakiPath.lineTo(size.width * 0.2579718, size.height * 0.5522095);
    nagasakiPath.lineTo(size.width * 0.2592752, size.height * 0.5540893);
    nagasakiPath.lineTo(size.width * 0.2586807, size.height * 0.5562598);
    nagasakiPath.lineTo(size.width * 0.2598011, size.height * 0.5563761);
    nagasakiPath.lineTo(size.width * 0.2600526, size.height * 0.5569381);
    nagasakiPath.lineTo(size.width * 0.2580404, size.height * 0.5583721);
    nagasakiPath.lineTo(size.width * 0.2581090, size.height * 0.5591473);
    nagasakiPath.lineTo(size.width * 0.2589779, size.height * 0.5594574);
    nagasakiPath.lineTo(size.width * 0.2574459, size.height * 0.5606783);
    nagasakiPath.lineTo(size.width * 0.2560511, size.height * 0.5604263);
    nagasakiPath.lineTo(size.width * 0.2539703, size.height * 0.5671316);
    nagasakiPath.lineTo(size.width * 0.2508377, size.height * 0.5692439);
    nagasakiPath.lineTo(size.width * 0.2503804, size.height * 0.5683718);
    nagasakiPath.lineTo(size.width * 0.2487340, size.height * 0.5683912);
    nagasakiPath.lineTo(size.width * 0.2504718, size.height * 0.5578489);
    nagasakiPath.lineTo(size.width * 0.2515694, size.height * 0.5584303);
    nagasakiPath.lineTo(size.width * 0.2512950, size.height * 0.5596124);
    nagasakiPath.lineTo(size.width * 0.2532386, size.height * 0.5590698);
    nagasakiPath.lineTo(size.width * 0.2532843, size.height * 0.5583140);
    nagasakiPath.lineTo(size.width * 0.2561883, size.height * 0.5580039);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2341685, size.height * 0.6303854);
    nagasakiPath.lineTo(size.width * 0.2344886, size.height * 0.6326916);
    nagasakiPath.lineTo(size.width * 0.2366380, size.height * 0.6342807);
    nagasakiPath.lineTo(size.width * 0.2364551, size.height * 0.6349202);
    nagasakiPath.lineTo(size.width * 0.2331396, size.height * 0.6351140);
    nagasakiPath.lineTo(size.width * 0.2326365, size.height * 0.6342419);
    nagasakiPath.lineTo(size.width * 0.2309444, size.height * 0.6347264);
    nagasakiPath.lineTo(size.width * 0.2306015, size.height * 0.6358504);
    nagasakiPath.lineTo(size.width * 0.2317676, size.height * 0.6363736);
    nagasakiPath.lineTo(size.width * 0.2320191, size.height * 0.6371294);
    nagasakiPath.lineTo(size.width * 0.2310359, size.height * 0.6379821);
    nagasakiPath.lineTo(size.width * 0.2301670, size.height * 0.6377302);
    nagasakiPath.lineTo(size.width * 0.2293667, size.height * 0.6364318);
    nagasakiPath.lineTo(size.width * 0.2257082, size.height * 0.6371876);
    nagasakiPath.lineTo(size.width * 0.2231701, size.height * 0.6361992);
    nagasakiPath.lineTo(size.width * 0.2237874, size.height * 0.6346101);
    nagasakiPath.lineTo(size.width * 0.2242448, size.height * 0.6351915);
    nagasakiPath.lineTo(size.width * 0.2264399, size.height * 0.6343969);
    nagasakiPath.lineTo(size.width * 0.2254338, size.height * 0.6330985);
    nagasakiPath.lineTo(size.width * 0.2250451, size.height * 0.6294165);
    nagasakiPath.lineTo(size.width * 0.2257996, size.height * 0.6285444);
    nagasakiPath.lineTo(size.width * 0.2268743, size.height * 0.6286219);
    nagasakiPath.lineTo(size.width * 0.2281091, size.height * 0.6299397);
    nagasakiPath.lineTo(size.width * 0.2326822, size.height * 0.6277499);
    nagasakiPath.lineTo(size.width * 0.2326594, size.height * 0.6286607);
    nagasakiPath.lineTo(size.width * 0.2341685, size.height * 0.6303854);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2460130, size.height * 0.6164518);
    nagasakiPath.lineTo(size.width * 0.2453042, size.height * 0.6194555);
    nagasakiPath.lineTo(size.width * 0.2467904, size.height * 0.6193780);
    nagasakiPath.lineTo(size.width * 0.2487798, size.height * 0.6182540);
    nagasakiPath.lineTo(size.width * 0.2495115, size.height * 0.6185253);
    nagasakiPath.lineTo(size.width * 0.2495801, size.height * 0.6196300);
    nagasakiPath.lineTo(size.width * 0.2456700, size.height * 0.6225175);
    nagasakiPath.lineTo(size.width * 0.2458529, size.height * 0.6249980);
    nagasakiPath.lineTo(size.width * 0.2442752, size.height * 0.6248817);
    nagasakiPath.lineTo(size.width * 0.2439779, size.height * 0.6269941);
    nagasakiPath.lineTo(size.width * 0.2432462, size.height * 0.6266840);
    nagasakiPath.lineTo(size.width * 0.2439551, size.height * 0.6236996);
    nagasakiPath.lineTo(size.width * 0.2429033, size.height * 0.6211609);
    nagasakiPath.lineTo(size.width * 0.2422859, size.height * 0.6217423);
    nagasakiPath.lineTo(size.width * 0.2409139, size.height * 0.6212191);
    nagasakiPath.lineTo(size.width * 0.2418514, size.height * 0.6197269);
    nagasakiPath.lineTo(size.width * 0.2434520, size.height * 0.6197656);
    nagasakiPath.lineTo(size.width * 0.2431776, size.height * 0.6174207);
    nagasakiPath.lineTo(size.width * 0.2458987, size.height * 0.6150177);
    nagasakiPath.lineTo(size.width * 0.2455328, size.height * 0.6131573);
    nagasakiPath.lineTo(size.width * 0.2464017, size.height * 0.6112387);
    nagasakiPath.lineTo(size.width * 0.2467676, size.height * 0.6138356);
    nagasakiPath.lineTo(size.width * 0.2460130, size.height * 0.6164518);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2649230, size.height * 0.6014328);
    nagasakiPath.lineTo(size.width * 0.2656319, size.height * 0.6016266);
    nagasakiPath.lineTo(size.width * 0.2657691, size.height * 0.6009677);
    nagasakiPath.lineTo(size.width * 0.2645114, size.height * 0.6009871);
    nagasakiPath.lineTo(size.width * 0.2648544, size.height * 0.6002507);
    nagasakiPath.lineTo(size.width * 0.2662950, size.height * 0.6000957);
    nagasakiPath.lineTo(size.width * 0.2666608, size.height * 0.6013747);
    nagasakiPath.lineTo(size.width * 0.2662264, size.height * 0.6018786);
    nagasakiPath.lineTo(size.width * 0.2669581, size.height * 0.6024793);
    nagasakiPath.lineTo(size.width * 0.2658834, size.height * 0.6028863);
    nagasakiPath.lineTo(size.width * 0.2658148, size.height * 0.6037002);
    nagasakiPath.lineTo(size.width * 0.2647858, size.height * 0.6038940);
    nagasakiPath.lineTo(size.width * 0.2652889, size.height * 0.6045917);
    nagasakiPath.lineTo(size.width * 0.2622020, size.height * 0.6090101);
    nagasakiPath.lineTo(size.width * 0.2579718, size.height * 0.6110256);
    nagasakiPath.lineTo(size.width * 0.2570343, size.height * 0.6104829);
    nagasakiPath.lineTo(size.width * 0.2571944, size.height * 0.6094365);
    nagasakiPath.lineTo(size.width * 0.2580633, size.height * 0.6102892);
    nagasakiPath.lineTo(size.width * 0.2590694, size.height * 0.6102310);
    nagasakiPath.lineTo(size.width * 0.2584291, size.height * 0.6085256);
    nagasakiPath.lineTo(size.width * 0.2605328, size.height * 0.6075179);
    nagasakiPath.lineTo(size.width * 0.2595038, size.height * 0.6063745);
    nagasakiPath.lineTo(size.width * 0.2612645, size.height * 0.6039328);
    nagasakiPath.lineTo(size.width * 0.2642142, size.height * 0.6014135);
    nagasakiPath.lineTo(size.width * 0.2649230, size.height * 0.6014328);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2349460, size.height * 0.6257344);
    nagasakiPath.lineTo(size.width * 0.2368438, size.height * 0.6267421);
    nagasakiPath.lineTo(size.width * 0.2358606, size.height * 0.6293777);
    nagasakiPath.lineTo(size.width * 0.2341457, size.height * 0.6284281);
    nagasakiPath.lineTo(size.width * 0.2339627, size.height * 0.6259476);
    nagasakiPath.lineTo(size.width * 0.2349460, size.height * 0.6257344);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2416685, size.height * 0.6249980);
    nagasakiPath.lineTo(size.width * 0.2404566, size.height * 0.6244941);
    nagasakiPath.lineTo(size.width * 0.2395420, size.height * 0.6232151);
    nagasakiPath.lineTo(size.width * 0.2411655, size.height * 0.6234089);
    nagasakiPath.lineTo(size.width * 0.2403194, size.height * 0.6223624);
    nagasakiPath.lineTo(size.width * 0.2407767, size.height * 0.6217229);
    nagasakiPath.lineTo(size.width * 0.2428347, size.height * 0.6233120);
    nagasakiPath.lineTo(size.width * 0.2425831, size.height * 0.6256957);
    nagasakiPath.lineTo(size.width * 0.2416685, size.height * 0.6249980);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2477051, size.height * 0.6052506);
    nagasakiPath.lineTo(size.width * 0.2476593, size.height * 0.6060645);
    nagasakiPath.lineTo(size.width * 0.2483910, size.height * 0.6063358);
    nagasakiPath.lineTo(size.width * 0.2471106, size.height * 0.6068784);
    nagasakiPath.lineTo(size.width * 0.2472020, size.height * 0.6073435);
    nagasakiPath.lineTo(size.width * 0.2445953, size.height * 0.6068784);
    nagasakiPath.lineTo(size.width * 0.2444581, size.height * 0.6063552);
    nagasakiPath.lineTo(size.width * 0.2454642, size.height * 0.6056188);
    nagasakiPath.lineTo(size.width * 0.2467904, size.height * 0.6055606);
    nagasakiPath.lineTo(size.width * 0.2469048, size.height * 0.6049405);
    nagasakiPath.lineTo(size.width * 0.2477051, size.height * 0.6052506);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2386045, size.height * 0.6277111);
    nagasakiPath.lineTo(size.width * 0.2382386, size.height * 0.6269166);
    nagasakiPath.lineTo(size.width * 0.2374383, size.height * 0.6267615);
    nagasakiPath.lineTo(size.width * 0.2373926, size.height * 0.6259476);
    nagasakiPath.lineTo(size.width * 0.2355176, size.height * 0.6249205);
    nagasakiPath.lineTo(size.width * 0.2362722, size.height * 0.6242228);
    nagasakiPath.lineTo(size.width * 0.2375755, size.height * 0.6245329);
    nagasakiPath.lineTo(size.width * 0.2381700, size.height * 0.6259670);
    nagasakiPath.lineTo(size.width * 0.2390161, size.height * 0.6243972);
    nagasakiPath.lineTo(size.width * 0.2394277, size.height * 0.6245329);
    nagasakiPath.lineTo(size.width * 0.2397249, size.height * 0.6253662);
    nagasakiPath.lineTo(size.width * 0.2387188, size.height * 0.6264127);
    nagasakiPath.lineTo(size.width * 0.2391761, size.height * 0.6269747);
    nagasakiPath.lineTo(size.width * 0.2386045, size.height * 0.6277111);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2596410, size.height * 0.6017429);
    nagasakiPath.lineTo(size.width * 0.2608986, size.height * 0.5985260);
    nagasakiPath.lineTo(size.width * 0.2608986, size.height * 0.6025762);
    nagasakiPath.lineTo(size.width * 0.2592523, size.height * 0.6023824);
    nagasakiPath.lineTo(size.width * 0.2596410, size.height * 0.6017429);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2672553, size.height * 0.5967818);
    nagasakiPath.lineTo(size.width * 0.2662264, size.height * 0.5973438);
    nagasakiPath.lineTo(size.width * 0.2637111, size.height * 0.5972275);
    nagasakiPath.lineTo(size.width * 0.2663864, size.height * 0.5954253);
    nagasakiPath.lineTo(size.width * 0.2676212, size.height * 0.5961035);
    nagasakiPath.lineTo(size.width * 0.2672553, size.height * 0.5967818);
    nagasakiPath.close();
    nagasakiPath.moveTo(size.width * 0.2440694, size.height * 0.6101535);
    nagasakiPath.lineTo(size.width * 0.2435435, size.height * 0.6104054);
    nagasakiPath.lineTo(size.width * 0.2426517, size.height * 0.6098047);
    nagasakiPath.lineTo(size.width * 0.2433834, size.height * 0.6087582);
    nagasakiPath.lineTo(size.width * 0.2443667, size.height * 0.6092814);
    nagasakiPath.lineTo(size.width * 0.2457157, size.height * 0.6089326);
    nagasakiPath.lineTo(size.width * 0.2453042, size.height * 0.6102504);
    nagasakiPath.lineTo(size.width * 0.2440694, size.height * 0.6101535);
    nagasakiPath.close();

    Paint nagasakiPaint = Paint()..style = PaintingStyle.fill;
    nagasakiPaint.color = japanColors.nagasaki ?? defaultColor;
    japanCanvas.drawPath(nagasakiPath, nagasakiPaint, onTapUp: (tabdetail) {
      callback('nagasaki', tabdetail);
    });

    Path okinawaPath = Path();
    okinawaPath.moveTo(size.width * 0.1878653, size.height * 0.9049894);
    okinawaPath.lineTo(size.width * 0.1897631, size.height * 0.9034197);
    okinawaPath.lineTo(size.width * 0.1945878, size.height * 0.9016949);
    okinawaPath.lineTo(size.width * 0.1954567, size.height * 0.9002415);
    okinawaPath.lineTo(size.width * 0.1937646, size.height * 0.8990787);
    okinawaPath.lineTo(size.width * 0.1914781, size.height * 0.8988849);
    okinawaPath.lineTo(size.width * 0.1907235, size.height * 0.8972765);
    okinawaPath.lineTo(size.width * 0.1914323, size.height * 0.8965982);
    okinawaPath.lineTo(size.width * 0.1905634, size.height * 0.8955711);
    okinawaPath.lineTo(size.width * 0.1907006, size.height * 0.8944083);
    okinawaPath.lineTo(size.width * 0.1918896, size.height * 0.8949316);
    okinawaPath.lineTo(size.width * 0.1944277, size.height * 0.8946021);
    okinawaPath.lineTo(size.width * 0.1961884, size.height * 0.8951835);
    okinawaPath.lineTo(size.width * 0.1966229, size.height * 0.8955711);
    okinawaPath.lineTo(size.width * 0.1958454, size.height * 0.8969470);
    okinawaPath.lineTo(size.width * 0.1965771, size.height * 0.8978772);
    okinawaPath.lineTo(size.width * 0.1986808, size.height * 0.8976640);
    okinawaPath.lineTo(size.width * 0.2008302, size.height * 0.8965013);
    okinawaPath.lineTo(size.width * 0.2015390, size.height * 0.8947572);
    okinawaPath.lineTo(size.width * 0.2034140, size.height * 0.8940014);
    okinawaPath.lineTo(size.width * 0.2033683, size.height * 0.8934006);
    okinawaPath.lineTo(size.width * 0.2066609, size.height * 0.8907456);
    okinawaPath.lineTo(size.width * 0.2076213, size.height * 0.8888077);
    okinawaPath.lineTo(size.width * 0.2074155, size.height * 0.8876643);
    okinawaPath.lineTo(size.width * 0.2079872, size.height * 0.8874318);
    okinawaPath.lineTo(size.width * 0.2100680, size.height * 0.8888077);
    okinawaPath.lineTo(size.width * 0.2109597, size.height * 0.8927611);
    okinawaPath.lineTo(size.width * 0.2069353, size.height * 0.8978385);
    okinawaPath.lineTo(size.width * 0.2029110, size.height * 0.8978966);
    okinawaPath.lineTo(size.width * 0.2030253, size.height * 0.8992338);
    okinawaPath.lineTo(size.width * 0.2018363, size.height * 0.8990400);
    okinawaPath.lineTo(size.width * 0.2030939, size.height * 0.9005709);
    okinawaPath.lineTo(size.width * 0.2004643, size.height * 0.9019662);
    okinawaPath.lineTo(size.width * 0.1978348, size.height * 0.9012298);
    okinawaPath.lineTo(size.width * 0.1985893, size.height * 0.9025282);
    okinawaPath.lineTo(size.width * 0.1946793, size.height * 0.9047762);
    okinawaPath.lineTo(size.width * 0.1939247, size.height * 0.9060746);
    okinawaPath.lineTo(size.width * 0.1902890, size.height * 0.9052026);
    okinawaPath.lineTo(size.width * 0.1885741, size.height * 0.9063072);
    okinawaPath.lineTo(size.width * 0.1890543, size.height * 0.9074312);
    okinawaPath.lineTo(size.width * 0.1906549, size.height * 0.9084583);
    okinawaPath.lineTo(size.width * 0.1904948, size.height * 0.9093885);
    okinawaPath.lineTo(size.width * 0.1927585, size.height * 0.9114427);
    okinawaPath.lineTo(size.width * 0.1926442, size.height * 0.9121210);
    okinawaPath.lineTo(size.width * 0.1903348, size.height * 0.9103962);
    okinawaPath.lineTo(size.width * 0.1888028, size.height * 0.9106675);
    okinawaPath.lineTo(size.width * 0.1857845, size.height * 0.9160743);
    okinawaPath.lineTo(size.width * 0.1862418, size.height * 0.9166557);
    okinawaPath.lineTo(size.width * 0.1879339, size.height * 0.9164619);
    okinawaPath.lineTo(size.width * 0.1885741, size.height * 0.9175471);
    okinawaPath.lineTo(size.width * 0.1848241, size.height * 0.9195820);
    okinawaPath.lineTo(size.width * 0.1837951, size.height * 0.9208029);
    okinawaPath.lineTo(size.width * 0.1816229, size.height * 0.9214618);
    okinawaPath.lineTo(size.width * 0.1807311, size.height * 0.9210548);
    okinawaPath.lineTo(size.width * 0.1798394, size.height * 0.9161906);
    okinawaPath.lineTo(size.width * 0.1830406, size.height * 0.9130124);
    okinawaPath.lineTo(size.width * 0.1852357, size.height * 0.9120628);
    okinawaPath.lineTo(size.width * 0.1853500, size.height * 0.9115590);
    okinawaPath.lineTo(size.width * 0.1833378, size.height * 0.9074893);
    okinawaPath.lineTo(size.width * 0.1834064, size.height * 0.9062490);
    okinawaPath.lineTo(size.width * 0.1837723, size.height * 0.9059584);
    okinawaPath.lineTo(size.width * 0.1843211, size.height * 0.9066948);
    okinawaPath.lineTo(size.width * 0.1878653, size.height * 0.9049894);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.2680785, size.height * 0.8233446);
    okinawaPath.lineTo(size.width * 0.2655633, size.height * 0.8261159);
    okinawaPath.lineTo(size.width * 0.2631166, size.height * 0.8268910);
    okinawaPath.lineTo(size.width * 0.2619733, size.height * 0.8265228);
    okinawaPath.lineTo(size.width * 0.2613331, size.height * 0.8287127);
    okinawaPath.lineTo(size.width * 0.2622020, size.height * 0.8301661);
    okinawaPath.lineTo(size.width * 0.2597554, size.height * 0.8316002);
    okinawaPath.lineTo(size.width * 0.2593438, size.height * 0.8327629);
    okinawaPath.lineTo(size.width * 0.2585435, size.height * 0.8321816);
    okinawaPath.lineTo(size.width * 0.2578804, size.height * 0.8327629);
    okinawaPath.lineTo(size.width * 0.2583605, size.height * 0.8347202);
    okinawaPath.lineTo(size.width * 0.2546105, size.height * 0.8329180);
    okinawaPath.lineTo(size.width * 0.2546791, size.height * 0.8319490);
    okinawaPath.lineTo(size.width * 0.2536502, size.height * 0.8302630);
    okinawaPath.lineTo(size.width * 0.2493285, size.height * 0.8296816);
    okinawaPath.lineTo(size.width * 0.2473850, size.height * 0.8284026);
    okinawaPath.lineTo(size.width * 0.2515008, size.height * 0.8275305);
    okinawaPath.lineTo(size.width * 0.2519124, size.height * 0.8271623);
    okinawaPath.lineTo(size.width * 0.2510435, size.height * 0.8262709);
    okinawaPath.lineTo(size.width * 0.2532615, size.height * 0.8251856);
    okinawaPath.lineTo(size.width * 0.2549993, size.height * 0.8251081);
    okinawaPath.lineTo(size.width * 0.2566456, size.height * 0.8234028);
    okinawaPath.lineTo(size.width * 0.2578575, size.height * 0.8240423);
    okinawaPath.lineTo(size.width * 0.2591151, size.height * 0.8226663);
    okinawaPath.lineTo(size.width * 0.2614932, size.height * 0.8228989);
    okinawaPath.lineTo(size.width * 0.2621791, size.height * 0.8214648);
    okinawaPath.lineTo(size.width * 0.2628651, size.height * 0.8220656);
    okinawaPath.lineTo(size.width * 0.2641456, size.height * 0.8220462);
    okinawaPath.lineTo(size.width * 0.2646715, size.height * 0.8203021);
    okinawaPath.lineTo(size.width * 0.2657919, size.height * 0.8192944);
    okinawaPath.lineTo(size.width * 0.2669581, size.height * 0.8195850);
    okinawaPath.lineTo(size.width * 0.2693361, size.height * 0.8186936);
    okinawaPath.lineTo(size.width * 0.2697020, size.height * 0.8205346);
    okinawaPath.lineTo(size.width * 0.2691989, size.height * 0.8210385);
    okinawaPath.lineTo(size.width * 0.2700450, size.height * 0.8214067);
    okinawaPath.lineTo(size.width * 0.2716913, size.height * 0.8194688);
    okinawaPath.lineTo(size.width * 0.2703879, size.height * 0.8176665);
    okinawaPath.lineTo(size.width * 0.2724230, size.height * 0.8164650);
    okinawaPath.lineTo(size.width * 0.2726745, size.height * 0.8182285);
    okinawaPath.lineTo(size.width * 0.2737721, size.height * 0.8188680);
    okinawaPath.lineTo(size.width * 0.2736120, size.height * 0.8208059);
    okinawaPath.lineTo(size.width * 0.2713026, size.height * 0.8222206);
    okinawaPath.lineTo(size.width * 0.2689703, size.height * 0.8220462);
    okinawaPath.lineTo(size.width * 0.2680785, size.height * 0.8233446);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.01326200, size.height * 0.9934750);
    okinawaPath.lineTo(size.width * 0.01275895, size.height * 0.9952967);
    okinawaPath.lineTo(size.width * 0.01161566, size.height * 0.9956068);
    okinawaPath.lineTo(size.width * 0.01168426, size.height * 0.9970214);
    okinawaPath.lineTo(size.width * 0.01076962, size.height * 0.9969439);
    okinawaPath.lineTo(size.width * 0.01051810, size.height * 0.9978354);
    okinawaPath.lineTo(size.width * 0.008574507, size.height * 0.9971183);
    okinawaPath.lineTo(size.width * 0.004938844, size.height * 0.9968277);
    okinawaPath.lineTo(size.width * 0.003589762, size.height * 0.9960137);
    okinawaPath.lineTo(size.width * 0.003315372, size.height * 0.9969052);
    okinawaPath.lineTo(size.width * 0.001600437, size.height * 0.9967114);
    okinawaPath.lineTo(size.width * 0.0007315365, size.height * 0.9956649);
    okinawaPath.lineTo(size.width * 0.002629398, size.height * 0.9939014);
    okinawaPath.lineTo(size.width * 0.003818420, size.height * 0.9942696);
    okinawaPath.lineTo(size.width * 0.004435796, size.height * 0.9951417);
    okinawaPath.lineTo(size.width * 0.004847381, size.height * 0.9928162);
    okinawaPath.lineTo(size.width * 0.004412931, size.height * 0.9920604);
    okinawaPath.lineTo(size.width * 0.005922074, size.height * 0.9902193);
    okinawaPath.lineTo(size.width * 0.007545545, size.height * 0.9913627);
    okinawaPath.lineTo(size.width * 0.01035804, size.height * 0.9916728);
    okinawaPath.lineTo(size.width * 0.01326200, size.height * 0.9934750);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.2399993, size.height * 0.8454757);
    okinawaPath.lineTo(size.width * 0.2398850, size.height * 0.8471617);
    okinawaPath.lineTo(size.width * 0.2430405, size.height * 0.8495260);
    okinawaPath.lineTo(size.width * 0.2408225, size.height * 0.8534987);
    okinawaPath.lineTo(size.width * 0.2384673, size.height * 0.8538669);
    okinawaPath.lineTo(size.width * 0.2359063, size.height * 0.8512120);
    okinawaPath.lineTo(size.width * 0.2370725, size.height * 0.8494678);
    okinawaPath.lineTo(size.width * 0.2358377, size.height * 0.8464253);
    okinawaPath.lineTo(size.width * 0.2367981, size.height * 0.8438672);
    okinawaPath.lineTo(size.width * 0.2400908, size.height * 0.8439448);
    okinawaPath.lineTo(size.width * 0.2399993, size.height * 0.8454757);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.02362020, size.height * 0.9896767);
    okinawaPath.lineTo(size.width * 0.02604398, size.height * 0.9894248);
    okinawaPath.lineTo(size.width * 0.02592965, size.height * 0.9887465);
    okinawaPath.lineTo(size.width * 0.02755312, size.height * 0.9867504);
    okinawaPath.lineTo(size.width * 0.02855922, size.height * 0.9872931);
    okinawaPath.lineTo(size.width * 0.02931379, size.height * 0.9858590);
    okinawaPath.lineTo(size.width * 0.02871928, size.height * 0.9850063);
    okinawaPath.lineTo(size.width * 0.02988543, size.height * 0.9839211);
    okinawaPath.lineTo(size.width * 0.03002263, size.height * 0.9829715);
    okinawaPath.lineTo(size.width * 0.03132598, size.height * 0.9831653);
    okinawaPath.lineTo(size.width * 0.03100586, size.height * 0.9846962);
    okinawaPath.lineTo(size.width * 0.02965678, size.height * 0.9857040);
    okinawaPath.lineTo(size.width * 0.02990830, size.height * 0.9862660);
    okinawaPath.lineTo(size.width * 0.02874214, size.height * 0.9872349);
    okinawaPath.lineTo(size.width * 0.02867355, size.height * 0.9880489);
    okinawaPath.lineTo(size.width * 0.02725587, size.height * 0.9890953);
    okinawaPath.lineTo(size.width * 0.02762172, size.height * 0.9912077);
    okinawaPath.lineTo(size.width * 0.02679855, size.height * 0.9939208);
    okinawaPath.lineTo(size.width * 0.02293423, size.height * 0.9946378);
    okinawaPath.lineTo(size.width * 0.02238545, size.height * 0.9937464);
    okinawaPath.lineTo(size.width * 0.02096777, size.height * 0.9931844);
    okinawaPath.lineTo(size.width * 0.02211106, size.height * 0.9922929);
    okinawaPath.lineTo(size.width * 0.02236259, size.height * 0.9911689);
    okinawaPath.lineTo(size.width * 0.02039613, size.height * 0.9903744);
    okinawaPath.lineTo(size.width * 0.01971015, size.height * 0.9910720);
    okinawaPath.lineTo(size.width * 0.01900131, size.height * 0.9904325);
    okinawaPath.lineTo(size.width * 0.01932143, size.height * 0.9894442);
    okinawaPath.lineTo(size.width * 0.02121930, size.height * 0.9897930);
    okinawaPath.lineTo(size.width * 0.02119643, size.height * 0.9882426);
    okinawaPath.lineTo(size.width * 0.02362020, size.height * 0.9896767);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.07241583, size.height * 0.9768477);
    okinawaPath.lineTo(size.width * 0.07280454, size.height * 0.9763438);
    okinawaPath.lineTo(size.width * 0.07307893, size.height * 0.9770802);
    okinawaPath.lineTo(size.width * 0.07385637, size.height * 0.9770221);
    okinawaPath.lineTo(size.width * 0.07257589, size.height * 0.9751035);
    okinawaPath.lineTo(size.width * 0.07360485, size.height * 0.9744640);
    okinawaPath.lineTo(size.width * 0.07392497, size.height * 0.9732044);
    okinawaPath.lineTo(size.width * 0.07264448, size.height * 0.9705494);
    okinawaPath.lineTo(size.width * 0.07305607, size.height * 0.9701812);
    okinawaPath.lineTo(size.width * 0.07621155, size.height * 0.9741346);
    okinawaPath.lineTo(size.width * 0.07623441, size.height * 0.9751423);
    okinawaPath.lineTo(size.width * 0.08060178, size.height * 0.9766732);
    okinawaPath.lineTo(size.width * 0.08151642, size.height * 0.9779716);
    okinawaPath.lineTo(size.width * 0.07497680, size.height * 0.9787662);
    okinawaPath.lineTo(size.width * 0.07285028, size.height * 0.9777972);
    okinawaPath.lineTo(size.width * 0.07241583, size.height * 0.9768477);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.2245649, size.height * 0.8665991);
    okinawaPath.lineTo(size.width * 0.2232158, size.height * 0.8676650);
    okinawaPath.lineTo(size.width * 0.2213865, size.height * 0.8681107);
    okinawaPath.lineTo(size.width * 0.2200832, size.height * 0.8671030);
    okinawaPath.lineTo(size.width * 0.2197631, size.height * 0.8655332);
    okinawaPath.lineTo(size.width * 0.2202432, size.height * 0.8648162);
    okinawaPath.lineTo(size.width * 0.2230557, size.height * 0.8651457);
    okinawaPath.lineTo(size.width * 0.2273774, size.height * 0.8632853);
    okinawaPath.lineTo(size.width * 0.2282463, size.height * 0.8633628);
    okinawaPath.lineTo(size.width * 0.2245649, size.height * 0.8665991);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.2512721, size.height * 0.8324722);
    okinawaPath.lineTo(size.width * 0.2521639, size.height * 0.8328211);
    okinawaPath.lineTo(size.width * 0.2528499, size.height * 0.8318134);
    okinawaPath.lineTo(size.width * 0.2542447, size.height * 0.8339257);
    okinawaPath.lineTo(size.width * 0.2568057, size.height * 0.8342358);
    okinawaPath.lineTo(size.width * 0.2572858, size.height * 0.8348753);
    okinawaPath.lineTo(size.width * 0.2566456, size.height * 0.8359993);
    okinawaPath.lineTo(size.width * 0.2557767, size.height * 0.8363481);
    okinawaPath.lineTo(size.width * 0.2545191, size.height * 0.8353598);
    okinawaPath.lineTo(size.width * 0.2541075, size.height * 0.8366194);
    okinawaPath.lineTo(size.width * 0.2524840, size.height * 0.8350109);
    okinawaPath.lineTo(size.width * 0.2509749, size.height * 0.8359993);
    okinawaPath.lineTo(size.width * 0.2512035, size.height * 0.8332862);
    okinawaPath.lineTo(size.width * 0.2497630, size.height * 0.8325498);
    okinawaPath.lineTo(size.width * 0.2491456, size.height * 0.8312126);
    okinawaPath.lineTo(size.width * 0.2507234, size.height * 0.8306506);
    okinawaPath.lineTo(size.width * 0.2511578, size.height * 0.8310769);
    okinawaPath.lineTo(size.width * 0.2504718, size.height * 0.8315227);
    okinawaPath.lineTo(size.width * 0.2512721, size.height * 0.8324722);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1407846, size.height * 0.9108032);
    okinawaPath.lineTo(size.width * 0.1387495, size.height * 0.9098342);
    okinawaPath.lineTo(size.width * 0.1381550, size.height * 0.9088652);
    okinawaPath.lineTo(size.width * 0.1414705, size.height * 0.9081288);
    okinawaPath.lineTo(size.width * 0.1432769, size.height * 0.9099117);
    okinawaPath.lineTo(size.width * 0.1424080, size.height * 0.9108613);
    okinawaPath.lineTo(size.width * 0.1427282, size.height * 0.9122372);
    okinawaPath.lineTo(size.width * 0.1412190, size.height * 0.9116559);
    okinawaPath.lineTo(size.width * 0.1407846, size.height * 0.9108032);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.2879260, size.height * 0.8234415);
    okinawaPath.lineTo(size.width * 0.2851821, size.height * 0.8270654);
    okinawaPath.lineTo(size.width * 0.2838559, size.height * 0.8274918);
    okinawaPath.lineTo(size.width * 0.2827355, size.height * 0.8267554);
    okinawaPath.lineTo(size.width * 0.2828498, size.height * 0.8253407);
    okinawaPath.lineTo(size.width * 0.2842446, size.height * 0.8252050);
    okinawaPath.lineTo(size.width * 0.2869885, size.height * 0.8229958);
    okinawaPath.lineTo(size.width * 0.2879260, size.height * 0.8234415);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.06729389, size.height * 0.9742896);
    okinawaPath.lineTo(size.width * 0.06731675, size.height * 0.9729912);
    okinawaPath.lineTo(size.width * 0.06802559, size.height * 0.9737082);
    okinawaPath.lineTo(size.width * 0.06848291, size.height * 0.9722935);
    okinawaPath.lineTo(size.width * 0.07054083, size.height * 0.9730493);
    okinawaPath.lineTo(size.width * 0.07108961, size.height * 0.9744059);
    okinawaPath.lineTo(size.width * 0.06834571, size.height * 0.9749291);
    okinawaPath.lineTo(size.width * 0.06729389, size.height * 0.9742896);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1939933, size.height * 0.8803002);
    okinawaPath.lineTo(size.width * 0.1960512, size.height * 0.8783042);
    okinawaPath.lineTo(size.width * 0.1971945, size.height * 0.8781298);
    okinawaPath.lineTo(size.width * 0.1958454, size.height * 0.8802615);
    okinawaPath.lineTo(size.width * 0.1925070, size.height * 0.8825288);
    okinawaPath.lineTo(size.width * 0.1939933, size.height * 0.8803002);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1879567, size.height * 0.8934587);
    okinawaPath.lineTo(size.width * 0.1885055, size.height * 0.8945052);
    okinawaPath.lineTo(size.width * 0.1855329, size.height * 0.8945827);
    okinawaPath.lineTo(size.width * 0.1849384, size.height * 0.8941370);
    okinawaPath.lineTo(size.width * 0.1854186, size.height * 0.8933231);
    okinawaPath.lineTo(size.width * 0.1879567, size.height * 0.8934587);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1673089, size.height * 0.9150278);
    okinawaPath.lineTo(size.width * 0.1679720, size.height * 0.9154929);
    okinawaPath.lineTo(size.width * 0.1679720, size.height * 0.9165588);
    okinawaPath.lineTo(size.width * 0.1673775, size.height * 0.9169658);
    okinawaPath.lineTo(size.width * 0.1675833, size.height * 0.9179347);
    okinawaPath.lineTo(size.width * 0.1665543, size.height * 0.9187293);
    okinawaPath.lineTo(size.width * 0.1664171, size.height * 0.9168301);
    okinawaPath.lineTo(size.width * 0.1673089, size.height * 0.9150278);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1934445, size.height * 0.8840210);
    okinawaPath.lineTo(size.width * 0.1943363, size.height * 0.8848931);
    okinawaPath.lineTo(size.width * 0.1941762, size.height * 0.8858039);
    okinawaPath.lineTo(size.width * 0.1935360, size.height * 0.8859590);
    okinawaPath.lineTo(size.width * 0.1922555, size.height * 0.8848156);
    okinawaPath.lineTo(size.width * 0.1934445, size.height * 0.8840210);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.01605162, size.height * 0.9977385);
    okinawaPath.lineTo(size.width * 0.01733211, size.height * 0.9982230);
    okinawaPath.lineTo(size.width * 0.01662327, size.height * 0.9992501);
    okinawaPath.lineTo(size.width * 0.01554858, size.height * 0.9984555);
    okinawaPath.lineTo(size.width * 0.01605162, size.height * 0.9977385);
    okinawaPath.close();
    okinawaPath.moveTo(size.width * 0.1652281, size.height * 0.9140395);
    okinawaPath.lineTo(size.width * 0.1661885, size.height * 0.9144465);
    okinawaPath.lineTo(size.width * 0.1650909, size.height * 0.9153379);
    okinawaPath.lineTo(size.width * 0.1639705, size.height * 0.9150472);
    okinawaPath.lineTo(size.width * 0.1652281, size.height * 0.9140395);
    okinawaPath.close();

    Paint okinawaPaint = Paint()..style = PaintingStyle.fill;
    okinawaPaint.color = japanColors.okinawa ?? defaultColor;
    japanCanvas.drawPath(okinawaPath, okinawaPaint, onTapUp: (tabdetail) {
      callback('okinawa', tabdetail);
    });

    Path osakaPath = Path();
    osakaPath.moveTo(size.width * 0.5308066, size.height * 0.5489732);
    osakaPath.lineTo(size.width * 0.5316526, size.height * 0.5474229);
    osakaPath.lineTo(size.width * 0.5301892, size.height * 0.5471516);
    osakaPath.lineTo(size.width * 0.5301206, size.height * 0.5455818);
    osakaPath.lineTo(size.width * 0.5308066, size.height * 0.5445935);
    osakaPath.lineTo(size.width * 0.5324986, size.height * 0.5437602);
    osakaPath.lineTo(size.width * 0.5314468, size.height * 0.5433145);
    osakaPath.lineTo(size.width * 0.5314468, size.height * 0.5433145);
    osakaPath.lineTo(size.width * 0.5326816, size.height * 0.5409696);
    osakaPath.lineTo(size.width * 0.5323386, size.height * 0.5381984);
    osakaPath.lineTo(size.width * 0.5306465, size.height * 0.5357953);
    osakaPath.lineTo(size.width * 0.5317212, size.height * 0.5318420);
    osakaPath.lineTo(size.width * 0.5307380, size.height * 0.5313575);
    osakaPath.lineTo(size.width * 0.5328188, size.height * 0.5303691);
    osakaPath.lineTo(size.width * 0.5306236, size.height * 0.5300978);
    osakaPath.lineTo(size.width * 0.5274224, size.height * 0.5285281);
    osakaPath.lineTo(size.width * 0.5279712, size.height * 0.5278305);
    osakaPath.lineTo(size.width * 0.5277883, size.height * 0.5259507);
    osakaPath.lineTo(size.width * 0.5268737, size.height * 0.5254856);
    osakaPath.lineTo(size.width * 0.5275368, size.height * 0.5248848);
    osakaPath.lineTo(size.width * 0.5285200, size.height * 0.5249817);
    osakaPath.lineTo(size.width * 0.5285200, size.height * 0.5249817);
    osakaPath.lineTo(size.width * 0.5289544, size.height * 0.5264158);
    osakaPath.lineTo(size.width * 0.5338935, size.height * 0.5275785);
    osakaPath.lineTo(size.width * 0.5340535, size.height * 0.5298265);
    osakaPath.lineTo(size.width * 0.5346252, size.height * 0.5296133);
    osakaPath.lineTo(size.width * 0.5362029, size.height * 0.5310280);
    osakaPath.lineTo(size.width * 0.5380093, size.height * 0.5305242);
    osakaPath.lineTo(size.width * 0.5371404, size.height * 0.5297102);
    osakaPath.lineTo(size.width * 0.5377349, size.height * 0.5283925);
    osakaPath.lineTo(size.width * 0.5394498, size.height * 0.5284312);
    osakaPath.lineTo(size.width * 0.5394498, size.height * 0.5296133);
    osakaPath.lineTo(size.width * 0.5422852, size.height * 0.5318420);
    osakaPath.lineTo(size.width * 0.5429712, size.height * 0.5338962);
    osakaPath.lineTo(size.width * 0.5453264, size.height * 0.5361441);
    osakaPath.lineTo(size.width * 0.5446632, size.height * 0.5373457);
    osakaPath.lineTo(size.width * 0.5446632, size.height * 0.5373457);
    osakaPath.lineTo(size.width * 0.5438629, size.height * 0.5372294);
    osakaPath.lineTo(size.width * 0.5435200, size.height * 0.5398650);
    osakaPath.lineTo(size.width * 0.5423538, size.height * 0.5407177);
    osakaPath.lineTo(size.width * 0.5411876, size.height * 0.5453105);
    osakaPath.lineTo(size.width * 0.5420565, size.height * 0.5454656);
    osakaPath.lineTo(size.width * 0.5425367, size.height * 0.5463376);
    osakaPath.lineTo(size.width * 0.5412334, size.height * 0.5480818);
    osakaPath.lineTo(size.width * 0.5424453, size.height * 0.5505236);
    osakaPath.lineTo(size.width * 0.5426282, size.height * 0.5527715);
    osakaPath.lineTo(size.width * 0.5421937, size.height * 0.5549033);
    osakaPath.lineTo(size.width * 0.5407989, size.height * 0.5556203);
    osakaPath.lineTo(size.width * 0.5407989, size.height * 0.5556203);
    osakaPath.lineTo(size.width * 0.5378492, size.height * 0.5559691);
    osakaPath.lineTo(size.width * 0.5351053, size.height * 0.5575195);
    osakaPath.lineTo(size.width * 0.5314011, size.height * 0.5572482);
    osakaPath.lineTo(size.width * 0.5266907, size.height * 0.5586822);
    osakaPath.lineTo(size.width * 0.5229636, size.height * 0.5588566);
    osakaPath.lineTo(size.width * 0.5201511, size.height * 0.5603876);
    osakaPath.lineTo(size.width * 0.5177731, size.height * 0.5607364);
    osakaPath.lineTo(size.width * 0.5167898, size.height * 0.5606589);
    osakaPath.lineTo(size.width * 0.5164926, size.height * 0.5589535);
    osakaPath.lineTo(size.width * 0.5158752, size.height * 0.5587791);
    osakaPath.lineTo(size.width * 0.5158752, size.height * 0.5587791);
    osakaPath.lineTo(size.width * 0.5217517, size.height * 0.5571319);
    osakaPath.lineTo(size.width * 0.5259590, size.height * 0.5538762);
    osakaPath.lineTo(size.width * 0.5281770, size.height * 0.5509887);
    osakaPath.lineTo(size.width * 0.5308066, size.height * 0.5489732);
    osakaPath.close();

    Paint osakaPaint = Paint()..style = PaintingStyle.fill;
    osakaPaint.color = japanColors.osaka ?? defaultColor;
    japanCanvas.drawPath(osakaPath, osakaPaint, onTapUp: (tabdetail) {
      callback('osaka', tabdetail);
    });

    Path okayamaPath = Path();
    okayamaPath.moveTo(size.width * 0.4679942, size.height * 0.5468996);
    okayamaPath.lineTo(size.width * 0.4647701, size.height * 0.5490120);
    okayamaPath.lineTo(size.width * 0.4636954, size.height * 0.5523452);
    okayamaPath.lineTo(size.width * 0.4592137, size.height * 0.5512987);
    okayamaPath.lineTo(size.width * 0.4580247, size.height * 0.5519576);
    okayamaPath.lineTo(size.width * 0.4538174, size.height * 0.5512987);
    okayamaPath.lineTo(size.width * 0.4523997, size.height * 0.5497871);
    okayamaPath.lineTo(size.width * 0.4487412, size.height * 0.5503491);
    okayamaPath.lineTo(size.width * 0.4481238, size.height * 0.5509499);
    okayamaPath.lineTo(size.width * 0.4486726, size.height * 0.5513762);
    okayamaPath.lineTo(size.width * 0.4435964, size.height * 0.5528491);
    okayamaPath.lineTo(size.width * 0.4420187, size.height * 0.5512212);
    okayamaPath.lineTo(size.width * 0.4420187, size.height * 0.5512212);
    okayamaPath.lineTo(size.width * 0.4417443, size.height * 0.5478492);
    okayamaPath.lineTo(size.width * 0.4389775, size.height * 0.5446516);
    okayamaPath.lineTo(size.width * 0.4390004, size.height * 0.5419773);
    okayamaPath.lineTo(size.width * 0.4380629, size.height * 0.5382952);
    okayamaPath.lineTo(size.width * 0.4387260, size.height * 0.5361248);
    okayamaPath.lineTo(size.width * 0.4350675, size.height * 0.5322489);
    okayamaPath.lineTo(size.width * 0.4350903, size.height * 0.5291482);
    okayamaPath.lineTo(size.width * 0.4361421, size.height * 0.5268034);
    okayamaPath.lineTo(size.width * 0.4338327, size.height * 0.5244391);
    okayamaPath.lineTo(size.width * 0.4338327, size.height * 0.5244391);
    okayamaPath.lineTo(size.width * 0.4346559, size.height * 0.5239546);
    okayamaPath.lineTo(size.width * 0.4352047, size.height * 0.5223267);
    okayamaPath.lineTo(size.width * 0.4360736, size.height * 0.5227531);
    okayamaPath.lineTo(size.width * 0.4402123, size.height * 0.5215322);
    okayamaPath.lineTo(size.width * 0.4394577, size.height * 0.5192261);
    okayamaPath.lineTo(size.width * 0.4400751, size.height * 0.5184897);
    okayamaPath.lineTo(size.width * 0.4418586, size.height * 0.5191292);
    okayamaPath.lineTo(size.width * 0.4446254, size.height * 0.5181796);
    okayamaPath.lineTo(size.width * 0.4451055, size.height * 0.5172106);
    okayamaPath.lineTo(size.width * 0.4446254, size.height * 0.5162804);
    okayamaPath.lineTo(size.width * 0.4468205, size.height * 0.5157959);
    okayamaPath.lineTo(size.width * 0.4486040, size.height * 0.5110868);
    okayamaPath.lineTo(size.width * 0.4524912, size.height * 0.5123077);
    okayamaPath.lineTo(size.width * 0.4553952, size.height * 0.5123271);
    okayamaPath.lineTo(size.width * 0.4578418, size.height * 0.5137611);
    okayamaPath.lineTo(size.width * 0.4590308, size.height * 0.5155246);
    okayamaPath.lineTo(size.width * 0.4605400, size.height * 0.5145557);
    okayamaPath.lineTo(size.width * 0.4609973, size.height * 0.5135092);
    okayamaPath.lineTo(size.width * 0.4636497, size.height * 0.5125596);
    okayamaPath.lineTo(size.width * 0.4637183, size.height * 0.5116294);
    okayamaPath.lineTo(size.width * 0.4671482, size.height * 0.5107961);
    okayamaPath.lineTo(size.width * 0.4668052, size.height * 0.5125208);
    okayamaPath.lineTo(size.width * 0.4672396, size.height * 0.5128503);
    okayamaPath.lineTo(size.width * 0.4690460, size.height * 0.5132573);
    okayamaPath.lineTo(size.width * 0.4711954, size.height * 0.5129278);
    okayamaPath.lineTo(size.width * 0.4727732, size.height * 0.5140712);
    okayamaPath.lineTo(size.width * 0.4732762, size.height * 0.5148851);
    okayamaPath.lineTo(size.width * 0.4730018, size.height * 0.5160672);
    okayamaPath.lineTo(size.width * 0.4741222, size.height * 0.5166680);
    okayamaPath.lineTo(size.width * 0.4736878, size.height * 0.5180439);
    okayamaPath.lineTo(size.width * 0.4748540, size.height * 0.5192648);
    okayamaPath.lineTo(size.width * 0.4782381, size.height * 0.5174819);
    okayamaPath.lineTo(size.width * 0.4794728, size.height * 0.5180052);
    okayamaPath.lineTo(size.width * 0.4810506, size.height * 0.5177532);
    okayamaPath.lineTo(size.width * 0.4842289, size.height * 0.5155052);
    okayamaPath.lineTo(size.width * 0.4849149, size.height * 0.5159510);
    okayamaPath.lineTo(size.width * 0.4849149, size.height * 0.5159510);
    okayamaPath.lineTo(size.width * 0.4839088, size.height * 0.5175013);
    okayamaPath.lineTo(size.width * 0.4853494, size.height * 0.5187803);
    okayamaPath.lineTo(size.width * 0.4851664, size.height * 0.5202919);
    okayamaPath.lineTo(size.width * 0.4836344, size.height * 0.5201563);
    okayamaPath.lineTo(size.width * 0.4830856, size.height * 0.5206601);
    okayamaPath.lineTo(size.width * 0.4825369, size.height * 0.5227918);
    okayamaPath.lineTo(size.width * 0.4811878, size.height * 0.5232763);
    okayamaPath.lineTo(size.width * 0.4810506, size.height * 0.5250786);
    okayamaPath.lineTo(size.width * 0.4789469, size.height * 0.5261251);
    okayamaPath.lineTo(size.width * 0.4794042, size.height * 0.5272685);
    okayamaPath.lineTo(size.width * 0.4790613, size.height * 0.5290320);
    okayamaPath.lineTo(size.width * 0.4782610, size.height * 0.5296521);
    okayamaPath.lineTo(size.width * 0.4798158, size.height * 0.5312993);
    okayamaPath.lineTo(size.width * 0.4782152, size.height * 0.5338380);
    okayamaPath.lineTo(size.width * 0.4786268, size.height * 0.5347488);
    okayamaPath.lineTo(size.width * 0.4810963, size.height * 0.5366093);
    okayamaPath.lineTo(size.width * 0.4823311, size.height * 0.5392642);
    okayamaPath.lineTo(size.width * 0.4823311, size.height * 0.5392642);
    okayamaPath.lineTo(size.width * 0.4811878, size.height * 0.5399037);
    okayamaPath.lineTo(size.width * 0.4807305, size.height * 0.5393611);
    okayamaPath.lineTo(size.width * 0.4792213, size.height * 0.5393417);
    okayamaPath.lineTo(size.width * 0.4751969, size.height * 0.5431788);
    okayamaPath.lineTo(size.width * 0.4743509, size.height * 0.5449036);
    okayamaPath.lineTo(size.width * 0.4721101, size.height * 0.5460469);
    okayamaPath.lineTo(size.width * 0.4691832, size.height * 0.5461632);
    okayamaPath.lineTo(size.width * 0.4679942, size.height * 0.5468996);
    okayamaPath.close();
    okayamaPath.moveTo(size.width * 0.4800216, size.height * 0.5524033);
    okayamaPath.lineTo(size.width * 0.4791756, size.height * 0.5525196);
    okayamaPath.lineTo(size.width * 0.4807305, size.height * 0.5511437);
    okayamaPath.lineTo(size.width * 0.4787640, size.height * 0.5515313);
    okayamaPath.lineTo(size.width * 0.4772320, size.height * 0.5540312);
    okayamaPath.lineTo(size.width * 0.4767061, size.height * 0.5528878);
    okayamaPath.lineTo(size.width * 0.4775521, size.height * 0.5519382);
    okayamaPath.lineTo(size.width * 0.4773006, size.height * 0.5514731);
    okayamaPath.lineTo(size.width * 0.4761573, size.height * 0.5509111);
    okayamaPath.lineTo(size.width * 0.4734820, size.height * 0.5518801);
    okayamaPath.lineTo(size.width * 0.4730018, size.height * 0.5513956);
    okayamaPath.lineTo(size.width * 0.4740308, size.height * 0.5497290);
    okayamaPath.lineTo(size.width * 0.4824454, size.height * 0.5471128);
    okayamaPath.lineTo(size.width * 0.4821710, size.height * 0.5480236);
    okayamaPath.lineTo(size.width * 0.4828570, size.height * 0.5486825);
    okayamaPath.lineTo(size.width * 0.4819424, size.height * 0.5530429);
    okayamaPath.lineTo(size.width * 0.4810277, size.height * 0.5520351);
    okayamaPath.lineTo(size.width * 0.4800216, size.height * 0.5524033);
    okayamaPath.close();

    Paint okayamaPaint = Paint()..style = PaintingStyle.fill;
    okayamaPaint.color = japanColors.okayama ?? defaultColor;
    japanCanvas.drawPath(okayamaPath, okayamaPaint, onTapUp: (tabdetail) {
      callback('okayama', tabdetail);
    });

    Path oitaPath = Path();
    oitaPath.moveTo(size.width * 0.3244884, size.height * 0.6139906);
    oitaPath.lineTo(size.width * 0.3252887, size.height * 0.6135061);
    oitaPath.lineTo(size.width * 0.3263863, size.height * 0.6108318);
    oitaPath.lineTo(size.width * 0.3244656, size.height * 0.6094171);
    oitaPath.lineTo(size.width * 0.3245342, size.height * 0.6082156);
    oitaPath.lineTo(size.width * 0.3237110, size.height * 0.6078474);
    oitaPath.lineTo(size.width * 0.3239854, size.height * 0.6071110);
    oitaPath.lineTo(size.width * 0.3251744, size.height * 0.6066071);
    oitaPath.lineTo(size.width * 0.3254945, size.height * 0.6053668);
    oitaPath.lineTo(size.width * 0.3248314, size.height * 0.6035258);
    oitaPath.lineTo(size.width * 0.3241455, size.height * 0.6032157);
    oitaPath.lineTo(size.width * 0.3252201, size.height * 0.6018786);
    oitaPath.lineTo(size.width * 0.3263406, size.height * 0.6016266);
    oitaPath.lineTo(size.width * 0.3270265, size.height * 0.5984291);
    oitaPath.lineTo(size.width * 0.3307079, size.height * 0.5957547);
    oitaPath.lineTo(size.width * 0.3328345, size.height * 0.5953090);
    oitaPath.lineTo(size.width * 0.3350524, size.height * 0.5958322);
    oitaPath.lineTo(size.width * 0.3394198, size.height * 0.5956191);
    oitaPath.lineTo(size.width * 0.3391226, size.height * 0.5947276);
    oitaPath.lineTo(size.width * 0.3400143, size.height * 0.5937199);
    oitaPath.lineTo(size.width * 0.3393283, size.height * 0.5921696);
    oitaPath.lineTo(size.width * 0.3396713, size.height * 0.5914525);
    oitaPath.lineTo(size.width * 0.3396713, size.height * 0.5914525);
    oitaPath.lineTo(size.width * 0.3404030, size.height * 0.5906192);
    oitaPath.lineTo(size.width * 0.3444731, size.height * 0.5923827);
    oitaPath.lineTo(size.width * 0.3503497, size.height * 0.5926153);
    oitaPath.lineTo(size.width * 0.3505555, size.height * 0.5917432);
    oitaPath.lineTo(size.width * 0.3528420, size.height * 0.5899991);
    oitaPath.lineTo(size.width * 0.3539625, size.height * 0.5881387);
    oitaPath.lineTo(size.width * 0.3578039, size.height * 0.5871697);
    oitaPath.lineTo(size.width * 0.3614624, size.height * 0.5887394);
    oitaPath.lineTo(size.width * 0.3643207, size.height * 0.5919758);
    oitaPath.lineTo(size.width * 0.3649380, size.height * 0.5940687);
    oitaPath.lineTo(size.width * 0.3647322, size.height * 0.5975376);
    oitaPath.lineTo(size.width * 0.3640005, size.height * 0.5978283);
    oitaPath.lineTo(size.width * 0.3630859, size.height * 0.6001732);
    oitaPath.lineTo(size.width * 0.3599533, size.height * 0.5993980);
    oitaPath.lineTo(size.width * 0.3595417, size.height * 0.5999600);
    oitaPath.lineTo(size.width * 0.3606850, size.height * 0.6012197);
    oitaPath.lineTo(size.width * 0.3604106, size.height * 0.6016460);
    oitaPath.lineTo(size.width * 0.3583298, size.height * 0.6018398);
    oitaPath.lineTo(size.width * 0.3578496, size.height * 0.6029832);
    oitaPath.lineTo(size.width * 0.3561804, size.height * 0.6027700);
    oitaPath.lineTo(size.width * 0.3556317, size.height * 0.6019561);
    oitaPath.lineTo(size.width * 0.3540082, size.height * 0.6022468);
    oitaPath.lineTo(size.width * 0.3537338, size.height * 0.6036227);
    oitaPath.lineTo(size.width * 0.3545341, size.height * 0.6065296);
    oitaPath.lineTo(size.width * 0.3579640, size.height * 0.6075179);
    oitaPath.lineTo(size.width * 0.3622627, size.height * 0.6059482);
    oitaPath.lineTo(size.width * 0.3653268, size.height * 0.6078086);
    oitaPath.lineTo(size.width * 0.3720950, size.height * 0.6065102);
    oitaPath.lineTo(size.width * 0.3689853, size.height * 0.6104442);
    oitaPath.lineTo(size.width * 0.3678420, size.height * 0.6128860);
    oitaPath.lineTo(size.width * 0.3694426, size.height * 0.6134867);
    oitaPath.lineTo(size.width * 0.3719121, size.height * 0.6125371);
    oitaPath.lineTo(size.width * 0.3726438, size.height * 0.6130798);
    oitaPath.lineTo(size.width * 0.3710661, size.height * 0.6137387);
    oitaPath.lineTo(size.width * 0.3701514, size.height * 0.6150565);
    oitaPath.lineTo(size.width * 0.3724152, size.height * 0.6156184);
    oitaPath.lineTo(size.width * 0.3731011, size.height * 0.6156766);
    oitaPath.lineTo(size.width * 0.3737642, size.height * 0.6143007);
    oitaPath.lineTo(size.width * 0.3751133, size.height * 0.6159285);
    oitaPath.lineTo(size.width * 0.3759365, size.height * 0.6155991);
    oitaPath.lineTo(size.width * 0.3758679, size.height * 0.6146107);
    oitaPath.lineTo(size.width * 0.3765310, size.height * 0.6143394);
    oitaPath.lineTo(size.width * 0.3766911, size.height * 0.6158898);
    oitaPath.lineTo(size.width * 0.3755478, size.height * 0.6165874);
    oitaPath.lineTo(size.width * 0.3731926, size.height * 0.6163742);
    oitaPath.lineTo(size.width * 0.3714777, size.height * 0.6190486);
    oitaPath.lineTo(size.width * 0.3717521, size.height * 0.6195912);
    oitaPath.lineTo(size.width * 0.3730783, size.height * 0.6199594);
    oitaPath.lineTo(size.width * 0.3736499, size.height * 0.6208508);
    oitaPath.lineTo(size.width * 0.3752962, size.height * 0.6203470);
    oitaPath.lineTo(size.width * 0.3763252, size.height * 0.6210640);
    oitaPath.lineTo(size.width * 0.3800752, size.height * 0.6211997);
    oitaPath.lineTo(size.width * 0.3802353, size.height * 0.6217035);
    oitaPath.lineTo(size.width * 0.3754106, size.height * 0.6222268);
    oitaPath.lineTo(size.width * 0.3757993, size.height * 0.6237190);
    oitaPath.lineTo(size.width * 0.3771941, size.height * 0.6236802);
    oitaPath.lineTo(size.width * 0.3753420, size.height * 0.6251530);
    oitaPath.lineTo(size.width * 0.3768511, size.height * 0.6265096);
    oitaPath.lineTo(size.width * 0.3735813, size.height * 0.6284863);
    oitaPath.lineTo(size.width * 0.3714777, size.height * 0.6275754);
    oitaPath.lineTo(size.width * 0.3709060, size.height * 0.6305405);
    oitaPath.lineTo(size.width * 0.3709060, size.height * 0.6305405);
    oitaPath.lineTo(size.width * 0.3696255, size.height * 0.6305211);
    oitaPath.lineTo(size.width * 0.3702200, size.height * 0.6274979);
    oitaPath.lineTo(size.width * 0.3664700, size.height * 0.6262964);
    oitaPath.lineTo(size.width * 0.3646408, size.height * 0.6265871);
    oitaPath.lineTo(size.width * 0.3642978, size.height * 0.6280212);
    oitaPath.lineTo(size.width * 0.3631774, size.height * 0.6291452);
    oitaPath.lineTo(size.width * 0.3580783, size.height * 0.6291064);
    oitaPath.lineTo(size.width * 0.3568893, size.height * 0.6299591);
    oitaPath.lineTo(size.width * 0.3548314, size.height * 0.6293777);
    oitaPath.lineTo(size.width * 0.3543969, size.height * 0.6288157);
    oitaPath.lineTo(size.width * 0.3548085, size.height * 0.6279049);
    oitaPath.lineTo(size.width * 0.3529106, size.height * 0.6262383);
    oitaPath.lineTo(size.width * 0.3482917, size.height * 0.6275948);
    oitaPath.lineTo(size.width * 0.3474228, size.height * 0.6275754);
    oitaPath.lineTo(size.width * 0.3463253, size.height * 0.6264515);
    oitaPath.lineTo(size.width * 0.3463253, size.height * 0.6264515);
    oitaPath.lineTo(size.width * 0.3431241, size.height * 0.6239903);
    oitaPath.lineTo(size.width * 0.3426439, size.height * 0.6195912);
    oitaPath.lineTo(size.width * 0.3412948, size.height * 0.6164518);
    oitaPath.lineTo(size.width * 0.3393283, size.height * 0.6149402);
    oitaPath.lineTo(size.width * 0.3388939, size.height * 0.6126728);
    oitaPath.lineTo(size.width * 0.3365158, size.height * 0.6105605);
    oitaPath.lineTo(size.width * 0.3332918, size.height * 0.6100566);
    oitaPath.lineTo(size.width * 0.3309595, size.height * 0.6111418);
    oitaPath.lineTo(size.width * 0.3306622, size.height * 0.6125759);
    oitaPath.lineTo(size.width * 0.3325601, size.height * 0.6149208);
    oitaPath.lineTo(size.width * 0.3321485, size.height * 0.6165680);
    oitaPath.lineTo(size.width * 0.3310281, size.height * 0.6177889);
    oitaPath.lineTo(size.width * 0.3301592, size.height * 0.6177695);
    oitaPath.lineTo(size.width * 0.3292445, size.height * 0.6165487);
    oitaPath.lineTo(size.width * 0.3278040, size.height * 0.6164518);
    oitaPath.lineTo(size.width * 0.3264320, size.height * 0.6149208);
    oitaPath.lineTo(size.width * 0.3244427, size.height * 0.6145913);
    oitaPath.lineTo(size.width * 0.3244884, size.height * 0.6139906);
    oitaPath.close();

    Paint oitaPaint = Paint()..style = PaintingStyle.fill;
    oitaPaint.color = japanColors.oita ?? defaultColor;
    japanCanvas.drawPath(oitaPath, oitaPaint, onTapUp: (tabdetail) {
      callback('oita', tabdetail);
    });

    Path sagaPath = Path();
    sagaPath.moveTo(size.width * 0.2775678, size.height * 0.6037390);
    sagaPath.lineTo(size.width * 0.2790998, size.height * 0.6055994);
    sagaPath.lineTo(size.width * 0.2794657, size.height * 0.6038165);
    sagaPath.lineTo(size.width * 0.2790312, size.height * 0.6034483);
    sagaPath.lineTo(size.width * 0.2805632, size.height * 0.6007546);
    sagaPath.lineTo(size.width * 0.2765617, size.height * 0.5981577);
    sagaPath.lineTo(size.width * 0.2776593, size.height * 0.5978671);
    sagaPath.lineTo(size.width * 0.2770648, size.height * 0.5972082);
    sagaPath.lineTo(size.width * 0.2776821, size.height * 0.5965880);
    sagaPath.lineTo(size.width * 0.2785739, size.height * 0.5968593);
    sagaPath.lineTo(size.width * 0.2793742, size.height * 0.5984097);
    sagaPath.lineTo(size.width * 0.2800145, size.height * 0.5979833);
    sagaPath.lineTo(size.width * 0.2787340, size.height * 0.5956966);
    sagaPath.lineTo(size.width * 0.2786654, size.height * 0.5950764);
    sagaPath.lineTo(size.width * 0.2799001, size.height * 0.5950183);
    sagaPath.lineTo(size.width * 0.2794428, size.height * 0.5933129);
    sagaPath.lineTo(size.width * 0.2809062, size.height * 0.5942431);
    sagaPath.lineTo(size.width * 0.2816379, size.height * 0.5941656);
    sagaPath.lineTo(size.width * 0.2816837, size.height * 0.5936424);
    sagaPath.lineTo(size.width * 0.2832385, size.height * 0.5935842);
    sagaPath.lineTo(size.width * 0.2833071, size.height * 0.5942431);
    sagaPath.lineTo(size.width * 0.2849992, size.height * 0.5954640);
    sagaPath.lineTo(size.width * 0.2835587, size.height * 0.5968981);
    sagaPath.lineTo(size.width * 0.2849535, size.height * 0.5979446);
    sagaPath.lineTo(size.width * 0.2875602, size.height * 0.5983128);
    sagaPath.lineTo(size.width * 0.2882004, size.height * 0.5980027);
    sagaPath.lineTo(size.width * 0.2880861, size.height * 0.5973632);
    sagaPath.lineTo(size.width * 0.2880861, size.height * 0.5973632);
    sagaPath.lineTo(size.width * 0.2940998, size.height * 0.5975182);
    sagaPath.lineTo(size.width * 0.2956775, size.height * 0.5968981);
    sagaPath.lineTo(size.width * 0.2976440, size.height * 0.5973632);
    sagaPath.lineTo(size.width * 0.2987187, size.height * 0.5969562);
    sagaPath.lineTo(size.width * 0.3026059, size.height * 0.5990298);
    sagaPath.lineTo(size.width * 0.3043665, size.height * 0.5993593);
    sagaPath.lineTo(size.width * 0.3057842, size.height * 0.6007352);
    sagaPath.lineTo(size.width * 0.3080479, size.height * 0.5988942);
    sagaPath.lineTo(size.width * 0.3097400, size.height * 0.5984097);
    sagaPath.lineTo(size.width * 0.3106775, size.height * 0.5988166);
    sagaPath.lineTo(size.width * 0.3106318, size.height * 0.6031770);
    sagaPath.lineTo(size.width * 0.3094656, size.height * 0.6031188);
    sagaPath.lineTo(size.width * 0.3082994, size.height * 0.6047854);
    sagaPath.lineTo(size.width * 0.3040693, size.height * 0.6075373);
    sagaPath.lineTo(size.width * 0.3027202, size.height * 0.6095527);
    sagaPath.lineTo(size.width * 0.3023315, size.height * 0.6119364);
    sagaPath.lineTo(size.width * 0.3023315, size.height * 0.6119364);
    sagaPath.lineTo(size.width * 0.2993361, size.height * 0.6119170);
    sagaPath.lineTo(size.width * 0.2988787, size.height * 0.6109093);
    sagaPath.lineTo(size.width * 0.2968665, size.height * 0.6097853);
    sagaPath.lineTo(size.width * 0.2964321, size.height * 0.6110643);
    sagaPath.lineTo(size.width * 0.2923391, size.height * 0.6138549);
    sagaPath.lineTo(size.width * 0.2964092, size.height * 0.6197850);
    sagaPath.lineTo(size.width * 0.2965007, size.height * 0.6205795);
    sagaPath.lineTo(size.width * 0.2955403, size.height * 0.6206377);
    sagaPath.lineTo(size.width * 0.2955403, size.height * 0.6206377);
    sagaPath.lineTo(size.width * 0.2891379, size.height * 0.6193199);
    sagaPath.lineTo(size.width * 0.2855937, size.height * 0.6161223);
    sagaPath.lineTo(size.width * 0.2829641, size.height * 0.6146301);
    sagaPath.lineTo(size.width * 0.2830785, size.height * 0.6139325);
    sagaPath.lineTo(size.width * 0.2842675, size.height * 0.6137387);
    sagaPath.lineTo(size.width * 0.2844961, size.height * 0.6129247);
    sagaPath.lineTo(size.width * 0.2836730, size.height * 0.6112387);
    sagaPath.lineTo(size.width * 0.2813407, size.height * 0.6114325);
    sagaPath.lineTo(size.width * 0.2781852, size.height * 0.6103085);
    sagaPath.lineTo(size.width * 0.2781166, size.height * 0.6078668);
    sagaPath.lineTo(size.width * 0.2757157, size.height * 0.6051924);
    sagaPath.lineTo(size.width * 0.2770648, size.height * 0.6032739);
    sagaPath.lineTo(size.width * 0.2770648, size.height * 0.6032739);
    sagaPath.lineTo(size.width * 0.2775678, size.height * 0.6037390);
    sagaPath.close();
    sagaPath.moveTo(size.width * 0.2738864, size.height * 0.5863364);
    sagaPath.lineTo(size.width * 0.2724916, size.height * 0.5862783);
    sagaPath.lineTo(size.width * 0.2715998, size.height * 0.5841465);
    sagaPath.lineTo(size.width * 0.2707538, size.height * 0.5851155);
    sagaPath.lineTo(size.width * 0.2702736, size.height * 0.5836814);
    sagaPath.lineTo(size.width * 0.2710511, size.height * 0.5827125);
    sagaPath.lineTo(size.width * 0.2706166, size.height * 0.5819567);
    sagaPath.lineTo(size.width * 0.2730404, size.height * 0.5793599);
    sagaPath.lineTo(size.width * 0.2761730, size.height * 0.5803288);
    sagaPath.lineTo(size.width * 0.2755785, size.height * 0.5819761);
    sagaPath.lineTo(size.width * 0.2767675, size.height * 0.5828481);
    sagaPath.lineTo(size.width * 0.2754642, size.height * 0.5834101);
    sagaPath.lineTo(size.width * 0.2772477, size.height * 0.5839334);
    sagaPath.lineTo(size.width * 0.2768590, size.height * 0.5849799);
    sagaPath.lineTo(size.width * 0.2743666, size.height * 0.5850768);
    sagaPath.lineTo(size.width * 0.2738864, size.height * 0.5863364);
    sagaPath.close();
    sagaPath.moveTo(size.width * 0.2744352, size.height * 0.5992236);
    sagaPath.lineTo(size.width * 0.2752812, size.height * 0.5972857);
    sagaPath.lineTo(size.width * 0.2770648, size.height * 0.5991267);
    sagaPath.lineTo(size.width * 0.2756699, size.height * 0.5990104);
    sagaPath.lineTo(size.width * 0.2754870, size.height * 0.5998244);
    sagaPath.lineTo(size.width * 0.2743895, size.height * 0.6002701);
    sagaPath.lineTo(size.width * 0.2737035, size.height * 0.5996887);
    sagaPath.lineTo(size.width * 0.2744352, size.height * 0.5992236);
    sagaPath.close();

    Paint sagaPaint = Paint()..style = PaintingStyle.fill;
    sagaPaint.color = japanColors.saga ?? defaultColor;
    japanCanvas.drawPath(sagaPath, sagaPaint, onTapUp: (tabdetail) {
      callback('saga', tabdetail);
    });

    Path shigaPath = Path();
    shigaPath.moveTo(size.width * 0.5756007, size.height * 0.5169587);
    shigaPath.lineTo(size.width * 0.5757607, size.height * 0.5186059);
    shigaPath.lineTo(size.width * 0.5773842, size.height * 0.5200206);
    shigaPath.lineTo(size.width * 0.5757150, size.height * 0.5248654);
    shigaPath.lineTo(size.width * 0.5756235, size.height * 0.5275398);
    shigaPath.lineTo(size.width * 0.5738400, size.height * 0.5296715);
    shigaPath.lineTo(size.width * 0.5733598, size.height * 0.5314544);
    shigaPath.lineTo(size.width * 0.5680092, size.height * 0.5336442);
    shigaPath.lineTo(size.width * 0.5649681, size.height * 0.5323652);
    shigaPath.lineTo(size.width * 0.5626358, size.height * 0.5323846);
    shigaPath.lineTo(size.width * 0.5618812, size.height * 0.5316482);
    shigaPath.lineTo(size.width * 0.5608065, size.height * 0.5324040);
    shigaPath.lineTo(size.width * 0.5609666, size.height * 0.5329078);
    shigaPath.lineTo(size.width * 0.5623842, size.height * 0.5329853);
    shigaPath.lineTo(size.width * 0.5625672, size.height * 0.5334892);
    shigaPath.lineTo(size.width * 0.5608065, size.height * 0.5346907);
    shigaPath.lineTo(size.width * 0.5609666, size.height * 0.5356984);
    shigaPath.lineTo(size.width * 0.5579025, size.height * 0.5367643);
    shigaPath.lineTo(size.width * 0.5579025, size.height * 0.5367643);
    shigaPath.lineTo(size.width * 0.5575596, size.height * 0.5359697);
    shigaPath.lineTo(size.width * 0.5581541, size.height * 0.5354659);
    shigaPath.lineTo(size.width * 0.5567593, size.height * 0.5343031);
    shigaPath.lineTo(size.width * 0.5558446, size.height * 0.5345938);
    shigaPath.lineTo(size.width * 0.5551586, size.height * 0.5338768);
    shigaPath.lineTo(size.width * 0.5544498, size.height * 0.5339737);
    shigaPath.lineTo(size.width * 0.5541526, size.height * 0.5322683);
    shigaPath.lineTo(size.width * 0.5524833, size.height * 0.5330047);
    shigaPath.lineTo(size.width * 0.5508599, size.height * 0.5320939);
    shigaPath.lineTo(size.width * 0.5514087, size.height * 0.5300203);
    shigaPath.lineTo(size.width * 0.5493736, size.height * 0.5270940);
    shigaPath.lineTo(size.width * 0.5487105, size.height * 0.5248267);
    shigaPath.lineTo(size.width * 0.5494879, size.height * 0.5243422);
    shigaPath.lineTo(size.width * 0.5501968, size.height * 0.5209702);
    shigaPath.lineTo(size.width * 0.5492135, size.height * 0.5168812);
    shigaPath.lineTo(size.width * 0.5500824, size.height * 0.5140906);
    shigaPath.lineTo(size.width * 0.5491221, size.height * 0.5141099);
    shigaPath.lineTo(size.width * 0.5464239, size.height * 0.5105442);
    shigaPath.lineTo(size.width * 0.5464239, size.height * 0.5105442);
    shigaPath.lineTo(size.width * 0.5474529, size.height * 0.5091101);
    shigaPath.lineTo(size.width * 0.5482989, size.height * 0.5089163);
    shigaPath.lineTo(size.width * 0.5484361, size.height * 0.5079473);
    shigaPath.lineTo(size.width * 0.5499224, size.height * 0.5079473);
    shigaPath.lineTo(size.width * 0.5507227, size.height * 0.5087225);
    shigaPath.lineTo(size.width * 0.5520260, size.height * 0.5081799);
    shigaPath.lineTo(size.width * 0.5544041, size.height * 0.5028312);
    shigaPath.lineTo(size.width * 0.5561647, size.height * 0.5043234);
    shigaPath.lineTo(size.width * 0.5572166, size.height * 0.5041296);
    shigaPath.lineTo(size.width * 0.5582684, size.height * 0.5024243);
    shigaPath.lineTo(size.width * 0.5612181, size.height * 0.5021917);
    shigaPath.lineTo(size.width * 0.5620184, size.height * 0.5001181);
    shigaPath.lineTo(size.width * 0.5645336, size.height * 0.5007383);
    shigaPath.lineTo(size.width * 0.5648537, size.height * 0.4992848);
    shigaPath.lineTo(size.width * 0.5629559, size.height * 0.4958741);
    shigaPath.lineTo(size.width * 0.5636647, size.height * 0.4945757);
    shigaPath.lineTo(size.width * 0.5651967, size.height * 0.4943237);
    shigaPath.lineTo(size.width * 0.5693354, size.height * 0.4961260);
    shigaPath.lineTo(size.width * 0.5693354, size.height * 0.4961260);
    shigaPath.lineTo(size.width * 0.5699300, size.height * 0.4981996);
    shigaPath.lineTo(size.width * 0.5714391, size.height * 0.4983352);
    shigaPath.lineTo(size.width * 0.5711647, size.height * 0.5014359);
    shigaPath.lineTo(size.width * 0.5729482, size.height * 0.5019979);
    shigaPath.lineTo(size.width * 0.5736571, size.height * 0.5010290);
    shigaPath.lineTo(size.width * 0.5749147, size.height * 0.5024049);
    shigaPath.lineTo(size.width * 0.5743659, size.height * 0.5041296);
    shigaPath.lineTo(size.width * 0.5758065, size.height * 0.5053699);
    shigaPath.lineTo(size.width * 0.5756007, size.height * 0.5073078);
    shigaPath.lineTo(size.width * 0.5768126, size.height * 0.5089551);
    shigaPath.lineTo(size.width * 0.5755549, size.height * 0.5098078);
    shigaPath.lineTo(size.width * 0.5754635, size.height * 0.5124046);
    shigaPath.lineTo(size.width * 0.5747318, size.height * 0.5134123);
    shigaPath.lineTo(size.width * 0.5746860, size.height * 0.5152146);
    shigaPath.lineTo(size.width * 0.5739543, size.height * 0.5156215);
    shigaPath.close();

    Paint shigaPaint = Paint()..style = PaintingStyle.fill;
    shigaPaint.color = japanColors.shiga ?? defaultColor;
    japanCanvas.drawPath(shigaPath, shigaPaint, onTapUp: (tabdetail) {
      callback('shiga', tabdetail);
    });

    Path shimanePath = Path();
    shimanePath.moveTo(size.width * 0.3904563, size.height * 0.5243228);
    shimanePath.lineTo(size.width * 0.3910965, size.height * 0.5227918);
    shimanePath.lineTo(size.width * 0.3939090, size.height * 0.5209896);
    shimanePath.lineTo(size.width * 0.3940919, size.height * 0.5196912);
    shimanePath.lineTo(size.width * 0.3952352, size.height * 0.5183928);
    shimanePath.lineTo(size.width * 0.4009745, size.height * 0.5149045);
    shimanePath.lineTo(size.width * 0.4042215, size.height * 0.5138580);
    shimanePath.lineTo(size.width * 0.4055020, size.height * 0.5128697);
    shimanePath.lineTo(size.width * 0.4064395, size.height * 0.5113581);
    shimanePath.lineTo(size.width * 0.4067367, size.height * 0.5082380);
    shimanePath.lineTo(size.width * 0.4045416, size.height * 0.5074822);
    shimanePath.lineTo(size.width * 0.4047703, size.height * 0.5067652);
    shimanePath.lineTo(size.width * 0.4073312, size.height * 0.5058738);
    shimanePath.lineTo(size.width * 0.4084745, size.height * 0.5064551);
    shimanePath.lineTo(size.width * 0.4104181, size.height * 0.5061257);
    shimanePath.lineTo(size.width * 0.4106696, size.height * 0.5057187);
    shimanePath.lineTo(size.width * 0.4092520, size.height * 0.5050405);
    shimanePath.lineTo(size.width * 0.4125446, size.height * 0.5044591);
    shimanePath.lineTo(size.width * 0.4130934, size.height * 0.5038389);
    shimanePath.lineTo(size.width * 0.4179638, size.height * 0.5028506);
    shimanePath.lineTo(size.width * 0.4202504, size.height * 0.5029281);
    shimanePath.lineTo(size.width * 0.4200904, size.height * 0.5016685);
    shimanePath.lineTo(size.width * 0.4227657, size.height * 0.5019010);
    shimanePath.lineTo(size.width * 0.4237032, size.height * 0.5000406);
    shimanePath.lineTo(size.width * 0.4258297, size.height * 0.4988003);
    shimanePath.lineTo(size.width * 0.4279105, size.height * 0.5008545);
    shimanePath.lineTo(size.width * 0.4303800, size.height * 0.5005251);
    shimanePath.lineTo(size.width * 0.4313175, size.height * 0.4998856);
    shimanePath.lineTo(size.width * 0.4362565, size.height * 0.5005057);
    shimanePath.lineTo(size.width * 0.4334897, size.height * 0.5010871);
    shimanePath.lineTo(size.width * 0.4325522, size.height * 0.5020754);
    shimanePath.lineTo(size.width * 0.4336726, size.height * 0.5039940);
    shimanePath.lineTo(size.width * 0.4362793, size.height * 0.5053118);
    shimanePath.lineTo(size.width * 0.4362793, size.height * 0.5053118);
    shimanePath.lineTo(size.width * 0.4359135, size.height * 0.5100403);
    shimanePath.lineTo(size.width * 0.4349531, size.height * 0.5112418);
    shimanePath.lineTo(size.width * 0.4355705, size.height * 0.5144006);
    shimanePath.lineTo(size.width * 0.4284821, size.height * 0.5170750);
    shimanePath.lineTo(size.width * 0.4285278, size.height * 0.5176370);
    shimanePath.lineTo(size.width * 0.4299227, size.height * 0.5178889);
    shimanePath.lineTo(size.width * 0.4304486, size.height * 0.5192261);
    shimanePath.lineTo(size.width * 0.4284135, size.height * 0.5205826);
    shimanePath.lineTo(size.width * 0.4280248, size.height * 0.5235670);
    shimanePath.lineTo(size.width * 0.4280248, size.height * 0.5235670);
    shimanePath.lineTo(size.width * 0.4266986, size.height * 0.5231407);
    shimanePath.lineTo(size.width * 0.4234516, size.height * 0.5239546);
    shimanePath.lineTo(size.width * 0.4212108, size.height * 0.5224236);
    shimanePath.lineTo(size.width * 0.4194044, size.height * 0.5236252);
    shimanePath.lineTo(size.width * 0.4167748, size.height * 0.5222686);
    shimanePath.lineTo(size.width * 0.4158602, size.height * 0.5224043);
    shimanePath.lineTo(size.width * 0.4103724, size.height * 0.5288576);
    shimanePath.lineTo(size.width * 0.4076514, size.height * 0.5293420);
    shimanePath.lineTo(size.width * 0.4057078, size.height * 0.5312800);
    shimanePath.lineTo(size.width * 0.4065767, size.height * 0.5321908);
    shimanePath.lineTo(size.width * 0.4081544, size.height * 0.5325977);
    shimanePath.lineTo(size.width * 0.4081773, size.height * 0.5342837);
    shimanePath.lineTo(size.width * 0.4041529, size.height * 0.5345551);
    shimanePath.lineTo(size.width * 0.4007916, size.height * 0.5366093);
    shimanePath.lineTo(size.width * 0.3970645, size.height * 0.5363573);
    shimanePath.lineTo(size.width * 0.3964928, size.height * 0.5355628);
    shimanePath.lineTo(size.width * 0.3955553, size.height * 0.5358341);
    shimanePath.lineTo(size.width * 0.3957154, size.height * 0.5363186);
    shimanePath.lineTo(size.width * 0.3945493, size.height * 0.5371519);
    shimanePath.lineTo(size.width * 0.3933602, size.height * 0.5363379);
    shimanePath.lineTo(size.width * 0.3905249, size.height * 0.5365899);
    shimanePath.lineTo(size.width * 0.3900447, size.height * 0.5374426);
    shimanePath.lineTo(size.width * 0.3891301, size.height * 0.5365124);
    shimanePath.lineTo(size.width * 0.3873237, size.height * 0.5362992);
    shimanePath.lineTo(size.width * 0.3866148, size.height * 0.5385084);
    shimanePath.lineTo(size.width * 0.3832993, size.height * 0.5401750);
    shimanePath.lineTo(size.width * 0.3826133, size.height * 0.5411052);
    shimanePath.lineTo(size.width * 0.3838709, size.height * 0.5417641);
    shimanePath.lineTo(size.width * 0.3822703, size.height * 0.5437602);
    shimanePath.lineTo(size.width * 0.3817901, size.height * 0.5472097);
    shimanePath.lineTo(size.width * 0.3803496, size.height * 0.5485275);
    shimanePath.lineTo(size.width * 0.3789776, size.height * 0.5488763);
    shimanePath.lineTo(size.width * 0.3782917, size.height * 0.5501166);
    shimanePath.lineTo(size.width * 0.3794121, size.height * 0.5513375);
    shimanePath.lineTo(size.width * 0.3794121, size.height * 0.5513375);
    shimanePath.lineTo(size.width * 0.3775600, size.height * 0.5522095);
    shimanePath.lineTo(size.width * 0.3764624, size.height * 0.5535855);
    shimanePath.lineTo(size.width * 0.3761194, size.height * 0.5541862);
    shimanePath.lineTo(size.width * 0.3771026, size.height * 0.5559110);
    shimanePath.lineTo(size.width * 0.3745417, size.height * 0.5589729);
    shimanePath.lineTo(size.width * 0.3729639, size.height * 0.5577520);
    shimanePath.lineTo(size.width * 0.3708146, size.height * 0.5591086);
    shimanePath.lineTo(size.width * 0.3684136, size.height * 0.5593024);
    shimanePath.lineTo(size.width * 0.3664243, size.height * 0.5576357);
    shimanePath.lineTo(size.width * 0.3660356, size.height * 0.5561435);
    shimanePath.lineTo(size.width * 0.3672932, size.height * 0.5531591);
    shimanePath.lineTo(size.width * 0.3630173, size.height * 0.5532366);
    shimanePath.lineTo(size.width * 0.3616225, size.height * 0.5500391);
    shimanePath.lineTo(size.width * 0.3631316, size.height * 0.5487988);
    shimanePath.lineTo(size.width * 0.3631774, size.height * 0.5472097);
    shimanePath.lineTo(size.width * 0.3641606, size.height * 0.5468996);
    shimanePath.lineTo(size.width * 0.3622627, size.height * 0.5419773);
    shimanePath.lineTo(size.width * 0.3622627, size.height * 0.5419773);
    shimanePath.lineTo(size.width * 0.3648923, size.height * 0.5420354);
    shimanePath.lineTo(size.width * 0.3683450, size.height * 0.5411634);
    shimanePath.lineTo(size.width * 0.3713862, size.height * 0.5382177);
    shimanePath.lineTo(size.width * 0.3739700, size.height * 0.5366286);
    shimanePath.lineTo(size.width * 0.3744959, size.height * 0.5353496);
    shimanePath.lineTo(size.width * 0.3759365, size.height * 0.5349620);
    shimanePath.lineTo(size.width * 0.3785889, size.height * 0.5325590);
    shimanePath.lineTo(size.width * 0.3803039, size.height * 0.5301560);
    shimanePath.lineTo(size.width * 0.3868435, size.height * 0.5255437);
    shimanePath.lineTo(size.width * 0.3904563, size.height * 0.5243228);
    shimanePath.close();
    shimanePath.moveTo(size.width * 0.4318434, size.height * 0.4713593);
    shimanePath.lineTo(size.width * 0.4309516, size.height * 0.4703904);
    shimanePath.lineTo(size.width * 0.4298541, size.height * 0.4702547);
    shimanePath.lineTo(size.width * 0.4302428, size.height * 0.4686850);
    shimanePath.lineTo(size.width * 0.4295568, size.height * 0.4683555);
    shimanePath.lineTo(size.width * 0.4297397, size.height * 0.4666695);
    shimanePath.lineTo(size.width * 0.4317290, size.height * 0.4647510);
    shimanePath.lineTo(size.width * 0.4341986, size.height * 0.4641502);
    shimanePath.lineTo(size.width * 0.4360050, size.height * 0.4647898);
    shimanePath.lineTo(size.width * 0.4389546, size.height * 0.4676191);
    shimanePath.lineTo(size.width * 0.4382687, size.height * 0.4705260);
    shimanePath.lineTo(size.width * 0.4372397, size.height * 0.4708942);
    shimanePath.lineTo(size.width * 0.4370110, size.height * 0.4698090);
    shimanePath.lineTo(size.width * 0.4366909, size.height * 0.4706810);
    shimanePath.lineTo(size.width * 0.4353647, size.height * 0.4708555);
    shimanePath.lineTo(size.width * 0.4367367, size.height * 0.4711268);
    shimanePath.lineTo(size.width * 0.4369882, size.height * 0.4722120);
    shimanePath.lineTo(size.width * 0.4363937, size.height * 0.4723477);
    shimanePath.lineTo(size.width * 0.4323007, size.height * 0.4724446);
    shimanePath.lineTo(size.width * 0.4326208, size.height * 0.4716113);
    shimanePath.lineTo(size.width * 0.4318434, size.height * 0.4713593);
    shimanePath.close();
    shimanePath.moveTo(size.width * 0.3266150, size.height * 0.4070396);
    shimanePath.lineTo(size.width * 0.3273467, size.height * 0.4066714);
    shimanePath.lineTo(size.width * 0.3278268, size.height * 0.4070977);
    shimanePath.lineTo(size.width * 0.3273238, size.height * 0.4077179);
    shimanePath.lineTo(size.width * 0.3275525, size.height * 0.4095977);
    shimanePath.lineTo(size.width * 0.3258147, size.height * 0.4113030);
    shimanePath.lineTo(size.width * 0.3228650, size.height * 0.4102565);
    shimanePath.lineTo(size.width * 0.3220875, size.height * 0.4083961);
    shimanePath.lineTo(size.width * 0.3234823, size.height * 0.4076016);
    shimanePath.lineTo(size.width * 0.3266150, size.height * 0.4070396);
    shimanePath.close();
    shimanePath.moveTo(size.width * 0.4250751, size.height * 0.4735298);
    shimanePath.lineTo(size.width * 0.4256925, size.height * 0.4737042);
    shimanePath.lineTo(size.width * 0.4254867, size.height * 0.4743437);
    shimanePath.lineTo(size.width * 0.4233602, size.height * 0.4752352);
    shimanePath.lineTo(size.width * 0.4241147, size.height * 0.4762041);
    shimanePath.lineTo(size.width * 0.4236117, size.height * 0.4774250);
    shimanePath.lineTo(size.width * 0.4226056, size.height * 0.4773088);
    shimanePath.lineTo(size.width * 0.4217596, size.height * 0.4759328);
    shimanePath.lineTo(size.width * 0.4209593, size.height * 0.4758747);
    shimanePath.lineTo(size.width * 0.4205248, size.height * 0.4763204);
    shimanePath.lineTo(size.width * 0.4215080, size.height * 0.4784909);
    shimanePath.lineTo(size.width * 0.4191529, size.height * 0.4772506);
    shimanePath.lineTo(size.width * 0.4205934, size.height * 0.4748476);
    shimanePath.lineTo(size.width * 0.4222169, size.height * 0.4747507);
    shimanePath.lineTo(size.width * 0.4221711, size.height * 0.4738592);
    shimanePath.lineTo(size.width * 0.4237260, size.height * 0.4741887);
    shimanePath.lineTo(size.width * 0.4250751, size.height * 0.4735298);
    shimanePath.close();
    shimanePath.moveTo(size.width * 0.4276818, size.height * 0.4762041);
    shimanePath.lineTo(size.width * 0.4246635, size.height * 0.4786459);
    shimanePath.lineTo(size.width * 0.4251666, size.height * 0.4770374);
    shimanePath.lineTo(size.width * 0.4244577, size.height * 0.4754871);
    shimanePath.lineTo(size.width * 0.4250522, size.height * 0.4751383);
    shimanePath.lineTo(size.width * 0.4256467, size.height * 0.4757197);
    shimanePath.lineTo(size.width * 0.4258068, size.height * 0.4747507);
    shimanePath.lineTo(size.width * 0.4266528, size.height * 0.4745957);
    shimanePath.lineTo(size.width * 0.4275446, size.height * 0.4750220);
    shimanePath.lineTo(size.width * 0.4276818, size.height * 0.4762041);
    shimanePath.close();
    shimanePath.moveTo(size.width * 0.4217596, size.height * 0.4787041);
    shimanePath.lineTo(size.width * 0.4248464, size.height * 0.4797312);
    shimanePath.lineTo(size.width * 0.4245263, size.height * 0.4804094);
    shimanePath.lineTo(size.width * 0.4218282, size.height * 0.4800994);
    shimanePath.lineTo(size.width * 0.4217596, size.height * 0.4787041);
    shimanePath.close();

    Paint shimanePaint = Paint()..style = PaintingStyle.fill;
    shimanePaint.color = japanColors.shimane ?? defaultColor;
    japanCanvas.drawPath(shimanePath, shimanePaint, onTapUp: (tabdetail) {
      callback('shimane', tabdetail);
    });

    Path saitamaPath = Path();
    saitamaPath.moveTo(size.width * 0.6798459, size.height * 0.4846535);
    saitamaPath.lineTo(size.width * 0.6803032, size.height * 0.4836458);
    saitamaPath.lineTo(size.width * 0.6791142, size.height * 0.4816109);
    saitamaPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    saitamaPath.lineTo(size.width * 0.6793428, size.height * 0.4807195);
    saitamaPath.lineTo(size.width * 0.6810578, size.height * 0.4787622);
    saitamaPath.lineTo(size.width * 0.6838702, size.height * 0.4787234);
    saitamaPath.lineTo(size.width * 0.6859739, size.height * 0.4767661);
    saitamaPath.lineTo(size.width * 0.6894495, size.height * 0.4759910);
    saitamaPath.lineTo(size.width * 0.6905013, size.height * 0.4744794);
    saitamaPath.lineTo(size.width * 0.6939998, size.height * 0.4743437);
    saitamaPath.lineTo(size.width * 0.6949602, size.height * 0.4728709);
    saitamaPath.lineTo(size.width * 0.6950059, size.height * 0.4710686);
    saitamaPath.lineTo(size.width * 0.6978184, size.height * 0.4672509);
    saitamaPath.lineTo(size.width * 0.6994190, size.height * 0.4673478);
    saitamaPath.lineTo(size.width * 0.7032833, size.height * 0.4690144);
    saitamaPath.lineTo(size.width * 0.7046553, size.height * 0.4687237);
    saitamaPath.lineTo(size.width * 0.7068732, size.height * 0.4692857);
    saitamaPath.lineTo(size.width * 0.7088397, size.height * 0.4688788);
    saitamaPath.lineTo(size.width * 0.7129784, size.height * 0.4714756);
    saitamaPath.lineTo(size.width * 0.7187863, size.height * 0.4705454);
    saitamaPath.lineTo(size.width * 0.7199753, size.height * 0.4714756);
    saitamaPath.lineTo(size.width * 0.7210958, size.height * 0.4711268);
    saitamaPath.lineTo(size.width * 0.7218046, size.height * 0.4700028);
    saitamaPath.lineTo(size.width * 0.7218046, size.height * 0.4700028);
    saitamaPath.lineTo(size.width * 0.7237253, size.height * 0.4707973);
    saitamaPath.lineTo(size.width * 0.7237253, size.height * 0.4707973);
    saitamaPath.lineTo(size.width * 0.7233366, size.height * 0.4725221);
    saitamaPath.lineTo(size.width * 0.7253031, size.height * 0.4763204);
    saitamaPath.lineTo(size.width * 0.7261948, size.height * 0.4765142);
    saitamaPath.lineTo(size.width * 0.7270866, size.height * 0.4758359);
    saitamaPath.lineTo(size.width * 0.7270866, size.height * 0.4758359);
    saitamaPath.lineTo(size.width * 0.7287101, size.height * 0.4785490);
    saitamaPath.lineTo(size.width * 0.7288473, size.height * 0.4805645);
    saitamaPath.lineTo(size.width * 0.7326659, size.height * 0.4868046);
    saitamaPath.lineTo(size.width * 0.7321628, size.height * 0.4893820);
    saitamaPath.lineTo(size.width * 0.7313625, size.height * 0.4899053);
    saitamaPath.lineTo(size.width * 0.7313625, size.height * 0.4899053);
    saitamaPath.lineTo(size.width * 0.7292589, size.height * 0.4900409);
    saitamaPath.lineTo(size.width * 0.7288701, size.height * 0.4892270);
    saitamaPath.lineTo(size.width * 0.7276811, size.height * 0.4894983);
    saitamaPath.lineTo(size.width * 0.7266522, size.height * 0.4889557);
    saitamaPath.lineTo(size.width * 0.7257147, size.height * 0.4903897);
    saitamaPath.lineTo(size.width * 0.7216446, size.height * 0.4897890);
    saitamaPath.lineTo(size.width * 0.7201125, size.height * 0.4913393);
    saitamaPath.lineTo(size.width * 0.7188549, size.height * 0.4907773);
    saitamaPath.lineTo(size.width * 0.7167741, size.height * 0.4914944);
    saitamaPath.lineTo(size.width * 0.7161339, size.height * 0.4898084);
    saitamaPath.lineTo(size.width * 0.7124982, size.height * 0.4912618);
    saitamaPath.lineTo(size.width * 0.7096400, size.height * 0.4913199);
    saitamaPath.lineTo(size.width * 0.7084281, size.height * 0.4901572);
    saitamaPath.lineTo(size.width * 0.7066446, size.height * 0.4898665);
    saitamaPath.lineTo(size.width * 0.7057071, size.height * 0.4881805);
    saitamaPath.lineTo(size.width * 0.7009053, size.height * 0.4878898);
    saitamaPath.lineTo(size.width * 0.6985501, size.height * 0.4868046);
    saitamaPath.lineTo(size.width * 0.6947544, size.height * 0.4862620);
    saitamaPath.lineTo(size.width * 0.6931538, size.height * 0.4852155);
    saitamaPath.lineTo(size.width * 0.6899754, size.height * 0.4863395);
    saitamaPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    saitamaPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    saitamaPath.lineTo(size.width * 0.6870715, size.height * 0.4877542);
    saitamaPath.lineTo(size.width * 0.6854937, size.height * 0.4867271);
    saitamaPath.lineTo(size.width * 0.6828413, size.height * 0.4863395);
    saitamaPath.lineTo(size.width * 0.6821782, size.height * 0.4850992);
    saitamaPath.close();

    Paint saitamaPaint = Paint()..style = PaintingStyle.fill;
    saitamaPaint.color = japanColors.saitama ?? defaultColor;
    japanCanvas.drawPath(saitamaPath, saitamaPaint, onTapUp: (tabdetail) {
      callback('saitama', tabdetail);
    });

    Path shizuokaPath = Path();
    shizuokaPath.moveTo(size.width * 0.6970638, size.height * 0.5329272);
    shizuokaPath.lineTo(size.width * 0.6946172, size.height * 0.5368999);
    shizuokaPath.lineTo(size.width * 0.6918047, size.height * 0.5388766);
    shizuokaPath.lineTo(size.width * 0.6907071, size.height * 0.5413184);
    shizuokaPath.lineTo(size.width * 0.6913702, size.height * 0.5427912);
    shizuokaPath.lineTo(size.width * 0.6903413, size.height * 0.5431207);
    shizuokaPath.lineTo(size.width * 0.6892437, size.height * 0.5426362);
    shizuokaPath.lineTo(size.width * 0.6883062, size.height * 0.5430044);
    shizuokaPath.lineTo(size.width * 0.6878489, size.height * 0.5440121);
    shizuokaPath.lineTo(size.width * 0.6849678, size.height * 0.5454462);
    shizuokaPath.lineTo(size.width * 0.6840989, size.height * 0.5451749);
    shizuokaPath.lineTo(size.width * 0.6816294, size.height * 0.5431982);
    shizuokaPath.lineTo(size.width * 0.6821553, size.height * 0.5426362);
    shizuokaPath.lineTo(size.width * 0.6818352, size.height * 0.5419192);
    shizuokaPath.lineTo(size.width * 0.6801660, size.height * 0.5412797);
    shizuokaPath.lineTo(size.width * 0.6801889, size.height * 0.5397099);
    shizuokaPath.lineTo(size.width * 0.6818809, size.height * 0.5382952);
    shizuokaPath.lineTo(size.width * 0.6807834, size.height * 0.5362023);
    shizuokaPath.lineTo(size.width * 0.6814007, size.height * 0.5358147);
    shizuokaPath.lineTo(size.width * 0.6809434, size.height * 0.5323458);
    shizuokaPath.lineTo(size.width * 0.6824754, size.height * 0.5311637);
    shizuokaPath.lineTo(size.width * 0.6812407, size.height * 0.5281987);
    shizuokaPath.lineTo(size.width * 0.6823611, size.height * 0.5258150);
    shizuokaPath.lineTo(size.width * 0.6870486, size.height * 0.5261251);
    shizuokaPath.lineTo(size.width * 0.6876660, size.height * 0.5247492);
    shizuokaPath.lineTo(size.width * 0.6835959, size.height * 0.5216679);
    shizuokaPath.lineTo(size.width * 0.6782910, size.height * 0.5206795);
    shizuokaPath.lineTo(size.width * 0.6720258, size.height * 0.5222686);
    shizuokaPath.lineTo(size.width * 0.6699678, size.height * 0.5253111);
    shizuokaPath.lineTo(size.width * 0.6708825, size.height * 0.5262801);
    shizuokaPath.lineTo(size.width * 0.6703794, size.height * 0.5274429);
    shizuokaPath.lineTo(size.width * 0.6633596, size.height * 0.5306598);
    shizuokaPath.lineTo(size.width * 0.6615304, size.height * 0.5332566);
    shizuokaPath.lineTo(size.width * 0.6619419, size.height * 0.5351946);
    shizuokaPath.lineTo(size.width * 0.6603642, size.height * 0.5375782);
    shizuokaPath.lineTo(size.width * 0.6568886, size.height * 0.5398068);
    shizuokaPath.lineTo(size.width * 0.6556538, size.height * 0.5424618);
    shizuokaPath.lineTo(size.width * 0.6556767, size.height * 0.5438571);
    shizuokaPath.lineTo(size.width * 0.6573916, size.height * 0.5452330);
    shizuokaPath.lineTo(size.width * 0.6571859, size.height * 0.5456594);
    shizuokaPath.lineTo(size.width * 0.6469648, size.height * 0.5425974);
    shizuokaPath.lineTo(size.width * 0.6422545, size.height * 0.5424618);
    shizuokaPath.lineTo(size.width * 0.6380472, size.height * 0.5433339);
    shizuokaPath.lineTo(size.width * 0.6319649, size.height * 0.5421517);
    shizuokaPath.lineTo(size.width * 0.6238247, size.height * 0.5420161);
    shizuokaPath.lineTo(size.width * 0.6238247, size.height * 0.5420161);
    shizuokaPath.lineTo(size.width * 0.6234588, size.height * 0.5375201);
    shizuokaPath.lineTo(size.width * 0.6244420, size.height * 0.5351364);
    shizuokaPath.lineTo(size.width * 0.6307301, size.height * 0.5321520);
    shizuokaPath.lineTo(size.width * 0.6336569, size.height * 0.5284312);
    shizuokaPath.lineTo(size.width * 0.6337255, size.height * 0.5263770);
    shizuokaPath.lineTo(size.width * 0.6370640, size.height * 0.5225012);
    shizuokaPath.lineTo(size.width * 0.6381386, size.height * 0.5220361);
    shizuokaPath.lineTo(size.width * 0.6379557, size.height * 0.5211252);
    shizuokaPath.lineTo(size.width * 0.6392591, size.height * 0.5200012);
    shizuokaPath.lineTo(size.width * 0.6380929, size.height * 0.5190323);
    shizuokaPath.lineTo(size.width * 0.6388018, size.height * 0.5171331);
    shizuokaPath.lineTo(size.width * 0.6388018, size.height * 0.5171331);
    shizuokaPath.lineTo(size.width * 0.6412484, size.height * 0.5169199);
    shizuokaPath.lineTo(size.width * 0.6423002, size.height * 0.5151177);
    shizuokaPath.lineTo(size.width * 0.6434664, size.height * 0.5150983);
    shizuokaPath.lineTo(size.width * 0.6439466, size.height * 0.5142650);
    shizuokaPath.lineTo(size.width * 0.6468734, size.height * 0.5130247);
    shizuokaPath.lineTo(size.width * 0.6496401, size.height * 0.5110674);
    shizuokaPath.lineTo(size.width * 0.6534130, size.height * 0.5098465);
    shizuokaPath.lineTo(size.width * 0.6537331, size.height * 0.5084512);
    shizuokaPath.lineTo(size.width * 0.6525212, size.height * 0.5071528);
    shizuokaPath.lineTo(size.width * 0.6525212, size.height * 0.5058544);
    shizuokaPath.lineTo(size.width * 0.6542133, size.height * 0.5053505);
    shizuokaPath.lineTo(size.width * 0.6532529, size.height * 0.5028118);
    shizuokaPath.lineTo(size.width * 0.6541904, size.height * 0.5017266);
    shizuokaPath.lineTo(size.width * 0.6534359, size.height * 0.5012227);
    shizuokaPath.lineTo(size.width * 0.6547164, size.height * 0.4999631);
    shizuokaPath.lineTo(size.width * 0.6555395, size.height * 0.5002344);
    shizuokaPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    shizuokaPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    shizuokaPath.lineTo(size.width * 0.6590151, size.height * 0.5032188);
    shizuokaPath.lineTo(size.width * 0.6581462, size.height * 0.5055056);
    shizuokaPath.lineTo(size.width * 0.6586721, size.height * 0.5075791);
    shizuokaPath.lineTo(size.width * 0.6576203, size.height * 0.5093814);
    shizuokaPath.lineTo(size.width * 0.6583749, size.height * 0.5119007);
    shizuokaPath.lineTo(size.width * 0.6599298, size.height * 0.5128891);
    shizuokaPath.lineTo(size.width * 0.6616676, size.height * 0.5118813);
    shizuokaPath.lineTo(size.width * 0.6634054, size.height * 0.5125790);
    shizuokaPath.lineTo(size.width * 0.6649831, size.height * 0.5177920);
    shizuokaPath.lineTo(size.width * 0.6665608, size.height * 0.5187610);
    shizuokaPath.lineTo(size.width * 0.6693962, size.height * 0.5189935);
    shizuokaPath.lineTo(size.width * 0.6710425, size.height * 0.5177726);
    shizuokaPath.lineTo(size.width * 0.6701279, size.height * 0.5126177);
    shizuokaPath.lineTo(size.width * 0.6711111, size.height * 0.5114356);
    shizuokaPath.lineTo(size.width * 0.6709968, size.height * 0.5081218);
    shizuokaPath.lineTo(size.width * 0.6732605, size.height * 0.5063582);
    shizuokaPath.lineTo(size.width * 0.6745639, size.height * 0.5088000);
    shizuokaPath.lineTo(size.width * 0.6769190, size.height * 0.5085675);
    shizuokaPath.lineTo(size.width * 0.6779480, size.height * 0.5104473);
    shizuokaPath.lineTo(size.width * 0.6843504, size.height * 0.5095364);
    shizuokaPath.lineTo(size.width * 0.6851965, size.height * 0.5090132);
    shizuokaPath.lineTo(size.width * 0.6867971, size.height * 0.5091489);
    shizuokaPath.lineTo(size.width * 0.6883291, size.height * 0.5083931);
    shizuokaPath.lineTo(size.width * 0.6883291, size.height * 0.5083931);
    shizuokaPath.lineTo(size.width * 0.6917818, size.height * 0.5083349);
    shizuokaPath.lineTo(size.width * 0.6921248, size.height * 0.5088000);
    shizuokaPath.lineTo(size.width * 0.6929251, size.height * 0.5117457);
    shizuokaPath.lineTo(size.width * 0.6922849, size.height * 0.5136255);
    shizuokaPath.lineTo(size.width * 0.6909815, size.height * 0.5148270);
    shizuokaPath.lineTo(size.width * 0.6915303, size.height * 0.5177726);
    shizuokaPath.lineTo(size.width * 0.6931309, size.height * 0.5188191);
    shizuokaPath.lineTo(size.width * 0.6934282, size.height * 0.5201369);
    shizuokaPath.lineTo(size.width * 0.6969038, size.height * 0.5205439);
    shizuokaPath.lineTo(size.width * 0.6969038, size.height * 0.5205439);
    shizuokaPath.lineTo(size.width * 0.6953717, size.height * 0.5224236);
    shizuokaPath.lineTo(size.width * 0.6950516, size.height * 0.5243809);
    shizuokaPath.lineTo(size.width * 0.6964922, size.height * 0.5248654);
    shizuokaPath.lineTo(size.width * 0.6961949, size.height * 0.5274429);
    shizuokaPath.lineTo(size.width * 0.6985501, size.height * 0.5290513);
    shizuokaPath.lineTo(size.width * 0.6982986, size.height * 0.5320164);
    shizuokaPath.close();

    Paint shizuokaPaint = Paint()..style = PaintingStyle.fill;
    shizuokaPaint.color = japanColors.shizuoka ?? defaultColor;
    japanCanvas.drawPath(shizuokaPath, shizuokaPaint, onTapUp: (tabdetail) {
      callback('shizuoka', tabdetail);
    });

    Path tochigiPath = Path();
    tochigiPath.moveTo(size.width * 0.7487634, size.height * 0.4360891);
    tochigiPath.lineTo(size.width * 0.7485576, size.height * 0.4399456);
    tochigiPath.lineTo(size.width * 0.7491750, size.height * 0.4418641);
    tochigiPath.lineTo(size.width * 0.7486719, size.height * 0.4443834);
    tochigiPath.lineTo(size.width * 0.7500896, size.height * 0.4463213);
    tochigiPath.lineTo(size.width * 0.7498838, size.height * 0.4469415);
    tochigiPath.lineTo(size.width * 0.7477116, size.height * 0.4473484);
    tochigiPath.lineTo(size.width * 0.7470713, size.height * 0.4480848);
    tochigiPath.lineTo(size.width * 0.7483747, size.height * 0.4518638);
    tochigiPath.lineTo(size.width * 0.7484204, size.height * 0.4553714);
    tochigiPath.lineTo(size.width * 0.7463168, size.height * 0.4589760);
    tochigiPath.lineTo(size.width * 0.7458366, size.height * 0.4612434);
    tochigiPath.lineTo(size.width * 0.7443046, size.height * 0.4616309);
    tochigiPath.lineTo(size.width * 0.7436643, size.height * 0.4608751);
    tochigiPath.lineTo(size.width * 0.7426354, size.height * 0.4609139);
    tochigiPath.lineTo(size.width * 0.7416979, size.height * 0.4618247);
    tochigiPath.lineTo(size.width * 0.7401430, size.height * 0.4613596);
    tochigiPath.lineTo(size.width * 0.7400287, size.height * 0.4623673);
    tochigiPath.lineTo(size.width * 0.7394341, size.height * 0.4626193);
    tochigiPath.lineTo(size.width * 0.7358671, size.height * 0.4627743);
    tochigiPath.lineTo(size.width * 0.7355698, size.height * 0.4636464);
    tochigiPath.lineTo(size.width * 0.7332832, size.height * 0.4645572);
    tochigiPath.lineTo(size.width * 0.7330089, size.height * 0.4662626);
    tochigiPath.lineTo(size.width * 0.7304250, size.height * 0.4657200);
    tochigiPath.lineTo(size.width * 0.7291445, size.height * 0.4689951);
    tochigiPath.lineTo(size.width * 0.7253945, size.height * 0.4706810);
    tochigiPath.lineTo(size.width * 0.7237253, size.height * 0.4707973);
    tochigiPath.lineTo(size.width * 0.7237253, size.height * 0.4707973);
    tochigiPath.lineTo(size.width * 0.7218046, size.height * 0.4700028);
    tochigiPath.lineTo(size.width * 0.7218046, size.height * 0.4700028);
    tochigiPath.lineTo(size.width * 0.7206385, size.height * 0.4684718);
    tochigiPath.lineTo(size.width * 0.7208443, size.height * 0.4679292);
    tochigiPath.lineTo(size.width * 0.7199753, size.height * 0.4674641);
    tochigiPath.lineTo(size.width * 0.7174372, size.height * 0.4678129);
    tochigiPath.lineTo(size.width * 0.7158138, size.height * 0.4669796);
    tochigiPath.lineTo(size.width * 0.7135043, size.height * 0.4675416);
    tochigiPath.lineTo(size.width * 0.7109662, size.height * 0.4656618);
    tochigiPath.lineTo(size.width * 0.7110577, size.height * 0.4645378);
    tochigiPath.lineTo(size.width * 0.7086568, size.height * 0.4630262);
    tochigiPath.lineTo(size.width * 0.7090684, size.height * 0.4611658);
    tochigiPath.lineTo(size.width * 0.7117894, size.height * 0.4581621);
    tochigiPath.lineTo(size.width * 0.7110348, size.height * 0.4566892);
    tochigiPath.lineTo(size.width * 0.7119495, size.height * 0.4543637);
    tochigiPath.lineTo(size.width * 0.7138244, size.height * 0.4531041);
    tochigiPath.lineTo(size.width * 0.7130470, size.height * 0.4517863);
    tochigiPath.lineTo(size.width * 0.7102345, size.height * 0.4519219);
    tochigiPath.lineTo(size.width * 0.7068732, size.height * 0.4504879);
    tochigiPath.lineTo(size.width * 0.7072848, size.height * 0.4478329);
    tochigiPath.lineTo(size.width * 0.7086339, size.height * 0.4461082);
    tochigiPath.lineTo(size.width * 0.7079937, size.height * 0.4438408);
    tochigiPath.lineTo(size.width * 0.7103260, size.height * 0.4411083);
    tochigiPath.lineTo(size.width * 0.7079937, size.height * 0.4402556);
    tochigiPath.lineTo(size.width * 0.7093199, size.height * 0.4372712);
    tochigiPath.lineTo(size.width * 0.7093199, size.height * 0.4372712);
    tochigiPath.lineTo(size.width * 0.7114693, size.height * 0.4364379);
    tochigiPath.lineTo(size.width * 0.7130927, size.height * 0.4344612);
    tochigiPath.lineTo(size.width * 0.7161796, size.height * 0.4339961);
    tochigiPath.lineTo(size.width * 0.7182833, size.height * 0.4325427);
    tochigiPath.lineTo(size.width * 0.7197238, size.height * 0.4323683);
    tochigiPath.lineTo(size.width * 0.7202497, size.height * 0.4315350);
    tochigiPath.lineTo(size.width * 0.7220561, size.height * 0.4311474);
    tochigiPath.lineTo(size.width * 0.7226506, size.height * 0.4303528);
    tochigiPath.lineTo(size.width * 0.7290531, size.height * 0.4286668);
    tochigiPath.lineTo(size.width * 0.7294647, size.height * 0.4269033);
    tochigiPath.lineTo(size.width * 0.7325744, size.height * 0.4257599);
    tochigiPath.lineTo(size.width * 0.7381079, size.height * 0.4263026);
    tochigiPath.lineTo(size.width * 0.7435729, size.height * 0.4282405);
    tochigiPath.lineTo(size.width * 0.7459052, size.height * 0.4301397);
    tochigiPath.lineTo(size.width * 0.7464311, size.height * 0.4319419);
    tochigiPath.lineTo(size.width * 0.7483747, size.height * 0.4318450);
    tochigiPath.lineTo(size.width * 0.7480088, size.height * 0.4354496);
    tochigiPath.close();

    Paint tochigiPaint = Paint()..style = PaintingStyle.fill;
    tochigiPaint.color = japanColors.tochigi ?? defaultColor;
    japanCanvas.drawPath(tochigiPath, tochigiPaint, onTapUp: (tabdetail) {
      callback('tochigi', tabdetail);
    });

    Path tokyoPath = Path();
    tokyoPath.moveTo(size.width * 0.7096629, size.height * 0.5414734);
    tokyoPath.lineTo(size.width * 0.7081080, size.height * 0.5407177);
    tokyoPath.lineTo(size.width * 0.7077879, size.height * 0.5399231);
    tokyoPath.lineTo(size.width * 0.7076507, size.height * 0.5372294);
    tokyoPath.lineTo(size.width * 0.7081766, size.height * 0.5362604);
    tokyoPath.lineTo(size.width * 0.7109662, size.height * 0.5370937);
    tokyoPath.lineTo(size.width * 0.7121552, size.height * 0.5388766);
    tokyoPath.lineTo(size.width * 0.7117894, size.height * 0.5417835);
    tokyoPath.lineTo(size.width * 0.7096629, size.height * 0.5414734);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7048382, size.height * 0.5533917);
    tokyoPath.lineTo(size.width * 0.7040836, size.height * 0.5578295);
    tokyoPath.lineTo(size.width * 0.7029632, size.height * 0.5570544);
    tokyoPath.lineTo(size.width * 0.7028260, size.height * 0.5560466);
    tokyoPath.lineTo(size.width * 0.7048382, size.height * 0.5533917);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7015912, size.height * 0.5576357);
    tokyoPath.lineTo(size.width * 0.7021629, size.height * 0.5581590);
    tokyoPath.lineTo(size.width * 0.7007681, size.height * 0.5585466);
    tokyoPath.lineTo(size.width * 0.7015912, size.height * 0.5576357);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7297619, size.height * 0.4974050);
    tokyoPath.lineTo(size.width * 0.7278869, size.height * 0.4972888);
    tokyoPath.lineTo(size.width * 0.7274296, size.height * 0.4954865);
    tokyoPath.lineTo(size.width * 0.7262863, size.height * 0.4963392);
    tokyoPath.lineTo(size.width * 0.7256003, size.height * 0.4993623);
    tokyoPath.lineTo(size.width * 0.7263320, size.height * 0.5008158);
    tokyoPath.lineTo(size.width * 0.7269037, size.height * 0.5005251);
    tokyoPath.lineTo(size.width * 0.7279098, size.height * 0.5019010);
    tokyoPath.lineTo(size.width * 0.7259205, size.height * 0.5015134);
    tokyoPath.lineTo(size.width * 0.7237939, size.height * 0.5020754);
    tokyoPath.lineTo(size.width * 0.7237939, size.height * 0.5020754);
    tokyoPath.lineTo(size.width * 0.7237711, size.height * 0.5013390);
    tokyoPath.lineTo(size.width * 0.7226735, size.height * 0.5008933);
    tokyoPath.lineTo(size.width * 0.7219189, size.height * 0.4995949);
    tokyoPath.lineTo(size.width * 0.7157909, size.height * 0.4971337);
    tokyoPath.lineTo(size.width * 0.7140531, size.height * 0.4988972);
    tokyoPath.lineTo(size.width * 0.7129327, size.height * 0.4979864);
    tokyoPath.lineTo(size.width * 0.7124296, size.height * 0.4984321);
    tokyoPath.lineTo(size.width * 0.7142360, size.height * 0.4996336);
    tokyoPath.lineTo(size.width * 0.7138016, size.height * 0.5035483);
    tokyoPath.lineTo(size.width * 0.7131156, size.height * 0.5036064);
    tokyoPath.lineTo(size.width * 0.7100287, size.height * 0.4999437);
    tokyoPath.lineTo(size.width * 0.7051126, size.height * 0.4985872);
    tokyoPath.lineTo(size.width * 0.7031461, size.height * 0.4988972);
    tokyoPath.lineTo(size.width * 0.7017970, size.height * 0.4969787);
    tokyoPath.lineTo(size.width * 0.7004022, size.height * 0.4970368);
    tokyoPath.lineTo(size.width * 0.6993504, size.height * 0.4959710);
    tokyoPath.lineTo(size.width * 0.6979784, size.height * 0.4957190);
    tokyoPath.lineTo(size.width * 0.6979784, size.height * 0.4957190);
    tokyoPath.lineTo(size.width * 0.6931766, size.height * 0.4934710);
    tokyoPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    tokyoPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    tokyoPath.lineTo(size.width * 0.6899983, size.height * 0.4863395);
    tokyoPath.lineTo(size.width * 0.6931538, size.height * 0.4852155);
    tokyoPath.lineTo(size.width * 0.6947772, size.height * 0.4862620);
    tokyoPath.lineTo(size.width * 0.6985730, size.height * 0.4868240);
    tokyoPath.lineTo(size.width * 0.7009281, size.height * 0.4879092);
    tokyoPath.lineTo(size.width * 0.7057300, size.height * 0.4881999);
    tokyoPath.lineTo(size.width * 0.7066675, size.height * 0.4898859);
    tokyoPath.lineTo(size.width * 0.7084510, size.height * 0.4901960);
    tokyoPath.lineTo(size.width * 0.7096629, size.height * 0.4913587);
    tokyoPath.lineTo(size.width * 0.7125211, size.height * 0.4912812);
    tokyoPath.lineTo(size.width * 0.7161568, size.height * 0.4898277);
    tokyoPath.lineTo(size.width * 0.7167970, size.height * 0.4915137);
    tokyoPath.lineTo(size.width * 0.7189007, size.height * 0.4907967);
    tokyoPath.lineTo(size.width * 0.7201583, size.height * 0.4913587);
    tokyoPath.lineTo(size.width * 0.7216903, size.height * 0.4898084);
    tokyoPath.lineTo(size.width * 0.7257604, size.height * 0.4904285);
    tokyoPath.lineTo(size.width * 0.7266979, size.height * 0.4889751);
    tokyoPath.lineTo(size.width * 0.7277269, size.height * 0.4895177);
    tokyoPath.lineTo(size.width * 0.7289159, size.height * 0.4892464);
    tokyoPath.lineTo(size.width * 0.7293046, size.height * 0.4900603);
    tokyoPath.lineTo(size.width * 0.7314311, size.height * 0.4899246);
    tokyoPath.lineTo(size.width * 0.7314311, size.height * 0.4899246);
    tokyoPath.lineTo(size.width * 0.7339006, size.height * 0.4943044);
    tokyoPath.lineTo(size.width * 0.7339006, size.height * 0.4943044);
    tokyoPath.lineTo(size.width * 0.7347009, size.height * 0.4957772);
    tokyoPath.lineTo(size.width * 0.7334204, size.height * 0.4963973);
    tokyoPath.lineTo(size.width * 0.7343351, size.height * 0.4971337);
    tokyoPath.lineTo(size.width * 0.7324372, size.height * 0.4982383);
    tokyoPath.lineTo(size.width * 0.7297619, size.height * 0.4974050);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7169113, size.height * 0.5703098);
    tokyoPath.lineTo(size.width * 0.7175287, size.height * 0.5694183);
    tokyoPath.lineTo(size.width * 0.7174601, size.height * 0.5683912);
    tokyoPath.lineTo(size.width * 0.7162711, size.height * 0.5673641);
    tokyoPath.lineTo(size.width * 0.7141446, size.height * 0.5675773);
    tokyoPath.lineTo(size.width * 0.7132299, size.height * 0.5695152);
    tokyoPath.lineTo(size.width * 0.7136415, size.height * 0.5707361);
    tokyoPath.lineTo(size.width * 0.7152193, size.height * 0.5709105);
    tokyoPath.lineTo(size.width * 0.7169113, size.height * 0.5703098);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7272009, size.height * 0.6154828);
    tokyoPath.lineTo(size.width * 0.7294189, size.height * 0.6166456);
    tokyoPath.lineTo(size.width * 0.7297619, size.height * 0.6152890);
    tokyoPath.lineTo(size.width * 0.7306537, size.height * 0.6151146);
    tokyoPath.lineTo(size.width * 0.7300820, size.height * 0.6133511);
    tokyoPath.lineTo(size.width * 0.7288244, size.height * 0.6132542);
    tokyoPath.lineTo(size.width * 0.7268122, size.height * 0.6115100);
    tokyoPath.lineTo(size.width * 0.7257147, size.height * 0.6115294);
    tokyoPath.lineTo(size.width * 0.7253488, size.height * 0.6129247);
    tokyoPath.lineTo(size.width * 0.7259891, size.height * 0.6140100);
    tokyoPath.lineTo(size.width * 0.7269494, size.height * 0.6142619);
    tokyoPath.lineTo(size.width * 0.7272009, size.height * 0.6154828);
    tokyoPath.close();
    tokyoPath.moveTo(size.width * 0.7272009, size.height * 0.6154828);
    tokyoPath.lineTo(size.width * 0.7294189, size.height * 0.6166456);
    tokyoPath.lineTo(size.width * 0.7297619, size.height * 0.6152890);
    tokyoPath.lineTo(size.width * 0.7306537, size.height * 0.6151146);
    tokyoPath.lineTo(size.width * 0.7300820, size.height * 0.6133511);
    tokyoPath.lineTo(size.width * 0.7288244, size.height * 0.6132542);
    tokyoPath.lineTo(size.width * 0.7268122, size.height * 0.6115100);
    tokyoPath.lineTo(size.width * 0.7257147, size.height * 0.6115294);
    tokyoPath.lineTo(size.width * 0.7253488, size.height * 0.6129247);
    tokyoPath.lineTo(size.width * 0.7259891, size.height * 0.6140100);
    tokyoPath.lineTo(size.width * 0.7269494, size.height * 0.6142619);
    tokyoPath.lineTo(size.width * 0.7272009, size.height * 0.6154828);
    tokyoPath.close();

    Paint tokyoPaint = Paint()..style = PaintingStyle.fill;
    tokyoPaint.color = japanColors.tokyo ?? defaultColor;
    japanCanvas.drawPath(tokyoPath, tokyoPaint, onTapUp: (tabdetail) {
      callback('tokyo', tabdetail);
    });

    Path tokushimaPath = Path();
    tokushimaPath.moveTo(size.width * 0.4993661, size.height * 0.5811815);
    tokushimaPath.lineTo(size.width * 0.4945871, size.height * 0.5828675);
    tokushimaPath.lineTo(size.width * 0.4925521, size.height * 0.5843597);
    tokushimaPath.lineTo(size.width * 0.4921405, size.height * 0.5853481);
    tokushimaPath.lineTo(size.width * 0.4892823, size.height * 0.5871116);
    tokushimaPath.lineTo(size.width * 0.4865612, size.height * 0.5884681);
    tokushimaPath.lineTo(size.width * 0.4844576, size.height * 0.5888363);
    tokushimaPath.lineTo(size.width * 0.4829942, size.height * 0.5923052);
    tokushimaPath.lineTo(size.width * 0.4809591, size.height * 0.5922277);
    tokushimaPath.lineTo(size.width * 0.4804789, size.height * 0.5931385);
    tokushimaPath.lineTo(size.width * 0.4810734, size.height * 0.5934098);
    tokushimaPath.lineTo(size.width * 0.4803875, size.height * 0.5937587);
    tokushimaPath.lineTo(size.width * 0.4803875, size.height * 0.5937587);
    tokushimaPath.lineTo(size.width * 0.4755628, size.height * 0.5933323);
    tokushimaPath.lineTo(size.width * 0.4737793, size.height * 0.5910262);
    tokushimaPath.lineTo(size.width * 0.4735506, size.height * 0.5901154);
    tokushimaPath.lineTo(size.width * 0.4746253, size.height * 0.5890689);
    tokushimaPath.lineTo(size.width * 0.4740994, size.height * 0.5875185);
    tokushimaPath.lineTo(size.width * 0.4695948, size.height * 0.5874216);
    tokushimaPath.lineTo(size.width * 0.4693662, size.height * 0.5835458);
    tokushimaPath.lineTo(size.width * 0.4682000, size.height * 0.5811040);
    tokushimaPath.lineTo(size.width * 0.4665994, size.height * 0.5814335);
    tokushimaPath.lineTo(size.width * 0.4660278, size.height * 0.5805420);
    tokushimaPath.lineTo(size.width * 0.4651360, size.height * 0.5807939);
    tokushimaPath.lineTo(size.width * 0.4641756, size.height * 0.5823637);
    tokushimaPath.lineTo(size.width * 0.4627808, size.height * 0.5827512);
    tokushimaPath.lineTo(size.width * 0.4609744, size.height * 0.5821311);
    tokushimaPath.lineTo(size.width * 0.4594881, size.height * 0.5803870);
    tokushimaPath.lineTo(size.width * 0.4553494, size.height * 0.5807164);
    tokushimaPath.lineTo(size.width * 0.4522854, size.height * 0.5797087);
    tokushimaPath.lineTo(size.width * 0.4514394, size.height * 0.5786622);
    tokushimaPath.lineTo(size.width * 0.4514394, size.height * 0.5786622);
    tokushimaPath.lineTo(size.width * 0.4527199, size.height * 0.5769181);
    tokushimaPath.lineTo(size.width * 0.4527199, size.height * 0.5749026);
    tokushimaPath.lineTo(size.width * 0.4521025, size.height * 0.5739531);
    tokushimaPath.lineTo(size.width * 0.4527656, size.height * 0.5726353);
    tokushimaPath.lineTo(size.width * 0.4527656, size.height * 0.5726353);
    tokushimaPath.lineTo(size.width * 0.4541833, size.height * 0.5722089);
    tokushimaPath.lineTo(size.width * 0.4545034, size.height * 0.5712206);
    tokushimaPath.lineTo(size.width * 0.4567900, size.height * 0.5695927);
    tokushimaPath.lineTo(size.width * 0.4581162, size.height * 0.5699609);
    tokushimaPath.lineTo(size.width * 0.4587564, size.height * 0.5689920);
    tokushimaPath.lineTo(size.width * 0.4604942, size.height * 0.5684300);
    tokushimaPath.lineTo(size.width * 0.4636497, size.height * 0.5679455);
    tokushimaPath.lineTo(size.width * 0.4656162, size.height * 0.5698253);
    tokushimaPath.lineTo(size.width * 0.4666909, size.height * 0.5698253);
    tokushimaPath.lineTo(size.width * 0.4693662, size.height * 0.5680618);
    tokushimaPath.lineTo(size.width * 0.4722015, size.height * 0.5677905);
    tokushimaPath.lineTo(size.width * 0.4729332, size.height * 0.5671316);
    tokushimaPath.lineTo(size.width * 0.4727960, size.height * 0.5663176);
    tokushimaPath.lineTo(size.width * 0.4744881, size.height * 0.5651936);
    tokushimaPath.lineTo(size.width * 0.4783753, size.height * 0.5648448);
    tokushimaPath.lineTo(size.width * 0.4821024, size.height * 0.5653487);
    tokushimaPath.lineTo(size.width * 0.4827427, size.height * 0.5647673);
    tokushimaPath.lineTo(size.width * 0.4852350, size.height * 0.5658913);
    tokushimaPath.lineTo(size.width * 0.4861954, size.height * 0.5654650);
    tokushimaPath.lineTo(size.width * 0.4865612, size.height * 0.5636045);
    tokushimaPath.lineTo(size.width * 0.4865612, size.height * 0.5636045);
    tokushimaPath.lineTo(size.width * 0.4929865, size.height * 0.5620736);
    tokushimaPath.lineTo(size.width * 0.4929865, size.height * 0.5638952);
    tokushimaPath.lineTo(size.width * 0.4947015, size.height * 0.5648448);
    tokushimaPath.lineTo(size.width * 0.4930551, size.height * 0.5705811);
    tokushimaPath.lineTo(size.width * 0.4932609, size.height * 0.5727128);
    tokushimaPath.lineTo(size.width * 0.4943585, size.height * 0.5737399);
    tokushimaPath.lineTo(size.width * 0.4951816, size.height * 0.5726547);
    tokushimaPath.lineTo(size.width * 0.4965307, size.height * 0.5747282);
    tokushimaPath.lineTo(size.width * 0.4979713, size.height * 0.5754259);
    tokushimaPath.lineTo(size.width * 0.4967823, size.height * 0.5761817);
    tokushimaPath.lineTo(size.width * 0.4983829, size.height * 0.5765499);
    tokushimaPath.lineTo(size.width * 0.4980627, size.height * 0.5774413);
    tokushimaPath.lineTo(size.width * 0.4951131, size.height * 0.5792630);
    tokushimaPath.lineTo(size.width * 0.4949073, size.height * 0.5799025);
    tokushimaPath.lineTo(size.width * 0.4955246, size.height * 0.5803095);
    tokushimaPath.lineTo(size.width * 0.5000521, size.height * 0.5803870);
    tokushimaPath.lineTo(size.width * 0.5003722, size.height * 0.5807939);
    tokushimaPath.lineTo(size.width * 0.4993661, size.height * 0.5811815);
    tokushimaPath.close();

    Paint tokushimaPaint = Paint()..style = PaintingStyle.fill;
    tokushimaPaint.color = japanColors.tokushima ?? defaultColor;
    japanCanvas.drawPath(tokushimaPath, tokushimaPaint, onTapUp: (tabdetail) {
      callback('tokushima', tabdetail);
    });

    Path tottoriPath = Path();
    tottoriPath.moveTo(size.width * 0.4363022, size.height * 0.5052924);
    tottoriPath.lineTo(size.width * 0.4396406, size.height * 0.5058544);
    tottoriPath.lineTo(size.width * 0.4407153, size.height * 0.5055443);
    tottoriPath.lineTo(size.width * 0.4417900, size.height * 0.5038777);
    tottoriPath.lineTo(size.width * 0.4440309, size.height * 0.5029087);
    tottoriPath.lineTo(size.width * 0.4481467, size.height * 0.5021723);
    tottoriPath.lineTo(size.width * 0.4514394, size.height * 0.5032963);
    tottoriPath.lineTo(size.width * 0.4555552, size.height * 0.5036258);
    tottoriPath.lineTo(size.width * 0.4632610, size.height * 0.5031800);
    tottoriPath.lineTo(size.width * 0.4647930, size.height * 0.5024630);
    tottoriPath.lineTo(size.width * 0.4679942, size.height * 0.5027925);
    tottoriPath.lineTo(size.width * 0.4722244, size.height * 0.5024049);
    tottoriPath.lineTo(size.width * 0.4785811, size.height * 0.5009708);
    tottoriPath.lineTo(size.width * 0.4798616, size.height * 0.4994786);
    tottoriPath.lineTo(size.width * 0.4815994, size.height * 0.4993817);
    tottoriPath.lineTo(size.width * 0.4818966, size.height * 0.4986259);
    tottoriPath.lineTo(size.width * 0.4832914, size.height * 0.4983740);
    tottoriPath.lineTo(size.width * 0.4832914, size.height * 0.4983740);
    tottoriPath.lineTo(size.width * 0.4848692, size.height * 0.4993817);
    tottoriPath.lineTo(size.width * 0.4857381, size.height * 0.5008739);
    tottoriPath.lineTo(size.width * 0.4854637, size.height * 0.5028506);
    tottoriPath.lineTo(size.width * 0.4865841, size.height * 0.5064939);
    tottoriPath.lineTo(size.width * 0.4882533, size.height * 0.5071528);
    tottoriPath.lineTo(size.width * 0.4880475, size.height * 0.5092458);
    tottoriPath.lineTo(size.width * 0.4897167, size.height * 0.5111062);
    tottoriPath.lineTo(size.width * 0.4893737, size.height * 0.5119395);
    tottoriPath.lineTo(size.width * 0.4899682, size.height * 0.5141875);
    tottoriPath.lineTo(size.width * 0.4862183, size.height * 0.5164161);
    tottoriPath.lineTo(size.width * 0.4848920, size.height * 0.5159122);
    tottoriPath.lineTo(size.width * 0.4848920, size.height * 0.5159122);
    tottoriPath.lineTo(size.width * 0.4842061, size.height * 0.5154665);
    tottoriPath.lineTo(size.width * 0.4810277, size.height * 0.5177145);
    tottoriPath.lineTo(size.width * 0.4794500, size.height * 0.5179664);
    tottoriPath.lineTo(size.width * 0.4782152, size.height * 0.5174432);
    tottoriPath.lineTo(size.width * 0.4748311, size.height * 0.5192261);
    tottoriPath.lineTo(size.width * 0.4736649, size.height * 0.5180052);
    tottoriPath.lineTo(size.width * 0.4740994, size.height * 0.5166292);
    tottoriPath.lineTo(size.width * 0.4729790, size.height * 0.5160285);
    tottoriPath.lineTo(size.width * 0.4732533, size.height * 0.5148464);
    tottoriPath.lineTo(size.width * 0.4727503, size.height * 0.5140324);
    tottoriPath.lineTo(size.width * 0.4711726, size.height * 0.5128891);
    tottoriPath.lineTo(size.width * 0.4690232, size.height * 0.5132185);
    tottoriPath.lineTo(size.width * 0.4672168, size.height * 0.5128115);
    tottoriPath.lineTo(size.width * 0.4667823, size.height * 0.5124821);
    tottoriPath.lineTo(size.width * 0.4671253, size.height * 0.5107573);
    tottoriPath.lineTo(size.width * 0.4636954, size.height * 0.5115906);
    tottoriPath.lineTo(size.width * 0.4636268, size.height * 0.5125208);
    tottoriPath.lineTo(size.width * 0.4609744, size.height * 0.5134704);
    tottoriPath.lineTo(size.width * 0.4605171, size.height * 0.5145169);
    tottoriPath.lineTo(size.width * 0.4590080, size.height * 0.5154859);
    tottoriPath.lineTo(size.width * 0.4578189, size.height * 0.5137224);
    tottoriPath.lineTo(size.width * 0.4553723, size.height * 0.5122883);
    tottoriPath.lineTo(size.width * 0.4524683, size.height * 0.5122689);
    tottoriPath.lineTo(size.width * 0.4485811, size.height * 0.5110480);
    tottoriPath.lineTo(size.width * 0.4467976, size.height * 0.5157572);
    tottoriPath.lineTo(size.width * 0.4446025, size.height * 0.5162417);
    tottoriPath.lineTo(size.width * 0.4450827, size.height * 0.5171719);
    tottoriPath.lineTo(size.width * 0.4446025, size.height * 0.5181408);
    tottoriPath.lineTo(size.width * 0.4418357, size.height * 0.5190904);
    tottoriPath.lineTo(size.width * 0.4400522, size.height * 0.5184509);
    tottoriPath.lineTo(size.width * 0.4394348, size.height * 0.5191873);
    tottoriPath.lineTo(size.width * 0.4401894, size.height * 0.5214934);
    tottoriPath.lineTo(size.width * 0.4360507, size.height * 0.5227143);
    tottoriPath.lineTo(size.width * 0.4351818, size.height * 0.5222880);
    tottoriPath.lineTo(size.width * 0.4346330, size.height * 0.5239158);
    tottoriPath.lineTo(size.width * 0.4338098, size.height * 0.5244003);
    tottoriPath.lineTo(size.width * 0.4338098, size.height * 0.5244003);
    tottoriPath.lineTo(size.width * 0.4328495, size.height * 0.5234314);
    tottoriPath.lineTo(size.width * 0.4280477, size.height * 0.5240515);
    tottoriPath.lineTo(size.width * 0.4280477, size.height * 0.5235476);
    tottoriPath.lineTo(size.width * 0.4280477, size.height * 0.5235476);
    tottoriPath.lineTo(size.width * 0.4284364, size.height * 0.5205632);
    tottoriPath.lineTo(size.width * 0.4304714, size.height * 0.5192067);
    tottoriPath.lineTo(size.width * 0.4299455, size.height * 0.5178695);
    tottoriPath.lineTo(size.width * 0.4285507, size.height * 0.5176176);
    tottoriPath.lineTo(size.width * 0.4285050, size.height * 0.5170556);
    tottoriPath.lineTo(size.width * 0.4355934, size.height * 0.5143813);
    tottoriPath.lineTo(size.width * 0.4349760, size.height * 0.5112224);
    tottoriPath.lineTo(size.width * 0.4359364, size.height * 0.5100209);
    tottoriPath.lineTo(size.width * 0.4363022, size.height * 0.5052924);
    tottoriPath.close();

    Paint tottoriPaint = Paint()..style = PaintingStyle.fill;
    tottoriPaint.color = japanColors.tottori ?? defaultColor;
    japanCanvas.drawPath(tottoriPath, tottoriPaint, onTapUp: (tabdetail) {
      callback('tottori', tabdetail);
    });

    Path toyomaPath = Path();
    toyomaPath.moveTo(size.width * 0.6071783, size.height * 0.4431819);
    toyomaPath.lineTo(size.width * 0.6101738, size.height * 0.4444997);
    toyomaPath.lineTo(size.width * 0.6124146, size.height * 0.4440540);
    toyomaPath.lineTo(size.width * 0.6168506, size.height * 0.4442284);
    toyomaPath.lineTo(size.width * 0.6195259, size.height * 0.4420773);
    toyomaPath.lineTo(size.width * 0.6203491, size.height * 0.4401200);
    toyomaPath.lineTo(size.width * 0.6202805, size.height * 0.4377751);
    toyomaPath.lineTo(size.width * 0.6211265, size.height * 0.4363992);
    toyomaPath.lineTo(size.width * 0.6241905, size.height * 0.4350232);
    toyomaPath.lineTo(size.width * 0.6305472, size.height * 0.4338605);
    toyomaPath.lineTo(size.width * 0.6305472, size.height * 0.4338605);
    toyomaPath.lineTo(size.width * 0.6321478, size.height * 0.4354302);
    toyomaPath.lineTo(size.width * 0.6340228, size.height * 0.4359147);
    toyomaPath.lineTo(size.width * 0.6340914, size.height * 0.4382402);
    toyomaPath.lineTo(size.width * 0.6349832, size.height * 0.4394029);
    toyomaPath.lineTo(size.width * 0.6349832, size.height * 0.4408951);
    toyomaPath.lineTo(size.width * 0.6363322, size.height * 0.4441509);
    toyomaPath.lineTo(size.width * 0.6363322, size.height * 0.4441509);
    toyomaPath.lineTo(size.width * 0.6358749, size.height * 0.4522514);
    toyomaPath.lineTo(size.width * 0.6331768, size.height * 0.4536079);
    toyomaPath.lineTo(size.width * 0.6329252, size.height * 0.4551001);
    toyomaPath.lineTo(size.width * 0.6334054, size.height * 0.4550226);
    toyomaPath.lineTo(size.width * 0.6336798, size.height * 0.4559722);
    toyomaPath.lineTo(size.width * 0.6322850, size.height * 0.4563016);
    toyomaPath.lineTo(size.width * 0.6313932, size.height * 0.4573287);
    toyomaPath.lineTo(size.width * 0.6314390, size.height * 0.4587822);
    toyomaPath.lineTo(size.width * 0.6304786, size.height * 0.4603519);
    toyomaPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    toyomaPath.lineTo(size.width * 0.6284207, size.height * 0.4620185);
    toyomaPath.lineTo(size.width * 0.6262713, size.height * 0.4618829);
    toyomaPath.lineTo(size.width * 0.6243506, size.height * 0.4602938);
    toyomaPath.lineTo(size.width * 0.6227271, size.height * 0.4609527);
    toyomaPath.lineTo(size.width * 0.6201433, size.height * 0.4602744);
    toyomaPath.lineTo(size.width * 0.6195030, size.height * 0.4587628);
    toyomaPath.lineTo(size.width * 0.6164161, size.height * 0.4603131);
    toyomaPath.lineTo(size.width * 0.6159360, size.height * 0.4602356);
    toyomaPath.lineTo(size.width * 0.6158445, size.height * 0.4585303);
    toyomaPath.lineTo(size.width * 0.6144954, size.height * 0.4584334);
    toyomaPath.lineTo(size.width * 0.6111570, size.height * 0.4597705);
    toyomaPath.lineTo(size.width * 0.6105854, size.height * 0.4589178);
    toyomaPath.lineTo(size.width * 0.6093277, size.height * 0.4589566);
    toyomaPath.lineTo(size.width * 0.6045716, size.height * 0.4628712);
    toyomaPath.lineTo(size.width * 0.6040000, size.height * 0.4650998);
    toyomaPath.lineTo(size.width * 0.6008217, size.height * 0.4674641);
    toyomaPath.lineTo(size.width * 0.6000442, size.height * 0.4673091);
    toyomaPath.lineTo(size.width * 0.6006387, size.height * 0.4658944);
    toyomaPath.lineTo(size.width * 0.5998613, size.height * 0.4644022);
    toyomaPath.lineTo(size.width * 0.5977576, size.height * 0.4634138);
    toyomaPath.lineTo(size.width * 0.5969573, size.height * 0.4641115);
    toyomaPath.lineTo(size.width * 0.5963857, size.height * 0.4629681);
    toyomaPath.lineTo(size.width * 0.5946250, size.height * 0.4640533);
    toyomaPath.lineTo(size.width * 0.5939619, size.height * 0.4661075);
    toyomaPath.lineTo(size.width * 0.5926357, size.height * 0.4662626);
    toyomaPath.lineTo(size.width * 0.5926357, size.height * 0.4662626);
    toyomaPath.lineTo(size.width * 0.5922927, size.height * 0.4645378);
    toyomaPath.lineTo(size.width * 0.5930244, size.height * 0.4637239);
    toyomaPath.lineTo(size.width * 0.5919955, size.height * 0.4600612);
    toyomaPath.lineTo(size.width * 0.5937104, size.height * 0.4543443);
    toyomaPath.lineTo(size.width * 0.5926586, size.height * 0.4532203);
    toyomaPath.lineTo(size.width * 0.5922241, size.height * 0.4510305);
    toyomaPath.lineTo(size.width * 0.5939848, size.height * 0.4486468);
    toyomaPath.lineTo(size.width * 0.5934589, size.height * 0.4477554);
    toyomaPath.lineTo(size.width * 0.5938247, size.height * 0.4458756);
    toyomaPath.lineTo(size.width * 0.5950823, size.height * 0.4446160);
    toyomaPath.lineTo(size.width * 0.5964543, size.height * 0.4378526);
    toyomaPath.lineTo(size.width * 0.5996555, size.height * 0.4351976);
    toyomaPath.lineTo(size.width * 0.6013247, size.height * 0.4346938);
    toyomaPath.lineTo(size.width * 0.6041601, size.height * 0.4348876);
    toyomaPath.lineTo(size.width * 0.6041601, size.height * 0.4348876);
    toyomaPath.lineTo(size.width * 0.6011189, size.height * 0.4393254);
    toyomaPath.lineTo(size.width * 0.6043659, size.height * 0.4423486);
    toyomaPath.lineTo(size.width * 0.6059436, size.height * 0.4433175);
    toyomaPath.close();

    Paint toyomaPaint = Paint()..style = PaintingStyle.fill;
    toyomaPaint.color = japanColors.toyama ?? defaultColor;
    japanCanvas.drawPath(toyomaPath, toyomaPaint, onTapUp: (tabdetail) {
      callback('toyoma', tabdetail);
    });

    Path wakayamaPath = Path();
    wakayamaPath.moveTo(size.width * 0.5488934, size.height * 0.5952702);
    wakayamaPath.lineTo(size.width * 0.5476587, size.height * 0.5960066);
    wakayamaPath.lineTo(size.width * 0.5469270, size.height * 0.5973438);
    wakayamaPath.lineTo(size.width * 0.5471328, size.height * 0.5987197);
    wakayamaPath.lineTo(size.width * 0.5460352, size.height * 0.5988748);
    wakayamaPath.lineTo(size.width * 0.5454635, size.height * 0.5981965);
    wakayamaPath.lineTo(size.width * 0.5461953, size.height * 0.5967431);
    wakayamaPath.lineTo(size.width * 0.5443889, size.height * 0.5969562);
    wakayamaPath.lineTo(size.width * 0.5400901, size.height * 0.5955028);
    wakayamaPath.lineTo(size.width * 0.5347166, size.height * 0.5947664);
    wakayamaPath.lineTo(size.width * 0.5300977, size.height * 0.5924215);
    wakayamaPath.lineTo(size.width * 0.5291602, size.height * 0.5909874);
    wakayamaPath.lineTo(size.width * 0.5295032, size.height * 0.5894565);
    wakayamaPath.lineTo(size.width * 0.5265993, size.height * 0.5882356);
    wakayamaPath.lineTo(size.width * 0.5288401, size.height * 0.5872085);
    wakayamaPath.lineTo(size.width * 0.5294118, size.height * 0.5861039);
    wakayamaPath.lineTo(size.width * 0.5261191, size.height * 0.5837396);
    wakayamaPath.lineTo(size.width * 0.5201282, size.height * 0.5813947);
    wakayamaPath.lineTo(size.width * 0.5185734, size.height * 0.5786622);
    wakayamaPath.lineTo(size.width * 0.5168127, size.height * 0.5779258);
    wakayamaPath.lineTo(size.width * 0.5142746, size.height * 0.5785459);
    wakayamaPath.lineTo(size.width * 0.5147548, size.height * 0.5740306);
    wakayamaPath.lineTo(size.width * 0.5183447, size.height * 0.5727903);
    wakayamaPath.lineTo(size.width * 0.5194651, size.height * 0.5715694);
    wakayamaPath.lineTo(size.width * 0.5177959, size.height * 0.5700966);
    wakayamaPath.lineTo(size.width * 0.5152350, size.height * 0.5696121);
    wakayamaPath.lineTo(size.width * 0.5166298, size.height * 0.5683718);
    wakayamaPath.lineTo(size.width * 0.5173157, size.height * 0.5667634);
    wakayamaPath.lineTo(size.width * 0.5193051, size.height * 0.5668990);
    wakayamaPath.lineTo(size.width * 0.5199910, size.height * 0.5662207);
    wakayamaPath.lineTo(size.width * 0.5196938, size.height * 0.5647673);
    wakayamaPath.lineTo(size.width * 0.5179789, size.height * 0.5643797);
    wakayamaPath.lineTo(size.width * 0.5169956, size.height * 0.5620154);
    wakayamaPath.lineTo(size.width * 0.5147090, size.height * 0.5599225);
    wakayamaPath.lineTo(size.width * 0.5150063, size.height * 0.5589923);
    wakayamaPath.lineTo(size.width * 0.5158295, size.height * 0.5587210);
    wakayamaPath.lineTo(size.width * 0.5158295, size.height * 0.5587210);
    wakayamaPath.lineTo(size.width * 0.5164468, size.height * 0.5588954);
    wakayamaPath.lineTo(size.width * 0.5167441, size.height * 0.5606008);
    wakayamaPath.lineTo(size.width * 0.5177273, size.height * 0.5606783);
    wakayamaPath.lineTo(size.width * 0.5201054, size.height * 0.5603295);
    wakayamaPath.lineTo(size.width * 0.5229179, size.height * 0.5587985);
    wakayamaPath.lineTo(size.width * 0.5266450, size.height * 0.5586241);
    wakayamaPath.lineTo(size.width * 0.5313553, size.height * 0.5571900);
    wakayamaPath.lineTo(size.width * 0.5350596, size.height * 0.5574613);
    wakayamaPath.lineTo(size.width * 0.5378035, size.height * 0.5559110);
    wakayamaPath.lineTo(size.width * 0.5407532, size.height * 0.5555622);
    wakayamaPath.lineTo(size.width * 0.5407532, size.height * 0.5555622);
    wakayamaPath.lineTo(size.width * 0.5416678, size.height * 0.5568799);
    wakayamaPath.lineTo(size.width * 0.5421251, size.height * 0.5602132);
    wakayamaPath.lineTo(size.width * 0.5441602, size.height * 0.5611821);
    wakayamaPath.lineTo(size.width * 0.5446404, size.height * 0.5624612);
    wakayamaPath.lineTo(size.width * 0.5437486, size.height * 0.5636239);
    wakayamaPath.lineTo(size.width * 0.5418965, size.height * 0.5629069);
    wakayamaPath.lineTo(size.width * 0.5406389, size.height * 0.5634301);
    wakayamaPath.lineTo(size.width * 0.5406617, size.height * 0.5648061);
    wakayamaPath.lineTo(size.width * 0.5397928, size.height * 0.5659107);
    wakayamaPath.lineTo(size.width * 0.5363858, size.height * 0.5687207);
    wakayamaPath.lineTo(size.width * 0.5360886, size.height * 0.5697671);
    wakayamaPath.lineTo(size.width * 0.5386953, size.height * 0.5716276);
    wakayamaPath.lineTo(size.width * 0.5385581, size.height * 0.5726547);
    wakayamaPath.lineTo(size.width * 0.5398843, size.height * 0.5730616);
    wakayamaPath.lineTo(size.width * 0.5405245, size.height * 0.5740500);
    wakayamaPath.lineTo(size.width * 0.5389011, size.height * 0.5775964);
    wakayamaPath.lineTo(size.width * 0.5397700, size.height * 0.5778483);
    wakayamaPath.lineTo(size.width * 0.5402501, size.height * 0.5789529);
    wakayamaPath.lineTo(size.width * 0.5428797, size.height * 0.5776351);
    wakayamaPath.lineTo(size.width * 0.5443889, size.height * 0.5776545);
    wakayamaPath.lineTo(size.width * 0.5458980, size.height * 0.5784491);
    wakayamaPath.lineTo(size.width * 0.5504940, size.height * 0.5777902);
    wakayamaPath.lineTo(size.width * 0.5504940, size.height * 0.5777902);
    wakayamaPath.lineTo(size.width * 0.5503340, size.height * 0.5815110);
    wakayamaPath.lineTo(size.width * 0.5542212, size.height * 0.5852705);
    wakayamaPath.lineTo(size.width * 0.5571708, size.height * 0.5857938);
    wakayamaPath.lineTo(size.width * 0.5571708, size.height * 0.5857938);
    wakayamaPath.lineTo(size.width * 0.5564163, size.height * 0.5866659);
    wakayamaPath.lineTo(size.width * 0.5560733, size.height * 0.5888945);
    wakayamaPath.lineTo(size.width * 0.5538782, size.height * 0.5893983);
    wakayamaPath.lineTo(size.width * 0.5533523, size.height * 0.5910456);
    wakayamaPath.lineTo(size.width * 0.5549986, size.height * 0.5915882);
    wakayamaPath.lineTo(size.width * 0.5548385, size.height * 0.5922665);
    wakayamaPath.lineTo(size.width * 0.5500824, size.height * 0.5950958);
    wakayamaPath.lineTo(size.width * 0.5488934, size.height * 0.5952702);
    wakayamaPath.close();

    Paint wakayamaPaint = Paint()..style = PaintingStyle.fill;
    wakayamaPaint.color = japanColors.wakayama ?? defaultColor;
    japanCanvas.drawPath(wakayamaPath, wakayamaPaint, onTapUp: (tabdetail) {
      callback('wakayama', tabdetail);
    });

    Path yamaguchiPath = Path();
    yamaguchiPath.moveTo(size.width * 0.3544198, size.height * 0.5719958);
    yamaguchiPath.lineTo(size.width * 0.3530707, size.height * 0.5712012);
    yamaguchiPath.lineTo(size.width * 0.3522704, size.height * 0.5729066);
    yamaguchiPath.lineTo(size.width * 0.3505783, size.height * 0.5735849);
    yamaguchiPath.lineTo(size.width * 0.3499152, size.height * 0.5731973);
    yamaguchiPath.lineTo(size.width * 0.3502582, size.height * 0.5720539);
    yamaguchiPath.lineTo(size.width * 0.3492521, size.height * 0.5717826);
    yamaguchiPath.lineTo(size.width * 0.3474914, size.height * 0.5746120);
    yamaguchiPath.lineTo(size.width * 0.3435585, size.height * 0.5766080);
    yamaguchiPath.lineTo(size.width * 0.3385738, size.height * 0.5750964);
    yamaguchiPath.lineTo(size.width * 0.3387567, size.height * 0.5735655);
    yamaguchiPath.lineTo(size.width * 0.3335890, size.height * 0.5710849);
    yamaguchiPath.lineTo(size.width * 0.3320113, size.height * 0.5718213);
    yamaguchiPath.lineTo(size.width * 0.3312796, size.height * 0.5735267);
    yamaguchiPath.lineTo(size.width * 0.3270723, size.height * 0.5769762);
    yamaguchiPath.lineTo(size.width * 0.3266378, size.height * 0.5758329);
    yamaguchiPath.lineTo(size.width * 0.3276896, size.height * 0.5741469);
    yamaguchiPath.lineTo(size.width * 0.3276211, size.height * 0.5708911);
    yamaguchiPath.lineTo(size.width * 0.3251973, size.height * 0.5679455);
    yamaguchiPath.lineTo(size.width * 0.3254717, size.height * 0.5667634);
    yamaguchiPath.lineTo(size.width * 0.3271866, size.height * 0.5665114);
    yamaguchiPath.lineTo(size.width * 0.3284442, size.height * 0.5643603);
    yamaguchiPath.lineTo(size.width * 0.3278954, size.height * 0.5620154);
    yamaguchiPath.lineTo(size.width * 0.3254488, size.height * 0.5597481);
    yamaguchiPath.lineTo(size.width * 0.3261348, size.height * 0.5594380);
    yamaguchiPath.lineTo(size.width * 0.3270037, size.height * 0.5567831);
    yamaguchiPath.lineTo(size.width * 0.3330402, size.height * 0.5559885);
    yamaguchiPath.lineTo(size.width * 0.3323543, size.height * 0.5550583);
    yamaguchiPath.lineTo(size.width * 0.3295646, size.height * 0.5543219);
    yamaguchiPath.lineTo(size.width * 0.3302049, size.height * 0.5527328);
    yamaguchiPath.lineTo(size.width * 0.3323085, size.height * 0.5541669);
    yamaguchiPath.lineTo(size.width * 0.3347780, size.height * 0.5535080);
    yamaguchiPath.lineTo(size.width * 0.3359671, size.height * 0.5537986);
    yamaguchiPath.lineTo(size.width * 0.3384594, size.height * 0.5559497);
    yamaguchiPath.lineTo(size.width * 0.3452277, size.height * 0.5554459);
    yamaguchiPath.lineTo(size.width * 0.3466454, size.height * 0.5538374);
    yamaguchiPath.lineTo(size.width * 0.3489777, size.height * 0.5538955);
    yamaguchiPath.lineTo(size.width * 0.3522704, size.height * 0.5506398);
    yamaguchiPath.lineTo(size.width * 0.3516530, size.height * 0.5493608);
    yamaguchiPath.lineTo(size.width * 0.3524533, size.height * 0.5482756);
    yamaguchiPath.lineTo(size.width * 0.3540539, size.height * 0.5485469);
    yamaguchiPath.lineTo(size.width * 0.3556545, size.height * 0.5471709);
    yamaguchiPath.lineTo(size.width * 0.3564320, size.height * 0.5463570);
    yamaguchiPath.lineTo(size.width * 0.3565006, size.height * 0.5446904);
    yamaguchiPath.lineTo(size.width * 0.3575524, size.height * 0.5444772);
    yamaguchiPath.lineTo(size.width * 0.3584213, size.height * 0.5427719);
    yamaguchiPath.lineTo(size.width * 0.3589929, size.height * 0.5423261);
    yamaguchiPath.lineTo(size.width * 0.3612109, size.height * 0.5428881);
    yamaguchiPath.lineTo(size.width * 0.3622856, size.height * 0.5419385);
    yamaguchiPath.lineTo(size.width * 0.3622856, size.height * 0.5419385);
    yamaguchiPath.lineTo(size.width * 0.3641835, size.height * 0.5468609);
    yamaguchiPath.lineTo(size.width * 0.3632002, size.height * 0.5471709);
    yamaguchiPath.lineTo(size.width * 0.3631545, size.height * 0.5487600);
    yamaguchiPath.lineTo(size.width * 0.3616454, size.height * 0.5500003);
    yamaguchiPath.lineTo(size.width * 0.3630402, size.height * 0.5531979);
    yamaguchiPath.lineTo(size.width * 0.3673161, size.height * 0.5531204);
    yamaguchiPath.lineTo(size.width * 0.3660585, size.height * 0.5561048);
    yamaguchiPath.lineTo(size.width * 0.3664472, size.height * 0.5575970);
    yamaguchiPath.lineTo(size.width * 0.3684365, size.height * 0.5592636);
    yamaguchiPath.lineTo(size.width * 0.3708374, size.height * 0.5590698);
    yamaguchiPath.lineTo(size.width * 0.3729868, size.height * 0.5577133);
    yamaguchiPath.lineTo(size.width * 0.3745645, size.height * 0.5589341);
    yamaguchiPath.lineTo(size.width * 0.3771255, size.height * 0.5558722);
    yamaguchiPath.lineTo(size.width * 0.3761423, size.height * 0.5541475);
    yamaguchiPath.lineTo(size.width * 0.3764853, size.height * 0.5535467);
    yamaguchiPath.lineTo(size.width * 0.3775828, size.height * 0.5521708);
    yamaguchiPath.lineTo(size.width * 0.3794350, size.height * 0.5512987);
    yamaguchiPath.lineTo(size.width * 0.3794350, size.height * 0.5512987);
    yamaguchiPath.lineTo(size.width * 0.3801209, size.height * 0.5526165);
    yamaguchiPath.lineTo(size.width * 0.3797322, size.height * 0.5541862);
    yamaguchiPath.lineTo(size.width * 0.3802810, size.height * 0.5568218);
    yamaguchiPath.lineTo(size.width * 0.3823846, size.height * 0.5583334);
    yamaguchiPath.lineTo(size.width * 0.3822017, size.height * 0.5595543);
    yamaguchiPath.lineTo(size.width * 0.3833450, size.height * 0.5623837);
    yamaguchiPath.lineTo(size.width * 0.3862718, size.height * 0.5629844);
    yamaguchiPath.lineTo(size.width * 0.3870264, size.height * 0.5626162);
    yamaguchiPath.lineTo(size.width * 0.3870264, size.height * 0.5626162);
    yamaguchiPath.lineTo(size.width * 0.3875752, size.height * 0.5635658);
    yamaguchiPath.lineTo(size.width * 0.3869121, size.height * 0.5645735);
    yamaguchiPath.lineTo(size.width * 0.3877581, size.height * 0.5654843);
    yamaguchiPath.lineTo(size.width * 0.3855173, size.height * 0.5672478);
    yamaguchiPath.lineTo(size.width * 0.3860660, size.height * 0.5729841);
    yamaguchiPath.lineTo(size.width * 0.3847627, size.height * 0.5748445);
    yamaguchiPath.lineTo(size.width * 0.3822703, size.height * 0.5750771);
    yamaguchiPath.lineTo(size.width * 0.3822932, size.height * 0.5782165);
    yamaguchiPath.lineTo(size.width * 0.3836194, size.height * 0.5795343);
    yamaguchiPath.lineTo(size.width * 0.3828648, size.height * 0.5807552);
    yamaguchiPath.lineTo(size.width * 0.3817444, size.height * 0.5786816);
    yamaguchiPath.lineTo(size.width * 0.3784746, size.height * 0.5772669);
    yamaguchiPath.lineTo(size.width * 0.3776286, size.height * 0.5775964);
    yamaguchiPath.lineTo(size.width * 0.3693740, size.height * 0.5722477);
    yamaguchiPath.lineTo(size.width * 0.3682993, size.height * 0.5734104);
    yamaguchiPath.lineTo(size.width * 0.3682307, size.height * 0.5744763);
    yamaguchiPath.lineTo(size.width * 0.3661499, size.height * 0.5740887);
    yamaguchiPath.lineTo(size.width * 0.3687109, size.height * 0.5718020);
    yamaguchiPath.lineTo(size.width * 0.3658527, size.height * 0.5704260);
    yamaguchiPath.lineTo(size.width * 0.3646637, size.height * 0.5702710);
    yamaguchiPath.lineTo(size.width * 0.3605021, size.height * 0.5713369);
    yamaguchiPath.lineTo(size.width * 0.3557003, size.height * 0.5731973);
    yamaguchiPath.lineTo(size.width * 0.3544198, size.height * 0.5719958);
    yamaguchiPath.close();
    yamaguchiPath.moveTo(size.width * 0.3890386, size.height * 0.5790110);
    yamaguchiPath.lineTo(size.width * 0.3869807, size.height * 0.5787397);
    yamaguchiPath.lineTo(size.width * 0.3857917, size.height * 0.5796312);
    yamaguchiPath.lineTo(size.width * 0.3844654, size.height * 0.5779452);
    yamaguchiPath.lineTo(size.width * 0.3843282, size.height * 0.5764142);
    yamaguchiPath.lineTo(size.width * 0.3870264, size.height * 0.5745732);
    yamaguchiPath.lineTo(size.width * 0.3901362, size.height * 0.5767631);
    yamaguchiPath.lineTo(size.width * 0.3923770, size.height * 0.5768793);
    yamaguchiPath.lineTo(size.width * 0.3952581, size.height * 0.5752321);
    yamaguchiPath.lineTo(size.width * 0.3977733, size.height * 0.5753484);
    yamaguchiPath.lineTo(size.width * 0.3948922, size.height * 0.5772088);
    yamaguchiPath.lineTo(size.width * 0.3932688, size.height * 0.5771894);
    yamaguchiPath.lineTo(size.width * 0.3928343, size.height * 0.5777902);
    yamaguchiPath.lineTo(size.width * 0.3932688, size.height * 0.5793986);
    yamaguchiPath.lineTo(size.width * 0.3912794, size.height * 0.5795924);
    yamaguchiPath.lineTo(size.width * 0.3910508, size.height * 0.5780033);
    yamaguchiPath.lineTo(size.width * 0.3900447, size.height * 0.5778095);
    yamaguchiPath.lineTo(size.width * 0.3888099, size.height * 0.5779839);
    yamaguchiPath.lineTo(size.width * 0.3890386, size.height * 0.5790110);
    yamaguchiPath.close();

    Paint yamaguchiPaint = Paint()..style = PaintingStyle.fill;
    yamaguchiPaint.color = japanColors.yamaguchi ?? defaultColor;
    japanCanvas.drawPath(yamaguchiPath, yamaguchiPaint, onTapUp: (tabdetail) {
      callback('yamaguchi', tabdetail);
    });

    Path yamanashiPath = Path();
    yamanashiPath.moveTo(size.width * 0.6979556, size.height * 0.4957190);
    yamanashiPath.lineTo(size.width * 0.6979099, size.height * 0.5007770);
    yamanashiPath.lineTo(size.width * 0.6971324, size.height * 0.5021336);
    yamanashiPath.lineTo(size.width * 0.6960120, size.height * 0.5031413);
    yamanashiPath.lineTo(size.width * 0.6943885, size.height * 0.5033351);
    yamanashiPath.lineTo(size.width * 0.6933367, size.height * 0.5045947);
    yamanashiPath.lineTo(size.width * 0.6892437, size.height * 0.5062032);
    yamanashiPath.lineTo(size.width * 0.6883291, size.height * 0.5083931);
    yamanashiPath.lineTo(size.width * 0.6883291, size.height * 0.5083931);
    yamanashiPath.lineTo(size.width * 0.6867971, size.height * 0.5091489);
    yamanashiPath.lineTo(size.width * 0.6851965, size.height * 0.5090132);
    yamanashiPath.lineTo(size.width * 0.6843504, size.height * 0.5095364);
    yamanashiPath.lineTo(size.width * 0.6779480, size.height * 0.5104473);
    yamanashiPath.lineTo(size.width * 0.6769190, size.height * 0.5085675);
    yamanashiPath.lineTo(size.width * 0.6745639, size.height * 0.5088000);
    yamanashiPath.lineTo(size.width * 0.6732605, size.height * 0.5063582);
    yamanashiPath.lineTo(size.width * 0.6709968, size.height * 0.5081218);
    yamanashiPath.lineTo(size.width * 0.6711111, size.height * 0.5114356);
    yamanashiPath.lineTo(size.width * 0.6701279, size.height * 0.5126177);
    yamanashiPath.lineTo(size.width * 0.6710425, size.height * 0.5177726);
    yamanashiPath.lineTo(size.width * 0.6693962, size.height * 0.5189935);
    yamanashiPath.lineTo(size.width * 0.6665608, size.height * 0.5187610);
    yamanashiPath.lineTo(size.width * 0.6649831, size.height * 0.5177920);
    yamanashiPath.lineTo(size.width * 0.6634054, size.height * 0.5125790);
    yamanashiPath.lineTo(size.width * 0.6616676, size.height * 0.5118813);
    yamanashiPath.lineTo(size.width * 0.6599298, size.height * 0.5128891);
    yamanashiPath.lineTo(size.width * 0.6583749, size.height * 0.5119007);
    yamanashiPath.lineTo(size.width * 0.6576203, size.height * 0.5093814);
    yamanashiPath.lineTo(size.width * 0.6586721, size.height * 0.5075791);
    yamanashiPath.lineTo(size.width * 0.6581462, size.height * 0.5055056);
    yamanashiPath.lineTo(size.width * 0.6590151, size.height * 0.5032188);
    yamanashiPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    yamanashiPath.lineTo(size.width * 0.6568657, size.height * 0.4970562);
    yamanashiPath.lineTo(size.width * 0.6551965, size.height * 0.4936261);
    yamanashiPath.lineTo(size.width * 0.6574831, size.height * 0.4914944);
    yamanashiPath.lineTo(size.width * 0.6554709, size.height * 0.4898277);
    yamanashiPath.lineTo(size.width * 0.6576889, size.height * 0.4860100);
    yamanashiPath.lineTo(size.width * 0.6581462, size.height * 0.4857775);
    yamanashiPath.lineTo(size.width * 0.6597926, size.height * 0.4869790);
    yamanashiPath.lineTo(size.width * 0.6638398, size.height * 0.4817272);
    yamanashiPath.lineTo(size.width * 0.6671096, size.height * 0.4828512);
    yamanashiPath.lineTo(size.width * 0.6670867, size.height * 0.4841496);
    yamanashiPath.lineTo(size.width * 0.6681843, size.height * 0.4851767);
    yamanashiPath.lineTo(size.width * 0.6692819, size.height * 0.4850023);
    yamanashiPath.lineTo(size.width * 0.6697849, size.height * 0.4842078);
    yamanashiPath.lineTo(size.width * 0.6738093, size.height * 0.4842659);
    yamanashiPath.lineTo(size.width * 0.6750440, size.height * 0.4864751);
    yamanashiPath.lineTo(size.width * 0.6772620, size.height * 0.4864558);
    yamanashiPath.lineTo(size.width * 0.6789312, size.height * 0.4846341);
    yamanashiPath.lineTo(size.width * 0.6798459, size.height * 0.4846535);
    yamanashiPath.lineTo(size.width * 0.6798459, size.height * 0.4846535);
    yamanashiPath.lineTo(size.width * 0.6821782, size.height * 0.4850992);
    yamanashiPath.lineTo(size.width * 0.6828413, size.height * 0.4863395);
    yamanashiPath.lineTo(size.width * 0.6854937, size.height * 0.4867271);
    yamanashiPath.lineTo(size.width * 0.6870715, size.height * 0.4877542);
    yamanashiPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    yamanashiPath.lineTo(size.width * 0.6895638, size.height * 0.4871922);
    yamanashiPath.lineTo(size.width * 0.6931538, size.height * 0.4934710);
    yamanashiPath.close();

    Paint yamanashiPaint = Paint()..style = PaintingStyle.fill;
    yamanashiPaint.color = japanColors.yamanashi ?? defaultColor;
    japanCanvas.drawPath(yamanashiPath, yamanashiPaint, onTapUp: (tabdetail) {
      callback('yamanashi', tabdetail);
    });

    Path yamagataPath = Path();
    yamagataPath.moveTo(size.width * 0.7497695, size.height * 0.3862650);
    yamagataPath.lineTo(size.width * 0.7490835, size.height * 0.3895789);
    yamagataPath.lineTo(size.width * 0.7491750, size.height * 0.3934741);
    yamagataPath.lineTo(size.width * 0.7504326, size.height * 0.3942687);
    yamagataPath.lineTo(size.width * 0.7473914, size.height * 0.3973887);
    yamagataPath.lineTo(size.width * 0.7444189, size.height * 0.3968849);
    yamagataPath.lineTo(size.width * 0.7427268, size.height * 0.3979701);
    yamagataPath.lineTo(size.width * 0.7393655, size.height * 0.3957996);
    yamagataPath.lineTo(size.width * 0.7365531, size.height * 0.3966911);
    yamagataPath.lineTo(size.width * 0.7343351, size.height * 0.3934354);
    yamagataPath.lineTo(size.width * 0.7335805, size.height * 0.3941136);
    yamagataPath.lineTo(size.width * 0.7321400, size.height * 0.3942493);
    yamagataPath.lineTo(size.width * 0.7307451, size.height * 0.3934935);
    yamagataPath.lineTo(size.width * 0.7285958, size.height * 0.3946175);
    yamagataPath.lineTo(size.width * 0.7271552, size.height * 0.3932997);
    yamagataPath.lineTo(size.width * 0.7253488, size.height * 0.3936485);
    yamagataPath.lineTo(size.width * 0.7253488, size.height * 0.3936485);
    yamagataPath.lineTo(size.width * 0.7243199, size.height * 0.3921563);
    yamagataPath.lineTo(size.width * 0.7232909, size.height * 0.3924083);
    yamagataPath.lineTo(size.width * 0.7217817, size.height * 0.3917881);
    yamagataPath.lineTo(size.width * 0.7202726, size.height * 0.3895401);
    yamagataPath.lineTo(size.width * 0.7216217, size.height * 0.3833969);
    yamagataPath.lineTo(size.width * 0.7231994, size.height * 0.3824086);
    yamagataPath.lineTo(size.width * 0.7223991, size.height * 0.3809357);
    yamagataPath.lineTo(size.width * 0.7231766, size.height * 0.3793466);
    yamagataPath.lineTo(size.width * 0.7228107, size.height * 0.3768080);
    yamagataPath.lineTo(size.width * 0.7239997, size.height * 0.3752189);
    yamagataPath.lineTo(size.width * 0.7276125, size.height * 0.3756452);
    yamagataPath.lineTo(size.width * 0.7307451, size.height * 0.3739786);
    yamagataPath.lineTo(size.width * 0.7325515, size.height * 0.3708973);
    yamagataPath.lineTo(size.width * 0.7299220, size.height * 0.3685136);
    yamagataPath.lineTo(size.width * 0.7257147, size.height * 0.3675834);
    yamagataPath.lineTo(size.width * 0.7238854, size.height * 0.3653936);
    yamagataPath.lineTo(size.width * 0.7248000, size.height * 0.3615371);
    yamagataPath.lineTo(size.width * 0.7242513, size.height * 0.3609751);
    yamagataPath.lineTo(size.width * 0.7208671, size.height * 0.3603550);
    yamagataPath.lineTo(size.width * 0.7167284, size.height * 0.3584946);
    yamagataPath.lineTo(size.width * 0.7167284, size.height * 0.3584946);
    yamagataPath.lineTo(size.width * 0.7194037, size.height * 0.3525258);
    yamagataPath.lineTo(size.width * 0.7233824, size.height * 0.3495995);
    yamagataPath.lineTo(size.width * 0.7259891, size.height * 0.3466926);
    yamagataPath.lineTo(size.width * 0.7285729, size.height * 0.3387859);
    yamagataPath.lineTo(size.width * 0.7299677, size.height * 0.3367704);
    yamagataPath.lineTo(size.width * 0.7315683, size.height * 0.3316543);
    yamagataPath.lineTo(size.width * 0.7311567, size.height * 0.3305303);
    yamagataPath.lineTo(size.width * 0.7311567, size.height * 0.3305303);
    yamagataPath.lineTo(size.width * 0.7368960, size.height * 0.3313249);
    yamagataPath.lineTo(size.width * 0.7377421, size.height * 0.3304334);
    yamagataPath.lineTo(size.width * 0.7399829, size.height * 0.3299683);
    yamagataPath.lineTo(size.width * 0.7404402, size.height * 0.3322357);
    yamagataPath.lineTo(size.width * 0.7420637, size.height * 0.3325845);
    yamagataPath.lineTo(size.width * 0.7438701, size.height * 0.3339411);
    yamagataPath.lineTo(size.width * 0.7509128, size.height * 0.3357627);
    yamagataPath.lineTo(size.width * 0.7533823, size.height * 0.3352395);
    yamagataPath.lineTo(size.width * 0.7541826, size.height * 0.3367317);
    yamagataPath.lineTo(size.width * 0.7566064, size.height * 0.3368867);
    yamagataPath.lineTo(size.width * 0.7579326, size.height * 0.3403750);
    yamagataPath.lineTo(size.width * 0.7614082, size.height * 0.3414021);
    yamagataPath.lineTo(size.width * 0.7619570, size.height * 0.3422741);
    yamagataPath.lineTo(size.width * 0.7619570, size.height * 0.3422741);
    yamagataPath.lineTo(size.width * 0.7614310, size.height * 0.3429524);
    yamagataPath.lineTo(size.width * 0.7638548, size.height * 0.3449291);
    yamagataPath.lineTo(size.width * 0.7642893, size.height * 0.3469833);
    yamagataPath.lineTo(size.width * 0.7661871, size.height * 0.3478554);
    yamagataPath.lineTo(size.width * 0.7646323, size.height * 0.3499871);
    yamagataPath.lineTo(size.width * 0.7651353, size.height * 0.3518669);
    yamagataPath.lineTo(size.width * 0.7641521, size.height * 0.3540955);
    yamagataPath.lineTo(size.width * 0.7632374, size.height * 0.3542893);
    yamagataPath.lineTo(size.width * 0.7617283, size.height * 0.3536110);
    yamagataPath.lineTo(size.width * 0.7614996, size.height * 0.3540567);
    yamagataPath.lineTo(size.width * 0.7628945, size.height * 0.3567117);
    yamagataPath.lineTo(size.width * 0.7629631, size.height * 0.3577582);
    yamagataPath.lineTo(size.width * 0.7620942, size.height * 0.3590178);
    yamagataPath.lineTo(size.width * 0.7627115, size.height * 0.3607813);
    yamagataPath.lineTo(size.width * 0.7640835, size.height * 0.3615371);
    yamagataPath.lineTo(size.width * 0.7645408, size.height * 0.3628937);
    yamagataPath.lineTo(size.width * 0.7631460, size.height * 0.3659943);
    yamagataPath.lineTo(size.width * 0.7606536, size.height * 0.3682036);
    yamagataPath.lineTo(size.width * 0.7610195, size.height * 0.3693663);
    yamagataPath.lineTo(size.width * 0.7586186, size.height * 0.3719244);
    yamagataPath.lineTo(size.width * 0.7582527, size.height * 0.3739011);
    yamagataPath.lineTo(size.width * 0.7587786, size.height * 0.3762847);
    yamagataPath.lineTo(size.width * 0.7562405, size.height * 0.3793466);
    yamagataPath.lineTo(size.width * 0.7558061, size.height * 0.3813233);
    yamagataPath.lineTo(size.width * 0.7535423, size.height * 0.3823892);
    yamagataPath.lineTo(size.width * 0.7496094, size.height * 0.3824086);
    yamagataPath.lineTo(size.width * 0.7497695, size.height * 0.3862650);
    yamagataPath.close();

    Paint yamagataPaint = Paint()..style = PaintingStyle.fill;
    yamagataPaint.color = japanColors.yamagata ?? defaultColor;
    japanCanvas.drawPath(yamagataPath, yamagataPaint, onTapUp: (tabdetail) {
      callback('yamagata', tabdetail);
    });
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return true;
  }
}
